/* DUPLICATOR MYSQL SCRIPT CREATED ON : April 29, 2014, 12:47 am */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=91 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=MyISAM AUTO_INCREMENT=105 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=6933 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=350 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=362 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=95 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=94 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_albums` (
  `id` bigint(20) NOT NULL,
  `name` text,
  `description` text,
  `a_order` smallint(5) NOT NULL,
  `main_photo` bigint(20) NOT NULL,
  `a_parent` bigint(20) NOT NULL,
  `p_order_by` smallint(5) NOT NULL,
  `cover_linktype` tinytext NOT NULL,
  `cover_linkpage` bigint(20) NOT NULL,
  `owner` text NOT NULL,
  `timestamp` tinytext NOT NULL,
  `upload_limit` tinytext NOT NULL,
  `alt_thumbsize` tinytext NOT NULL,
  `default_tags` tinytext NOT NULL,
  `cover_type` tinytext NOT NULL,
  `suba_order_by` tinytext NOT NULL,
  `views` bigint(20) NOT NULL DEFAULT '0',
  `cats` tinytext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_comments` (
  `id` bigint(20) NOT NULL,
  `timestamp` tinytext NOT NULL,
  `photo` bigint(20) NOT NULL,
  `user` text NOT NULL,
  `ip` tinytext NOT NULL,
  `email` text NOT NULL,
  `comment` text,
  `status` tinytext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `photokey` (`photo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_exif` (
  `id` bigint(20) NOT NULL,
  `photo` bigint(20) NOT NULL,
  `tag` tinytext NOT NULL,
  `description` text,
  `status` tinytext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `photo` (`photo`),
  KEY `photo_2` (`photo`),
  KEY `photo_3` (`photo`),
  KEY `photokey` (`photo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

;

CREATE TABLE `wp_wppa_iptc` (
  `id` bigint(20) NOT NULL,
  `photo` bigint(20) NOT NULL,
  `tag` tinytext NOT NULL,
  `description` text,
  `status` tinytext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `photo` (`photo`),
  KEY `photo_2` (`photo`),
  KEY `photo_3` (`photo`),
  KEY `photokey` (`photo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_photos` (
  `id` bigint(20) NOT NULL,
  `album` bigint(20) NOT NULL,
  `ext` tinytext NOT NULL,
  `name` text,
  `description` longtext,
  `p_order` smallint(5) NOT NULL,
  `mean_rating` tinytext NOT NULL,
  `linkurl` text NOT NULL,
  `linktitle` text,
  `linktarget` tinytext NOT NULL,
  `owner` text NOT NULL,
  `timestamp` tinytext NOT NULL,
  `status` tinytext NOT NULL,
  `rating_count` bigint(20) NOT NULL DEFAULT '0',
  `tags` tinytext NOT NULL,
  `alt` tinytext NOT NULL,
  `filename` tinytext NOT NULL,
  `modified` tinytext NOT NULL,
  `location` tinytext NOT NULL,
  `views` bigint(20) NOT NULL DEFAULT '0',
  `page_id` bigint(20) NOT NULL DEFAULT '0',
  `exifdtm` tinytext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `album` (`album`),
  KEY `album_2` (`album`),
  KEY `album_3` (`album`),
  KEY `albumkey` (`album`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_rating` (
  `id` bigint(20) NOT NULL,
  `photo` bigint(20) NOT NULL,
  `value` smallint(5) NOT NULL,
  `user` text NOT NULL,
  `timestamp` tinytext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `photokey` (`photo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_wppa_session` (
  `id` bigint(20) NOT NULL,
  `session` tinytext NOT NULL,
  `timestamp` tinytext NOT NULL,
  `user` tinytext NOT NULL,
  `ip` tinytext NOT NULL,
  `status` tinytext NOT NULL,
  `data` text NOT NULL,
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `sessionkey` (`session`(20))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES("1", "94", "akismet_result", "false");
INSERT INTO `wp_commentmeta` VALUES("2", "94", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1318955083.83\";s:7:\"message\";s:28:\"Akismet cleared this comment\";s:5:\"event\";s:9:\"check-ham\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("3", "94", "akismet_history", "a:4:{s:4:\"time\";s:12:\"1319125034.1\";s:7:\"message\";s:52:\"globalthrillz changed the comment status to approved\";s:5:\"event\";s:15:\"status-approved\";s:4:\"user\";s:13:\"globalthrillz\";}");
INSERT INTO `wp_commentmeta` VALUES("4", "94", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319127952.97\";s:7:\"message\";s:54:\"globalthrillz changed the comment status to unapproved\";s:5:\"event\";s:17:\"status-unapproved\";s:4:\"user\";s:13:\"globalthrillz\";}");
INSERT INTO `wp_commentmeta` VALUES("5", "94", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319227575.53\";s:7:\"message\";s:52:\"globalthrillz changed the comment status to approved\";s:5:\"event\";s:15:\"status-approved\";s:4:\"user\";s:13:\"globalthrillz\";}");
INSERT INTO `wp_commentmeta` VALUES("6", "95", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319617293.68\";s:7:\"message\";s:52:\"globalthrillz changed the comment status to approved\";s:5:\"event\";s:15:\"status-approved\";s:4:\"user\";s:13:\"globalthrillz\";}");
INSERT INTO `wp_commentmeta` VALUES("7", "95", "akismet_result", "false");
INSERT INTO `wp_commentmeta` VALUES("8", "95", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319558792.42\";s:7:\"message\";s:28:\"Akismet cleared this comment\";s:5:\"event\";s:9:\"check-ham\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("9", "96", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319617365.81\";s:7:\"message\";s:28:\"Akismet cleared this comment\";s:5:\"event\";s:9:\"check-ham\";s:4:\"user\";s:13:\"globalthrillz\";}");
INSERT INTO `wp_commentmeta` VALUES("10", "96", "akismet_result", "false");
INSERT INTO `wp_commentmeta` VALUES("11", "97", "akismet_result", "false");
INSERT INTO `wp_commentmeta` VALUES("12", "97", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319667635.73\";s:7:\"message\";s:28:\"Akismet cleared this comment\";s:5:\"event\";s:9:\"check-ham\";s:4:\"user\";s:0:\"\";}");
INSERT INTO `wp_commentmeta` VALUES("13", "97", "akismet_history", "a:4:{s:4:\"time\";s:13:\"1319715810.94\";s:7:\"message\";s:52:\"globalthrillz changed the comment status to approved\";s:5:\"event\";s:15:\"status-approved\";s:4:\"user\";s:13:\"globalthrillz\";}");

/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("2", "295", "City Worker", "cityworker@miamigov.com", "", "74.252.102.142", "2011-03-30 14:39:00", "2011-03-30 14:39:00", "Looking forward to your posts...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("3", "295", "Ingrid", "ingridgnzlz@yahoo.com", "", "65.3.128.69", "2011-04-07 18:50:52", "2011-04-07 18:50:52", "Miss you already!!! Can\'t wait to see pictures! Love you!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("4", "295", "Israel Vasquez", "israel@israelvasquez.com", "", "119.235.71.156", "2011-04-16 02:27:10", "2011-04-16 02:27:10", "Pictures are up. Miss you!", "0", "1", "", "", "3", "1");
INSERT INTO `wp_comments` VALUES("5", "32", "rawco", "rawco@earth.com", "", "184.33.95.195", "2011-04-02 07:29:37", "2011-04-02 07:29:37", "", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("6", "32", "Krystle", "krysbeni@hotmail.com", "", "74.236.41.43", "2011-04-04 00:45:06", "2011-04-04 00:45:06", "OMG, that\'s awesome that you got to go to a tennis match. Tennis rocks man and it\'s easy to get into it.  Great pics.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("7", "32", "Vicky", "victoriesjav@msn.com", "", "166.216.162.26", "2011-04-12 00:32:10", "2011-04-12 00:32:10", "Glad you went... we had a nice time.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("8", "59", "Freddy", "Fernandopolania@gmail.com", "http://Www.fernandopolania.com", "166.137.8.246", "2011-04-08 19:06:13", "2011-04-08 19:06:13", "Enjoy Cali,it\'s a special place.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("9", "59", "mark s", "mstielow@comcast.net", "", "66.176.165.151", "2011-04-09 09:28:48", "2011-04-09 09:28:48", "hey man, don\'t smoke the sheep doo doo, it probably will kill you the same as smoking poison sumac.  I was only kidding.  Danny mentioned this to me.\nI so you are off on your voyage.  I will try a look in once in a while to so how things are going.  I have saved this page as a favorite.\nhave some fun, mark s.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("10", "59", "mark s", "mstielow@comcast.net", "", "66.176.165.151", "2011-04-09 09:34:01", "2011-04-09 09:34:01", "miami is a cesspool.  you\'ll never want to come back after seeing more of the world.  There\'s more to life than eating, driving a car and little electronic devices.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("11", "59", "Armando", "armando_s_valdes@hotmail.com", "", "76.18.18.138", "2011-04-09 18:47:43", "2011-04-09 18:47:43", "Did I tell you I lived in San Diego for two years??? Cool. It looks like you\'ve taken the 2nd step on the journey of a thousand miles!! Very pretty there. Looking at the ocean from a cliff is beautiful and tranquil (unless that is, you fall off - stay away from the edges. If you do fall in, here\'s a little trick: quickly throw your iphone out of the water). Also, where it says on this page, about the author, there is a photo of a round headed man... Where is your photo? Or is that your photo and you have become a super enlightened being and when your photo is taken all we see is light?!?", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("12", "59", "Rawco", "dseijo@gmail.com", "", "74.252.102.142", "2011-04-11 14:12:49", "2011-04-11 14:12:49", "A good traveler has no fixed plans, and is not intent on arriving. Lao Tzu", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("13", "59", "mark s", "not@again.com", "", "66.176.165.151", "2011-04-11 23:17:52", "2011-04-11 23:17:52", "hey I got a better idea if you decide to fall off a cliff into the water, hold your breath.  and better yet, buy a wet suit on the way down since the water is awful cold.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("14", "59", "Krystle", "krysbeni@hotmail.com", "", "74.236.41.43", "2011-04-12 13:16:31", "2011-04-12 13:16:31", "Have fun and yes i agree with Freddy, Cali is a very special place. I hope you get out of it everything it has to offer in the few days you\'re there.  Try to see if you can go to the Sequoia National Park...its crazy to see those massive trees isreal, I mean they are so tall and wide that you\'ll freak when you see them.  Its such a peaceful place to be in. Looking forward to your next posts.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("15", "59", "Hector P", "City6121@yahoo.com", "", "70.88.37.189", "2011-04-15 11:46:22", "2011-04-15 11:46:22", "Wow sounds like your first day is going well. We need to see more pictures. At least I can live your journey through your pics.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("16", "59", "Israel Vasquez", "israel@israelvasquez.com", "", "119.235.71.156", "2011-04-16 02:28:16", "2011-04-16 02:28:16", "Awesome! Yeah stay posted my friend!", "0", "1", "", "", "9", "1");
INSERT INTO `wp_comments` VALUES("17", "59", "Israel Vasquez", "israel@israelvasquez.com", "", "119.235.71.156", "2011-04-16 02:42:43", "2011-04-16 02:42:43", "haha yes i remember you telling me that. this is newport beach.", "0", "1", "", "", "11", "1");
INSERT INTO `wp_comments` VALUES("18", "59", "Lukas", "klia@bellsouth.net", "", "74.161.162.48", "2011-04-19 18:55:48", "2011-04-19 18:55:48", "hey israel i hope you are having tons of fun. the pics look awesome. hope you get to go surfing in all the cool places you visit. btw a cool thing to do is collect sand or water from each place you go to but idk if they will let you take that stuff on the airplane but you can try. see ya and have fun. \n\np.s.\ncant believe barca and real tied....\nin your face.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("19", "59", "Israel Vasquez", "israel@israelvasquez.com", "", "202.74.213.95", "2011-04-20 04:55:00", "2011-04-20 04:55:00", "Pura Vida!", "0", "1", "", "", "12", "1");
INSERT INTO `wp_comments` VALUES("20", "59", "Israel Vasquez", "israel@israelvasquez.com", "", "202.74.213.95", "2011-04-20 04:57:44", "2011-04-20 04:57:44", "LUKAS! Thanks! I\'m living my dreams dude. Say hi to your family. California was freezing and I didnt get time to surf but I surfed in Fiji at cloudbreak by Tavarua. Kelly Slater was there 3 weeks before I got there. Check out the pictures on your dad\'s facebook. \nMadrid got lucky. I saw the highlights lol. Be safe my lil bro. Jah bless.", "0", "1", "", "", "18", "1");
INSERT INTO `wp_comments` VALUES("21", "59", "cybermagnetik", "aleshvladimir@mail.com", "http://www.step-two.ru/2011/05/pierre-thomas-injuries-will-probably-be-through/", "188.233.9.61", "2011-05-19 21:58:36", "2011-05-19 21:58:36", "What a great web log. I spend hours on the net reading blogs, about tons of various subjects. I have to first of all give praise to whoever created your theme and second of all to you for writing what i can only describe as an fabulous article. I honestly believe there is a skill to writing articles that only very few posses and honestly you got it. The combining of demonstrative and upper-class content is by all odds super rare with the astronomic amount of blogs on the cyberspace.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("22", "68", "VG &amp; the Fruitbat", "vgandthefruitbat@gmail.com", "", "65.2.173.13", "2011-04-13 13:35:52", "2011-04-13 13:35:52", "That was deep", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("23", "68", "Rawco", "dseijo@gmail.com", "", "74.252.102.142", "2011-04-14 19:07:31", "2011-04-14 19:07:31", "Your photoshop skills are improving, nice edit.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("24", "68", "Manny", "otero927@yahoo.com", "", "68.215.6.154", "2011-04-15 20:25:13", "2011-04-15 20:25:13", "Glad you are having fun...be safe.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("25", "68", "Taco", "a_tacoronte@yahoo.com", "", "76.110.135.147", "2011-04-16 04:06:38", "2011-04-16 04:06:38", "Good luck Isra!!!. The pictures are awesome. Have fun.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("26", "68", "Joanna D.", "jbdonline@me.com", "", "65.70.36.49", "2011-04-18 16:40:14", "2011-04-18 16:40:14", "Yay glad you\'re keeping us posted! I\'ll be keeping up with you cuz...What a journey! I hope everything turns out even better than expected. No matter what, you\'ll learn, grow, and enjoy the beauties of the earth. :) SOOOo awesome..Love you primo..Keep safe - MUAH!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("27", "68", "Israel Vasquez", "israel@israelvasquez.com", "", "202.74.213.95", "2011-04-20 04:53:04", "2011-04-20 04:53:04", "Love you too prima! Thanks!", "0", "1", "", "", "26", "1");
INSERT INTO `wp_comments` VALUES("28", "68", "Israel Vasquez", "israel@israelvasquez.com", "", "202.74.213.95", "2011-04-20 04:54:27", "2011-04-20 04:54:27", "We should meet somewhere with Daniel. Maybe in Asia around August? LMK...", "0", "1", "", "", "26", "1");
INSERT INTO `wp_comments` VALUES("29", "75", "Stephany", "stephfannyd@gmail.com", "", "174.252.138.16", "2011-05-09 18:50:21", "2011-05-09 18:50:21", "Wow I\'m sure u hear this ALL the time but I\'m so envious of you and your travels. Please post lots of pix love!!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("34", "83", "maggiev", "maggie@supermix.com", "", "216.242.230.2", "2011-04-25 12:58:35", "2011-04-25 12:58:35", "I think it was sooooooo AWSOME that you were able to experience the Memorial there, and to have guest go with you. Keep enjoying your adventure to the MAXX!!Be safe!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("35", "92", "Ingrid", "ingridgnzlz@yahoo.com", "", "74.161.99.180", "2011-04-26 16:24:55", "2011-04-26 16:24:55", "WOW!!! I\'m in love with New Zealand!!! Keep posting....I feel like I\'m there with you. Continue enjoying your time there! Love ya\'", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("36", "92", "Jared", "jaredhernandez@bellsouth.net", "", "66.193.235.9", "2011-04-27 18:17:21", "2011-04-27 18:17:21", "So beautiful!  Keep posting pictures and enjoy your trip.  \n\nOh, Mustard Plug is having their 20th Year Anniversary, show is at Culture Room next month, won\'t be the same without you.  :)\n\nSay hi to Kiwi from me!\n\nMiss ya bro.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("37", "92", "Israel Vasquez", "israel@israelvasquez.com", "", "118.93.178.82", "2011-04-28 23:40:05", "2011-04-28 23:40:05", "thanks! love you!", "0", "1", "", "", "35", "1");
INSERT INTO `wp_comments` VALUES("38", "92", "Israel Vasquez", "israel@israelvasquez.com", "", "118.93.178.82", "2011-04-28 23:40:42", "2011-04-28 23:40:42", "Ah! Have a few beers for me. I will. Miss you dude. Be safe.", "0", "1", "", "", "36", "1");
INSERT INTO `wp_comments` VALUES("39", "98", "Manny", "otero927@yahoo.com", "", "65.10.1.8", "2011-04-30 02:02:20", "2011-04-30 02:02:20", "I\'m glad you are enjoying yourself. Mabel showed me this and I knew you would appreciate it...just don\'t get any ideas...\n\nhttp://vimeo.com/14074949", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("40", "98", "Israel Vasquez", "israel@israelvasquez.com", "", "118.93.178.82", "2011-04-30 05:57:46", "2011-04-30 05:57:46", "I\'ve seen it. I posted it on facebook a few months ago. It\'s amazing. Thanks! I have too many ideas. lol", "0", "1", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("41", "98", "Yani", "yanismiles@hotmail.com", "", "98.64.20.180", "2011-05-09 19:24:15", "2011-05-09 19:24:15", "Hey Israel, Where\'d you plagiarize \"Cape Reinga is generally considered the separation marker between the Tasman Sea to the west and the Pacific Ocean to the east. From the lighthouse it is possible to watch the tidal race, as the two seas clash to create unsettled waters just off the coast\" from? LOL... Sorry, it\'s the english teacher in me just messing with you... Loving the pics. Have a blast!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("42", "101", "maggiev", "maggie@supermix.com", "", "216.242.230.2", "2011-05-02 20:01:15", "2011-05-02 20:01:15", "BEAUTIFUL SAND PICTURE.. ANY PROOF OF YOU BODY SURFING?? LOL :)", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("43", "101", "Israel Vasquez", "israel@israelvasquez.com", "", "118.92.15.42", "2011-05-06 23:33:36", "2011-05-06 23:33:36", "Yea but I gotta get the video from my friend that filmed it on her camera.", "0", "1", "", "", "42", "1");
INSERT INTO `wp_comments` VALUES("44", "111", "Gabe", "gabrielluisreyes@gmail.com", "http://www.mindyouband.com", "98.249.158.246", "2011-05-09 13:03:16", "2011-05-09 13:03:16", "DUDE. You\'re taking the dream trip! It\'ll be over before you know it. Soak it all in, and we\'ll have a badass home coming party when you get back. Get a good book to read for those bored lonely moments. \"The Sun Also Rises\" is a good travel book... but \"On The Road\" is better. If you have an address I can send you a copy ahead I\'ll try and hook it up.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("45", "111", "Steven Benitez", "stevenbenitez44@gmail.com", "", "69.159.192.57", "2011-05-09 14:24:47", "2011-05-09 14:24:47", "Amazing pics bro", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("46", "111", "Michele", "locatika@hotmail.com", "", "98.64.81.97", "2011-05-09 14:28:48", "2011-05-09 14:28:48", "Friends and Family are here traveling with you! This website is an amazing way to share all your experiences. Keeping busy is the key... and keep on moving! If you stay in one spot too long you might get stuck, but at the same time you don\'t want to rush it. Get to know the place and make great friendships. Balance is important just like in all things. As the weeks pass by homesickness will fade away... traveling will become normality. It will be your way of life! And when you come back... everything will pretty much be the same except for YOU. Seeing the world utterly changes your perspective.\nKeep on posting!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("47", "111", "Saray", "lovers912@gmail.com", "", "74.161.246.36", "2011-05-09 18:12:36", "2011-05-09 18:12:36", "Wow!, amazing place, keep on enjoying your journey and take lots of pictures, like that we can feel we are close to you, We are always checking if there are new pics or a new post from you so we can also feel part of it, but yeah we miss you a lot too! It\'s great that you are making lots of friends and checking this great places, NZ looks beautiful!... \nLove ya \nyour sis.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("48", "111", "Yani", "yanismiles@hotmail.com", "", "98.64.20.180", "2011-05-09 19:31:33", "2011-05-09 19:31:33", "That view is incredible! Thanks for posting... Enjoy it and know that you\'re also missed back home...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("49", "111", "Freddy", "fernandopolania@gmail.com", "", "168.221.157.158", "2011-05-09 19:33:16", "2011-05-09 19:33:16", "Don\'t get down bro. Hang on.We\'re packing up my car and driving over. :o)", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("50", "111", "Ingrid", "Ingridgnzlz@yahoo.com", "", "208.54.85.59", "2011-05-10 11:19:06", "2011-05-10 11:19:06", "Amazing view!! keep having an amazing time in your travels. We love seeing your posts. When you are \"lonely\" just know that you have all of your family and friends with you through this site and fb. It makes us feel as if we are there with you. Maybe I should just go meet with you so you don\'t have any lonely days ;)", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("51", "111", "Jared", "jaredhernandez@bellsouth.net", "", "66.193.235.9", "2011-05-10 19:10:21", "2011-05-10 19:10:21", "Dude, we miss you too but don\'t get all melancholy on us.  I believe most of us are trying to live vicariously through you and these \"down days\" just don\'t work for us so chin up!  :) Haha JK Remember Prov. 17:17, with that in mind, when you\'re feeling blue get in contact with us.  Know we\'ll always be here for you, miss you and can\'t wait see you again.  \n\nNow regarding Piha... What a beautiful PLACE!!  And that spot looks totally surfable.  Actually, most of the ocean pics you\'ve sent while in New Zealand have lines just rolling in.  Gorgeous!  Enjoy it!\n\nMad love,\nJ", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("52", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:49:15", "2011-05-11 07:49:15", "Thanks dude! The last thing on my mind right now is for this to be over. I\'m having the time of my life! Party soudns Greeeaatt! lol I\'ll look into those books. Some days you have your bored moments which may lead to loneliness but you got to keep moving. I\'ve learned that the key is to stay busy and keep moving. Havent even been close to home sick yet haha. Dude if you need anything txt me at that google number. Be safe. Peace!", "0", "1", "", "", "44", "1");
INSERT INTO `wp_comments` VALUES("53", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:52:25", "2011-05-11 07:52:25", "Yes balance is important. Not homesick at all actually! Just saying its normal to have your down and ups while traveling alone or even with someone. The key is to stay busy and keep moving. Auckland is a big city like Miami and it started to feel like back home haha Now im road trippin the islands and its amazing. Keep up the comments. Thanks! Be safe.", "0", "1", "", "", "46", "1");
INSERT INTO `wp_comments` VALUES("54", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:52:50", "2011-05-11 07:52:50", "Thanks sis! Love ya!", "0", "1", "", "", "47", "1");
INSERT INTO `wp_comments` VALUES("55", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:53:06", "2011-05-11 07:53:06", "Chusso!", "0", "1", "", "", "45", "1");
INSERT INTO `wp_comments` VALUES("56", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:55:57", "2011-05-11 07:55:57", "hahaha not down brother just happy and excited to be here but some days could get boring and lonely if your not moving and staying busy..specially in the city. im out and about road tripping the islands. Pura vida! Come meet me! lol", "0", "1", "", "", "49", "1");
INSERT INTO `wp_comments` VALUES("57", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 07:57:33", "2011-05-11 07:57:33", "haha come meet me. its ok. no worries. they arent really lonely days, they are lonely moments every once in a blue moon but thats part of the experience. That what makes this experience a true journey. Dale! pura vida!", "0", "1", "", "", "50", "1");
INSERT INTO `wp_comments` VALUES("58", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 08:01:06", "2011-05-11 08:01:06", "Thanks for the advice haha I\'m not melancholy..reeeelax. Only when I listen to Smashing Pumpkins and over looking the ocean on a cliff do I get a little melancholy, but its a good melancholy, a pensive one. Suuuurrreeemmmmmaannn!! Bro there is always swells here but the water is FREEZINGGGG!! I had to buy a thicker wetsuit. haha I\'ll post more stuff soon. Pura vida!", "0", "1", "", "", "51", "1");
INSERT INTO `wp_comments` VALUES("59", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 08:02:11", "2011-05-11 08:02:11", "Sureman! lol", "0", "1", "", "", "48", "1");
INSERT INTO `wp_comments` VALUES("60", "111", "Israel Vasquez", "israel@israelvasquez.com", "", "203.109.204.230", "2011-05-11 08:02:11", "2011-05-11 08:02:11", "Sureman! lol", "0", "1", "", "", "48", "1");
INSERT INTO `wp_comments` VALUES("61", "111", "Elizabeth Buetow", "Elizabeth@simplystaging.ca", "", "184.151.63.216", "2011-05-11 12:07:35", "2011-05-11 12:07:35", "Hey cuz. Wow. I just found this. Amazing. \nEnjoy every second of it and know we are all\nLiving this trip with you.\nLove you primito..\nE", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("62", "111", "Priscilla", "Prbprisy@yahoo.com", "", "166.205.12.43", "2011-05-12 03:35:39", "2011-05-12 03:35:39", "Dude it doing something we all wish to experience storage once in our lives, I\'m so excited for u, it was  the topic of our conversations enjoy every moment", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("63", "111", "Priscilla", "Prbprisy@yahoo.com", "", "166.205.12.43", "2011-05-12 03:40:11", "2011-05-12 03:40:11", "Sorry just got an iPhone learning how to use it guess next time I should spell check but u get the picture, I hate autofill sometimes. Have fun!", "0", "1", "", "", "62", "0");
INSERT INTO `wp_comments` VALUES("72", "126", "Manny", "otero927@yahoo.com", "", "72.153.78.143", "2011-05-13 02:10:56", "2011-05-13 02:10:56", "I\'m really impressed with your photos...", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("73", "126", "Israel Vasquez", "israel@israelvasquez.com", "", "121.73.128.83", "2011-05-13 14:30:22", "2011-05-13 14:30:22", "Thanks! It\'s really not that hard to take nice pictures here. It\'s such a beautiful and surreal place. That\'s with a point and shoot.", "0", "1", "", "", "72", "1");
INSERT INTO `wp_comments` VALUES("74", "126", "Ingrid", "ingridgnzlz@yahoo.com", "", "71.196.72.122", "2011-05-19 00:54:48", "2011-05-19 00:54:48", "Wow, what an amazing view!! Wish we could be there with you! enjoy!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("79", "133", "mark stielow", "mstielow@comcast.net", "", "66.176.165.151", "2011-05-22 22:27:58", "2011-05-22 22:27:58", "May 22, @ 6:00 pm\nhow you doing?  I obviously see you are still traveling.  I\'m sure you have been having fun and all (you better be since that is what it is all about).  Nothing really new here to report.  It\'s starting to get awfully hot again.  Still been dry though.  No rain really to speak of for a while.  A few weeks ago it looked like it might start to rain a bit more often, but then that trailed off to nothing.  Now all the rain there is stays over the glades.  There was a fire in Big Cypress swamp a couple of weeks ago.  It really smelled bad of wildfire smoke a couple of mornings but it clears out during the day when the winds come off the ocean.  Fort Lauderdale is pretty quiet again.  All the snowbirds and tourists have left.  Makes it a little easier to bicycle.  I\'m leaving in a few minutes to take about an hour ride and then get ready for work.  Holiday coming up next weekend and then I am going to take a week off in June.  Again, nothing big to report on.  Take care of yourself and be safe.  mark s.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("80", "133", "Israel Vasquez", "israel@israelvasquez.com", "", "116.89.224.152", "2011-06-03 00:33:17", "2011-06-03 00:33:17", "Hi Mark! Good to hear from you. That is really good info, impressed! Hope you enjoyed your bike ride. I\'m still in New Zealand and just finished a road trip around the south island and most of the north island. It rains a lot here and the weather is cool, stays in the 50\'s because its winter but some nights it can get cold. Apart from that, knowing I\'m not a fan of the cold weather, its a wonderful place and it has amazing scenery and I would recommend to anyone. You should take a long trip over here one day. Thanks for the updates and keep in touch. Be safe and take care.", "0", "1", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("81", "136", "Jared", "jaredhernandez@bellsouth.net", "", "66.193.235.9", "2011-06-06 13:25:10", "2011-06-06 13:25:10", "That\'s awesome, I hope you had a cafesito and played some dominoes. :)\n\nBTW, I couldn\'t help but think of the aliens in Independence Day when I saw that Colossal Squid. haha\n\nTake care man!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("82", "136", "Israel Vasquez", "israel@israelvasquez.com", "", "202.20.6.129", "2011-06-08 06:24:04", "2011-06-08 06:24:04", "LOL That was the first thing that came to my mind when I the Colossal Squid too. Thanks for the comment. Miss you man! Take care.", "0", "1", "", "", "0", "1");
INSERT INTO `wp_comments` VALUES("83", "136", "Rebecca", "rebecca.ann.hausen@gmail.com", "", "67.205.238.254", "2011-06-23 03:09:38", "2011-06-23 03:09:38", "Haha! I thought of Independence Day too - cool shot. :)\n\nThe Cubans must have had a long boat ride on that one... :P Jk", "0", "1", "", "", "81", "0");
INSERT INTO `wp_comments` VALUES("92", "189", "cecelia", "cil16wil@att.net", "", "74.252.102.139", "2011-06-17 20:39:35", "2011-06-17 20:39:35", "Hey Israel, I\'m still here in the City posting things for the CIP website. I finally managed to see your website....Awesome! I will be following your adventures around the world. I am really interested in going to Asia. I odn\'t know about the Great Barrier reef though, a bit too scary shark wise for my tatses, but I hope you get to do it since it is one of your goals. Talk to you again soon.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("94", "241", "toca la loca", "reyesalfaro@hotmail.com", "", "69.42.103.8", "2011-10-18 16:24:43", "2011-10-18 16:24:43", "Your long lost brother finally finds you !!!  how cute", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("95", "257", "toca la loca", "reyesalfaro@hotmail.com", "", "69.42.103.8", "2011-10-25 16:06:32", "2011-10-25 16:06:32", "yo the phone remind me when i was seating at the edge of grand canyon.  priceless!!", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("96", "257", "Israel Vasquez", "israel@israelvasquez.com", "", "118.173.28.241", "2011-10-26 08:22:45", "2011-10-26 08:22:45", "I still haven\'t been there and its so close to me. We should do a trip there when I get back.", "0", "1", "", "", "95", "1");
INSERT INTO `wp_comments` VALUES("97", "265", "Keith Lorren", "Keith@keithlorren.com", "http://www.KeithLorren.com", "38.105.146.82", "2011-10-26 22:20:35", "2011-10-26 22:20:35", "One of my favorite countries! Im so happy you got to expereince this! Best wishes to you my brother! salam alaykum!!", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "20140429_traveltheworld", "535ef6bd1eb646671140429004757", "20", "2014-04-29 00:47:57", "globalthrillz", "O:11:\"DUP_Package\":15:{s:2:\"ID\";i:1;s:4:\"Name\";s:23:\"20140429_traveltheworld\";s:4:\"Hash\";s:29:\"535ef6bd1eb646671140429004757\";s:8:\"NameHash\";s:53:\"20140429_traveltheworld_535ef6bd1eb646671140429004757\";s:7:\"Version\";s:5:\"0.5.2\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:56:\"/home/israel/public_html/traveltheworld/wp-snapshots/tmp\";s:8:\"StoreURL\";s:53:\"http://israelvasquez.com/traveltheworld/wp-snapshots/\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":15:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:65:\"20140429_traveltheworld_535ef6bd1eb646671140429004757_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:39:\"/home/israel/public_html/traveltheworld\";s:8:\"DirCount\";i:0;s:9:\"FileCount\";i:0;s:9:\"LinkCount\";i:0;s:4:\"Size\";i:0;s:11:\"BigFileList\";a:0:{}s:15:\"InvalidFileList\";a:0:{}s:10:\"\0*\0Package\";r:1;s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:67:\"20140429_traveltheworld_535ef6bd1eb646671140429004757_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:66:\"20140429_traveltheworld_535ef6bd1eb646671140429004757_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}");

/* INSERT TABLE DATA: wp_links */
INSERT INTO `wp_links` VALUES("1", "http://codex.wordpress.org/", "Documentation", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("2", "http://wordpress.org/news/", "WordPress Blog", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "http://wordpress.org/news/feed/");
INSERT INTO `wp_links` VALUES("3", "http://wordpress.org/support/", "Support Forums", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("4", "http://wordpress.org/extend/plugins/", "Plugins", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("5", "http://wordpress.org/extend/themes/", "Themes", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("6", "http://wordpress.org/support/forum/requests-and-feedback", "Feedback", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("7", "http://planet.wordpress.org/", "WordPress Planet", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://israelvasquez.com/traveltheworld", "yes");
INSERT INTO `wp_options` VALUES("2", "blogname", "Travel the world", "yes");
INSERT INTO `wp_options` VALUES("3", "blogdescription", "One year trip around the world", "yes");
INSERT INTO `wp_options` VALUES("4", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("5", "admin_email", "admin@israelvasquez.com", "yes");
INSERT INTO `wp_options` VALUES("6", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("7", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("8", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("12", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("13", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("17", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("18", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("19", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("29", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("30", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("31", "permalink_structure", "", "yes");
INSERT INTO `wp_options` VALUES("32", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("33", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("34", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("35", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("36", "active_plugins", "a:5:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:39:\"multi-level-navigation-plugin/index.php\";i:3;s:41:\"wordpress-importer/wordpress-importer.php\";i:4;s:28:\"wp-photo-album-plus/wppa.php\";}", "yes");
INSERT INTO `wp_options` VALUES("37", "home", "http://israelvasquez.com/traveltheworld", "yes");
INSERT INTO `wp_options` VALUES("38", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("39", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("40", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("41", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("42", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("43", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("44", "recently_edited", "a:5:{i:0;s:94:\"/home/israel/public_html/traveltheworld/wp-content/themes/TheTravelTheme/includes/sendmail.php\";i:1;s:82:\"/home/israel/public_html/traveltheworld/wp-content/themes/TheTravelTheme/index.php\";i:2;s:82:\"/home/israel/public_html/traveltheworld/wp-content/themes/TheTravelTheme/style.css\";i:3;s:92:\"/home/israel/public_html/traveltheworld/wp-content/themes/TheTravelTheme/framework/theme.php\";i:4;s:81:\"/home/israel/public_html/traveltheworld/wp-content/themes/TheTravelTheme/home.php\";}", "no");
INSERT INTO `wp_options` VALUES("45", "template", "twentyeleven", "yes");
INSERT INTO `wp_options` VALUES("46", "stylesheet", "twentyeleven", "yes");
INSERT INTO `wp_options` VALUES("47", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("48", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("49", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("50", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("51", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("52", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("53", "db_version", "27916", "yes");
INSERT INTO `wp_options` VALUES("54", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("55", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("56", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("57", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("58", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("59", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("60", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("61", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("62", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("63", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("64", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("65", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("66", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("67", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("68", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("71", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("72", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("73", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("74", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("75", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("76", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("77", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("78", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("79", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("80", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("81", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("82", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("83", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("84", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("85", "widget_categories", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("86", "widget_text", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:309:\"<script type=\"text/javascript\"><!--\r\ngoogle_ad_client = \"ca-pub-8152219922834805\";\r\n/* israelvasquez */\r\ngoogle_ad_slot = \"2000898208\";\r\ngoogle_ad_width = 120;\r\ngoogle_ad_height = 240;\r\n//-->\r\n</script>\r\n<script type=\"text/javascript\"\r\nsrc=\"http://pagead2.googlesyndication.com/pagead/show_ads.js\">\r\n</script>\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("87", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("88", "uninstall_plugins", "a:1:{s:45:\"bulletproof-security/bulletproof-security.php\";s:30:\"bulletproof_security_uninstall\";}", "no");
INSERT INTO `wp_options` VALUES("89", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("91", "embed_size_w", "", "yes");
INSERT INTO `wp_options` VALUES("92", "embed_size_h", "600", "yes");
INSERT INTO `wp_options` VALUES("93", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("94", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("95", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("96", "initial_db_version", "21115", "yes");
INSERT INTO `wp_options` VALUES("97", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:71:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:10:\"wppa_admin\";b:1;s:11:\"wppa_upload\";b:1;s:11:\"wppa_import\";b:1;s:11:\"wppa_export\";b:1;s:13:\"wppa_settings\";b:1;s:9:\"wppa_potd\";b:1;s:13:\"wppa_comments\";b:1;s:9:\"wppa_help\";b:1;s:13:\"wppa_moderate\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("98", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("99", "widget_recent-posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("162", "widget_social", "a:2:{i:2;a:6:{s:5:\"title\";s:0:\"\";s:3:\"alt\";s:12:\"Follow Us on\";s:7:\"package\";s:14:\"komodomedia_16\";s:9:\"animation\";s:4:\"fade\";s:12:\"enable_sites\";N;s:12:\"custom_count\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("103", "sidebars_widgets", "a:13:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:4:{i:0;s:8:\"search-2\";i:1;s:10:\"nav_menu-2\";i:2;s:6:\"text-2\";i:3;s:8:\"social-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}s:9:\"sidebar-8\";a:0:{}s:9:\"sidebar-9\";a:0:{}s:10:\"sidebar-10\";a:0:{}s:10:\"sidebar-11\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("104", "cron", "a:6:{i:1398755261;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1398755400;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1398767428;a:1:{s:24:\"akismet_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1398789791;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1398798476;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("6294", "_site_transient_timeout_browser_a566fdd5e27848d1d4948ba6a875a217", "1398875024", "yes");
INSERT INTO `wp_options` VALUES("6295", "_site_transient_browser_a566fdd5e27848d1d4948ba6a875a217", "a:9:{s:8:\"platform\";s:9:\"Macintosh\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"34.0.1847.116\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("1969", "link_manager_enabled", "1", "yes");
INSERT INTO `wp_options` VALUES("6923", "_site_transient_timeout_theme_roots", "1398733691", "yes");
INSERT INTO `wp_options` VALUES("6924", "_site_transient_theme_roots", "a:6:{s:14:\"TheTravelTheme\";s:7:\"/themes\";s:12:\"twentyeleven\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:9:\"twentyten\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("113", "dashboard_widget_options", "a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:39:\"http://israelvasquez.com/traveltheworld\";s:4:\"link\";s:115:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://israelvasquez.com/traveltheworld/\";s:3:\"url\";s:148:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://israelvasquez.com/traveltheworld/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}", "yes");
INSERT INTO `wp_options` VALUES("6296", "_transient_timeout_feed_df272f46eda81b57710ed75dad73a85b", "1398313431", "no");
INSERT INTO `wp_options` VALUES("4250", "travel_slideshow", "a:7:{s:17:\"disable_slideshow\";b:0;s:5:\"count\";s:1:\"5\";s:6:\"height\";s:3:\"440\";s:9:\"animSpeed\";s:4:\"1000\";s:9:\"pauseTime\";s:4:\"5000\";s:12:\"pauseOnHover\";s:4:\"true\";s:8:\"autoplay\";s:4:\"true\";}", "yes");
INSERT INTO `wp_options` VALUES("619", "wppa_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("620", "wppa_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("621", "wppa_search_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("622", "wppa_excl_sep", "no", "yes");
INSERT INTO `wp_options` VALUES("623", "wppa_photos_only", "no", "yes");
INSERT INTO `wp_options` VALUES("624", "wppa_watermark_on", "no", "yes");
INSERT INTO `wp_options` VALUES("625", "wppa_watermark_user", "no", "yes");
INSERT INTO `wp_options` VALUES("626", "wppa_watermark_file", "specimen.png", "yes");
INSERT INTO `wp_options` VALUES("627", "wppa_watermark_pos", "cencen", "yes");
INSERT INTO `wp_options` VALUES("628", "wppa_watermark_upload", "", "yes");
INSERT INTO `wp_options` VALUES("629", "wppa_watermark_opacity", "20", "yes");
INSERT INTO `wp_options` VALUES("630", "wppa_slide_order", "0,1,2,3,4,5,6,7,8,9,10", "yes");
INSERT INTO `wp_options` VALUES("631", "wppa_swap_namedesc", "no", "yes");
INSERT INTO `wp_options` VALUES("632", "wppa_widgettitle", "Photo of the day", "yes");
INSERT INTO `wp_options` VALUES("633", "wppa_widget_linkurl", "Type your custom url here", "yes");
INSERT INTO `wp_options` VALUES("634", "wppa_widget_linktitle", "Type the title here", "yes");
INSERT INTO `wp_options` VALUES("635", "wppa_widget_subtitle", "none", "yes");
INSERT INTO `wp_options` VALUES("636", "wppa_widget_album", "0", "yes");
INSERT INTO `wp_options` VALUES("637", "wppa_widget_photo", "", "yes");
INSERT INTO `wp_options` VALUES("638", "wppa_potd_align", "center", "yes");
INSERT INTO `wp_options` VALUES("639", "wppa_widget_method", "1", "yes");
INSERT INTO `wp_options` VALUES("640", "wppa_widget_period", "168", "yes");
INSERT INTO `wp_options` VALUES("641", "wppa_widget_width", "200", "yes");
INSERT INTO `wp_options` VALUES("642", "wppa_toptenwidgettitle", "Top Ten Photos", "yes");
INSERT INTO `wp_options` VALUES("6905", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6906", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: How to Change BuddyPress Profile Field Visibility Settings\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21951\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:180:\"http://wptavern.com/how-to-change-buddypress-profile-field-visibility-settings?utm_source=rss&utm_medium=rss&utm_campaign=how-to-change-buddypress-profile-field-visibility-settings\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2567:\"<p>Profile field visibility settings were <a href=\"http://bpdevel.wordpress.com/2012/03/16/profile-field-visibility-in-bp-1-6/\" target=\"_blank\">added to BuddyPress in version 1.6</a> in order to address a popular request for profile privacy. The settings had remained the same up until the recent 2.0 release. Field visibility settings were previously tacked onto each field in the profile editing screens. BuddyPress project lead John James Jacoby <a href=\"https://buddypress.trac.wordpress.org/ticket/5352\" target=\"_blank\">proposed</a> that the plugin separate field data from field privacy by moving the visibility into its own settings page.</p>\n<p><a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" target=\"_blank\">BuddyPress 2.0</a> added a new Settings > Profile tab that allows users to configure profile field visibility from a single screen. This change declutters the profile editing pages and provides an easier way to edit field visibility all in one pass.</p>\n<p>If you were not aware that the settings were moved in BP 2.0, it may have seemed that they disappeared entirely. Logged-in members can now find them at <strong>Settings > Profile</strong>:</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/buddypress-profile-field-visibility.png\" rel=\"prettyphoto[21951]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/buddypress-profile-field-visibility.png?resize=1025%2C846\" alt=\"buddypress-profile-field-visibility\" class=\"aligncenter size-full wp-image-21955\" /></a></p>\n<p>As you can see in the example, some fields do not have visibility options. This is because administrators can opt to override them and set per-member visibility settings for each field at <strong>Users > Profile Fields > Edit Field</strong>.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/admin-visibility-settings.png\" rel=\"prettyphoto[21951]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/admin-visibility-settings.png?resize=985%2C666\" alt=\"admin-visibility-settings\" class=\"aligncenter size-full wp-image-21964\" /></a></p>\n<p>The default option is to let members change the field&#8217;s visibility, but you can also elect to enforce the default visibility for all members.</p>\n<p>If you don&#8217;t have a BuddyPress site handy for checking out the new profile field visibility settings page, you can see a live demo on <a href=\"http://buddypress.org/\" target=\"_blank\">BuddyPress.org</a> when logged into your profile.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Apr 2014 23:25:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"WPTavern: Genesis Skeleton for WordPress: Rapidly Create, Develop, and Deploy Across Multiple Environments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21826\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:250:\"http://wptavern.com/genesis-skeleton-for-wordpress-rapidly-create-develop-and-deploy-across-multiple-environments?utm_source=rss&utm_medium=rss&utm_campaign=genesis-skeleton-for-wordpress-rapidly-create-develop-and-deploy-across-multiple-environments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8515:\"<p>Last week we featured a collection of <a href=\"http://wptavern.com/13-vagrant-resources-for-wordpress-development\" target=\"_blank\">Vagrant resources for WordPress development</a>. Eric Clemmons, one of our readers, commented to let us know about <a href=\"https://github.com/genesis/wordpress\" target=\"_blank\">Genesis Skeleton for WordPress</a>, an awesome project that uses Vagrant for creating, developing and deploying WordPress across multiple environments.</p>\n<p>When Clemmons created Genesis, he wasn&#8217;t aware of how easily the name might be confused with the Genesis theme from StudioPress, so he&#8217;s updating the project to be called &#8220;Genesis Skeleton for WordPress.&#8221; The project utilizes <a href=\"http://nodejs.org/\" target=\"_blank\">NodeJS</a>, <a href=\"http://www.vagrantup.com/\" target=\"_blank\">Vagrant</a> and <a href=\"https://www.virtualbox.org/\" target=\"_blank\">VirtualBox</a>. For scaffolding and development, it relies on <a href=\"http://yeoman.io/\" target=\"_blank\">Yeoman</a>, <a href=\"http://bower.io/\" target=\"_blank\">Bower</a>, <a href=\"https://github.com/genesis/generator-wordpress/\" target=\"_blank\">Genesis WordPress Generator</a>, and <a href=\"https://github.com/smdahlen/vagrant-hostmanager\" target=\"_blank\">Vagrant Host Manager</a>. Deployment is handled by Capistrano and Ansible. This setup allows for the following:</p>\n<ul>\n<li>Generate a functional WordPress site + server</li>\n<li>First-class local development</li>\n<li>Independently stage features for review</li>\n<li>Use production data when developing</li>\n<li>High-performance, zero-configuration caching out of the box</li>\n<li>Easily monitor remote server errors</li>\n<li>Instant, secure SSH access</li>\n<li>Automated server provisioning</li>\n<li>Consistent, reliable environments</li>\n</ul>\n<p>Here&#8217;s a quick demo:</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/genesis.gif\" rel=\"prettyphoto[21826]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/genesis.gif?resize=782%2C614\" alt=\"genesis\" class=\"aligncenter size-full wp-image-21830\" /></a></p>\n<p>Clemmons and his colleagues use Genesis at <a href=\"http://www.cmn.com/\" target=\"_blank\">Consumer Media Network</a> to make it easier to develop, test, stage, and deploy a robust WordPress site. &#8220;The project has been re-invented over the past 2 years,&#8221; Clemmons said. &#8220;Once Yeoman and Ansible gained more traction, I was ready to re-tool it into what it is today.&#8221;</p>\n<h3>What makes the Genesis Skeleton for WordPress unique?</h3>\n<p>The Genesis project was specifically created to allow the developers at CMN to follow the best practices set for all of their other projects, including non-WordPress projects using Symfony or Node. Clemmons outlined those practices and how they are integrated into Genesis:</p>\n<ul>\n<li>Local development should be within a Vagrant VM to keep the client OS pristine.</li>\n<li>All environments (local/staging/production) should share the exact same machine setup (i.e. provisioning) to minimize environmental errors when deploying.</li>\n<li>Utilize the best-in-class tools suited for individual tasks:  Vagrant for local development, Yeoman for scaffolding, WordPress for the CMS, Ansible for provisioning, Capistrano for deployment.</li>\n<li>Draw a firm line in the sand regarding what Genesis Skeleton won&#8217;t do. (e.g. installing themes, plugins)</li>\n<li>Encourage performance via Apache optimization and Varnish, vs. relying on the application layer (e.g. WordPress Plugins) to do the server&#8217;s job.</li>\n<li>Support for staging/previewing branches. (e.g. http://my-new-feature.staging.mysite.com)</li>\n</ul>\n<p>While the first incarnation of the Genesis skeleton used a wrapper script, the latest version requires the developer to have a better understanding of his tools. <strong>&#8220;I intentionally avoided &#8216;do-it-all&#8217; wrapper scripts, because the developer becomes reliant on Genesis Skeleton, not the underlying tools powering their project,&#8221;</strong> Clemmons said. He&#8217;s started several &#8220;Genesis Skeletons&#8221; for various technologies they use for scaffolding projects at CMN. The <a href=\"https://github.com/genesis/angular\" target=\"_blank\">Angular</a> and <a href=\"https://github.com/genesis/wordpress\" target=\"_blank\">WordPress</a> skeletons have both been open source for the past year.</p>\n<h3>Genesis Skeleton Provides a Consistent Workflow and Better Collaboration</h3>\n<p>Because Clemmons and his team have dozens of WordPress sites, he wanted them to have a consistent workflow across all projects, no matter what the complexity:</p>\n<ol>\n<li>git clone &#8230;</li>\n<li>bower install</li>\n<li>vagrant up </li>\n<li>cap production genesis:down</li>\n<li>open http://local.reponame.com/</li>\n<li>cap production deploy</li>\n</ol>\n<p>This streamlined workflow allows his team to collaborate on projects more efficiently. <strong>&#8220;We&#8217;ve been able to have a half-dozen people openly collaborating, committing, and deploying the same WordPress site within a day,&#8221;</strong> Clemmons said. The Genesis Skeleton has revolutionized the way they work together:</p>\n<blockquote><p>Whereas, in the past, a single developer was in charge of everything and was responsible for FTP&#8217;ing (ugh!) the code to production, and subsequently committing and pushing to Github afterwards. (Hopefully they remembered that part!)</p>\n<p>Now, Github is our &#8216;single source of truth&#8217; for what gets deployed, and our sites have vastly improved in terms of reliability, quality, and speed.</p></blockquote>\n<p>From the outside, the Skeleton may seem like a fancy excuse to use all the newest development tools available, but Clemmons reports that changing their workflow greatly increased the team&#8217;s productivity. &#8220;The best thing that Genesis Skeleton for WordPress has done for us is to allow all members of our technology team (from systems, to frontend, to backend) to actively collaborate and work on a site,&#8221; he said. <strong>&#8220;The productivity gains have been astounding!&#8221;</strong></p>\n<h3>Open Sourcing the Genesis Skeleton for WordPress</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/genesis-skeleton.jpg\" rel=\"prettyphoto[21826]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/genesis-skeleton.jpg?resize=700%2C325\" alt=\"genesis-skeleton\" class=\"aligncenter size-full wp-image-21832\" /></a></p>\n<p>The Genesis skeleton is now a fairly well-supported and well-documented open source project on github. Clemmons said the project grew out of their own need across dozens of sites and a previous project he began two years ago. &#8220;Once I completed the latest iteration&#8217;s prototype, we battle-tested in production,&#8221; he said. &#8220;The entire team worked to solidify the project with regards to performance, workflow, and edge-cases specific to WordPress.&#8221;</p>\n<p>When asked why he decided to open source the skeleton, Clemmons said that he hopes the community will be able to benefit from the project. <strong>&#8220;I usually despise working with WordPress, as do many others, not because it&#8217;s a terrible framework, but because the development/deployment workflow is generally terrible and out-dated,&#8221;</strong> he said. &#8220;Because this is a problem that wasn&#8217;t solved at my place of business (and was marginally solved by moving hosting to a PaaS), I wanted to share the progress with the community at large.&#8221;</p>\n<p>Clemmons has always believed in open sourcing tools wherever possible. He also encourages the activity with his colleagues. When his team is active in building something for work, they try to open source the parts not specific to the business model. As a result, Clemmons has seen an impressive amount of involvement with the project. &#8220;Key individuals have been essential to improving performance and resolving bugs, so clearly open-sourcing it was the right move.&#8221;</p>\n<p>If you want to incorporate modern development tools into your WordPress projects, Genesis is a solid option for getting started. Whether you&#8217;re one person working alone or collaborating with a large team, Genesis makes it easy to create a consistent development and deployment workflow across all environments. Check out the <a href=\"https://github.com/genesis/wordpress\" target=\"_blank\">Genesis Skeleton for WordPress</a> on Github.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Apr 2014 16:49:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: WPWeekly Episode 147 – Interview With Japh Thompson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=21889&preview_id=21889\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:162:\"http://wptavern.com/wpweekly-episode-147-interview-with-japh-thompson?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-147-interview-with-japh-thompson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2403:\"<p>In this episode of WordPress Weekly, I sat down with <a href=\"http://japh.com.au/\" title=\"http://japh.com.au/\">Japh Thompson</a> to discuss his experience working at Envato for the past four years. Thompson worked in support before becoming the WordPress Evangelist for ThemeForest. In the interview, we learned what it was like to be a liaison between a huge theme marketplace and the WordPress Community.</p>\n<p>We learned how difficult it was to try to change the negative perception of ThemeForest while working alongside the community. Last but not least, we learned what he&#8217;s working on at <a href=\"https://x-team.com/\" title=\"https://x-team.com/\">X-Team</a>.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in\" title=\"http://wptavern.com/how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in\">How The Advanced Image Editing Properties Contributed To WordPress Theme Lock-in</a><br />\n<a href=\"http://wptavern.com/themelab-acquired-by-syed-balkhi\" title=\"http://wptavern.com/themelab-acquired-by-syed-balkhi\">ThemeLab Acquired By Syed Balkhi</a><br />\n<a href=\"http://wptavern.com/take-the-wordpress-contributor-experience-survey\" title=\"http://wptavern.com/take-the-wordpress-contributor-experience-survey\">Take the WordPress Contributor Experience Survey</a><br />\n<a href=\"http://wptavern.com/why-wordpress-cant-kill-commercial-plugin-businesses\" title=\"http://wptavern.com/why-wordpress-cant-kill-commercial-plugin-businesses\">Why WordPress Can’t Kill Commercial Plugin Businesses</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, May 2nd 3 P.M. Eastern &#8211; Special Guest <a href=\"http://siobhanmckeown.com/\" title=\"http://siobhanmckeown.com/\">Siobhan McKeown</a></p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #147:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 26 Apr 2014 16:22:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WPTavern: How to Repair a Crashed WordPress Posts Table\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21797\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:154:\"http://wptavern.com/how-to-repair-a-crashed-wordpress-posts-table?utm_source=rss&utm_medium=rss&utm_campaign=how-to-repair-a-crashed-wordpress-posts-table\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4659:\"<div id=\"attachment_21873\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/emergency.jpg\" rel=\"prettyphoto[21797]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/emergency.jpg?resize=1024%2C482\" alt=\"photo credit: Code & Martini by Ivana Vasilj - cc license\" class=\"size-full wp-image-21873\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"https://flic.kr/p/dLUWMb\">Code &#038; Martini</a> by <a href=\"https://www.flickr.com/photos/ivanavasilj/\">Ivana Vasilj</a> &#8211; cc license</p></div>\n<p>Every now and then the WordPress posts table will crash and screw up your website. Why does this happen? It&#8217;s not always clear how tables get corrupted, although it can usually be attributed to an <a href=\"https://dev.mysql.com/doc/refman/5.1/en/crashing.html\" target=\"_blank\">unexpected event</a>, such as the MySQL server or the server host getting killed in the middle of an update, causing interrupted writes to the database.</p>\n<h3>Symptoms of a Crashed Posts Table</h3>\n<p>If you navigate to the &#8220;All Posts&#8221; or &#8220;All Pages&#8221; screen in the WordPress admin and find nothing there, your first instinct is probably to freak out. <strong><em>What happened to all of my content?!</em></strong> Don&#8217;t worry; it&#8217;s still there. This is often a symptom of a crashed posts table in the database. It&#8217;s the MySQL equivalent to a throwing a tantrum, but it&#8217;s easily fixed, so you should stay calm.</p>\n<p>You may also see blank pages or get 404s on existing pages where there should be content. Those who have BuddyPress active may also see a message like this:</p>\n<p><strong>&#8220;The following active BuddyPress Components do not have associated WordPress Pages: User Groups, Members, Activate, Register. Repair&#8221;</strong></p>\n<p>When the posts table is crashed, BuddyPress can&#8217;t find those pages, so it gives you that warning, even though you set the pages before.</p>\n<h3>How to Fix a Crashed Table</h3>\n<p>Sometimes WordPress can repair this problem automatically, but other times you&#8217;ll just have to do it manually via phpMyAdmin. Before touching anything, make sure that you have a backup of your database.</p>\n<p>If you&#8217;re not comfortable with phpmyadmin, you should first try to use <a href=\"http://codex.wordpress.org/Editing_wp-config.php#Automatic_Database_Optimizing\" target=\"_blank\">WordPress&#8217; recommended method of database repair</a>, available since 2.9. Add the following to your <em>wp-config.php</em> file:</p>\n<pre class=\"brush: php; light: true; title: ; notranslate\">define( \'WP_ALLOW_REPAIR\', true );</pre>\n<p>That should take effect and automatically repair your crashed table after you visit the script at: <strong>{$your_site}/wp-admin/maint/repair.php</strong></p>\n<p>If you&#8217;re comfortable with using phpmyadmin, you may opt for an alternative method of repair, which really does the same thing as the previous method:</p>\n<p>Log into your host&#8217;s control panel and launch phpMyAdmin. Select your database and then look for the <strong>wp_posts</strong> table. Chances are that it&#8217;s not going to look like the other tables and will probably say &#8220;In Use&#8221;:</p>\n<div id=\"attachment_21856\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/crashed-posts-table.jpg\" rel=\"prettyphoto[21797]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/crashed-posts-table.jpg?resize=974%2C179\" alt=\"Scary, right?!\" class=\"size-full wp-image-21856\" /></a><p class=\"wp-caption-text\">Scary, right?!</p></div>\n<p>This is the table that is bedeviling you and you&#8217;ll want to select it and then click on &#8220;<a href=\"https://dev.mysql.com/doc/refman/5.1/en/repair-table.html\" target=\"_blank\">Repair Table</a>&#8221; in the dropdown:</p>\n<div id=\"attachment_21861\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/repair-table.jpg\" rel=\"prettyphoto[21797]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/repair-table.jpg?resize=815%2C234\" alt=\"Repair Table\" class=\"size-full wp-image-21861\" /></a><p class=\"wp-caption-text\">Repair Table</p></div>\n<p>This should have you all fixed up. Visit your site to verify that your posts and pages are back to normal. <em>Note:</em> This also works for other corrupted tables, i.e. wp_options, etc. It&#8217;s a fairly easy solution to a problem that presents itself as a dire emergency on the frontend of your WordPress site. File this one away for the next time you suspect a corrupted table.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Apr 2014 22:42:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"WPTavern: WordPress Code Reference is Now Live\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21839\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"http://wptavern.com/wordpress-code-reference-is-now-live?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-code-reference-is-now-live\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3186:\"<p>Siobhan McKeown <a href=\"http://make.wordpress.org/docs/2014/04/25/good-news-everyone-version-1-of-the-code/\" target=\"_blank\">announced</a> that the first version of the WordPress Code Reference is now live. It&#8217;s still in the very early stages of development but is now out in the wild so that people can help contribute. <a href=\"http://developer.wordpress.org/reference\" target=\"_blank\">Go try it out</a> to see how easy it is to search the WordPress code base.</p>\n<p>The reference was created as part of the <a href=\"http://make.wordpress.org/docs/tag/devhub/\" target=\"_blank\">devhub project</a> to make it easy for developers to find more information about WordPress&#8217; functions, classes, methods, hooks, and filters. After a few quick searches, I found that the search function is actually quite forgiving and will return results that are similar to what you were looking for, even if you spell it wrong.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/wordpress-code-reference.jpg\" rel=\"prettyphoto[21839]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/wordpress-code-reference.jpg?resize=794%2C595\" alt=\"wordpress-code-reference\" class=\"aligncenter size-full wp-image-21841\" /></a></p>\n<h3>How can you help improve the reference?</h3>\n<p>McKeown said that current development for the parser will continue on Github and you can <a href=\"https://github.com/rmccue/WP-Parser/issues?labels=enhancement&state=open\" target=\"_blank\">open a ticket</a> there to offer feedback on issues and enhancements. Tickets for the code reference theme can be found on <a href=\"https://meta.trac.wordpress.org/query?status=!closed&component=developer.wordpress.org\" target=\"_blank\">meta trac</a>. Very soon you&#8217;ll be able to submit code examples to the reference, McKeown said:</p>\n<blockquote><p>Please feel free to add tickets to meta trac if there are any issues you encounter, and if there’s a feature or enhancement you’d like we can discuss that too. We do have the functionality ready for submitting examples, we just need a few parser things fixed before we can deploy it.</p></blockquote>\n<p>The documentation team has been working at a feverish pace to completely overhaul WordPress docs to make them more useful to the community. The contributor handbooks have a <a href=\"https://make.wordpress.org/docs/2014/04/24/redesigned-contributor-handbooks/\" target=\"_blank\">new design</a> that is now live on the <a href=\"http://make.wordpress.org/core/handbook/\" target=\"_blank\">core</a>, <a href=\"http://make.wordpress.org/mobile/handbook/\" target=\"_blank\">mobile</a>, <a href=\"http://make.wordpress.org/docs/handbook/\" target=\"_blank\">docs</a>, and <a href=\"http://make.wordpress.org/polyglots/handbook/\" target=\"_blank\">polyglot</a> handbooks. If you want to get in on the fun and help to make WordPress docs more awesome, join the <a href=\"https://make.wordpress.org/docs/\" target=\"_blank\">Docs team</a> at their weekly meeting <a href=\"http://www.timeanddate.com/worldclock/fixedtime.html?hour=23&min=00&sec=0&p1=0&msg=Docs+Team+Chat\" target=\"_blank\">Thursdays at 23:00 UTC</a> in IRC on the #wordpress-sfd channel.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Apr 2014 20:50:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Interface: A Free Responsive Business Theme for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21697\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:176:\"http://wptavern.com/interface-a-free-responsive-business-theme-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=interface-a-free-responsive-business-theme-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2890:\"<p><a href=\"http://wordpress.org/themes/interface\" target=\"_blank\">Interface</a> is a new business theme in the WordPress Themes Directory, created by <a href=\"http://themehorse.com/\" target=\"_blank\">Theme Horse</a>, the same folks behind the popular <a href=\"http://wordpress.org/themes/clean-retina\" target=\"_blank\">Clean Retina</a> and <a href=\"http://wordpress.org/themes/attitude\" target=\"_blank\">Attitude</a> themes that have more than 80,000 downloads combined. If you need to set up a simple business site and you&#8217;re into the flat-style <a href=\"http://wptavern.com/exploring-wordpress-theme-designers-love-affair-with-mint-green\" target=\"_blank\">mint green design trend</a>, then the new Interface theme might be just the ticket.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/interface.jpg\" rel=\"prettyphoto[21697]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/interface.jpg?resize=880%2C660\" alt=\"interface\" class=\"aligncenter size-full wp-image-21789\" /></a></p>\n<p>The theme is responsive, retina ready, and compatible with both BuddyPress and bbPress. The social features drop nicely into the theme without any conflicts.</p>\n<p>Interface includes several options in the customizer for setting the header image, navigation, background, etc. It also includes a host of theme-specific widgets that you can edit live to create promotional boxes, feature recent work, display services, and add items typically related to business needs.</p>\n<p>In addition to the customizer options, Interface includes its own options panel for further customization of the homepage slider, layouts, social links, blog category, optional search form in the header, favicon and more advanced settings.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/interface-options.jpg\" rel=\"prettyphoto[21697]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/interface-options.jpg?resize=875%2C183\" alt=\"interface-options\" class=\"aligncenter size-full wp-image-21804\" /></a></p>\n<p>Inside this theme you&#8217;ll find many different building blocks for customizing your business site, including:</p>\n<ul>\n<li>4 layouts for posts/pages</li>\n<li>5 unique page templates</li>\n<li>8 widget areas</li>\n<li>6 custom widgets</li>\n<li>Separate top and bottom info bar to highlight contact/email/location</li>\n</ul>\n<p>Check out the <a href=\"http://themehorse.com/preview/interface/\" target=\"_blank\">live demo</a> on the Theme Horse site where you can view all the different page and blog templates available for both business and more blogger-oriented sites. With all the customization options, <a href=\"http://wordpress.org/themes/interface\" target=\"_blank\">Interface</a> is bound to be another favorite from the folks at Theme Horse. Add it to your site from WordPress.org via the theme browser in your admin panel.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Apr 2014 18:09:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"Matt: Scrollkit and Longreads at Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43748\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://ma.tt/2014/04/scrollkit-and-longreads-at-automattic/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:680:\"<p>You might have seen the news last week that <a href=\"http://www.businessweek.com/articles/2014-04-09/automattic-steward-of-wordpress-snaps-up-longreads\">Longreads is joining Automattic&#8217;s editorial team</a>. Today I&#8217;m excited to announce that <a href=\"http://www.scrollkit.com/\">we&#8217;ve acquired Scroll Kit and they&#8217;re joining Automattic as well</a>, and will be focused on making customization more visual and intuitive. We&#8217;re barely on the second inning of what WordPress could be, and the impact it can have on the world, and I consider myself very lucky to be working with the best and brightest on transforming the way the world publishes.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Apr 2014 00:32:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Automattic Snaps Up Scroll Kit to Add to the WordPress.com Product Team\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21755\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:206:\"http://wptavern.com/automattic-snaps-up-scroll-kit-to-add-to-the-wordpress-com-product-team?utm_source=rss&utm_medium=rss&utm_campaign=automattic-snaps-up-scroll-kit-to-add-to-the-wordpress-com-product-team\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3265:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/scroll-kit.png\" rel=\"prettyphoto[21755]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/scroll-kit.png?resize=640%2C338\" alt=\"scroll-kit\" class=\"aligncenter size-full wp-image-21768\" /></a></p>\n<p>Scroll Kit founders Cody Brown and Kate Ray <a href=\"http://www.scrollkit.com/\" target=\"_blank\">announced</a> today that they are joining the product team at WordPress.com. Automattic, having recently acquired <a href=\"http://wptavern.com/automattic-acquires-longreads-invests-in-digital-longform-publishing\" target=\"_blank\">Longreads</a> and <a href=\"http://wptavern.com/cloudup-makes-file-sharing-incredibly-easy\" target=\"_blank\">Cloudup</a>, adds <a href=\"http://www.scrollkit.com/\" target=\"_blank\">Scroll Kit</a> to its collection, ostensibly in order to subsume its better features into WordPress.com.</p>\n<p>Unlike Cloudup and Longreads, which have continued on with business as usual after acquisition, Scroll Kit will be shutting down its editor in three months as part of the deal. Users of the app are encouraged to export their scrolls in case a more native solution is available further down the road.</p>\n<p>Scroll Kit allowed users to create beautiful web pages without writing a line of code. Its powerful visual content editor was actually used to<a href=\"http://techcrunch.com/2013/05/21/snow-fail-the-new-york-times-and-its-misunderstanding-of-copyright/\" target=\"_blank\"> recreate the New York Time&#8217;s interactive Snowfall experiment in an hour</a>, a project which NYT says took hundreds of hours of hand-coding. Although its makers cannot yet comment on their super secret future plans, one cannot help but wonder if this radically simplified visual editor may soon make its way into WordPress.com.</p>\n<p>Scroll Kit already has a WordPress <a href=\"http://wordpress.org/plugins/scrollkit/\" target=\"_blank\">plugin</a> listed among WordPress.com VIP&#8217;s list of layout and organization <a href=\"http://vip.wordpress.com/plugins/\" target=\"_blank\">plugins</a>. This tool offered Scroll Kit users the ability to connect directly to self-hosted WordPress sites and create customized templates as well as change images, fonts, backgrounds, and add special effects. <strong>&#8220;We&#8217;ll take what we learned building Scroll Kit and apply it to a product that’s always been tightly integrated with ours,&#8221;</strong> Scroll Kit creators said, as they bid their current users goodbye.</p>\n<p>Will WordPress.com incorporate Scroll Kit&#8217;s editor into the theme editing experience for its customers? If so, it will be interesting to see if some of those features trickle down to the open source WordPress project. With the instant popularity of front-end visual editors like <a href=\"http://velocitypage.com/\" target=\"_blank\">VelocityPage</a> for self-hosted sites, a simplified theme editing experience is bound to resonate with WordPress.com&#8217;s user base. Scroll Kit&#8217;s makers said that their objective was <strong>&#8220;to create a process for making the web that was more like drawing on a piece of paper.&#8221;</strong> If they can bring that experience to WordPress.com, then Automattic has just bought itself a magic wand.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Apr 2014 23:37:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: View More Themes in the WordPress Theme Browser\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21736\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"http://wptavern.com/view-more-themes-in-the-wordpress-theme-browser?utm_source=rss&utm_medium=rss&utm_campaign=view-more-themes-in-the-wordpress-theme-browser\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3169:\"<p><a href=\"http://wptavern.com/wordpress-3-9-smith-released\" target=\"_blank\">WordPress 3.9</a> brought a huge improvement to the WordPress theme browsing experience. By default, the new browser shows large preview images of themes with indicators for the ones you already have installed. It also allows for better filtering and exploring of featured and popular items.</p>\n<div id=\"attachment_21121\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png\" rel=\"prettyphoto[21736]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png?resize=859%2C503\" alt=\"Theme Browser Experience Revamped In WordPress 3.9\" class=\"size-full wp-image-21121\" /></a><p class=\"wp-caption-text\">Theme Browser Experience Revamped In WordPress 3.9</p></div>\n<p>These updates to the theme browser make it far more likely that WordPress users will want to look for new themes without leaving the admin. The experience is much better than searching directly on WordPress.org.</p>\n<h3>See More Themes</h3>\n<p>Themes and their previews load quickly from WordPress.org, but the size of the thumbnails prevents you from seeing more of them on the screen at once. <a href=\"http://wordpress.org/plugins/see-more-themes/\" target=\"_blank\">See More Themes</a> is a new plugin, written by <a href=\"http://www.sdavismedia.com/\" target=\"_blank\">Sean Davis</a>, that allows you to browse more themes. When activated, the plugin modifies WordPress&#8217; default admin CSS for the theme browser, reducing the size of the thumbnails to display more themes.</p>\n<p>The default theme browser looks like this:</p>\n<div id=\"attachment_21748\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/old-theme-browser.png\" rel=\"prettyphoto[21736]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/old-theme-browser.png?resize=1025%2C643\" alt=\"Default Theme Browser\" class=\"size-full wp-image-21748\" /></a><p class=\"wp-caption-text\">Default Theme Browser</p></div>\n<p>When you have See More Themes activated, you&#8217;ll be able to take in more themes at a glance:</p>\n<div id=\"attachment_21749\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/new-theme-browser.png\" rel=\"prettyphoto[21736]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/new-theme-browser.png?resize=1025%2C643\" alt=\"Theme Browser with See More Themes plugin activated\" class=\"size-full wp-image-21749\" /></a><p class=\"wp-caption-text\">Theme Browser with See More Themes plugin activated</p></div>\n<p>Sometimes it takes hours of browsing and previewing themes before you can settle on one that works for your site. See More Themes helps you browse through them faster while still presenting a decent sized thumbnail. It also maintains the theme browser&#8217;s responsiveness. If you like being able to see more themes at once, <a href=\"http://wordpress.org/plugins/see-more-themes/\" target=\"_blank\">download</a> the plugin from WordPress.org the next time you&#8217;re on the hunt for new themes in the admin.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Apr 2014 22:10:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: Why WordPress Can’t Kill Commercial Plugin Businesses\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21735\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:168:\"http://wptavern.com/why-wordpress-cant-kill-commercial-plugin-businesses?utm_source=rss&utm_medium=rss&utm_campaign=why-wordpress-cant-kill-commercial-plugin-businesses\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2820:\"<p><span class=\"post-byline\"><span class=\"author publisher-anchor-color\">Iain Poulson recently published a post that asks an important but easy question to answer. </span></span><a title=\"http://www.polevaultweb.com/2014/04/will-wordpress-plugin-business-killer/\" href=\"http://www.polevaultweb.com/2014/04/will-wordpress-plugin-business-killer/\">Will WordPress be a Plugin Business Killer?</a> The post is based on the idea that features from a commercial plugin added to WordPress could kill the business based on that plugin.</p>\n<p>The short answer to Poulson&#8217;s question is <strong>no</strong>. Here&#8217;s why.</p>\n<h3>WordPress Needs To Be Generic</h3>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2009/08/gravitylogo.png\" rel=\"prettyphoto[21735]\"><img class=\"alignright size-full wp-image-2322\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2009/08/gravitylogo.png?resize=108%2C109\" alt=\"gravityforms logo\" /></a>WordPress serves a huge audience. Commercial plugins usually address a specific niche and hammer away at it with features and functionality. It wouldn&#8217;t make sense to take GravityForms or Backup Buddy and merge them into WordPress because those plugins are not generic enough to cover a wide audience.</p>\n<p>Even if a GravityForms were to merge into core, it would likely be stripped of its niche focused functionality and probably be rewritten. It would be stripped to a point of basic functionality to cover the majority of WordPress users. GravityForms would likely continue to exist as a successful commercial plugin since it would contain features that didn&#8217;t make it to the core of WordPress.</p>\n<h3>Don&#8217;t Sell Features, Sell Products</h3>\n<p>Within the comments of the article, Carl Hancock of RocketGenius <a title=\"http://www.polevaultweb.com/2014/04/will-wordpress-plugin-business-killer/#comment-1352082767\" href=\"http://www.polevaultweb.com/2014/04/will-wordpress-plugin-business-killer/#comment-1352082767\">made a great point</a> when he said:</p>\n<blockquote><p>To me a viable commercial product is just that. A product. Not a feature. If something is more of a feature, then unless it&#8217;s part of a collection of offerings it could be dicey to rely on it as a commercial plugin. Features aren&#8217;t products.</p></blockquote>\n<p>I agree. Commercial plugins that are just glorified features are more at risk of being added to core than full-fledged products. Regardless of either camp, merging existing plugins into core is not a routine task. Outside of the features as plugins first model, it rarely happens.</p>\n<p>I don&#8217;t think commercial plugin author needs to worry. Is it a possibility worth considering? Definitely, but it&#8217;s one of those thoughts that should be in the back of your mind, not the forefront.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Apr 2014 21:46:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: Take the WordPress Contributor Experience Survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21701\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:160:\"http://wptavern.com/take-the-wordpress-contributor-experience-survey?utm_source=rss&utm_medium=rss&utm_campaign=take-the-wordpress-contributor-experience-survey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4205:\"<div id=\"attachment_21721\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/we.jpg\" rel=\"prettyphoto[21701]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/we.jpg?resize=1024%2C474\" alt=\"photo credit:  - cc license\" class=\"size-full wp-image-21721\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"https://flic.kr/p/mkLUc\">23rdian</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-nc/2.0/\">cc</a> license</p></div>\n<p>If you&#8217;ve ever contributed to the WordPress project, whether through code, documentation, plugins and themes, speaking at a WordCamp, etc., your feedback is requested on the WordPress <a href=\"http://wordpressdotorg.polldaddy.com/s/wordpress-contributor-experience-poll\" target=\"_blank\">Contributor Experience Survey</a>.  Jen Mylo <a href=\"http://make.wordpress.org/community/2014/04/24/contributor-experience-survey/\" target=\"_blank\">announced</a> the survey today, noting that none of the questions are mandatory.</p>\n<p>One of the questions in the survey asks: <strong>&#8220;What can the WordPress project do to make current contributors feel valued?&#8221;</strong> Since the vast majority of community contributions to the project are done on a volunteer basis, the project is seeking feedback for recognizing and valuing those efforts.</p>\n<p>Recent and continued <a href=\"http://wptavern.com/wordpress-org-profile-redesign-is-live\" target=\"_blank\">improvements to WordPress.org profiles</a> present a more accurate representation of a user&#8217;s involvement in the project and recognize users with badges that denote contributions to code, plugins, themes, WordCamps, as well as active participation in the groups listed on <a href=\"http://make.wordpress.org/\" target=\"_blank\">make.wordpress.org</a>. Do these badges resonate with contributors or are there more creative ways that the project can help them feel valued?</p>\n<h3>Helping New Contributors Feel Welcome and Encouraged</h3>\n<p>Another important question on the survey asks what the WordPress project can do better to make new contributors feel welcome and encouraged. Getting a better handle on this could potentially help the project expand its contributor base and move forward at a faster rate. This past year WordPress has launched several new initiatives targeted at improving new contributors&#8217; experiences.</p>\n<p>Recent <a href=\"http://wptavern.com/wordpress-core-trac-gets-a-design-refresh-new-features-and-enhancements\" target=\"_blank\">updates to WordPress core trac</a>, as well as the <a href=\"http://make.wordpress.org/core/2014/01/27/proposed-trac-component-reorganization/\" target=\"_blank\">components reorganization</a>, have gone a long way toward helping contributors to specialize and stay informed on selected tickets. The addition of the <a href=\"https://core.trac.wordpress.org/query?keywords=~good-first-bug\" target=\"_blank\">“good-first-bug”</a> keyword helps to streamline areas where new contributors might get their feet wet.</p>\n<p>In addition to helping new code contributors, the <a href=\"http://make.wordpress.org/community/author/andreamiddleton/\" target=\"_blank\">WordCamp Organizer Hangouts</a> have been instrumental in getting new organizers oriented with the responsibilities of leading an event. A <a href=\"http://make.wordpress.org/docs/2014/02/25/docs-issue-tracker/\" target=\"_blank\">preliminary version</a> of a new <a href=\"http://wptavern.com/coming-soon-an-issues-tracker-for-wordpress-documentation\" target=\"_blank\">issues tracker for WordPress documentation</a> was recently launched and will be refined to help documentation contributors work together more efficiently. However, there are many more areas where contributors might jump in that have not yet been optimized for newcomers.</p>\n<p>The survey asks for feedback on user experiences contributing to the project, both positive and negative. If you have any thoughts on how WordPress can improve these experiences, take a few minutes to communicate your feedback via the <a href=\"http://wordpressdotorg.polldaddy.com/s/wordpress-contributor-experience-poll\" target=\"_blank\">Contributor Experience Survey</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Apr 2014 18:23:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Read Where You Write In WordPress With The Orbital Feed Reader Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20779\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:202:\"http://wptavern.com/read-where-you-write-in-wordpress-with-the-orbital-feed-reader-plugin?utm_source=rss&utm_medium=rss&utm_campaign=read-where-you-write-in-wordpress-with-the-orbital-feed-reader-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3366:\"<p>When <a title=\"http://googlereader.blogspot.com/2013/07/a-final-farewell.html\" href=\"http://googlereader.blogspot.com/2013/07/a-final-farewell.html\">Google Reader was shut down</a> on July 2nd, 2013, those who use RSS searched far and wide for suitable replacements. I&#8217;ve settled on using <a title=\"http://feedly.com/\" href=\"http://feedly.com/\">Feedly </a>for my needs. However, there is a plugin available that adds an RSS reader to WordPress so you can create blog posts as you read RSS feeds from within the same interface. It&#8217;s called <a title=\"http://wordpress.org/plugins/orbital-feed-reader/\" href=\"http://wordpress.org/plugins/orbital-feed-reader/\">Orbital Feed Reader</a> and is available on the WordPress plugin directory.</p>\n<div id=\"attachment_21690\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/FeedsWithinOrbitalFeedReader.png\" rel=\"prettyphoto[20779]\"><img class=\"size-full wp-image-21690\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/FeedsWithinOrbitalFeedReader.png?resize=1025%2C559\" alt=\"My Feeds Within Orbital Feed Reader\" /></a><p class=\"wp-caption-text\">My Feeds Within Orbital Feed Reader</p></div>\n<p>By default, Orbital is subscribed to a few different feeds to get you started. The design of the interface is a far cry from what I&#8217;m use to with Feedly. Because of the way content from feeds are displayed, it&#8217;s hard to determine when posts begin and end. The way the content is displayed makes it hard to decipher, especially if the content contains a lot of images.</p>\n<p>If you can get past those setbacks, the feed reader performs as advertised. At the end of each article is a Blog This button. Clicking the button opens up the Press This bookmarklet enabling you to quickly post content to your site. Any text that is highlighted within the article before the button is selected will automatically be shown in the content area of the <a title=\"http://codex.wordpress.org/Press_This\" href=\"http://codex.wordpress.org/Press_This\">Press This bookmarklet</a>. Being able to read feeds and quickly publish articles to a blog is a nice convenience.</p>\n<p>You can add feeds either by importing an OPML file or by using a site&#8217;s RSS feed URL.</p>\n<div id=\"attachment_21691\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/OrbitalHowToAddFeeds.png\" rel=\"prettyphoto[20779]\"><img class=\"size-full wp-image-21691\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/OrbitalHowToAddFeeds.png?resize=542%2C208\" alt=\"How To Add Feeds In Orbital\" /></a><p class=\"wp-caption-text\">How To Add Feeds In Orbital</p></div>\n<h3>I&#8217;m Sticking With Feedly</h3>\n<p>Although I don&#8217;t use my feed reader as much as I used to, I prefer Feedly over Orbital because of the synching options between the web and mobile versions of the service. Feedly also displays content in a way that makes it easier to read compared to Orbital. Last but not least, I have the Press This bookmarklet installed in FireFox so I can blog stories from anywhere on the web.</p>\n<p>With that said, the plugin&#8217;s purpose is to enable users to read RSS feeds and easily create blog content from within the same interface. It&#8217;s the plugin&#8217;s shining feature and it does so without any problems.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Apr 2014 17:42:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"WPTavern: ThemeLab Acquired By Syed Balkhi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=19860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:128:\"http://wptavern.com/themelab-acquired-by-syed-balkhi?utm_source=rss&utm_medium=rss&utm_campaign=themelab-acquired-by-syed-balkhi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3938:\"<p><a title=\"https://www.themelab.com/\" href=\"https://www.themelab.com/\">ThemeLab</a>, a popular site dedicated to WordPress theme topics has been acquired by <a title=\"http://www.balkhis.com/\" href=\"http://www.balkhis.com/\">Syed Balkhi</a>. ThemeLab has been a valuable resource of information since 2007. Leland Fiegel, the site&#8217;s previous owner made a positive mark within the community <a title=\"http://www.themelab.com/stop-downloading-wordpress-themes-from-shady-sites/\" href=\"http://www.themelab.com/stop-downloading-wordpress-themes-from-shady-sites/\">when he published an in-depth post</a> explaining why users shouldn&#8217;t download and use themes from shady sites discovered in Google.</p>\n<div id=\"attachment_19876\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/03/ThemeLabShadySites.gif\" rel=\"prettyphoto[19860]\"><img class=\"size-large wp-image-19876\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/03/ThemeLabShadySites.gif?resize=500%2C265\" alt=\"Don\'t Download Themes From Shady Sites\" /></a><p class=\"wp-caption-text\">Don&#8217;t Download Themes From Shady Sites</p></div>\n<p>According to the <a title=\"https://www.themelab.com/about-us/\" href=\"https://www.themelab.com/about-us/\">about page</a>, the acquisition took place in 2013. During the time of acquisition, Balkhi and his team have revamped the site and turned it into a commercial theme shop. The site&#8217;s mission statement fits in with a trend we&#8217;ve noticed with commercial themes in general: &#8220;While most companies are focused on either design or functionality, our approach is to bring the best of both worlds with a special emphasis on usability.&#8221;</p>\n<blockquote><p>As a WordPress user watching from the sidelines, I’ve noticed that themes have become extremely complex over the last several years. The race to add more features, more options, more shortcodes, and more of everything has led developers to lose sight of what’s more important: <strong>usability</strong>.</p>\n<p>Beginners who are just starting out no longer find WordPress to be easy. A lot of this has to do with themes because that’s their first encounter. Having to go through 600 options just to get the theme to look like the demo is beyond silly.</p></blockquote>\n<p>All of the free themes released on ThemeLab have been retired and are no longer available for download. Tutorials published by Fiegel will be updated as necessary with new ones on the way.</p>\n<h3>What&#8217;s Next For Fiegel?</h3>\n<p>ThemeLab has been an excellent resource of information within the WordPress community over the years. It&#8217;s awesome to see Fiegel has found the right buyer with the right price. In a <a title=\"http://leland.me/six-years-of-theme-lab/\" href=\"http://leland.me/six-years-of-theme-lab/\">detailed post on his personal blog</a>, Fiegel explains what the past six years have been like running ThemeLab as well the lessons he learned.</p>\n<p>His next endeavor is called <a title=\"http://pluginferno.com/\" href=\"http://pluginferno.com/\">Pluginferno</a> and focuses on commercial plugins for WordPress, addons for existing popular plugins, plugin reviews, and commentary about the WordPress community in general.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/Testing.png\" rel=\"prettyphoto[19860]\"><img class=\"aligncenter size-full wp-image-21672\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/Testing.png?resize=1025%2C772\" alt=\"Testing\" /></a></p>\n<p>He&#8217;ll also be entering the commercial theme market through <a title=\"http://powertheme.com/\" href=\"http://powertheme.com/\">PowerTheme</a>. There&#8217;s not a lot of information about the site but it will sell 100% GPL licensed themes. Both sites give Fiegel a fresh start. The lessons learned from running ThemeLab should make it easier for his new endeavors to be financially successful.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Apr 2014 21:41:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Have You Turned On Akismet 3.0′s Silent Discard Feature?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21649\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:172:\"http://wptavern.com/have-you-turned-on-akismet-3-0s-silent-discard-feature?utm_source=rss&utm_medium=rss&utm_campaign=have-you-turned-on-akismet-3-0s-silent-discard-feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3926:\"<p><a href=\"http://wordpress.org/plugins/akismet/\" target=\"_blank\">Akismet</a> is one of those quiet utility plugins that works in the background of your WordPress site without a lot of fanfare. When it&#8217;s doing it&#8217;s job, your blog comments stay spam-free and you never think twice about it. Forgetting to activate Akismet on a new site will quickly remind you of just how much spam is targeted at WordPress sites.</p>\n<p><a href=\"http://blog.akismet.com/2014/04/15/akismet-3-0-0/\" target=\"_blank\">Akismet 3.0</a> is a major rewrite of the plugin that improves its efficiency in handling the worst spam that hits your site. When you visit your Akismet settings you&#8217;ll see how many days of your life Akismet has saved you as well as some new stats and graphs demonstrating the plugin&#8217;s effectiveness. Here&#8217;s an example from a small, personal blog:</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/akismet-settings.jpg\" rel=\"prettyphoto[21649]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/akismet-settings.jpg?resize=795%2C545\" alt=\"akismet-settings\" class=\"aligncenter size-full wp-image-21659\" /></a></p>\n<h3>Akismet 3.0&#8242;s Silent Discard Feature Improves Performance</h3>\n<p>In addition to an easier signup and configuration process, this version introduced a silent discard feature that identifies and outright blocks the worst spam comments.</p>\n<p>Throughout the course of improving Akismet, the team found that approximately 80% of spam is so bad that it could be flagged as “pervasive.” The silent discard feature causes pervasive spam to bypass the spam folder entirely so that you&#8217;ll never see it.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/akismet-discard-spam-feature.png\" rel=\"prettyphoto[21649]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/akismet-discard-spam-feature.png?resize=697%2C116\" alt=\"akismet-discard-spam-feature\" class=\"aligncenter size-full wp-image-21657\" /></a></p>\n<p>The plugin previously had a relatively ineffective option that allowed site owners the ability to automatically discard spam on older posts. This didn&#8217;t do much to block the worst spam and users found it to be confusing.</p>\n<p>Akismet 3.0 remembers your selections for this previous feature and applies them to the new silent discard feature. In most cases this means that the silent discard will be automatically turned on when you update the plugin. For users who are new to Akismet, the default setting is to store the pervasive spam in the spam folder for 15 days. The silent discard feature will need to be turned on from the plugin&#8217;s configuration page.</p>\n<p>There are some very compelling reasons to turn this new feature on. When <a href=\"http://blog.akismet.com/2014/04/23/theres-a-ninja-in-your-akismet/\" target=\"_blank\">announcing</a> the silent discard option, the folks at Akismet said that <strong>&#8220;enabling the feature can result in significant reductions in your storage and resource usage requirements.&#8221;</strong> This is especially true on sites that are always publishing new content. Silently discarding the most pervasive spam, instead of storing all of it for 15 days, frees up the storage and resources required to display and manage those spam comments in the admin.</p>\n<p>Akismet has zapped more than 135 billion spam comments and track backs to date, and the service is getting smarter at defeating the worst spam. The most important spam-fighting feature of 3.0 is the ability to silently discard pervasive spam before it even has the chance to land on your doorstop and get logged in your database. Turning this option on is a no-brainer. If you haven&#8217;t yet updated your plugins or have been waiting to update to WordPress 3.9, Akismet 3.0&#8242;s silent discard feature is another reason to get moving on those updates.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Apr 2014 21:04:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Tweet Archive: A Free WordPress Theme to Match the New Twitter Profiles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21511\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:204:\"http://wptavern.com/tweet-archive-a-free-wordpress-theme-to-match-the-new-twitter-profiles?utm_source=rss&utm_medium=rss&utm_campaign=tweet-archive-a-free-wordpress-theme-to-match-the-new-twitter-profiles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3922:\"<p>Yesterday, Twitter <a href=\"https://blog.twitter.com/2014/your-new-web-profile-is-here\" target=\"_blank\">announced</a> that it was rolling out the new profile redesign to all users. If you haven&#8217;t updated your Twitter profile, you can click on the &#8220;Get it Now&#8221; button on the <a href=\"https://about.twitter.com/products/new-profiles\" target=\"_blank\">new profiles product page</a>.</p>\n<p>Last week we featured <a href=\"http://wptavern.com/ozh-tweet-archiver-2-0-backs-up-your-tweets-to-wordpress\" target=\"_blank\">Ozh’ Tweet Archiver</a> as an easy way to archive your tweets to WordPress. The 2.0 version of the plugin has been updated to work with Twitter’s OAuth API and 2.0.1 has support for post formats, thanks to a contribution from <a href=\"http://wptavern.com/ozh-tweet-archiver-2-0-backs-up-your-tweets-to-wordpress#comment-54394\" target=\"_blank\">Chip Bennett</a>. Ozh also updated the Tweet Archive WordPress theme that accompanies the plugin in order to more closely match Twitter&#8217;s new profile design.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/tweet-archiver-theme.jpg\" rel=\"prettyphoto[21511]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/tweet-archiver-theme.jpg?resize=1025%2C589\" alt=\"tweet-archiver-theme\" class=\"aligncenter size-full wp-image-21624\" /></a></p>\n<p>You can view a <a href=\"http://planetozh.com/tweets/\" target=\"_blank\">live demo</a> on Ozh&#8217;s tweet archive site. He created the theme for his own use so you&#8217;ll need to edit a few files to personalize it. It was designed to work in combination with the plugin, so the top bar displaying total tweets, following, and followers only works with the plugin installed. The theme utilizes Font Awesome icons within the tweet archive and social accounts display. It also has support for a sidebar which you can use to allow easy browsing of archived tweets, stats, hashtags, or anything you wish.</p>\n<p>All of the user info in the left column can be customized in the <em>header.php</em> file as well as the avatar. The header image can be changed in <em>style.css</em>. It would be cool if the theme was updated to use WordPress&#8217; custom header feature, but it wasn&#8217;t really created for distribution. Ozh has the project open to contribution, however, if anyone is interested in refining the theme.</p>\n<h3>Use Your WordPress-Powered Twitter Archive to Boost Traffic</h3>\n<p>Tweet Archive includes a search bar within the header, since WordPress&#8217; search feature is much easier to use when looking for specific content within your tweets. Ryan Hellyer, who has his tweets backed up to a subdomain, <a href=\"http://wptavern.com/ozh-tweet-archiver-2-0-backs-up-your-tweets-to-wordpress#comment-54142\" target=\"_blank\">commented</a> on our previous post, highlighting another merit to hosting your own archive:</p>\n<blockquote><p>Another unexpected benefit, is that I actually get traffic from it. Google seems to preferentially send traffic my way instead of to Twitter itself sometimes.</p></blockquote>\n<p>If you&#8217;re getting extra traffic from hosting your own Twitter archive, you may want to make use of Twitter&#8217;s new pinned tweet feature. This should be easy to accomplish in your archive with WordPress&#8217; built-in sticky posts and a little bit of CSS to make it a larger entry. That way, when visitors land on your archive, they will see your curated favorites at the top of the list.</p>\n<p>If you&#8217;re using the <a href=\"http://wordpress.org/plugins/ozh-tweet-archiver/\" target=\"_blank\">Ozh Tweet Archiver plugin</a> to automatically archive your tweets to WordPress and you want a theme that will approximate the new Twitter design, grab the <a href=\"https://github.com/ozh/ozh-tweet-archive-theme\" target=\"_blank\">Tweet Archive WordPress theme</a> on Github and customize it to match your Twitter profile.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Apr 2014 18:20:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Akismet: There’s a Ninja in Your Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1351\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://blog.akismet.com/2014/04/23/theres-a-ninja-in-your-akismet/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2910:\"<p>One of our favorite additions to <a href=\"http://blog.akismet.com/2014/04/15/akismet-3-0-0/\">Akismet 3.0</a> is the new discard setting. Previously, our plugin featured an option that allowed site owners the ability to automatically discard spam on older posts. But, as some may certainly agree, it was rather confusing and had little effect on the world&#8217;s smarter spammers.</p>\n<p>After giving thought to how we could improve that particular setting and the overall user experience, we found that approximately 80% of spam could be flagged as &#8220;pervasive&#8221;, meaning that it is the absolute worst of the worst (of the worst!). In fact, that 80% is so bad that there is simply no benefit in paying any attention to it at all. Not even for kicks and giggles. Trust us.</p>\n<p>We came up with something that would allow you to automatically and silently discard all of that pervasive spam attacking your site so that it never even appears in your &#8220;Spam&#8221; folder. The new setting identifies the <strong>worst and most pervasive</strong> spam (which can certainly change over time) on our side during the comment check and will immediately discard it if you&#8217;ve configured the plugin to do so. </p>\n<p>If you&#8217;re new to Akismet, these spam comments will be stored by default; you must activate the new feature from the plugin&#8217;s configuration page (if you upgraded to 3.0, Akismet will use the previous value of your 30-day discard setting) :</p>\n<p><a href=\"http://akismet.files.wordpress.com/2014/04/akismet-discard-spam-feature.png\"><img src=\"http://akismet.files.wordpress.com/2014/04/akismet-discard-spam-feature.png?w=640&h=106\" alt=\"Akismet Discard Spam Feature\" width=\"640\" height=\"106\" class=\"alignnone size-large wp-image-1376\" /></a></p>\n<p>It&#8217;s all very ninja-esque, we think. What&#8217;s more, enabling the feature can result in significant reductions in your storage and resource usage requirements.</p>\n<p>This is a great step forward in our mission to make the web a cleaner place. We tested the feature on <a href=\"http://wordpress.com/\">WordPress.com</a> and received excellent results and feedback prior to rolling it into the plugin. So, we think (and hope) you&#8217;ll enjoy it. We are also working on an enhancement to the feature, which will highlight the pervasive spam comments in the &#8220;Spam&#8221; folder for users who choose to store them.</p>\n<p>If you have any feedback on the new feature, we would love to <a href=\"http://akismet.com/contact/\">hear from you</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1351/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1351/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1351&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Apr 2014 13:09:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Anthony Bubel\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: New Plugin Adds Less CSS Preprocessor to WordPress Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21533\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:178:\"http://wptavern.com/new-plugin-adds-less-css-preprocessor-to-wordpress-themes?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-adds-less-css-preprocessor-to-wordpress-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3374:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/less-theme-support.jpg\" rel=\"prettyphoto[21533]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/less-theme-support.jpg?resize=772%2C250\" alt=\"less-theme-support\" class=\"aligncenter size-full wp-image-21583\" /></a></p>\n<p>Many WordPress developers opt to use the <a href=\"http://lesscss.org/\" target=\"_blank\">Less</a> CSS preprocessor to speed up theme development. Its availability of variables, mixins, and functions allows you to do more with CSS and to do it more efficiently. It also makes it easy to compile and minify files for production use. However, the initial setup for adding Less to each theme is a somewhat time-consuming process.</p>\n<p>Justin Kopepasah wrote a tutorial in the past for <a href=\"http://kopepasah.com/tutorial/using-less-in-a-live-wordpress-theme/\" target=\"_blank\">using LESS in a live WordPress theme</a>, followed by one that <a href=\"http://kopepasah.com/tutorial/easily-add-less-css-pre-processor-to-any-wordpress-theme/\" target=\"_blank\">automated the process</a> by setting up the functionality as a Git submodule. Over time, he found that adding Less to each theme was becoming quite a chore, so he created a plugin to make the process easier for anyone.</p>\n<p>Kopepasah&#8217;s <a href=\"https://wordpress.org/plugins/less-theme-support/\" target=\"_blank\">Less Theme Support</a> plugin radically simplifies the process of adding Less to your WordPress theme. It requires just two simple steps following activation:</p>\n<ol>\n<li>Add <em>style.less</em> to your theme&#8217;s root directory</li>\n<li>Add theme support to the after_setup_theme hook:\n<pre class=\"brush: php; light: true; title: ; notranslate\">add_theme_support( \'less\', array( \'enable\' =&gt; true ) );</pre>\n</li>\n</ol>\n<p>Less Theme Support comes with four different options which change how it functions on development vs. production sites. All are boolean values defaulting to false:</p>\n<ul>\n<li><strong>enable</strong> – Enables Less and enqueues <em>less.min.js</em> on the front end.</li>\n<li><strong>develop</strong> – Enables development environment for Less and enqueues <em>less-develop.js</em>.</li>\n<li><strong>watch</strong> – Enables watch mode for Less and enqueues <em>less-watch.js</em>.</li>\n<li><strong>minify</strong> – Enables usage of a minified stylesheet (<em>style.min.css</em>) on the front end for all other visitors (best generated using lessc -x style.less > style.min.css).</li>\n</ul>\n<p>These options give you quite a bit of flexibility. For example, during development you might configure your theme support with the enable, develop, and watch options:</p>\n<pre class=\"brush: php; title: ; notranslate\">add_theme_support( \'less\', array(\n    \'enable\'  =&gt; true,\n    \'develop\' =&gt; true,\n    \'watch\'  =&gt; true\n) );</pre>\n<p>Less theme support in production would us the minify option:</p>\n<pre class=\"brush: php; title: ; notranslate\">add_theme_support( \'less\', array(\n \'minify\' =&gt; true\n) );</pre>\n<p>Using the <a href=\"https://wordpress.org/plugins/less-theme-support/\" target=\"_blank\">Less Theme Support</a> plugin provides a much cleaner and easier way to add Less to your theme. Download it from WordPress.org or via the project&#8217;s page on <a href=\"https://github.com/kopepasah/less-theme-support\" target=\"_blank\">Github</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 21:49:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Display Before and After Images In WordPress With The TwentyTwenty Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=20955\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:210:\"http://wptavern.com/display-before-and-after-images-in-wordpress-with-the-twentytwenty-plugin?utm_source=rss&utm_medium=rss&utm_campaign=display-before-and-after-images-in-wordpress-with-the-twentytwenty-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4181:\"<p>Have you ever wanted to combine two images to show a before and after? You can&#8217;t do that with WordPress out of the box but it&#8217;s possible if you use the <a title=\"http://wordpress.org/plugins/twentytwenty/\" href=\"http://wordpress.org/plugins/twentytwenty/\">TwentyTwenty plugin</a> by <a title=\"http://aspiringwebdev.com/\" href=\"http://aspiringwebdev.com/\">Corey Martin</a>. The plugin takes advantage of the <a title=\"http://www.w3schools.com/cssref/pr_pos_clip.asp\" href=\"http://www.w3schools.com/cssref/pr_pos_clip.asp\">clip property</a> within CSS by stacking two identical sized images on top of each other. The clip property allows the image to show through the container. The slider is responsive and uses custom movement events within the <a title=\"https://github.com/stephband/jquery.event.move\" href=\"https://github.com/stephband/jquery.event.move\">jQuery Event Move library</a> to support <strong>1:1</strong> slider movement on mobile devices.</p>\n<p>The plugin is very simple to use. Upload two identical sized images to the media library. When inserting images into a post, make sure the attachment display settings for image size are the same. Add the <strong>[TwentyTwenty]</strong> shortcode above the before image. Add <strong>[/TwentyTwenty]</strong> after the second image. Here&#8217;s an example of the shortcode added to a post.</p>\n<div id=\"attachment_21585\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyShortcode.png\" rel=\"prettyphoto[20955]\"><img class=\"size-full wp-image-21585\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyShortcode.png?resize=754%2C703\" alt=\"TwentyTwenty Shortcode In Action\" /></a><p class=\"wp-caption-text\">TwentyTwenty Shortcode In Action</p></div>\n<p>The shortcode generates a slider that can be moved back and forth. You&#8217;ll see which images are before and after when you hover over the slider. To see either image, users must click and drag the circle left or right.</p>\n<div id=\"attachment_21588\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyBefore.png\" rel=\"prettyphoto[20955]\"><img class=\"size-full wp-image-21588\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyBefore.png?resize=650%2C200\" alt=\"TwentyTwenty Before Image\" /></a><p class=\"wp-caption-text\">TwentyTwenty Before Image</p></div>\n<div id=\"attachment_21587\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyAfter.png\" rel=\"prettyphoto[20955]\"><img class=\"size-full wp-image-21587\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/TwentyTwentyAfter.png?resize=650%2C200\" alt=\"TwentyTwenty After Image\" /></a><p class=\"wp-caption-text\">TwentyTwenty After Image</p></div>\n<p>The plugin was written using <a title=\"http://sass-lang.com/\" href=\"http://sass-lang.com/\">Sass</a> and Zurb.com has a <a title=\"http://zurb.com/playground/twentytwenty\" href=\"http://zurb.com/playground/twentytwenty\">listing of each Sass variable</a> used and what its default value is. The variables enable you to control everything from the handle color to the handle radius.</p>\n<p>Here are a couple of ideas where TwentyTwenty would be ideal to use.</p>\n<ul>\n<li>Compare counterfeit merchandise to real merchandise</li>\n<li>Website redesigns</li>\n<li>Home improvement renovations</li>\n</ul>\n<p>During my test with WordPress 3.9, I didn&#8217;t experience any problems. According to Martin, <a title=\"http://wordpress.org/support/plugin/twentytwenty\" href=\"http://wordpress.org/support/plugin/twentytwenty\">TwentyTwenty</a> is compatible with the latest versions of Chrome, Safari, FireFox, iOS, IE 9, and above. If you want to see the plugin in action, you can either watch this screencast by Martin or visit the <a title=\"http://zurb.com/playground/twentytwenty\" href=\"http://zurb.com/playground/twentytwenty\">plugin&#8217;s page on Zurb.com</a>.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p><strong>Outside of showing before and after images, what other creative ways could this plugin be used?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 21:20:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WPTavern: WordPress 3.9 Adds 30 New Dashicons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21545\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:134:\"http://wptavern.com/wordpress-3-9-adds-30-new-dashicons?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-9-adds-30-new-dashicons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1541:\"<p><a title=\"http://melchoyce.github.io/dashicons/\" href=\"http://melchoyce.github.io/dashicons/\">Dashicons</a> are what’s known as an icon font and were added to the core of WordPress with the release of 3.8. The icons are vector based so they can be as large or small as you want without losing quality. Plugin authors can use CSS, HTML, or a Glyph for use within Photoshop to display an icon. While 3.8 had 167 icons, WordPress 3.9 shipped with <a title=\"http://make.wordpress.org/core/2014/04/16/dashicons-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/16/dashicons-in-wordpress-3-9/\">30 new Dashicons</a> bringing the total to 197.</p>\n<div id=\"attachment_21547\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WP39Dashicons.png\" rel=\"prettyphoto[21545]\"><img class=\"size-full wp-image-21547\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WP39Dashicons.png?resize=652%2C313\" alt=\"New Dashicons In WordPress 3.9\" /></a><p class=\"wp-caption-text\">New Dashicons In WordPress 3.9</p></div>\n<p>The icons cover Media, TinyMCE, WordPress.org, Sorting, Widgets, Alerts, and Miscellaneous. Some plugin authors have already opted out of using a bitmap image and are using a Dashicon to represent their plugin within the WordPress admin menu. If none of the Dashicons match your use case, try <a title=\"http://genericons.com\" href=\"http://genericons.com\">Genericons</a> instead. Genereicons is also an icon font but has icons that are not focused on WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 19:37:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Automattic Introduces Postbot App for Scheduling Photo Posts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21535\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/automattic-introduces-postbot-app-for-scheduling-photo-posts?utm_source=rss&utm_medium=rss&utm_campaign=automattic-introduces-postbot-app-for-scheduling-photo-posts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4368:\"<p>Today Automattic introduced <a href=\"https://postbot.co/\" target=\"_blank\">Postbot</a>, a new stand-alone application for scheduling image posts. The new app allows users to upload multiple images and schedule them out over several days. Postbot creates a post for each image and automatically posts them to the selected blog, saving users the trouble of manually scheduling each one.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/postbot.gif\" rel=\"prettyphoto[21535]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/postbot.gif?resize=752%2C376\" alt=\"postbot\" class=\"aligncenter size-full wp-image-21539\" /></a></p>\n<p>When using <a href=\"https://postbot.co/\">Postbot</a>, you&#8217;ll need to connect via WordPress.com. The app is automatically connected to your main WordPress.com blog but once logged in you&#8217;ll have the option to connect other sites. Self-hosted WordPress sites can use the app via <a href=\"http://jetpack.me/\" target=\"_blank\">Jetpack</a> with the <a href=\"http://jetpack.me/support/json-api/\" target=\"_blank\">JSON API module</a> enabled.</p>\n<p>Right now, you can only use the app from a desktop or mobile browser and John Godley, representing Automattic, says that a mobile app is not currently in the works. He elaborated on why they chose to create it as a standalone web app:</p>\n<blockquote><p>Postbot lets us provide a very targeted set of features to anyone with a WordPress.com or WordPress.org/Jetpack blog (or both), from one central place. It’s already mobile-ready so a special mobile app isn&#8217;t currently planned.</p></blockquote>\n<p>The experience of visiting <a href=\"https://postbot.co/\" target=\"_blank\">Postbot.co</a> from a mobile browser is not unlike using a mobile app. Those who plan to use it frequently via mobile can easily set a bookmark for quick launch while on the go.</p>\n<h3>Postbot Puts Photo Publishing on Autopilot</h3>\n<p>Postbot allows you to upload up to 50 photos at once to be published individually on different dates. While the images are uploading you can edit the titles, tags and content for each. The option to set a category is planned for a future version.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/uploading-postbot.png\" rel=\"prettyphoto[21535]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/uploading-postbot.png?resize=688%2C311\" alt=\"uploading-postbot\" class=\"aligncenter size-full wp-image-21550\" /></a></p>\n<p>Scheduling allows you to set the number of days between posts published with the option to ignore weekends.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/schedule_postbot.png\" rel=\"prettyphoto[21535]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/schedule_postbot.png?resize=635%2C42\" alt=\"schedule_postbot\" class=\"aligncenter size-full wp-image-21551\" /></a></p>\n<p>The app doesn&#8217;t yet allow you to set the featured image, but it&#8217;s on Automattic&#8217;s list of <a href=\"https://github.com/Automattic/Postbot/issues/6\" target=\"_blank\">feature requests</a> for future enhancements.</p>\n<p>Postbot is an excellent example of the kinds of apps that can be created using the <a href=\"http://developer.wordpress.com/docs/api/\" target=\"_blank\">WordPress.com API</a>. If you want to take a peek under the hood, the app&#8217;s code was released under the GPL and can be found on <a href=\"https://github.com/Automattic/Postbot\" target=\"_blank\">Github</a>. This means that anyone can host their own Postbot web app or create interesting variations that interact with WordPress.com services.</p>\n<p>Postbot is potentially very useful for photobloggers who want to break up their posts into individual images. It could also be handy for automating sites that are dedicated to publishing photos every day, i.e. &#8220;The Daily Kitten&#8221; or &#8220;Your Daily Dose of Fun.&#8221; It allows these kinds of sites to go on autopilot for publishing fresh content on a regular basis. Publishing new posts multiple times per day is an option <a href=\"http://en.blog.wordpress.com/2014/04/22/postbot-scheduled-photos/#comment-202397\" target=\"_blank\">currently under consideration</a> and may be a possibility in the future. We&#8217;ll be following the app&#8217;s progress as it adds new features based on user feedback.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 19:17:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Mike Little: Apologies for the old posts.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=2023\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"http://journalized.zed1.com/archives/2014/04/22/apologies-for-the-old-posts/?utm_source=rss&utm_medium=rss&utm_campaign=apologies-for-the-old-posts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:598:\"<p>Folks, it looks like when I moved this old blog from a subdirectory to a subdomain, <a href=\"http://planet.wordpress.org\">planet.wordpress.org</a> (the feed that shows up in your dashboard) thought my last few old posts were new. Hence a lot of old stuff appeared in your dashboard.</p>\n<p>Sorry for the confusion&#8230;</p>\n<p>Mike</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2014/04/22/apologies-for-the-old-posts/\">Apologies for the old posts.</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 14:36:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: How The Advanced Image Editing Properties Contributed To WordPress Theme Lock-in\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:224:\"http://wptavern.com/how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in?utm_source=rss&utm_medium=rss&utm_campaign=how-the-advanced-image-editing-properties-contributed-to-wordpress-theme-lock-in\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6280:\"<p>Although <a title=\"http://wptavern.com/wordpress-3-9-smith-released\" href=\"http://wptavern.com/wordpress-3-9-smith-released\">WordPress 3.9</a> has refined the media editing experience, it did so at the cost of removing a feature users appreciated. In WordPress 3.8, users could easily add a border, vertical, and horizontal padding to images. WordPress 3.9 removed this from the advanced image settings screen.</p>\n<p>It’s not just those who use the self-hosted version of WordPress <a title=\"http://wordpress.org/support/topic/major-problems-with-image-editing-in-wp-39?replies=12\" href=\"http://wordpress.org/support/topic/major-problems-with-image-editing-in-wp-39?replies=12\">that are upset with the change</a>. A WordPress.com <a title=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\" href=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\">support forum thread</a> with over 430 posts is filled with users asking why the feature was removed. In some cases, WordPress.com staff are explaining how to use HTML code to add or remove borders to images.</p>\n<p>Thankfully, there&#8217;s a new plugin available that not only restores the original advanced image settings but has expanded upon them. The plugin is called <a title=\"http://wordpress.org/plugins/advanced-image-styles/\" href=\"http://wordpress.org/plugins/advanced-image-styles/\">Advanced Image Styles</a> and is maintained by <a title=\"http://profiles.wordpress.org/gcorne/\" href=\"http://profiles.wordpress.org/gcorne/\">Gregory Cornelius</a>. As you can see, users can now apply padding in all four directions instead of two. You can also apply a border color instead of just the border width.</p>\n<div id=\"attachment_21489\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/AdvancedImageEditingOptions.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21489\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/AdvancedImageEditingOptions.png?resize=840%2C401\" alt=\"Advanced Image Editing Styles\" /></a><p class=\"wp-caption-text\">Advanced Image Styles</p></div>\n<p><a title=\"http://wordpress.org/support/view/plugin-reviews/advanced-image-styles\" href=\"http://wordpress.org/support/view/plugin-reviews/advanced-image-styles\">Early reviews</a> indicate users are happy to see these options return despite having to use a plugin. Unfortunately, those on WordPress.com are still out of luck. A member of the WordPress.com staff says <a title=\"http://en.forums.wordpress.com/topic/image-resize-1/page/15?replies=430#post-1754610\" href=\"http://en.forums.wordpress.com/topic/image-resize-1/page/15?replies=430#post-1754610\">it&#8217;s possible</a> the plugin will be merged into the WordPress.com codebase.</p>\n<blockquote><p>I have asked the developers if this will be merged. At the moment I have not heard back. I will let you know as soon as possible!</p></blockquote>\n<h3>These Options Are Causing Theme Lock-in</h3>\n<p>If themes are coded to properly handle image padding and borders, the options within WordPress are redundant and unnecessary. What&#8217;s troubling is users are utilizing these options to override the styling within the theme instead of changing its CSS stylesheet.</p>\n<p>In a test on my local server, I used the advanced image editing options to add a black, four pixel border to an image within the media library. Then I switched themes to see if the border was still there. I discovered that settings applied to images via the WordPress image editing options are displayed no matter which theme is used.</p>\n<div id=\"attachment_21520\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/OldTavernDesign.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21520\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/OldTavernDesign.png?resize=605%2C339\" alt=\"Old Tavern Design With The Black Image Border\" /></a><p class=\"wp-caption-text\">Old Tavern Design With The Black Image Border</p></div>\n<div id=\"attachment_21519\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/NewTavernDesign.png\" rel=\"prettyphoto[21488]\"><img class=\"size-full wp-image-21519\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/NewTavernDesign.png?resize=665%2C387\" alt=\"New Tavern Design With The Black Image Border\" /></a><p class=\"wp-caption-text\">New Tavern Design With The Black Image Border</p></div>\n<p>If a user switches to a theme that uses a color scheme not compatible with the image border color, each image has to be edited individually within the media library. Each time an image is edited using the advanced settings provided by WordPress, you lose more theme compatibility and it further locks you in to a specific theme.</p>\n<h3>WordPress.com vs. Self-hosted WordPress</h3>\n<div id=\"attachment_21515\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WPcomWporg.png\" rel=\"prettyphoto[21488]\"><img class=\"wp-image-21515 size-full\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/WPcomWporg.png?resize=738%2C296\" alt=\"WPcomWporg\" /></a><p class=\"wp-caption-text\">WordPress.com and WordPress.org</p></div>\n<p>I understand why WordPress.com users would be so upset with the removal of these options. By default, they don&#8217;t have the ability to edit their theme&#8217;s CSS file. That is reserved as a paid upgrade. So these options give them a chance to override the styling within the theme without having the paid upgrade.</p>\n<p>For self-hosted WordPress users, there is no excuse. Image borders and padding should be controlled through the theme, not the advanced image editing options provided by WordPress. Despite the options making it easy to apply those changes to images, users are only hurting themselves by using them.</p>\n<p>I think the options for padding and image borders should stay removed from the self-hosted version of WordPress while restored on WordPress.com. In retrospect, these options should have never existed in the first place.</p>\n<p><strong>Do you think the image border width, color, and padding options should be restored to the self-hosted version of WordPress?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Apr 2014 01:37:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"Mike Little: WordPress 10th Anniversary: a Reflection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1929\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:171:\"http://journalized.zed1.com/archives/2013/05/27/wordpress-10th-anniversary-a-reflection/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-10th-anniversary-a-reflection\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:468:\"<p>I posted about <a href=\"http://mikelittle.org/wordpress-10th-anniversary/\">WordPress&#8217; 10th Anniversary</a> celebration and reflected on the last 10 years over on my new blog</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2013/05/27/wordpress-10th-anniversary-a-reflection/\">WordPress 10th Anniversary: a Reflection</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Mike Little: WordPress – A 10 year journey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1867\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"http://journalized.zed1.com/archives/2013/01/25/wordpress-a-10-year-journey/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-a-10-year-journey\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2530:\"<p><a href=\"http://journalized.zed1.com/wp-content/uploads/2013/01/wordpress-logo-notext-rgb.png\"><img class=\"size-thumbnail wp-image-1873 alignleft\" alt=\"WordPress logo\" src=\"http://journalized.zed1.com/wp-content/uploads/2013/01/wordpress-logo-notext-rgb-150x150.png\" width=\"150\" height=\"150\" /></a></p>\n<p>I find it hard to believe but it has now been <strong>ten years</strong> since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off what became the <a href=\"http://wordpress.org/\">WordPress</a> project!<br />\nFrom those humble beginnings of a simple unmaintained blogging platform (b2/Cafelog) to a world-beating open source CMS. B2/Cafelog was used by perhaps 2,000 bloggers. Now WordPress runs more than <a href=\"http://en.wordpress.com/stats/\">60 million sites</a> around the world. That&#8217;s over <a href=\"http://w3techs.com/technologies/overview/content_management/all\">17.5% of the web</a>!</p>\n<h2>WordPress Industry</h2>\n<p>WordPress now supports a world-wide industry from individual <a href=\"http://mikelittle.org/\">WordPress specialists</a> like me (I&#8217;ve just completed my fourth year as my own company <a href=\"http://zed1.com/\">zed1.com</a>); small WordPress-based companies like <a href=\"http://codeforthepeople.com/\">Code for the People</a>; through to multi-million dollar companies like <a href=\"http://www.copyblogger.com/\">Copyblogger</a>, <a href=\"http://www.woothemes.com/\">WooThemes</a>, and of course <a href=\"http://automattic.com/\">Automattic</a>.</p>\n<p>Praise must go as usual to the <a href=\"http://make.wordpress.org/\">fantastic community</a> around WordPress, the singular vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<h2>Here&#8217;s to the next year</h2>\n<p>As WordPress enters it&#8217;s <strong>eleventh</strong> year, with version 3.5.1 recently released and <a href=\"http://make.wordpress.org/core/\">version 3.6 currently in the making</a>, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2013/01/25/wordpress-a-10-year-journey/\">WordPress &#8211; A 10 year journey</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Mike Little: WordCamp Edinburgh UK 2012\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1856\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"http://journalized.zed1.com/archives/2012/05/29/wordcamp-edinburgh-uk-2012/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-edinburgh-uk-2012\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1650:\"<p><a href=\"http://journalized.zed1.com/wp-content/uploads/2012/05/wordcamp-edinburgh-header-1.png\"><img class=\"aligncenter size-full wp-image-1857\" title=\"wordcamp-edinburgh-header-1\" src=\"http://journalized.zed1.com/wp-content/uploads/2012/05/wordcamp-edinburgh-header-1.png\" alt=\"\" width=\"855\" height=\"330\" /></a></p>\n<p>Folks, if you are looking to attend WordCamp Edinburgh UK 2012, on the weekend of the 14th and 15th of July, you need to get your <a href=\"http://2012.edinburgh.wordcamp.org/tickets/\">tickets</a> pretty soon to qualify for the early bird price (£35).</p>\n<p>After midday this coming Friday (June 1st) the price will rise to £45. Mind you, that&#8217;s still a fantastic price for a <a href=\"http://2012.edinburgh.wordcamp.org/\"><strong>two-day weekend</strong> filled with WordPressy goodness</a> .</p>\n<p>I&#8217;ll be there of course, will you? It&#8217;s looking like a cracker with some <a href=\"http://wiki.wpuk.org/2012_content_ideas\">great ideas for sessions already put forward</a>. I&#8217;ll be running an extended session called <a href=\"http://2012.edinburgh.wordcamp.org/session/starting-out-with-wordpress/\">Starting Out with WordPress</a>. Once again, get your <a href=\"http://2012.edinburgh.wordcamp.org/tickets/\">tickets</a> soon.</p>\n<p>I look forward to seeing you there.</p>\n<p><a href=\"http://wpuk.org/\">WPUK</a> is organising this event.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/05/29/wordcamp-edinburgh-uk-2012/\">WordCamp Edinburgh UK 2012</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"Mike Little: WordPress is Nine. Happy Birthday WordPress!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1852\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"http://journalized.zed1.com/archives/2012/05/27/wordpress-is-nine-happy-birthday-wordpress/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-is-nine-happy-birthday-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1387:\"<p>Today is the ninth birthday of WordPress (the anniversary of the <a href=\"http://wordpress.org/news/2003/05/wordpress-now-available/\">first release</a>).</p>\n<p>WordPress still continues to astonish me in its phenomenal growth. Comparing to <a href=\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/\">this time last year</a>, WordPress now powers <a href=\"http://en.wordpress.com/stats/\">more than 74 million sites</a>, accounting for <a href=\"http://w3techs.com/technologies/overview/content_management/all\">more than 16% of the internet</a>.</p>\n<div>I&#8217;m looking forward to the next year in the world of WordPress. As usual there are lots of exciting things ahead. The first <a href=\"http://wpappstore.com/\">WordPress App Store</a> launched recently, and I&#8217;m sure there will be more (it looks like <a href=\"http://z1.tl/wpmudevdashboard\">WPMU Dev&#8217;s updater/dashboard</a> now lets you buy).</div>\n<div></div>\n<div>WordPress is really maturing and as a platform and as an industry. There is much more to come and I can&#8217;t wait.</div>\n<div></div>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/05/27/wordpress-is-nine-happy-birthday-wordpress/\">WordPress is Nine. Happy Birthday WordPress!</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"Mike Little: WordPress 3 for Business Bloggers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1847\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:159:\"http://journalized.zed1.com/archives/2012/03/11/wordpress-3-for-business-bloggers/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-for-business-bloggers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1071:\"<p>I&#8217;m currently reading <a href=\"http://www.packtpub.com/wordpress-3-for-business-bloggers/book\">WordPress 3 for Business Bloggers</a><a href=\"http://www.packtpub.com/wordpress-3-for-business-bloggers/book\"><img class=\"alignright\" title=\"WordPress 3 for Business Bloggers\" src=\"https://www.packtpub.com/sites/default/files/imagecache/productview/1322OS_WordPress%203%20for%20Business%20Bloggers_Frontcover.jpg\" alt=\"\" width=\"124\" height=\"152\" /></a> by Paul Thewlis. I&#8217;m trying to squeeze it in between all the other stuff I seem to have on my plate. I read the first edition of the book a couple of years ago (though I can&#8217;t find my review to point to); so I&#8217;m looking forward to this one.</p>\n<p>I&#8217;ll post a proper review when I&#8217;ve finished it.</p>\n<p>&nbsp;</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/03/11/wordpress-3-for-business-bloggers/\">WordPress 3 for Business Bloggers</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Mike Little: WordPress – 9 years since it’s conception\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1836\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"http://journalized.zed1.com/archives/2012/01/25/wordpress-9-years-since-its-conception/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-9-years-since-its-conception\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2138:\"<p>Simon D <a title=\"Simon\'s tweet\" href=\"https://twitter.com/#!/simond/status/162125708506832896\">reminded me</a> that it is now nine years since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off this whole WordPress thing!</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>Nine years ago today @<a href=\"https://twitter.com/mikelittlezed1\">mikelittlezed1</a> floated an idea which eventually became WordPress. <a href=\"https://twitter.com/search/%23thanksmike\">#thanksmike</a> <a href=\"http://t.co/teYbVHX8\" title=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">ma.tt/2003/01/the-bl…</a></p>\n<p>&mdash; Simon Dickson (@simond) <a href=\"https://twitter.com/simond/status/162125708506832896\">January 25, 2012</a></p></blockquote>\n<p></p>\n<p>WordPress is really shaping up, and is an evermore stable and functional CMS platform. The statistics continue to astonish me, with more than <a href=\"http://en.wordpress.com/stats/\">70 million sites</a> around the world. That&#8217;s nearly <a href=\"http://w3techs.com/technologies/overview/content_management/all\">16% of the web</a>!</p>\n<p>WordPress is supporting a whole industry of WordPress experts, including me: I&#8217;m just starting my fourth year as an <a href=\"http://zed1.com/\">independent WordPress specialist</a>.</p>\n<p>Praise must go as usual to the fantastic community around WordPress, the singular vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<p>With version 3.4 currently in the making, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2012/01/25/wordpress-9-years-since-its-conception/\">WordPress &#8211; 9 years since it&#8217;s conception</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Mike Little: WordPress’ Eighth Birthday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1813\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:143:\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-eighth-birthday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1737:\"<p>Today is WordPress&#8217; official eighth birthday (the anniversary of the <a href=\"http://wordpress.org/news/2003/05/wordpress-now-available/\">first release</a>).</p>\n<p>I still marvel at the incredible distance it has come. I&#8217;m also still proud that I had a part in its birth. But even more, I marvel at the wonderful contribution of all the WordPress community make to this fantastic project.</p>\n<p>A client said to me this morning &#8220;This WordPress is brilliant isn&#8217;t it?&#8221; As I helped him set up his fourth WordPress site. You can&#8217;t get much clearer praise than that.</p>\n<p>So raise a virtual beer (or other non-alcoholic beverage if, like me, you are teetotal) to WordPress, the community, and to another year.</p>\n<p><strong>Update:</strong> I just spotted this tweet from <a href=\"http://twitter.com/#!/nacin\">Andrew Nacin</a>:</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>At more than 20 million WordPress.com blogs, that puts WordPress at north of 45 million sites. Wowza. Happy birthday indeed.</p>\n<p>&mdash; Andrew Nacin (@nacin) <a href=\"https://twitter.com/nacin/status/74139775761793024\">May 27, 2011</a></p></blockquote>\n<p></p>\n<p>Wow! 25 million <a href=\"http://wordpress.org/\">standalone WordPress</a> sites plus 20 million <a href=\"http://WordPress.com\">WordPress.com</a> sites! No wonder it <a href=\"http://w3techs.com/technologies/overview/content_management/all\">powers more than 14 percent of the web</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2011/05/27/wordpress-eighth-birthday/\">WordPress&#8217; Eighth Birthday</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"Mike Little: WordPress – 8 Years in the making\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1748\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:155:\"http://journalized.zed1.com/archives/2011/01/27/wordpress-8-years-in-the-making/?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-8-years-in-the-making\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2038:\"<p>Wow! Another year has passed and it is now eight years since my fateful <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">comment on Matt&#8217;s blog </a>that kicked off this whole WordPress thing!</p>\n<p>WordPress is now a mature CMS platform driving <a href=\"http://w3techs.com/technologies/overview/content_management/all\">13% of the web</a>! It is used for an <a href=\"http://wordpress.org/showcase/\">astonishing array</a> of very different web sites around the world, from the humblest one person blog to <a title=\"I\'m a Scientist, Get me out of here!\" href=\"http://imascientist.org.uk/\">award-winning education sites</a>, <a title=\"The New Adventures of Stephen Fry\" href=\"http://www.stephenfry.com/\">celebrity sites</a>, <a title=\"The New York Times blogs\" href=\"http://www.nytimes.com/interactive/blogs/directory.html\">newspapers</a>, and even <a title=\"The official site of the Prime Minister\'s Office\" href=\"http://www.number10.gov.uk\">world leaders</a>!</p>\n<p>WordPress is supporting a whole industry of <a title=\"WordPress consultants\" href=\"http://codepoet.com/\">WordPress experts</a>, including me: I&#8217;m now in my third year as an <a href=\"http://zed1.com/\">independent WordPress specialist</a>.</p>\n<p>I believe that WordPress has achieved this massive success in no small way because of the fantastic community around it, the keen-eyed vision of <a href=\"http://ma.tt/\">Matt Mullenweg</a>, and the awesome power of the <a title=\"GNU General Public License\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GPL</a> open source license.</p>\n<p>With version 3.1 just around the corner, I predict it will be another great year for <a title=\"Personal Publishing Platform\" href=\"http://wordpress.org\">WordPress</a>.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2011/01/27/wordpress-8-years-in-the-making/\">WordPress &#8211; 8 Years in the making</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"Mike Little: WordCamp slides featured on Slideshare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1523\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"http://journalized.zed1.com/archives/2010/07/21/wordcamp-slides-featured-on-slideshare/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-slides-featured-on-slideshare\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1285:\"<p>The slides from <a href=\"http://www.slideshare.net/mikelittle/wordcamp-2010-im-a-scientist-get-me-out-of-here-mike-little\">my presentation at WordCamp UK</a> in Manchester over the weekend are now on SlideShare. I presented on the fantastic <a href=\"http://imascientist.org.uk/\">I&#8217;m a Scientist Get me Out of Here</a> project website I have built for <a href=\"http://www.gallomanor.com/\">Gallomanor</a> this year.</p>\n<p>It&#8217;s best to read the notes in the &#8220;Notes on slide x&#8221; tab so that everything makes sense! I also link to some of the plugins I used at the end.</p>\n<p>Amazingly, the presentation features on the <a href=\"http://www.slideshare.net/\">SlideShare home page</a> today along with a couple of other presentations from <a href=\"http://uk.wordcamp.org/\">WordCamp UK</a>! See the &#8220;featured&#8221; section in the right hand column. Woo Hoo!</p>\n<p>I have still to finish my write-up of the weekend, but will hopefully get that done &#8216;real soon&#8217;.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2010/07/21/wordcamp-slides-featured-on-slideshare/\">WordCamp slides featured on Slideshare</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Mike Little: WordCamp UK A Few Places Left\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://journalized.zed1.com/?p=1519\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:153:\"http://journalized.zed1.com/archives/2010/07/15/wordcamp-uk-a-few-tickets-left/?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-uk-a-few-tickets-left\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1313:\"<p>For those of you thinking you may have missed out on this coming weekend&#8217;s WordPress fun at <a href=\"http://uk.wordcamp.org/\">WordCamp UK</a> in Manchester, think again!</p>\n<p>As the tickets did not completely sell out, we are making the last few available on the door, as we did last year.</p>\n<p>You must email me (mike at my domain ) to reserve a ticket, and then turn up on Saturday morning with your £30 cash.</p>\n<p>To recap, WordCamp UK is this weekend, July 17th and 18th, at the <a href=\"http://www.business.mmu.ac.uk/\">Manchester Metropolitan University Business School</a> which is in Manchester city centre, a few minutes walk from the main Piccadilly train Station.</p>\n<p>There are <a href=\"http://wiki.wordcampuk.tonyscott.org.uk/2010_running_order\">four simultaneous tracks</a> : General &amp; user, Specialist &amp; developer, Miscellaneous &amp; spontaneous and a &#8216;Genius Bar&#8217; (a range of WordPress experts available to advice attendees on a one-to-one basis).</p>\n<p>I look forward to seeing you there.</p>\n<p>The post <a rel=\"nofollow\" href=\"http://journalized.zed1.com/archives/2010/07/15/wordcamp-uk-a-few-tickets-left/\">WordCamp UK A Few Places Left</a> appeared first on <a rel=\"nofollow\" href=\"http://journalized.zed1.com\">Mike Little&#039;s Journalized</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Mike Little\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: WordPress Projects Announced for Google Summer of Code 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21492\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:182:\"http://wptavern.com/wordpress-projects-announced-for-google-summer-of-code-2014?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-projects-announced-for-google-summer-of-code-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2585:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/gsoc2014.png\" rel=\"prettyphoto[21492]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/gsoc2014.png?resize=924%2C156\" alt=\"gsoc2014\" class=\"aligncenter size-full wp-image-21501\" /></a></p>\n<p>Earlier this year, WordPress was <a href=\"http://wptavern.com/wordpress-accepted-as-a-mentoring-organization-for-google-summer-of-code-2014\" target=\"_blank\">accepted</a> as one of 190 mentoring organizations for <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2014\" target=\"_blank\">Google Summer of Code 2014</a>. This year marks the 10th annual GSoC and WordPress&#8217; 7th year participating in the program. Five students have been <a href=\"http://make.wordpress.org/community/2014/04/21/gsoc-students-accepted/\" target=\"_blank\">accepted</a> and will soon begin work on some exciting projects:</p>\n<ul>\n<li><a href=\"http://profiles.wordpress.org/secretmapper\" target=\"_blank\">Arian Allenson M. Valdez</a> — Working on GlotPress UI and profiles with Yoav Farhi and Marko Heijnen as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/gautamgupta\" target=\"_blank\">Gautam Gupta</a> — Working on bbPress improvements with John James Jacoby and Stephen Edgar as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/avryl\" target=\"_blank\">Janneke Van Dorpe</a> — Working on front-end editing/content blocks with Gregory Cornelius and Aaron Jorbin as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/celloexpressions\" target=\"_blank\">Nick Halsey</a> — Working on adding custom menus to the customizer with Erick Hitter and Konstantin Obenland as mentors</li>\n<li><a href=\"http://profiles.wordpress.org/VarunAgw\" target=\"_blank\">Varun Agrawal</a> — Working on SupportPress as a plugin with Ian Dunn, Aaron Campbell, and Alex Mills as mentors</li>\n</ul>\n<p>The students selected to participate are all very talented and enthusiastic. In fact, several of them are already active in contributing to WordPress core and have several plugins hosted in the directory.</p>\n<p>GSoC 2014 kicks off May 19th when the students will begin their summer coding adventures. In the meantime, they will be bonding with their mentoring teams and working to nail down the scope of their projects. Jen Mylo, who is coordinating WordPress&#8217; involvement in the GSoC, will be working with the teams to set up some livestreamed prototype demos at midterm. Students will also be posting on a weekly basis and we&#8217;ll be following the progress on their projects throughout the summer.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 20:15:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: 13 Vagrant Resources for WordPress Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21194\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"http://wptavern.com/13-vagrant-resources-for-wordpress-development?utm_source=rss&utm_medium=rss&utm_campaign=13-vagrant-resources-for-wordpress-development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8683:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/vagrant.png\" rel=\"prettyphoto[21194]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/vagrant.png?resize=1025%2C463\" alt=\"vagrant\" class=\"aligncenter size-full wp-image-21435\" /></a></p>\n<p><a href=\"http://www.vagrantup.com/\" target=\"_blank\">Vagrant</a> is an open source tool that makes it easy to configure and distribute virtual development environments. The project was started in 2010 by Mitchell Hashimoto and John Bender who wanted to create a way to standardize development environments for teams. Vagrant was designed to put an end to the &#8220;works on my machine&#8221; frustration that often surfaces when teams develop on different environments.</p>\n<p>Because it&#8217;s so lightweight and portable, many WordPress developers have adopted Vagrant for development, which has resulted in different tools and configurations for various project needs. We&#8217;ve collected a few WordPress-related Vagrant resources here that will help you get started.</p>\n<h3>Varying Vagrant Vagrants</h3>\n<p><a href=\"https://github.com/Varying-Vagrant-Vagrants/VVV\" target=\"_blank\">Varying Vagrant Vagrants</a> is one of the most widely used and best-supported Vagrant configurations for WordPress development. Originally created by the folks at <a href=\"http://10up.com/\" target=\"_blank\">10up</a>, the open source VVV project <a href=\"http://10up.com/blog/varying-vagrant-vagrants-future/\" target=\"_blank\">became a community organization</a> earlier this year. The company still contributes to its development and maintenance, helping to make it one of the most stable options for setting up a Vagrant-based WordPress development environment. VVV provides a comprehensive configuration for developing themes and plugins as well as for contributing to WordPress core.</p>\n<h3>VVV Site Wizard</h3>\n<p>If you&#8217;re a VVV user who is often creating and removing sites, then the <a href=\"https://github.com/aliso/vvv-site-wizard\" target=\"_blank\">VVV Site Wizard</a> may be able to save you some time. It completely automates the creation of new sites as well as the teardown of old ones.</p>\n<h3>WordPress Theme Review VVV</h3>\n<p>If you&#8217;re a VVV user who spends quite a bit of time developing WordPress themes, this is a quick Vagrant setup that adds all the necessary tools for reviewing themes. <a href=\"https://github.com/aubreypwd/wordpress-themereview-vvv\" target=\"_blank\">WordPress Theme Review VVV</a> creates a fresh WordPress site, installs and activates the Developer and Theme-Check plugins, and imports the Theme Unit Test data. Check out our <a href=\"http://wptavern.com/wordpress-theme-review-vvv-a-quick-vagrant-setup-for-testing-and-reviewing-themes\" target=\"_blank\">tutorial</a> for a quick walkthrough on setting it set up.</p>\n<h3>Primary Vagrant</h3>\n<p><a href=\"https://github.com/ChrisWiegman/Primary-Vagrant\" target=\"_blank\">Primary Vagrant</a> is a configuration created by Chris Wiegman. It&#8217;s similar to VVV but with a few important differences: it uses Apache instead of NGINX and Puppet instead of Bash. Wiegman used VVV and Puppet as a base for a new Vagrant configuration for WordPress plugin or theme development. Primary Vagrant supports Apache and MySQL on Ubuntu and allows for use of different major PHP versions (currently 5.3 – 5.5), which can be easily changed with one line of code.</p>\n<h3>VagrantPress</h3>\n<p><a href=\"https://github.com/chad-thompson/vagrantpress\" target=\"_blank\">VagrantPress</a> is a simple configuration that sets up a WordPress development environment using Apache with Vagrant/Puppet. It&#8217;s geared toward developing themes and plugins. VagrantPress currently does not allow for multiple installations but Chat Thompson, the project&#8217;s creator, <a href=\"http://wptavern.com/vagrantpress-a-wordpress-development-environment-for-themes-and-plugins#comment-53714\" target=\"_blank\">plans to add more features</a> related to automating the provisioning and maintenance of multiple WordPress installations.</p>\n<h3>Chassis</h3>\n<p><a href=\"https://github.com/Chassis/Chassis\" target=\"_blank\">Chassis</a> uses Vagrant and Puppet to create a development environment running Ubuntu, Ngnix, PHP 5.4, Imagick, MySQL, Xdebug, WP-CLI, and WordPress, a setup which more closely matches many managed WP hosting environments. Chassis makes it easy to add additional testing domains via a YAML configuration file. It also has support for WordPress multisite, which can be enabled in config.local.yaml or the project configuration file.</p>\n<h3>WordPress and Vagrant Google Group</h3>\n<p><a href=\"https://groups.google.com/forum/#!forum/wordpress-and-vagrant\" target=\"_blank\">WordPress and Vagrant</a> is a public Google group that you can join to post basic or advanced questions about using Vagrant for development. This can be a helpful resource for troubleshooting some unique issues concerning Vagrant-based WordPress development environments. Most of the threads seem to be about working with VVV, but the group isn&#8217;t specifically limited.</p>\n<h3>WordPress Vagrant Boxes</h3>\n<p><a href=\"https://github.com/tierra/wp-vagrant\" target=\"_blank\">WordPress Vagrant Boxes</a> is a Vagrant configuration that uses Apache. Although the web server is preconfigured to look for WordPress in a specific location, WordPress Vagrant Boxes is unique in that it doesn&#8217;t checkout or install WordPress at all. It&#8217;s up to you to unpack and install a WordPress ZIP, checkout from SVN, or clone from git.</p>\n<h3>VCCW (vagrant-chef-centos-wordpress)</h3>\n<p><a href=\"https://github.com/miya0001/vagrant-chef-centos-wordpress\" target=\"_blank\">VCCW</a> (Vagrant + Chef + CentOS + WordPress) was configured for those developing WordPress plugins, themes or websites. It includes 17 customizable constants for setting the WordPress version (or beta release), language, hostname, subdirectory, admin credentials, default plugins, default theme, multisite, SSL and other options. These constants give you a lot of flexibility in tailoring your development environment to your specific needs.</p>\n<h3>Throwaway WordPress VMs with Vagrant and Ansible</h3>\n<p><a href=\"https://github.com/jalefkowit/vagrant-ansible-wordpress\" target=\"_blank\">Throwaway WordPress VMs</a> uses Vagrant and <a href=\"http://www.ansible.com/home\" target=\"_blank\">Ansible</a> to automate the process of creating and provisioning local virtual machines for WordPress development. The scripts were designed for use with Ubuntu, but you can select any version of Ubuntu you wish to use, or a base box from <a href=\"http://www.vagrantbox.es/\" target=\"_blank\">vagrantbox.es</a>.</p>\n<h3>WordPress Machine</h3>\n<p><a href=\"https://github.com/audionerd/wordpress-machine\" target=\"_blank\">WordPress Machine</a> sets up WordPress on a LAMP stack. It also includes Composer, <a href=\"http://wp-cli.org/\" target=\"_blank\">WP-CLI</a>, and <a href=\"http://forge.thethemefoundry.com/\" target=\"_blank\">Forge</a> for WordPress theme setup and asset compilation (SCSS, CoffeeScript). This configuration runs <a href=\"http://ajk.fi/2013/wordpress-as-a-submodule/\" target=\"_blank\">WordPress as a submodule</a> using <a href=\"https://github.com/Darep/wordpress-boilerplate\" target=\"_blank\">WordPress Boilerplate</a>, which means that themes, plugins and uploads are separated from the WordPress installation so that WP can be easily updated as a git submodule.</p>\n<h3>Monkey Rocket</h3>\n<p>The developer who created <a href=\"https://github.com/Cikica/monkeyrocket\" target=\"_blank\">Monkey Rocket</a> used much of the code from VVV, which he found installed more things than he needed for a simple development environment. This Vagrant configuration is basically a stripped down version of VVV that will set you up with the latest stable version of WordPress at local.wordpress.dev on your machine.</p>\n<h3>WordPress Kickstart</h3>\n<p><a href=\"https://github.com/jnettome/wordpress_kickstart\" target=\"_blank\">WordPress Kickstart</a> is a Vagrant development environment provisioned by Puppet. It was created for use with production stacks that are hosted on <a href=\"https://www.digitalocean.com/\" target=\"_blank\">DigitalOcean</a>. Once you enter your DigitalOcean API credentials into the vagrantfile, you&#8217;ll have a command available for working on production deployment and provisioning. This command allows you to create a new droplet, setup your SSH key for authentication, create a new user account, and run the provisioners configured. You can easily switch back and forth from production to development by removing .vagrant/ from your project&#8217;s root folder.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 14:19:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: WPWeekly Episode 146 – WordPress 3.9 With Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=21420&preview_id=21420\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:168:\"http://wptavern.com/wpweekly-episode-146-wordpress-3-9-with-andrew-nacin?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-146-wordpress-3-9-with-andrew-nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2175:\"<p>In this weeks edition of WordPress Weekly, we discussed several topics with WordPress lead developer <a href=\"http://nacin.com/\" title=\"http://nacin.com/\">Andrew Nacin</a>. Ever since the release of WordPress 3.7, many have questioned why auto updates are turned on by default for minor and security updates. Nacin described the philosophy behind the auto update system and why the team will be sticking with its current implementation.</p>\n<p>We also learned the details behind the release of a major security update to Jetpack. Last but not least, Nacin describes what it was like to lead the release of 3.9 and what he&#8217;ll be focusing on now that he won&#8217;t be leading a release cycle.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/wordpress-3-9-smith-released\" title=\"http://wptavern.com/wordpress-3-9-smith-released\">WordPress 3.9 “Smith” Released</a><br />\n<a href=\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\" title=\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\">WordPress 3.9 Has Built-In Support for Pasting from Microsoft Word</a><br />\n<a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" title=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\">BuddyPress 2.0 Released: Big Performance Improvements and New Administration Tools</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, April 25th 3 P.M. Eastern &#8211; Special Guest &#8211; Japh</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #146:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 14:29:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Andrew: Customizing TinyMCE 4.0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://azaozz.wordpress.com/?p=380\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://azaozz.wordpress.com/2014/04/19/customizing-tinymce-4-0/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2358:\"<p>Many of the TinyMCE settings have changed in version 4.0. There is a new default theme: Modern, and all the UI settings for the former Advanced theme (<code>theme_advanced...)</code> are deprecated.</p>\n<p>One often used setting was <code>theme_advanced_blockformats</code><strong><code>.</code></strong> It was renamed to <code>block_formats</code> and keeps the same formatting. To specify a different set of elements for the &#8216;blockformats&#8217; drop-down (second toolbar row in the WordPress Visual editor), you can set a string of name=value pairs separated by a semicolon in the initialization object:</p>\n<pre class=\"brush: jscript; title: ; notranslate\">block_formats: \"Paragraph=p;Heading 1=h1;Heading 2=h2;Heading 3=h3\"</pre>\n<p>Another handy setting: <code>theme_advanced_styles</code> doesn&#8217;t exist any more. However there is a more powerful version: <code>style_formats</code>. Now it can replace or add items to the new &#8220;Formats&#8221; menu.The value is an array of objects each containing a name that is displayed as sub-menu and several settings: a CSS class name or an inline style, and optionally the wrapper element where the class or inline style will be set:</p>\n<pre class=\"brush: jscript; title: ; notranslate\">\ntoolbar3: \'styleselect\',\nstyle_formats_merge: true,\nstyle_formats: { name: \'Custom styles\', [\n  {title: \'Red bold text\', inline: \'b\', styles: {color: \'#ff0000\'}},\n  {title: \'Red text\', inline: \'span\', styles: {color: \'#ff0000\'}},\n  {title: \'Red header\', block: \'h1\', styles: {color: \'#ff0000\'}},\n  {title: \'Example 1\', inline: \'span\', classes: \'example1\'},\n  {title: \'Example 2\', inline: \'span\', classes: \'example2\'}\n]}\n</pre>\n<p>The above code will add another sub-menu to &#8220;Formats&#8221; without replacing the default menu items. There is <a href=\"http://www.tinymce.com/wiki.php/Configuration:style_formats\">more information</a> and an <a href=\"http://www.tinymce.com/tryit/custom_formats.php\">example</a> on the TinyMCE website.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/azaozz.wordpress.com/380/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/azaozz.wordpress.com/380/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=azaozz.wordpress.com&blog=3380945&post=380&subd=azaozz&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 07:04:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Quotable: Highlight and Share WordPress Posts on Twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:174:\"http://wptavern.com/quotable-highlight-and-share-wordpress-posts-on-twitter?utm_source=rss&utm_medium=rss&utm_campaign=quotable-highlight-and-share-wordpress-posts-on-twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3084:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable.png\" alt=\"quotable\" width=\"772\" height=\"250\" class=\"aligncenter size-full wp-image-21403\" /></a></p>\n<p>Readers may not always identify with the title that you&#8217;ve chosen for your posts but they may find a gem within your article that is more &#8220;quotable&#8221; and worth sharing. <a href=\"http://wordpress.org/plugins/quotable/\" target=\"_blank\">Quotable</a> is a new WordPress plugin that capitalizes on this, allowing readers to highlight any text within your content to quote the article on Twitter.</p>\n<p>The plugin, developed by <a href=\"http://josiahsprague.com/\" target=\"_blank\">Josiah Sprague</a>, was partially inspired by the toolbar on Medium.com that enables visitors to tweet or comment on the text they select. Sprague said that he created it out of his love for both WordPress and Twitter:</p>\n<blockquote><p> I love how both platforms make it easy for people to share ideas and communicate openly and freely. I love that both serve as a sort of “public square” of the web and support discourse, democracy and free society.</p></blockquote>\n<p>Quotable adds a tiny Twitter icon to the end of blockquotes for quick sharing.  It also works with text highlighting. Readers will often instinctively highlight text that they agree with or are wanting to share. When they do, they&#8217;ll naturally discover that it&#8217;s easy to share.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable2.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable2.png\" alt=\"quotable2\" width=\"916\" height=\"458\" class=\"aligncenter size-full wp-image-21405\" /></a></p>\n<p>When you click the Twitter bird, a tweet modal will automatically launch with the quoted text inserted. Quotable also integrates with Twitter accounts configured via Yoast&#8217;s WordPress SEO, which allows you to include Twitter mentions for post authors and suggest following the website&#8217;s Twitter account.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/quotable-1.png\" rel=\"prettyphoto[21400]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/quotable-1.png\" alt=\"quotable-1\" width=\"1400\" height=\"1360\" class=\"aligncenter size-full wp-image-21404\" /></a></p>\n<p>Let&#8217;s face it &#8211; the comments section of your post is not always the locus of the conversation sparked by your blog. Even if your post is the origin of a hotly debated topic, the conversation often moves to Twitter, and that&#8217;s OK. This plugin helps you to be ready to follow the conversation wherever it goes, especially if you configure it to automatically mention you, the post author, when a quote gets tweeted.</p>\n<p>I tested Quotable with WordPress 3.9 and found that it works as advertised and fits naturally into any theme without being obtrusive. <a href=\"http://wordpress.org/plugins/quotable/\" target=\"_blank\">Download</a> it for free from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 23:10:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Akismet: New in 3.0: Activation with Jetpack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1308\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://blog.akismet.com/2014/04/18/activation-with-jetpack/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2091:\"<p>We launched <a href=\"http://blog.akismet.com/2014/04/15/akismet-3-0-0/\" title=\"Akismet 3.0.0 is Now Available\">Akismet 3.0</a> just a few days ago and hope that you&#8217;ve already upgraded to enjoy its many new features. One of the nifty items we added to the mix is a seamless activation process using the popular <a href=\"http://wordpress.org/plugins/jetpack/\" title=\"Jetpack by WordPress.com\">Jetpack</a> plugin.</p>\n<p>Let&#8217;s take a closer look.</p>\n<p>If you have Jetpack and Akismet installed and activated on your site &#8211; and the Jetpack plugin connected to a <a href=\"http://wordpress.com\" title=\"WordPress.com\">WordPress.com</a> account &#8211; you will find this new feature in your dashboard via <strong>Jetpack &#8594; Akismet</strong>.</p>\n<p>There, you will see which WordPress.com account is connected via Jetpack and an option to activate the Akismet plugin using that very same account.</p>\n<p><a href=\"http://akismet.files.wordpress.com/2014/04/akismet-activation-with-jetpack.png\"><img src=\"http://akismet.files.wordpress.com/2014/04/akismet-activation-with-jetpack.png?w=640&h=263\" alt=\"Akismet Activation with Jetpack\" class=\"alignnone size-large wp-image-1348\" /></a></p>\n<p>Click on <strong>Use this Akismet account</strong>, and you&#8217;re all set! Of course, you will have the option to disconnect the account at any time from the same page in your dashboard.</p>\n<p>And if you want to use a different account to activate Akismet, no worries at all. Simply select the option to register a different email address or manually enter an existing API key.</p>\n<p>Digging the new flow? Any problems with it? <a href=\"http://akismet.com/contact/\" title=\"Contact Akismet\">Drop us a line</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1308/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1308/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1308&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 19:40:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Anthony Bubel\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordPress 3.9 Has Built-in Support for Pasting from Microsoft Word\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21366\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-9-has-built-in-support-for-pasting-from-microsoft-word\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2744:\"<div id=\"attachment_21384\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/paste.png\" rel=\"prettyphoto[21366]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/paste.png\" alt=\"photo credit: This Year\'s Love - cc\" width=\"900\" height=\"401\" class=\"size-full wp-image-21384\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/hand-nor-glove/1481913840/\">This Year&#8217;s Love</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<p>A common support question that&#8217;s been popping up on the web after WordPress users update to 3.9: <strong>What happened to the &#8220;Paste from Word&#8221; button in the visual editor?</strong> If you find that the button is missing, don&#8217;t worry &#8211; it&#8217;s not a bug.  Prior to this update, the button was located in the kitchen sink of the visual editor:</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/paste-from-word.png\" rel=\"prettyphoto[21366]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/paste-from-word.png\" alt=\"paste-from-word\" width=\"622\" height=\"233\" class=\"aligncenter size-full wp-image-21370\" /></a></p>\n<p>WordPress 3.9, however, <a href=\"https://core.trac.wordpress.org/changeset/28089\" target=\"_blank\">removes the &#8220;paste from word&#8221; button</a> entirely. It includes <a href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\" target=\"_blank\">TinyMCE 4.0</a> and has better built-in support for pasting in blocks of text for Microsoft Word. The better your software gets, the more the magic happens behind the scenes. WordPress now detects if the pasted text is coming from MS Word and makes the appropriate changes.</p>\n<p>Until I saw the <a href=\"http://www.reddit.com/r/Wordpress/comments/23ah5d/copy_from_word_button_went_missing/\" target=\"_blank\">question</a> on Reddit, indicating that the button had gone missing, I had no idea that anyone still used this feature. The missing button is actually an enhancement, not a bug. Hopefully this information has reached you before you started deactivating all your plugins.</p>\n<p>Unless you had been closely following the posts at <a href=\"http://make.wordpress.org\" target=\"_blank\">make.wordpress.org</a>, this improvement might have been easy to miss. Check out our <a href=\"http://wptavern.com/wordpress-3-9-smith-released\" target=\"_blank\">summary of everything that&#8217;s new in WordPress 3.9</a>. If you&#8217;re having any problems with the update, you may want to review some of the <a href=\"http://wptavern.com/common-issues-and-troubleshooting-wordpress-3-9\" target=\"_blank\">known issues</a> with plugins before posting in the support forums.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 17:53:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: How to Limit Activity Comment Depth in BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21347\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:162:\"http://wptavern.com/how-to-limit-activity-comment-depth-in-buddypress?utm_source=rss&utm_medium=rss&utm_campaign=how-to-limit-activity-comment-depth-in-buddypress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2642:\"<p>BuddyPress 2.0 was <a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" target=\"_blank\">released</a> this week with many new administrative tools that make it easier to manage communities from the backend. One of the lesser known new features is the ability to limit comment depth in the activity stream.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/old-threaded-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/old-threaded-comments-300x258.png\" alt=\"old-threaded-comments\" width=\"300\" height=\"258\" class=\"alignright size-medium wp-image-21351\" /></a>Activity threads can sometimes get out of control when it comes to replies, which results in the comments box getting progressively squished to an inconveniently small size.</p>\n<p>In the past, the only way to change the comment depth was to filter the output of the bp_activity_can_comment_reply() function, but this wasn&#8217;t very user-friendly for community managers.</p>\n<p>Since WordPress already has a built-in setting for comment depth, this was a natural fit for activity comments and did not require adding any new settings. BuddyPress 2.0 now <a href=\"https://buddypress.trac.wordpress.org/ticket/2768\" target=\"_blank\">respects WordPress&#8217; comment depth settings</a>. You can adjust them in the admin at <strong>Settings > Discussion > Other Comment Settings</strong>.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/threaded-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/threaded-comments.png\" alt=\"threaded-comments\" width=\"1200\" height=\"397\" class=\"aligncenter size-full wp-image-21349\" /></a></p>\n<p>In the following example, threaded comments have been set to three. You&#8217;ll notice that the third comment has no reply link beneath it. Members can still comment on the activity item itself but will not be able to add more than three replies.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/activity-comments.png\" rel=\"prettyphoto[21347]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/activity-comments.png\" alt=\"activity-comments\" width=\"900\" height=\"680\" class=\"aligncenter size-full wp-image-21355\" /></a></p>\n<p>This update shouldn&#8217;t affect the structure of your previous activity comments/replies, but it will be in effect for threaded comments moving forward. If you&#8217;ve been itching to to limit activity comment depth on your BuddyPress site, this new setting makes it easy to set a limit, without having to touch any code.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 06:42:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Cédric Motte : Sans contenu, WordPress n’est rien\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34325\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.tv/2014/04/17/cedric-motte-sans-contenu-wordpress-nest-rien/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:673:\"<div id=\"v-4WgeuUC1-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34325/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34325/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34325&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/17/cedric-motte-sans-contenu-wordpress-nest-rien/\"><img alt=\"13 &#8211; Cedric Motte-Conf-WCParis2014.mp4\" src=\"http://videos.videopress.com/4WgeuUC1/video-88337de484_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 21:58:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: Automattic Publishes Transparency Report, Reaffirms Support for Freedom of Speech\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21275\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:224:\"http://wptavern.com/automattic-publishes-transparency-report-reaffirms-support-for-freedom-of-speech?utm_source=rss&utm_medium=rss&utm_campaign=automattic-publishes-transparency-report-reaffirms-support-for-freedom-of-speech\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5451:\"<p>Automattic was created to bring WordPress&#8217; open source publishing software to people on a larger scale. The company shares <a href=\"http://codex.wordpress.org/WordPress_Policies\" target=\"_blank\">WordPress&#8217; mission</a> to democratize publishing. As part of that mission, Automattic published a transparency report, which outlines the number of information requests, takedown demands, and national security requests it has received.</p>\n<p>The <a href=\"http://transparency.automattic.com/\" target=\"_blank\">Transparency Report</a> is located on a new site which helps users to navigate what will likely become a large archive of information, as Automattic plans to publish a new report every six months. This report will keep users informed about which governments are making requests and policies for responding to them.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/transparency-report.jpg\" rel=\"prettyphoto[21275]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/transparency-report.jpg\" alt=\"transparency-report\" width=\"1280\" height=\"664\" class=\"aligncenter size-full wp-image-21310\" /></a></p>\n<p>Writing on behalf of Automattic, Jenny Zhu <a href=\"http://en.blog.wordpress.com/2014/04/17/transparency-report/\" target=\"_blank\">summarized</a> the company&#8217;s policy regarding information requests:</p>\n<blockquote><p>Our policy is to notify you of any information request we receive regarding your account, so that you may challenge the request. The only exception is if we are prohibited by law (not just asked nicely by the police) from making such a notification. </p></blockquote>\n<h3>Automattic is Committed to Actively Pushing Back Against Requests That Violate Freedom of Speech</h3>\n<p>Historically, Automattic has demonstrated its support for freedom of speech by <a href=\"http://en.blog.wordpress.com/2010/07/01/support-the-first-amendment-with-1-for-all/\" target=\"_blank\">raising awareness about the First Amendment</a>, even taking to the courts <a href=\"http://en.blog.wordpress.com/2013/11/21/striking-back-against-censorship/\" target=\"_blank\">to stand with users against DMCA abuse</a>. The company also recently joined forces with other organizations around the globe to <a href=\"http://wptavern.com/wordpress-com-joins-google-reddit-and-tumblr-in-protesting-nsa-surveillance\" target=\"_blank\">protest NSA surveillance</a>.</p>\n<p>Through its statement today, Automattic emphasized that it will push back against requests that constitute infringements on freedom of speech:</p>\n<blockquote><p>We also carefully review all legal requests we receive and actively push back on those that are procedurally deficient, overly-broad, or otherwise improper (i.e., those that target non-criminal free speech).</p></blockquote>\n<h3>The US Government Represents 60% of the Information Requests</h3>\n<p>Russia, not known for its support of free press, leads the way in <a href=\"http://transparency.automattic.com/takedown-demands/\" target=\"_blank\">takedown demands</a> with 88% of the total requests received by WordPress.com. The United States, however, far and away leads in the number of user <a href=\"http://transparency.automattic.com/information-requests/\" target=\"_blank\">information requests</a> from governments and law enforcement agencies from July 1 – December 31, 2013.</p>\n<p>While most of the countries listed have submitted a handful of requests, the US government sent 20 requests, specifying 29 different sites. In 60% of those requests, some or all information was produced. The requests shown here do not include those related to litigation and civil proceedings.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/information-requests.jpg\" rel=\"prettyphoto[21275]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/information-requests.jpg\" alt=\"information-requests\" width=\"753\" height=\"736\" class=\"aligncenter size-full wp-image-21315\" /></a></p>\n<p>Automattic specifies that the company will only turn over private user information upon receipt of valid US legal process. Requests that originate from outside the US are required to be served through a US court or enforcement agency.</p>\n<p>The company is not permitted to disclose very much regarding national security requests, despite wishing they could:</p>\n<blockquote><p>Finally, we’re reporting the maximum amount of information allowed by law about the number and type(s) of National Security Requests that we received. The disclosures we’re currently allowed to make are limited, and unfortunately, we’re not permitted to paint a more truthful picture.</p></blockquote>\n<p>The <a href=\"http://transparency.automattic.com/\" target=\"_blank\">Transparency Report</a> makes it clear that Automattic will not tolerate censorship of its users and is committed to disclosing as much information related to government requests as they are permitted. Many governments are <a href=\"http://www.bloomberg.com/news/2014-04-11/nsa-said-to-have-used-heartbleed-bug-exposing-consumers.html\" target=\"_blank\">ruthless about extracting information from citizens</a>, even when it comes at the expense of the people they serve. Given that the United States leads the pack in information requests, it&#8217;s reassuring to know that WordPress.com, one of the most highly trafficked sites in the US and around the globe, is committed to standing against any request that violates users&#8217; freedom of speech.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 20:43:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Common Issues and Troubleshooting WordPress 3.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21274\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"http://wptavern.com/common-issues-and-troubleshooting-wordpress-3-9?utm_source=rss&utm_medium=rss&utm_campaign=common-issues-and-troubleshooting-wordpress-3-9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8165:\"<div id=\"attachment_21291\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39Support.png\" rel=\"prettyphoto[21274]\"><img class=\"size-full wp-image-21291\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39Support.png\" alt=\"WordPress 3.9 Featured Images\" width=\"639\" height=\"200\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/ironrodart/4154904299/\">IronRodArt &#8211; Royce Bair (&#8220;Star Shooter&#8221;)</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<p>After the release of WordPress 3.9, I decided to help out in the <a title=\"http://wordpress.org/support/\" href=\"http://wordpress.org/support/\">support forums</a> since they usually become busy soon after a release. Providing support in the WordPress.org forums gives you a clear indication on how well a release is being received and whether or not anything major broke. After spending five hours in the support forum, here are some common issues being reported by users.</p>\n<h3>Visual Editor Disappeared Or Is Broken</h3>\n<p>A lot of users are <a title=\"http://wordpress.org/tags/visual-editor\" href=\"http://wordpress.org/tags/visual-editor\">reporting that the visual editor</a> has either disappeared or is broken. Considering the <a title=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\" href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\">number</a> of changes that took place with TinyMCE in 3.9, this is not surprising. In most cases, having users go through the following process solved the problem.</p>\n<ol>\n<li>Deactivate ALL plugins.</li>\n<li>Switch to default TwentyFourteen theme.</li>\n<li>Manually empty browser cache.</li>\n</ol>\n<p>If the visual editor doesn&#8217;t work after disabling all plugins and switching to the default theme, there could be a JavaScript issue. Follow <a title=\"http://codex.wordpress.org/Using_Your_Browser_to_Diagnose_JavaScript_Errors\" href=\"http://codex.wordpress.org/Using_Your_Browser_to_Diagnose_JavaScript_Errors\">these instructions</a> to diagnose JavaScript errors in your browser. Then, open up a new support forum thread and make sure to add the following information:</p>\n<ul>\n<li>the browsers that you are experiencing the problem in</li>\n<li>whether SCRIPT_DEBUG fixed the error or not</li>\n<li>the JavaScript error</li>\n<li>the location of the error &#8211; both the file name and the line number</li>\n<li>the context of the error &#8211; including the whole error stack will help developers</li>\n</ul>\n<p>This detailed information will help volunteer moderators determine the best way to solve your problem.</p>\n<h3>Master List Of Known Issues</h3>\n<p>Themes and plugins confirmed to be the cause of the problem are documented and added to the <a title=\"http://wordpress.org/support/topic/wordpress-39-master-list?replies=4\" href=\"http://wordpress.org/support/topic/wordpress-39-master-list?replies=4\">master list</a> of known issues with WordPress 3.9. So far, the list of plugins is up to eight with at least one in the process of being fixed.</p>\n<ul>\n<li><a href=\"http://wordpress.org/plugins/wysija-newsletters/\">MailPoet Newsletters</a> &#8211; Issue with <a href=\"https://wordpress.org/support/topic/39-update-tinymce-disappeared?replies=6#post-5465005\">outdated TinyMCE plugin in version 2.6.3</a>, disabling plugin fixed Visual Editor problem. MailPoet is already working on a fix for the TinyMCE issue in the next versions 2.6.4 (for post editor screen) and 2.6.5 (for newsletter editor).</li>\n<li><a href=\"https://wordpress.org/plugins/ziplist-recipe-plugin/\">ZipList Recipe Plugin</a> &#8211; Version 2.2 has a problem with the post editor in <a href=\"https://wordpress.org/support/topic/plugin-causes-posts-to-not-be-editable?replies=2\">both Visual and Text mode</a>.</li>\n<li><a href=\"http://wordpress.org/plugins/zedity/\">Zedity</a> &#8211; Version 3.1.0 causes the Visual Editor to break.</li>\n<li><a href=\"https://wordpress.org/plugins/enhanced-media-library/\">Enhanced Media Library</a> &#8211; Version 1.0.4 doesn&#8217;t show any media in the media library when the Add Media button is clicked</li>\n<li><a href=\"http://wordpress.org/plugins/soundcloud-is-gold/\">SoundCloud Is Gold</a> &#8211; Version 2.2.1 disables the Visual editor and prevents text from being entered</li>\n<li><a href=\"https://wordpress.org/plugins/nofollow/\">Ultimate NoFollow</a> &#8211; Version 1.4.1 doesn&#8217;t allow links to be inserted in the visual editor</li>\n<li><a href=\"https://wordpress.org/plugins/many-tips-together/\">Admin Tweaks</a> &#8211; version 2.3.8 causes the visual editor to white out.</li>\n<li><a href=\"http://wordpress.org/plugins/qtranslate/\">Qtranslate</a> &#8211; version 2.5.39 causes the media uploaded not to function</li>\n</ul>\n<p>The support team tries their best to help everyone with any WordPress problem even if it&#8217;s for a commercial theme or plugin. However, due to the great variety of existing themes and plugins it is nearly impossible to know everything. Your best option is to contact the developer for support. It’s always best to go to where the theme/plugin is officially supported when trying to get support.</p>\n<h3>How To Create An Audio Playlist</h3>\n<p>A few users have asked where the link is to create an audio playlist. In order to see the link to create an audio playlist, you either need existing audio files within the media library or you need to add them. It&#8217;s worth noting that if you host your media files on a content delivery network that&#8217;s not synchronized with the WordPress media library, you won&#8217;t be able to take advantage of the playlist feature.</p>\n<h3>Easy Way To Add Borders and Padding To Images Removed</h3>\n<p>Although WordPress 3.9 has refined the media editing experience, it did so at the cost of removing a feature users appreciated. In WordPress 3.8, users could easily add a border, vertical, and horizontal padding to images. WordPress 3.9 has removed this from the advanced image settings screen.</p>\n<div id=\"attachment_21279\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP38ImageProperties.png\" rel=\"prettyphoto[21274]\"><img class=\"size-full wp-image-21279\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP38ImageProperties.png\" alt=\"Image Properties In WordPress 3.8\" width=\"620\" height=\"476\" /></a><p class=\"wp-caption-text\">Image Properties In WordPress 3.8</p></div>\n<p>It&#8217;s not just those who use the self-hosted version of WordPress that are upset with the change. A WordPress.com <a title=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\" href=\"http://en.forums.wordpress.com/topic/image-resize-1?replies=430\">support forum thread</a> with over 430 posts is filled with users asking why the feature was removed. In some cases, WordPress.com staff are explaining how to use HTML code to add or remove borders to images. It&#8217;s possible that a plugin will soon be released that will restore this feature.</p>\n<h3>Use Patience When Asking For Support</h3>\n<p>Since WordPress 3.9 is a major upgrade, please exercise patience when requesting support on the forum. This <a title=\"https://codex.wordpress.org/Using_the_Support_Forums#Getting_Your_Questions_Answered_on_the_Forum\" href=\"https://codex.wordpress.org/Using_the_Support_Forums#Getting_Your_Questions_Answered_on_the_Forum\">guide on the Codex</a> does a great job explaining how to get your question answered. Last but not least, if a volunteer helps solve your problem, say thank you. During my five-hour support stint, I realized first-hand that providing support is a thankless job. Reading thank you notes and seeing users express joy from having their problem solved gave me the energy to keep on going.</p>\n<p>I encourage you to take 15-20 minutes to browse the support forum and help out where you can. Not only will you get a better understanding of problems users are facing, but you&#8217;ll learn a lot in the process. To anyone who&#8217;s taken the time to answer a support question on the forum, <strong>thank you!</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 19:45:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.tv: Introducing WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34317\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.tv/2014/04/16/introducing-wordpress-3-9-smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:635:\"<div id=\"v-sAiXhCfV-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34317/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34317/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34317&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/04/16/introducing-wordpress-3-9-smith/\"><img alt=\"WordPress3-9-Smith\" src=\"http://videos.videopress.com/sAiXhCfV/wordpress3-9-smith_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 21:10:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: How To Set Up 1 Or 2 Columns For WordPress Dashboard Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21030\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:184:\"http://wptavern.com/how-to-set-up-1-or-2-columns-for-wordpress-dashboard-widgets?utm_source=rss&utm_medium=rss&utm_campaign=how-to-set-up-1-or-2-columns-for-wordpress-dashboard-widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3932:\"<p>One of the improvements in <a title=\"http://wordpress.org/news/2013/12/parker/\" href=\"http://wordpress.org/news/2013/12/parker/\">WordPress 3.8</a> was the responsive dashboard. Thanks to this improvement, the option to select the number of columns to display dashboard widgets <a title=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\" href=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\">was removed</a>. The dashboard now shows the appropriate number of columns using the available screen real estate. Unfortunately, for those using wide-screen monitors, this usually means 4-5 skinny columns. In the screenshot below, you can see that even if a column doesn&#8217;t have a widget assigned to it, the column remains in place.</p>\n<div id=\"attachment_21233\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/DashboardWithFourColumns.png\" rel=\"prettyphoto[21030]\"><img class=\"size-full wp-image-21233\" src=\"http://wptavern.com/wp-content/uploads/2014/04/DashboardWithFourColumns.png\" alt=\"The Result Of A Responsive Dashboard\" width=\"1724\" height=\"417\" /></a><p class=\"wp-caption-text\">The Result Of A Responsive Dashboard</p></div>\n<p>The issue was <a title=\"http://imtheirwebguy.com/dont-hit-update-just-yet-wp-3-8-overhauls-ui-breaks-dashboard-widgets/\" href=\"http://imtheirwebguy.com/dont-hit-update-just-yet-wp-3-8-overhauls-ui-breaks-dashboard-widgets/\">brought up by Chris Jenkins</a> shortly after the release of WordPress 3.8. WordPress core developer Mark Jaquith agreed that &#8220;dashboard widgets should be able to specify a min-width, such that they span multiple columns if WordPress tries to make them smaller than that.&#8221; Jaquith <a title=\"https://core.trac.wordpress.org/ticket/26575\" href=\"https://core.trac.wordpress.org/ticket/26575\">created a ticket</a> suggesting a fix but so far, a patch has not been created.</p>\n<p>Since the ticket was created, Jenkins has developed and released a plugin called <a title=\"http://wordpress.org/plugins/two-column-admin/\" href=\"http://wordpress.org/plugins/two-column-admin/\">Two Column Admin</a>. When activated, the plugin restores the ability to select 1 or 2 columns to the screen options tab. The downside to using this plugin is that selecting two columns will disable the responsiveness of the dashboard widgets. Instead of merging into one column when the screen size gets smaller, the two columns will crash into each other.</p>\n<div id=\"attachment_21234\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/TwoColumnUnresponsiveWidgets.png\" rel=\"prettyphoto[21030]\"><img class=\"size-full wp-image-21234\" src=\"http://wptavern.com/wp-content/uploads/2014/04/TwoColumnUnresponsiveWidgets.png\" alt=\"Two Column Unresponsive Widgets\" width=\"500\" height=\"447\" /></a><p class=\"wp-caption-text\">Two Column Unresponsive Widgets</p></div>\n<p>Matt Beck <a title=\"https://core.trac.wordpress.org/ticket/26575#comment:1\" href=\"https://core.trac.wordpress.org/ticket/26575#comment:1\">responded to the ticket</a> with a good suggestion in lieu of the column option returning:</p>\n<blockquote><p>Best case scenario would be for the number/width of columns to adjust to the number of active dashboard widgets instead of displaying the empty drag/drop areas. In lieu of that, some mechanism to specify either column-count of a widget intended to be wide and/or better yet &#8211; maximum number of columns to display on the dashboard would be great.</p></blockquote>\n<p>After being stuck with four columns since the release of 3.8, I&#8217;ve forgotten how nice it is to have wide dashboard widgets. I&#8217;m hopeful that in the future, the ability to specify the number of columns in the dashboard returns as I prefer three, not four columns.</p>\n<p><strong>How many of you would like to be able to specify a specific amount of columns versus the current implementation?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 19:30:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: BuddyPress Development Trunk to Adopt a Grunt-Powered Build System\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21231\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/buddypress-development-trunk-to-adopt-a-grunt-powered-build-system?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-development-trunk-to-adopt-a-grunt-powered-build-system\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3238:\"<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/grunt.jpg\" rel=\"prettyphoto[21231]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/grunt.jpg\" alt=\"grunt\" width=\"916\" height=\"360\" class=\"aligncenter size-full wp-image-21245\" /></a></p>\n<p>Now that <a href=\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\" target=\"_blank\">BuddyPress 2.0</a> has been released, the core development team is refining its workflow to make use of <a href=\"http://gruntjs.com/\" target=\"_blank\">Grunt</a>, the Javascript task runner that the WordPress project <a href=\"http://make.wordpress.org/core/2013/08/06/a-new-frontier-for-core-development/\" target=\"_blank\">adopted</a> last year. The <a href=\"http://buddypress.svn.wordpress.org/trunk\" target=\"_blank\">BuddyPress development trunk</a> will be adopting a similar Grunt-powered build system that will automate many tedious tasks.</p>\n<p>The BuddyPress trunk will be reorganized to include a <strong>/src</strong> directory for BuddyPress, minus bbPress 1.1 and the BP-Default theme, which will be removed. The <strong>/tests</strong> directory will house the phpUnit tests. <a href=\"https://travis-ci.org/buddypress/BuddyPress\" target=\"_blank\">Travis-CI</a> and configuration files for tests will be moved to the root.</p>\n<h3>Who Is Affected?</h3>\n<p>The reorganization of the trunk will not affect production releases of BuddyPress, so for most ordinary users nothing will change. BuddyPress core contributor Paul Gibbs specified who will be affected by the changes in his <a href=\"http://bpdevel.wordpress.com/2014/04/16/grunt-coming-to-buddypress/\" target=\"_blank\">post</a> on the development blog. The changes concern you if:</p>\n<ul>\n<li>You develop plugins for BuddyPress</li>\n<li>You are a core contributor</li>\n<li>You run a checkout of trunk on a production site</li>\n</ul>\n<p>While this cross section of affected users represents just a handful of BuddyPress developers, the good news for everyone is that both core and extension development will become more efficient. That means that improvements and new plugins are likely to reach you faster than before.</p>\n<h3>How Will Grunt Make BuddyPress Development More Efficient?</h3>\n<p>Grunt will reduce the amount of manual labor that developers put into contributing to the BuddyPress core and creating plugins. The task runner will handle all of the following:</p>\n<ul>\n<li>Validate and lint CSS/JS</li>\n<li>Generate right-to-left CSS</li>\n<li>Compress images</li>\n<li>Run unit tests</li>\n<li>Generate the .pot file for internationalization</li>\n<li>Check for missing text domains</li>\n<li>Make it easier for developers to apply patches from BuddyPress Trac for testing</li>\n</ul>\n<p>The core team may add to this list in the future. If you want to get involved in the discussion or keep an eye on the &#8220;grunt-ification&#8221; of the BuddyPress trunk, there&#8217;s a <a href=\"https://buddypress.trac.wordpress.org/ticket/5160\" target=\"_blank\">trac ticket</a> open where updates will be posted. Core contributors and developers running a checkout of trunk on production/development sites will want to stay tuned for any changes that might affect your workflow.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 19:16:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: WordPress 3.9 “Smith” Released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=19881\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"http://wptavern.com/wordpress-3-9-smith-released?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-3-9-smith-released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:13415:\"<div id=\"attachment_21131\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WordPress39.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21131\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WordPress39.png\" alt=\"WordPress 3.9 Featured Image\" width=\"637\" height=\"227\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/wbaiv/6252639219/\">wbaiv</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-sa/2.0/\">cc</a></p></div>\n<p><a title=\"http://wordpress.org/news/2014/04/smith/\" href=\"http://wordpress.org/news/2014/04/smith/\">WordPress 3.9 &#8220;Smith&#8221;</a> is now available, just four months after the release of 3.8. This release continues the strategy of developing features as plugins first. <a title=\"http://wordpress.org/plugins/widget-customizer/\" href=\"http://wordpress.org/plugins/widget-customizer/\">Widgets Customizer</a> by <a title=\"http://profiles.wordpress.org/westonruter\" href=\"http://profiles.wordpress.org/westonruter\">Westonruter</a> is the only plugin that was developed and merged into WordPress this time around. Much of the work in <a title=\"http://codex.wordpress.org/Version_3.9\" href=\"http://codex.wordpress.org/Version_3.9\">WordPress 3.9</a> is an improvement of features added in earlier versions. Without further ado, let&#8217;s take a look at what this release has to offer.</p>\n<h3>New: Create Audio/Video Playlists</h3>\n<p>Building upon the addition of audio and video in WordPress 3.6, WordPress 3.9 offers a lot of enhancements. For starters, you can now create audio playlists. You can also add multiple sources to help with cross-browser compatibility. Managing multiple sources is easy thanks to an improved workflow. WordPress now has subtitle support for videos as long as you supply the appropriate files. <a title=\"http://html5doctor.com/video-subtitling-and-webvtt/\" href=\"http://html5doctor.com/video-subtitling-and-webvtt/\">This post by HTML5Doctor</a> explains how to create the proper files to add subtitles to videos.</p>\n<div id=\"attachment_21126\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39AudioPlaylists.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21126\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39AudioPlaylists.png\" alt=\"Audio Playlist In The Visual Editor Of WordPress 3.9\" width=\"911\" height=\"464\" /></a><p class=\"wp-caption-text\">Audio Playlist In The Visual Editor Of WordPress 3.9</p></div>\n<h3>Searching For WordPress Themes Has Never Been Easier</h3>\n<p>The theme browsing experience in WordPress 3.8 has been significantly improved in 3.9. The new theme browser features large preview images, indicators on which themes you already have installed, and fast-loading previews. Browsing and installing new themes in WordPress has never been easier.</p>\n<div id=\"attachment_21121\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21121\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39ThemeExperience.png\" alt=\"Theme Browser Experience Revamped In WordPress 3.9\" width=\"859\" height=\"503\" /></a><p class=\"wp-caption-text\">Theme Browser Experience Revamped In WordPress 3.9</p></div>\n<h3>Crop and Edit Images From Within The Visual Editor</h3>\n<p>Images are easier to edit and remove from posts. Simply click on the image within the visual editor and select the pencil icon. This will launch the image details screen. From here, you can quickly edit the details of the image and if you select the <strong>Edit Original button</strong>, you&#8217;ll be able to crop, flip, and change the image size. You can also drag and drop images right into the editor. Alternatively, you can crop and edit an image from within the visual editor.</p>\n<div id=\"attachment_21117\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/ImageEditingWP39.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21117\" src=\"http://wptavern.com/wp-content/uploads/2014/04/ImageEditingWP39.png\" alt=\"Image Editing In WordPress 3.9\" width=\"818\" height=\"488\" /></a><p class=\"wp-caption-text\">Image Editing In WordPress 3.9</p></div>\n<p>Instead of seeing a placeholder, galleries can now be previewed as a grid within the visual editor. You cannot yet drag images around to change the display order, but this feature is expected to be added in a future update.</p>\n<div id=\"attachment_21116\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/LivePreviewGalleries.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21116\" src=\"http://wptavern.com/wp-content/uploads/2014/04/LivePreviewGalleries.png\" alt=\"Preview Galleries Live Within The Visual Editor\" width=\"878\" height=\"625\" /></a><p class=\"wp-caption-text\">Preview Galleries Live Within The Visual Editor</p></div>\n<h3>Live Widget Previews</h3>\n<p>You can now preview changes to widgets in real-time thanks to the theme customizer. Gone are the days of having to refresh the page every time you want to preview a change to a widget.</p>\n<div id=\"attachment_21138\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39LiveWidgetPreview.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21138\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39LiveWidgetPreview.png\" alt=\"WordPress 3.9 Live Widget Previews\" width=\"1150\" height=\"569\" /></a><p class=\"wp-caption-text\">WordPress 3.9 Live Widget Previews</p></div>\n<h3>A New Streamlined Post Editor</h3>\n<p>The post editor in WordPress 3.9 has been updated to use TinyMCE 4.0. The update provides the following enhancements:</p>\n<ul>\n<li>New UI and UI API.</li>\n<li>New theme.</li>\n<li>Revamped events system/API.</li>\n<li>Better code quality, readability and build process.</li>\n<li>Lots of (inline) documentation.</li>\n</ul>\n<p>The Paste from Word button has been removed. When text from Microsoft Word is pasted into WordPress, the editor will automatically strip out the special formatting. The distraction free writing mode button is now on the right side of the editor. Distraction free writing mode <a title=\"http://wptavern.com/distraction-free-writing-mode-will-be-responsive-in-wordpress-3-9\" href=\"http://wptavern.com/distraction-free-writing-mode-will-be-responsive-in-wordpress-3-9\">is also responsive</a>. The changes to the editor are a noticeable improvement when compared to WordPress 3.8.</p>\n<div id=\"attachment_21130\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/WP39TinyMCE40.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-21130\" src=\"http://wptavern.com/wp-content/uploads/2014/04/WP39TinyMCE40.png\" alt=\"TinyMCE 4.0 In WordPress 3.9\" width=\"683\" height=\"349\" /></a><p class=\"wp-caption-text\">TinyMCE 4.0 In WordPress 3.9</p></div>\n<h3>oEmbed Support Added For Meetup and Imgur</h3>\n<p>Publishing content from either Meetup.com or Imgur is now as simple as <a title=\"http://wptavern.com/wordpress-3-9-to-add-oembed-support-for-meetup-com-and-imgur\" href=\"http://wptavern.com/wordpress-3-9-to-add-oembed-support-for-meetup-com-and-imgur\">pasting the URL</a> into the editor. Meanwhile, oEmbed support for Qik has been removed.</p>\n<div id=\"attachment_20405\" class=\"wp-caption aligncenter\"><a href=\"http://wptavern.com/wp-content/uploads/2014/04/oembeddedurlformeetupevent2.png\" rel=\"prettyphoto[19881]\"><img class=\"size-full wp-image-20405\" src=\"http://wptavern.com/wp-content/uploads/2014/04/oembeddedurlformeetupevent2.png\" alt=\"Meetup Group Event Embedded Into A Post\" width=\"545\" height=\"255\" /></a><p class=\"wp-caption-text\">Meetup Group Event Embedded Into A Post</p></div>\n<h3>Take A Tour Of WordPress 3.9</h3>\n<p>Michael Pick does a great job showing and explaining the new features in WordPress 3.9.<br />\n</p>\n<h3>Important Information For WordPress Developers</h3>\n<p>There are a lot of under-the-hood improvements in WordPress 3.9. Over the past two-weeks, those responsible for adding specific features to WordPress have written detailed blog posts on the <a title=\"http://make.wordpress.org/core/\" href=\"http://make.wordpress.org/core/\">Make WordPress Core</a> development blog. Here is a list of noteworthy items you may have missed.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5 Galleries and Captions in WordPress 3.9</a> &#8211; WordPress 3.6 introduced HTML5 versions of popular template tags, starting out with comments, the comment form, and the search form. With the 3.9 release the team added galleries and captions to that list. Now, when adding HTML5 support for those features, WordPress will use <code>&lt;figure&gt;</code> and <code>&lt;figcaption&gt;</code> elements, instead of the generic definition list markup.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">Symlinked Plugins in WordPress 3.9</a> &#8211; One of the cool little features included with 3.9 is the ability to symlink plugin directories. While it has been possible to symlink plugins in the past, functions such as <code>plugins_url()</code> return the wrong URL, which causes breakage in most plugins. The team has corrected this with the help of a new function.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload 2.x in WordPress 3.9</a> &#8211; Plupload is the library that powers most of the file upload interfaces in WordPress, and in 3.9 the team has updated the bundled library to version 2.1.1. This post lists some of the things that have changed, which may affect WordPress plugins and themes.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL in WordPress 3.9</a> &#8211; In WordPress 3.9, we added an extra layer to WPDB, causing it to switch to using the mysqli PHP library, when using PHP 5.5 or higher. For plugin developers, this means that you absolutely shouldn’t be using PHP’s mysql_*() functions any more – you can use the equivalent WPDB functions instead.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\">Masonry in WordPress 3.9</a> &#8211; If you use Masonry in your themes or plugins, here’s what you should know about the 3.9 update.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/03/27/tinymce-4-0-requires-textcss-for-editor-style-files/\" href=\"http://make.wordpress.org/core/2014/03/27/tinymce-4-0-requires-textcss-for-editor-style-files/\">TinyMCE 4.0 Requires text/css For Editor Style Files</a> &#8211; As of TinyMCE 4.0, the visual editor iframe now has an HTML5 document type (<code><!--<span class=\"hiddenSpellError\" pre=\"\"-->DOCTYPE html&gt;</code>). In this scenario, CSS files must be served with the <code>text/css</code> content type. A server will serve a <code>*.css</code> file with the proper content type, but if you’re using a PHP file for an editor style file, you need to be the one to do it.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/16/multisite-changes-in-3-9/\" href=\"http://make.wordpress.org/core/2014/04/16/multisite-changes-in-3-9/\">Multisite Changes In 3.9</a> &#8211; Much of the bootstrap code for Multisite in ms-settings.php has been refactored in<a href=\"http://core.trac.wordpress.org/ticket/27003\"> #27003</a> with the intent to improve how we handle the detection of domains and paths for sites and networks in core. Several other smaller enhancements and bugs have been completed in this and in other tickets.</p>\n<p><a title=\"http://make.wordpress.org/core/2014/04/16/jquery-ui-and-wpdialogs-in-wordpress-3-9/\" href=\"http://make.wordpress.org/core/2014/04/16/jquery-ui-and-wpdialogs-in-wordpress-3-9/\">jQuery UI and wpdialogs in WordPress 3.9</a> &#8211; WordPress 3.9 does not use the “wpdialogs” TinyMCE plugin as part of the TinyMCE 4.0 update which comes with a new dialog manager.</p>\n<h3>Thanks To Everyone Who Contributed To 3.9</h3>\n<p>Although 3.9 doesn&#8217;t have a lot of <strong>new</strong> features, the refinements to existing functionality are just as satisfying. I&#8217;m happy to see a release where the focus was more on improving what WordPress already has versus adding new functionality. Even though the live previews of widgets is my favorite feature, several of the pesky bugs that were squashed are a close second.</p>\n<p>WordPress wouldn&#8217;t be what it is today without all of the awesome contributions from the community. Thanks to everyone who helped make 3.9 a reality! This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder. </a>There are 267 contributors with props in this release, which is a new high for WordPress.</p>\n<p><strong>What is your favorite feature or enhancement in WordPress 3.9?</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:34:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Dev Blog: WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:22531:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n\n<h2 class=\"about-headline-callout\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"http://wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"http://wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"http://wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div></div>\n<hr />\n<h2>Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"http://wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2>Do more with audio and video</h2>\n\n<a href=\"http://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\">Ain\'t Misbehavin\'</a>\n<a href=\"http://wordpress.org/news/files/2014/04/DavenportBlues.mp3\">Davenport Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\">Buddy Bolden\'s Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\">Squaty Roo</a>\n<a href=\"http://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\">Dixie Blues</a>\n<a href=\"http://wordpress.org/news/files/2014/04/WolverineBlues.mp3\">Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2>Live widget and header previews</h2>\n<div class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<a href=\"http://wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2>Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"http://wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2>The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"http://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"http://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"http://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"http://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"http://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"http://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"http://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"http://profiles.wordpress.org/cmmarslender\">cmmarslender</a>, <a href=\"http://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"http://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"http://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"http://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"http://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"http://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"http://profiles.wordpress.org/fahmiadib\">Fahmi</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"http://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"http://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"http://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"http://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"http://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"http://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"http://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"http://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lkwdwrd\">lkwdwrd</a>, <a href=\"http://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"http://profiles.wordpress.org/ldebrouwer\">Luc De Brouwer</a>, <a href=\"http://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"http://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"http://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"http://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"http://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/oso96_2000\">oso96_2000</a>, <a href=\"http://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"http://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"http://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/pbearne\">Pbearne</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"http://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"http://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/richard2222\">richard2222</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"http://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"http://profiles.wordpress.org/ruudjoyo\">ruud@joyo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/salcode\">salcode</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"http://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"http://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"http://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"http://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"http://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"http://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"http://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/toru\">Toru</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"http://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"http://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"http://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"http://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"http://make.wordpress.org/\">Make WordPress</a> and our <a href=\"http://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: BuddyPress 2.0 Released: Big Performance Improvements and New Administration Tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=21201\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:226:\"http://wptavern.com/buddypress-2-0-released-big-performance-improvements-and-new-administration-tools?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-2-0-released-big-performance-improvements-and-new-administration-tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4710:\"<p>BuddyPress 2.0 &#8220;<a href=\"http://buddypress.org/2014/04/buddypress-2-0-juliana/\" target=\"_blank\">Juliana</a>&#8221; arrived on schedule today, less than a week after the plugin crossed <a href=\"http://wptavern.com/major-milestone-for-buddypress-2-million-downloads-and-counting\" target=\"_blank\">two million downloads</a>. This release focused heavily on improving BuddyPress performance, adding new administrative tools and enhancing the activity stream. It&#8217;s named for <a href=\"http://julianaspizza.com/\" target=\"_blank\">Juliana’s Pizza</a> in Brooklyn, NY, a pizza joint that is special to members of the core development team.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress20.png\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress20.png\" alt=\"buddypress20\" width=\"1555\" height=\"1305\" class=\"aligncenter size-full wp-image-21202\" /></a></p>\n<h3>Performance Improvements</h3>\n<p>One of the major highlights of this release is the <a href=\"http://wptavern.com/ http://wptavern.com/buddypress-2-0-ramps-up-performance-reduces-footprint-by-up-to-75\" target=\"_blank\">massive improvement in performance</a>, especially as it relates to Members and Activity directories. BuddyPress 2.0 improves MySQL efficiency, decreasing queries by up to 75% and reducing query time by up to 71%, depending on the your site&#8217;s hosting environment. If your site uses advanced caching systems, such as APC and Memcached, expect a performance increase here, as 2.0 completely overhauls how these are utilized.</p>\n<h3>New BuddyPress Administration Tools</h3>\n<p>BuddyPress 2.0 introduces a host of new administration tools that make it easier to manage communities. Administrators can now <a href=\"http://wptavern.com/buddypress-2-0-to-add-profile-editing-in-the-wordpress-admin\" target=\"_blank\">edit member profiles</a> in the WordPress admin. This release also ships with a new <a href=\"http://wptavern.com/buddypress-2-0-to-add-signups-administration-screen\" target=\"_blank\">signups administration screen</a> that allows administrators to track the status of pending accounts and facilitate the signup process.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/03/signups-featured.jpg\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/03/signups-featured.jpg\" alt=\"signups-featured\" width=\"800\" height=\"438\" class=\"aligncenter size-full wp-image-19429\" /></a></p>\n<p>Community managers will be pleased to know that version 2.0 provides <a href=\"http://wptavern.com/buddypress-2-0-to-add-better-spam-management-capabilities-for-administrators\" target=\"_blank\">better spam management capabilities</a> with the ability to mark users as ham/spam within the admin users panel, a feature that was previously only available on multisite installations.</p>\n<p>Version 2.0 includes a handy new &#8220;Repair Tools&#8221; menu at Dashboard > Tools > BuddyPress. This menu makes it easy to correct data that can sometimes get out of sync on BuddyPress sites.</p>\n<p><a href=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-tools.jpg\" rel=\"prettyphoto[21201]\"><img src=\"http://wptavern.com/wp-content/uploads/2014/04/buddypress-tools.jpg\" alt=\"buddypress-tools\" width=\"750\" height=\"516\" class=\"aligncenter size-full wp-image-21219\" /></a></p>\n<h3>Improved Activity Stream</h3>\n<p>The activity stream has received a few enhancements in 2.0. It will now automatically let you know when new items are ready to be loaded. It&#8217;s also much better integrated with blog posts. Comments are synced across blog-related activity items and the actual post itself. This unifies conversations that take place in different areas on a BP site.</p>\n<p>The activity stream will also play better with translations. Given that roughly half of BuddyPress installs are in a language other than English, this is a nice update. Check out this demo video created by <a href=\"https://twitter.com/BoweFrankema/status/455055453706526721\" target=\"_blank\">Bowe Frankema</a> to see how that works.</p>\n<p></p>\n<p></p>\n<p>Improvements in BuddyPress 2.0 help the social features to really shine and make community management more efficient for administrators. The plugin has come a long way since <a href=\"http://buddypress.org/2009/04/buddypress-10-has-arrived/\" target=\"_blank\">version 1.0</a> was released almost five years ago. The BuddyPress community has grown and thanks to the work of 42 volunteer contributors, 2.0 is ready for download today. Check out the full <a href=\"http://codex.buddypress.org/developer/releases/version-2-0/\" target=\"_blank\">2.0 changelog</a> to see everything that&#8217;s new and improved.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 15:53:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"BuddyPress: BuddyPress 2.0 “Juliana”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=181333\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://buddypress.org/2014/04/buddypress-2-0-juliana/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10225:\"<p>The BuddyPress team is thrilled to announce that BuddyPress 2.0 &#8220;Juliana&#8221; is now available!</p>\n<p>This release focuses on administrative tools, performance, and improvements to the activity stream. Let&#8217;s take a look at some of the highlights.</p>\n<div></div>\n<h4>New Administrative Tools</h4>\n<p>If you manage a BuddyPress-powered community, BuddyPress 2.0 is for you. We have built a number of new tools that simplify and centralize common administrative tasks:</p>\n<ul>\n<li><em>Profile editing</em> &#8211; Need to manage a user&#8217;s profile information? We&#8217;ve integrated a new &#8220;Extended Profile&#8221; tab into the Dashboard &gt; Users interface, where you can manage profile data, avatars, user status, and more.<br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/admin-xprofile.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/admin-xprofile-300x206.jpg\" alt=\"admin-xprofile\" width=\"300\" height=\"206\" class=\"alignleft size-medium wp-image-181344\" /></a>\n  </li>\n<li><em>Spam User Management</em> &#8211; WordPress Multisite has long had the ability to manage spam users from the Dashboard. We&#8217;ve brought the same capabilities to non-Multisite installations. <br />\n<a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/user-mark-spam.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/user-mark-spam-300x206.jpg\" alt=\"user-mark-spam\" class=\"size-thumbnail wp-image-181342\" /></a>\n  </li>\n<div> </div>\n<li><em>Pending Users</em> &#8211; The Pending users tab in Dashboard &gt; Users lets you see a list of signups that have not yet been activated. You can also perform useful tasks like manual account activation and resending activation emails. <br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/users-pending.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/users-pending-300x206.jpg\" alt=\"users-pending\" class=\"size-thumbnail wp-image-181343\" /></a>\n  </li>\n<li><em>Repair Tools</em> &#8211; Occasionally, BP friend counts and other data can get out of sync. The new Tools screen lets admins manually reset these values. <br /><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/tools-buddypress.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/tools-buddypress-300x206.jpg\" alt=\"tools-buddypress\" class=\"size-thumbnail wp-image-181341\" /></a>\n  </li>\n</ul>\n<div></div>\n<h4>Performance Improvements</h4>\n<p>The most successful BuddyPress sites are highly dynamic, with a steady stream of new visitors and new content. This dynamic nature means that BuddyPress is a highly database-driven platform, and database performance is often a bottleneck when it comes to scaling BP sites. BuddyPress 2.0 tackles this problem head-on. We&#8217;ve streamlined some of the most common problematic queries &#8211; such as those in the Members and Activity directories &#8211; to shave up to 95% of the query time off of certain individual queries. The sheer number of queries has been dramatically reduced as well, so that single page views access the database up to 50% less than in BP 1.9. And we&#8217;ve totally overhauled the way that BuddyPress utilizes advanced caching systems like APC and Memcached, so that users of these systems will see up to 75% fewer cache misses on costly queries.</p>\n<p>If you&#8217;re a BuddyPress developer or site administrator, you can get more in-depth explanation of changes and an overview of selected benchmarks <a href=\"http://bpdevel.wordpress.com/2014/04/02/one-of-the-primary-focuses/\">in this post on bpdevel.wordpress.com</a>. If you are a BuddyPress user, you can just sit back and enjoy the speedier pageloads and reduced server overhead of your BuddyPress 2.0 site!</p>\n<div></div>\n<h4>Activity Stream Enhancements</h4>\n<p>Spend a lot of time viewing the activity stream? BuddyPress 2.0 automatically lets you know when new items are ready to be loaded.</p>\n<p><a href=\"http://buddypress.org/wp-content/uploads/1/2014/04/load-newest.jpg\"><img src=\"http://buddypress.org/wp-content/uploads/1/2014/04/load-newest.jpg\" alt=\"load-newest\" width=\"558\" height=\"302\" class=\"size-full wp-image-181356\" /></a></p>\n<p>The activity stream is better integrated with blog posts, too. Comment on a blog post, and an activity item is posted. Comment on a blog-related activity item, and a blog comment is posted. No more worrying about fractured conversations.</p>\n<p>We’ve also reworked the way that phrases like &#8220;Boone posted an update&#8221; are handled, so that they’re always up-to-date and always translatable.</p>\n<div></div>\n<h4>And much more</h4>\n<p>BuddyPress 2.0 introduces dozens more small features, and fixes scores of bugs. We&#8217;ve compiled <a href=\"http://codex.buddypress.org/developer/releases/version-2-0/\">a complete 2.0 changelog</a> on the BuddyPress Codex.</p>\n<div></div>\n<h4>Juliana is Number Two</h4>\n<p>BuddyPress 2.0 is named for <a href=\"http://julianaspizza.com/\">Juliana&#8217;s Pizza</a> in Brooklyn, NY. Juliana&#8217;s is the second pizza establishment opened in the same location by master pizzaiolo Patsy Grimaldi (it&#8217;s a long story), and was also the locale for a serious BuddyPress powwow and up-close dining experience by two members of the core team. For these reasons (not to mention the outstanding pizza) we think that BuddyPress 2.0 &#8220;Juliana&#8221; has a special ring to it.</p>\n<div></div>\n<h4>Thanks, thanks, and more thanks</h4>\n<p>BuddyPress is built, with love, by a worldwide network of volunteers. The following people contributed patches during the BuddyPress 2.0 development cycle:</p>\n<p><a href=\"https://profiles.wordpress.org/boonebgorges/\">boonebgorges</a>, <a href=\"https://profiles.wordpress.org/Bowromir/\">Bowromir</a>, <a href=\"https://profiles.wordpress.org/burakali/\">burakali</a>, <a href=\"https://profiles.wordpress.org/chouf1/\">chouf1</a>, <a href=\"https://profiles.wordpress.org/cmmarslender/\">cmmarslender</a>, <a href=\"https://profiles.wordpress.org/danbp/\">danbp</a>, <a href=\"https://profiles.wordpress.org/dcavins/\">dcavins</a>, <a href=\"https://profiles.wordpress.org/Denis-de-Bernardy/\">Denis-de-Bernardy</a>, <a href=\"https://profiles.wordpress.org/DJPaul/\">DJPaul</a>, <a href=\"https://profiles.wordpress.org/ericlewis/\">ericlewis</a>, <a href=\"https://profiles.wordpress.org/glyndavidson/\">glyndavidson</a>, <a href=\"https://profiles.wordpress.org/graham-washbrook/\">graham-washbrook</a>, <a href=\"https://profiles.wordpress.org/henrywright/\">henrywright</a>, <a href=\"https://profiles.wordpress.org/henry.wright/\">henry.wright</a>, <a href=\"https://profiles.wordpress.org/hnla/\">hnla</a>, <a href=\"https://profiles.wordpress.org/imath/\">imath</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">johnjamesjacoby</a>, <a href=\"https://profiles.wordpress.org/karmatosed/\">karmatosed</a>, <a href=\"https://profiles.wordpress.org/lenasterg/\">lenasterg</a>, <a href=\"https://profiles.wordpress.org/MacPresss/\">MacPresss</a>, <a href=\"https://profiles.wordpress.org/markoheijnen/\">markoheijnen</a>, <a href=\"https://profiles.wordpress.org/megainfo/\">megainfo</a>, <a href=\"https://profiles.wordpress.org/mercime\">mercime</a>, <a href=\"https://profiles.wordpress.org/modemlooper/\">modemlooper</a>, <a href=\"https://profiles.wordpress.org/mpa4hu/\">mpa4hu</a>, <a href=\"https://profiles.wordpress.org/needle/\">needle</a>, <a href=\"https://profiles.wordpress.org/netweb/\">netweb</a>, <a href=\"https://profiles.wordpress.org/ninnypants/\">ninnypants</a>, Pietro Oliva, <a href=\"https://profiles.wordpress.org/pross/\">pross</a>, <a href=\"https://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"https://profiles.wordpress.org/reactuate/\">reactuate</a>, <a href=\"https://profiles.wordpress.org/rodrigorznd/\">rodrigorznd</a>, <a href=\"https://profiles.wordpress.org/rogercoathup/\">rogercoathup</a>, <a href=\"https://profiles.wordpress.org/rzen/\">rzen</a>, <a href=\"https://profiles.wordpress.org/SergeyBiryukov/\">SergeyBiryukov</a>, <a href=\"https://profiles.wordpress.org/shanebp/\">shanebp</a>, <a href=\"https://profiles.wordpress.org/SlothLoveChunk/\">SlothLoveChunk</a>, <a href=\"https://profiles.wordpress.org/StijnDeWitt/\">StijnDeWitt</a>, <a href=\"https://profiles.wordpress.org/terraling/\">terraling</a>, <a href=\"https://profiles.wordpress.org/trishasalas/\">trishasalas</a>, <a href=\"https://profiles.wordpress.org/tw2113/\">tw2113</a>, <a href=\"https://profiles.wordpress.org/vanillalounge/\">vanillalounge</a>.</p>\n<p>Many thanks to these contributors, and to all who have pitched in the forums and elsewhere.</p>\n<p>One final point. Technically, BuddyPress &#8220;2.0&#8243; is just the version between 1.9 and 2.1. But still, there&#8217;s something special about crossing into the 2.x series, especially given the timing: we just crossed <a href=\"http://wptavern.com/major-milestone-for-buddypress-2-million-downloads-and-counting\">2 million downloads</a>, and it&#8217;s been almost exactly five years since <a href=\"http://buddypress.org/2009/04/buddypress-10-has-arrived/\">BuddyPress 1.0 was released</a>. On behalf of the core team and contributors, I&#8217;d like to extend a few special thanks: to founding developer <a href=\"http://apeatling.com/\">Andy Peatling</a> for getting the ball rolling; to <a href=\"http://ma.tt\">Matt Mullenweg</a> for providing support to the BuddyPress project; and especially to the many thousands of BuddyPress users who have followed and advocated for the project over the years. If BP has done great things for the thousands of communities that depend on it (and I think it has), it&#8217;s because of the incredible community around the software itself. <strike>A million</strike> Two million thanks to all of you.</p>\n<div></div>\n<h4>Upgrade Today</h4>\n<p>You can get BuddyPress 2.0 from the <a href=\"http://wordpress.org/plugins/buddypress/\">wordpress.org plugin repository</a>, or right from your WordPress Dashboard. </p>\n<p>As always, questions, comments, bug reports, feature requests, and general laudatory remarks can be directed toward our <a href=\"https://buddypress.org/support/\">support forums</a> or our <a href=\"https://buddypress.trac.wordpress.org\">development tracker</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 14:48:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Boone Gorges\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 28 Apr 2014 23:58:07 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"250639\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 28 Apr 2014 23:45:14 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20131030160355\";}", "no");
INSERT INTO `wp_options` VALUES("6312", "_transient_timeout_dash_aa95765b5cc111c56d5993d476b1c2f0", "1398313433", "no");
INSERT INTO `wp_options` VALUES("6313", "_transient_dash_aa95765b5cc111c56d5993d476b1c2f0", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://blog.akismet.com/2014/04/23/theres-a-ninja-in-your-akismet/\' title=\'One of our favorite additions to Akismet 3.0 is the new discard setting. Previously, our plugin featured an option that allowed site owners the ability to automatically discard spam on older posts. But, as some may certainly agree, it was rather confusing and had little effect on the world’s smarter spammers. After giving thought to how we could improve that particular setting and the overall user experience, we found that approximately 80% of spam could be flagged as “pervasive”, meaning that it is the absolute worst of the worst (of the worst!). In fact, that 80% is so bad that there is simply no benefit in paying any attention to it at all. Not even for kicks and giggles. Trust us. We came up with something that would allow you to automatically and silently discard all of that pervasive spam attacking your site so that it never even appears in your “Spam” folder. The new setting identifies the worst and most pervasive spam (which can certainly change over time) on our side during the comment check and will immediately discard it if you’ve configured the plugin to do so.  If you’re new to Akismet, these spam comments will be stored by default; you must activate the new feature from the plugin’s configuration page (if you upgraded to 3.0, Akismet will use the previous value of your 30-day discard setting) :  It’s all very ninja-esque, we think. What’s more, enabling the feature can result in significant reductions in your storage and resource usage requirements. This is a great step forward in our mission to make the web a cleaner place. We tested the feature on WordPress.com and received excellent results and feedback prior to rolling it into the plugin. So, we think (and hope) you’ll enjoy it. We are also working on an enhancement to the feature, which will highlight the pervasive spam comments in the “Spam” folder for users who choose to store them. If you have any feedback on the new feature, we would love to hear from you.   \'>Akismet: There’s a Ninja in Your Akismet</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/new-plugin-adds-less-css-preprocessor-to-wordpress-themes?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=new-plugin-adds-less-css-preprocessor-to-wordpress-themes\' title=\' Many WordPress developers opt to use the Less CSS preprocessor to speed up theme development. Its availability of variables, mixins, and functions allows you to do more with CSS and to do it more efficiently. It also makes it easy to compile and minify files for production use. However, the initial setup for adding Less to each theme is a somewhat time-consuming process. Justin Kopepasah wrote a tutorial in the past for using LESS in a live WordPress theme, followed by one that automated the process by setting up the functionality as a Git submodule. Over time, he found that adding Less to each theme was becoming quite a chore, so he created a plugin to make the process easier for anyone. Kopepasah’s Less Theme Support plugin radically simplifies the process of adding Less to your WordPress theme. It requires just two simple steps following activation:  Add style.less to your theme’s root directory Add theme support to the after_setup_theme hook: add_theme_support( &#039;less&#039;, array( &#039;enable&#039; =&gt; true ) );   Less Theme Support comes with four different options which change how it functions on development vs. production sites. All are boolean values defaulting to false:  enable – Enables Less and enqueues less.min.js on the front end. develop – Enables development environment for Less and enqueues less-develop.js. watch – Enables watch mode for Less and enqueues less-watch.js. minify – Enables usage of a minified stylesheet (style.min.css) on the front end for all other visitors (best generated using lessc -x style.less &gt; style.min.css).  These options give you quite a bit of flexibility. For example, during development you might configure your theme support with the enable, develop, and watch options: add_theme_support( &#039;less&#039;, array(     &#039;enable&#039;  =&gt; true,     &#039;develop&#039; =&gt; true,     &#039;watch&#039;  =&gt; true ) ); Less theme support in production would us the minify option: add_theme_support( &#039;less&#039;, array(  &#039;minify&#039; =&gt; true ) ); Using the Less Theme Support plugin provides a much cleaner and easier way to add Less to your theme. Download it from WordPress.org or via the project’s page on Github.\'>WPTavern: New Plugin Adds Less CSS Preprocessor to WordPress Themes</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/display-before-and-after-images-in-wordpress-with-the-twentytwenty-plugin?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=display-before-and-after-images-in-wordpress-with-the-twentytwenty-plugin\' title=\'Have you ever wanted to combine two images to show a before and after? You can’t do that with WordPress out of the box but it’s possible if you use the TwentyTwenty plugin by Corey Martin. The plugin takes advantage of the clip property within CSS by stacking two identical sized images on top of each other. The clip property allows the image to show through the container. The slider is responsive and uses custom movement events within the jQuery Event Move library to support 1:1 slider movement on mobile devices. The plugin is very simple to use. Upload two identical sized images to the media library. When inserting images into a post, make sure the attachment display settings for image size are the same. Add the [TwentyTwenty] shortcode above the before image. Add [/TwentyTwenty] after the second image. Here’s an example of the shortcode added to a post. TwentyTwenty Shortcode In Action The shortcode generates a slider that can be moved back and forth. You’ll see which images are before and after when you hover over the slider. To see either image, users must click and drag the circle left or right. TwentyTwenty Before Image TwentyTwenty After Image The plugin was written using Sass and Zurb.com has a listing of each Sass variable used and what its default value is. The variables enable you to control everything from the handle color to the handle radius. Here are a couple of ideas where TwentyTwenty would be ideal to use.  Compare counterfeit merchandise to real merchandise Website redesigns Home improvement renovations  During my test with WordPress 3.9, I didn’t experience any problems. According to Martin, TwentyTwenty is compatible with the latest versions of Chrome, Safari, FireFox, iOS, IE 9, and above. If you want to see the plugin in action, you can either watch this screencast by Martin or visit the plugin’s page on Zurb.com.  Outside of showing before and after images, what other creative ways could this plugin be used?\'>WPTavern: Display Before and After Images In WordPress With The TwentyTwenty Plugin</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/wordpress-3-9-adds-30-new-dashicons?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=wordpress-3-9-adds-30-new-dashicons\' title=\'Dashicons are what’s known as an icon font and were added to the core of WordPress with the release of 3.8. The icons are vector based so they can be as large or small as you want without losing quality. Plugin authors can use CSS, HTML, or a Glyph for use within Photoshop to display an icon. While 3.8 had 167 icons, WordPress 3.9 shipped with 30 new Dashicons bringing the total to 197. New Dashicons In WordPress 3.9 The icons cover Media, TinyMCE, WordPress.org, Sorting, Widgets, Alerts, and Miscellaneous. Some plugin authors have already opted out of using a bitmap image and are using a Dashicon to represent their plugin within the WordPress admin menu. If none of the Dashicons match your use case, try Genericons instead. Genereicons is also an icon font but has icons that are not focused on WordPress.\'>WPTavern: WordPress 3.9 Adds 30 New Dashicons</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/automattic-introduces-postbot-app-for-scheduling-photo-posts?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=automattic-introduces-postbot-app-for-scheduling-photo-posts\' title=\'Today Automattic introduced Postbot, a new stand-alone application for scheduling image posts. The new app allows users to upload multiple images and schedule them out over several days. Postbot creates a post for each image and automatically posts them to the selected blog, saving users the trouble of manually scheduling each one.  When using Postbot, you’ll need to connect via WordPress.com. The app is automatically connected to your main WordPress.com blog but once logged in you’ll have the option to connect other sites. Self-hosted WordPress sites can use the app via Jetpack with the JSON API module enabled. Right now, you can only use the app from a desktop or mobile browser and John Godley, representing Automattic, says that a mobile app is not currently in the works. He elaborated on why they chose to create it as a standalone web app: Postbot lets us provide a very targeted set of features to anyone with a WordPress.com or WordPress.org/Jetpack blog (or both), from one central place. It’s already mobile-ready so a special mobile app isn’t currently planned. The experience of visiting Postbot.co from a mobile browser is not unlike using a mobile app. Those who plan to use it frequently via mobile can easily set a bookmark for quick launch while on the go. Postbot Puts Photo Publishing on Autopilot Postbot allows you to upload up to 50 photos at once to be published individually on different dates. While the images are uploading you can edit the titles, tags and content for each. The option to set a category is planned for a future version.  Scheduling allows you to set the number of days between posts published with the option to ignore weekends.  The app doesn’t yet allow you to set the featured image, but it’s on Automattic’s list of feature requests for future enhancements. Postbot is an excellent example of the kinds of apps that can be created using the WordPress.com API. If you want to take a peek under the hood, the app’s code was released under the GPL and can be found on Github. This means that anyone can host their own Postbot web app or create interesting variations that interact with WordPress.com services. Postbot is potentially very useful for photobloggers who want to break up their posts into individual images. It could also be handy for automating sites that are dedicated to publishing photos every day, i.e. “The Daily Kitten” or “Your Daily Dose of Fun.” It allows these kinds of sites to go on autopilot for publishing fresh content on a regular basis. Publishing new posts multiple times per day is an option currently under consideration and may be a possibility in the future. We’ll be following the app’s progress as it adds new features based on user feedback.\'>WPTavern: Automattic Introduces Postbot App for Scheduling Photo Posts</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("595", "wppa_skinfile", "default", "yes");
INSERT INTO `wp_options` VALUES("596", "wppa_regen", "", "yes");
INSERT INTO `wp_options` VALUES("597", "wppa_rerate", "", "yes");
INSERT INTO `wp_options` VALUES("598", "wppa_cleanup", "", "yes");
INSERT INTO `wp_options` VALUES("599", "wppa_recup", "", "yes");
INSERT INTO `wp_options` VALUES("600", "wppa_rating_clear", "no", "yes");
INSERT INTO `wp_options` VALUES("601", "wppa_iptc_clear", "", "yes");
INSERT INTO `wp_options` VALUES("602", "wppa_exif_clear", "", "yes");
INSERT INTO `wp_options` VALUES("603", "wppa_html", "no", "yes");
INSERT INTO `wp_options` VALUES("604", "wppa_check_balance", "no", "yes");
INSERT INTO `wp_options` VALUES("605", "wppa_allow_debug", "no", "yes");
INSERT INTO `wp_options` VALUES("4104", "wppa_apply_newphoto_desc_user", "no", "yes");
INSERT INTO `wp_options` VALUES("607", "wppa_filter_priority", "1001", "yes");
INSERT INTO `wp_options` VALUES("608", "wppa_lightbox_name", "wppa", "yes");
INSERT INTO `wp_options` VALUES("609", "wppa_allow_foreign_shortcodes", "no", "yes");
INSERT INTO `wp_options` VALUES("610", "wppa_arrow_color", "black", "yes");
INSERT INTO `wp_options` VALUES("611", "wppa_meta_page", "yes", "yes");
INSERT INTO `wp_options` VALUES("612", "wppa_meta_all", "yes", "yes");
INSERT INTO `wp_options` VALUES("613", "wppa_cp_points_comment", "0", "yes");
INSERT INTO `wp_options` VALUES("614", "wppa_cp_points_rating", "0", "yes");
INSERT INTO `wp_options` VALUES("615", "wppa_max_album_newtime", "0", "yes");
INSERT INTO `wp_options` VALUES("643", "wppa_thumbnailwidgettitle", "Thumbnail Photos", "yes");
INSERT INTO `wp_options` VALUES("644", "wppa_searchwidgettitle", "Search photos", "yes");
INSERT INTO `wp_options` VALUES("645", "wppa_comadmin_show", "all", "yes");
INSERT INTO `wp_options` VALUES("646", "wppa_comadmin_order", "timestamp", "yes");
INSERT INTO `wp_options` VALUES("4248", "travel_homepage", "a:4:{s:9:\"home_page\";s:0:\"\";s:6:\"layout\";s:5:\"right\";s:7:\"content\";s:38:\"[blog count=\\\"10\\\" nopaging=\\\"false\\\"]\";s:19:\"shortcode_generator\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("616", "wppa_max_photo_newtime", "0", "yes");
INSERT INTO `wp_options` VALUES("617", "wppa_apply_newphoto_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("618", "wppa_newphoto_description", "\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'block\'); jQuery(\'.wppa-more\').css(\'display\', \'none\'); wppaOvlResize();\">\r\n<div class=\"wppa-more\">\r\nCamera info\r\n</div>\r\n</a>\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'none\'); jQuery(\'.wppa-more\').css(\'display\', \'block\'); wppaOvlResize();\">\r\n<div class=\"wppa-dtl\" style=\"display:none;\" >\r\nHide Camera info\r\n</div>\r\n</a>\r\n<div class=\"wppa-dtl\" style=\"display:none;\">\r\n<br />\r\n<style>\r\n.wppa-label { padding: 0 3px !important; border: none !important; }\r\n.wppa-value { padding: 0 3px 0 12px !important; border:none !important; }\r\n</style>\r\n<table style=\"margin:0; border:none;\" >\r\n<tr><td class=\"wppa-label\" >Date Time</td><td class=\"wppa-value\" >E#0132</td></tr>\r\n<tr><td class=\"wppa-label\" >Camera</td><td class=\"wppa-value\" >E#0110</td></tr>\r\n<tr><td class=\"wppa-label\" >Focal length</td><td class=\"wppa-value\" >E#920A</td></tr>\r\n<tr><td class=\"wppa-label\" >F-Stop</td><td class=\"wppa-value\" >E#829D</td></tr>\r\n<tr><td class=\"wppa-label\" >ISO Speed Rating</td><td class=\"wppa-value\" >E#8827</td></tr>\r\n<tr><td class=\"wppa-label\" >Exposure program</td><td class=\"wppa-value\" >E#8822</td></tr>\r\n<tr><td class=\"wppa-label\" >Metering mode</td><td class=\"wppa-value\" >E#9207</td></tr>\r\n<tr><td class=\"wppa-label\" >Flash</td><td class=\"wppa-value\" >E#9209</td></tr>\r\n</table>\r\n</div>", "yes");
INSERT INTO `wp_options` VALUES("360", "wppa_colwidth", "640", "yes");
INSERT INTO `wp_options` VALUES("361", "wppa_resize_on_upload", "no", "yes");
INSERT INTO `wp_options` VALUES("362", "wppa_resize_to", "0", "yes");
INSERT INTO `wp_options` VALUES("363", "wppa_min_thumbs", "1", "yes");
INSERT INTO `wp_options` VALUES("364", "wppa_bwidth", "1", "yes");
INSERT INTO `wp_options` VALUES("365", "wppa_bradius", "6", "yes");
INSERT INTO `wp_options` VALUES("366", "wppa_box_spacing", "8", "yes");
INSERT INTO `wp_options` VALUES("367", "wppa_fullsize", "640", "yes");
INSERT INTO `wp_options` VALUES("368", "wppa_maxheight", "480", "yes");
INSERT INTO `wp_options` VALUES("369", "wppa_enlarge", "no", "yes");
INSERT INTO `wp_options` VALUES("370", "wppa_fullimage_border_width", "", "yes");
INSERT INTO `wp_options` VALUES("371", "wppa_numbar_max", "10", "yes");
INSERT INTO `wp_options` VALUES("372", "wppa_thumbsize", "100", "yes");
INSERT INTO `wp_options` VALUES("373", "wppa_thumb_aspect", "0:0:none", "yes");
INSERT INTO `wp_options` VALUES("374", "wppa_tf_width", "100", "yes");
INSERT INTO `wp_options` VALUES("375", "wppa_tf_height", "130", "yes");
INSERT INTO `wp_options` VALUES("376", "wppa_tn_margin", "4", "yes");
INSERT INTO `wp_options` VALUES("377", "wppa_thumb_auto", "yes", "yes");
INSERT INTO `wp_options` VALUES("378", "wppa_thumb_page_size", "0", "yes");
INSERT INTO `wp_options` VALUES("379", "wppa_popupsize", "150", "yes");
INSERT INTO `wp_options` VALUES("380", "wppa_use_thumbs_if_fit", "yes", "yes");
INSERT INTO `wp_options` VALUES("381", "wppa_max_cover_width", "1024", "yes");
INSERT INTO `wp_options` VALUES("382", "wppa_text_frame_height", "54", "yes");
INSERT INTO `wp_options` VALUES("383", "wppa_smallsize", "150", "yes");
INSERT INTO `wp_options` VALUES("384", "wppa_album_page_size", "0", "yes");
INSERT INTO `wp_options` VALUES("385", "wppa_rating_max", "5", "yes");
INSERT INTO `wp_options` VALUES("386", "wppa_rating_prec", "2", "yes");
INSERT INTO `wp_options` VALUES("387", "wppa_gravatar_size", "40", "yes");
INSERT INTO `wp_options` VALUES("388", "wppa_topten_count", "10", "yes");
INSERT INTO `wp_options` VALUES("389", "wppa_topten_size", "86", "yes");
INSERT INTO `wp_options` VALUES("1917", "wppa_comten_size", "86", "yes");
INSERT INTO `wp_options` VALUES("1918", "wppa_share_size", "32", "yes");
INSERT INTO `wp_options` VALUES("392", "wppa_thumbnail_widget_count", "10", "yes");
INSERT INTO `wp_options` VALUES("393", "wppa_thumbnail_widget_size", "86", "yes");
INSERT INTO `wp_options` VALUES("394", "wppa_lasten_count", "10", "yes");
INSERT INTO `wp_options` VALUES("395", "wppa_lasten_size", "86", "yes");
INSERT INTO `wp_options` VALUES("396", "wppa_ovl_txt_lines", "auto", "yes");
INSERT INTO `wp_options` VALUES("4105", "wppa_slideshow_pagesize", "0", "yes");
INSERT INTO `wp_options` VALUES("398", "wppa_bc_on_search", "yes", "yes");
INSERT INTO `wp_options` VALUES("399", "wppa_bc_on_topten", "yes", "yes");
INSERT INTO `wp_options` VALUES("400", "wppa_bc_on_lasten", "yes", "yes");
INSERT INTO `wp_options` VALUES("401", "wppa_show_home", "yes", "yes");
INSERT INTO `wp_options` VALUES("402", "wppa_bc_separator", "raquo", "yes");
INSERT INTO `wp_options` VALUES("403", "wppa_bc_txt", "&lt;span style=&quot;color:red; font_size:24px;&quot;&gt;&amp;bull;&lt;/span&gt;", "yes");
INSERT INTO `wp_options` VALUES("404", "wppa_bc_url", "http://israelvasquez.com/traveltheworld/wp-content/plugins/wp-photo-album-plus/images/arrow.gif", "yes");
INSERT INTO `wp_options` VALUES("405", "wppa_pagelink_pos", "bottom", "yes");
INSERT INTO `wp_options` VALUES("406", "wppa_show_startstop_navigation", "yes", "yes");
INSERT INTO `wp_options` VALUES("407", "wppa_show_browse_navigation", "yes", "yes");
INSERT INTO `wp_options` VALUES("408", "wppa_filmstrip", "yes", "yes");
INSERT INTO `wp_options` VALUES("409", "wppa_film_show_glue", "yes", "yes");
INSERT INTO `wp_options` VALUES("410", "wppa_show_full_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("411", "wppa_show_full_desc", "yes", "yes");
INSERT INTO `wp_options` VALUES("412", "wppa_rating_on", "yes", "yes");
INSERT INTO `wp_options` VALUES("413", "wppa_rating_display_type", "graphic", "yes");
INSERT INTO `wp_options` VALUES("414", "wppa_show_avg_rating", "yes", "yes");
INSERT INTO `wp_options` VALUES("415", "wppa_show_comments", "yes", "yes");
INSERT INTO `wp_options` VALUES("416", "wppa_comment_gravatar", "none", "yes");
INSERT INTO `wp_options` VALUES("417", "wppa_comment_gravatar_url", "http://", "yes");
INSERT INTO `wp_options` VALUES("418", "wppa_show_bbb", "no", "yes");
INSERT INTO `wp_options` VALUES("419", "wppa_custom_on", "no", "yes");
INSERT INTO `wp_options` VALUES("420", "wppa_custom_content", "<div style=\"color:red; font-size:24px; font-weight:bold; text-align:center;\">Hello world!</div>", "yes");
INSERT INTO `wp_options` VALUES("421", "wppa_show_slideshownumbar", "no", "yes");
INSERT INTO `wp_options` VALUES("422", "wppa_show_iptc", "no", "yes");
INSERT INTO `wp_options` VALUES("423", "wppa_show_exif", "no", "yes");
INSERT INTO `wp_options` VALUES("424", "wppa_copyright_on", "yes", "yes");
INSERT INTO `wp_options` VALUES("425", "wppa_copyright_notice", "<span style=\"color:red\" >Warning: Do not upload copyrighted material!</span>", "yes");
INSERT INTO `wp_options` VALUES("426", "wppa_thumb_text_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("427", "wppa_thumb_text_desc", "yes", "yes");
INSERT INTO `wp_options` VALUES("428", "wppa_thumb_text_rating", "yes", "yes");
INSERT INTO `wp_options` VALUES("429", "wppa_popup_text_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("430", "wppa_popup_text_desc", "yes", "yes");
INSERT INTO `wp_options` VALUES("431", "wppa_popup_text_desc_strip", "no", "yes");
INSERT INTO `wp_options` VALUES("432", "wppa_popup_text_rating", "yes", "yes");
INSERT INTO `wp_options` VALUES("433", "wppa_show_rating_count", "no", "yes");
INSERT INTO `wp_options` VALUES("434", "wppa_show_cover_text", "yes", "yes");
INSERT INTO `wp_options` VALUES("435", "wppa_enable_slideshow", "yes", "yes");
INSERT INTO `wp_options` VALUES("436", "wppa_show_slideshowbrowselink", "yes", "yes");
INSERT INTO `wp_options` VALUES("437", "wppa_show_viewlink", "yes", "yes");
INSERT INTO `wp_options` VALUES("438", "wppa_show_bbb_widget", "no", "yes");
INSERT INTO `wp_options` VALUES("439", "wppa_ovl_close_txt", "CLOSE", "yes");
INSERT INTO `wp_options` VALUES("440", "wppa_ovl_theme", "black", "yes");
INSERT INTO `wp_options` VALUES("441", "wppa_ovl_slide_name", "no", "yes");
INSERT INTO `wp_options` VALUES("442", "wppa_ovl_slide_desc", "yes", "yes");
INSERT INTO `wp_options` VALUES("443", "wppa_ovl_thumb_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("444", "wppa_ovl_thumb_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("445", "wppa_ovl_potd_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("446", "wppa_ovl_potd_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("447", "wppa_bgcolor_even", "#eeeeee", "yes");
INSERT INTO `wp_options` VALUES("448", "wppa_bcolor_even", "#cccccc", "yes");
INSERT INTO `wp_options` VALUES("449", "wppa_bgcolor_alt", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("450", "wppa_bcolor_alt", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("451", "wppa_bgcolor_nav", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("452", "wppa_bcolor_nav", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("453", "wppa_bgcolor_namedesc", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("454", "wppa_bcolor_namedesc", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("455", "wppa_bgcolor_com", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("456", "wppa_bcolor_com", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("457", "wppa_bgcolor_img", "#eeeeee", "yes");
INSERT INTO `wp_options` VALUES("458", "wppa_bcolor_img", "", "yes");
INSERT INTO `wp_options` VALUES("459", "wppa_bgcolor_fullimg", "#cccccc", "yes");
INSERT INTO `wp_options` VALUES("460", "wppa_bcolor_fullimg", "#777777", "yes");
INSERT INTO `wp_options` VALUES("461", "wppa_bgcolor_cus", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("462", "wppa_bcolor_cus", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("463", "wppa_bgcolor_numbar", "#cccccc", "yes");
INSERT INTO `wp_options` VALUES("464", "wppa_bcolor_numbar", "#cccccc", "yes");
INSERT INTO `wp_options` VALUES("465", "wppa_bgcolor_numbar_active", "#333333", "yes");
INSERT INTO `wp_options` VALUES("466", "wppa_bcolor_numbar_active", "#333333", "yes");
INSERT INTO `wp_options` VALUES("467", "wppa_bgcolor_iptc", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("468", "wppa_bcolor_iptc", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("469", "wppa_bgcolor_exif", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("470", "wppa_bcolor_exif", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("471", "wppa_allow_ajax", "no", "yes");
INSERT INTO `wp_options` VALUES("472", "wppa_use_photo_names_in_urls", "no", "yes");
INSERT INTO `wp_options` VALUES("473", "wppa_fullvalign", "fit", "yes");
INSERT INTO `wp_options` VALUES("474", "wppa_fullhalign", "center", "yes");
INSERT INTO `wp_options` VALUES("475", "wppa_start_slide", "run", "yes");
INSERT INTO `wp_options` VALUES("476", "wppa_start_slideonly", "yes", "yes");
INSERT INTO `wp_options` VALUES("477", "wppa_animation_type", "fadeover", "yes");
INSERT INTO `wp_options` VALUES("478", "wppa_slideshow_timeout", "2500", "yes");
INSERT INTO `wp_options` VALUES("479", "wppa_animation_speed", "800", "yes");
INSERT INTO `wp_options` VALUES("480", "wppa_slide_pause", "no", "yes");
INSERT INTO `wp_options` VALUES("481", "wppa_slide_wrap", "yes", "yes");
INSERT INTO `wp_options` VALUES("482", "wppa_fulldesc_align", "center", "yes");
INSERT INTO `wp_options` VALUES("483", "wppa_clean_pbr", "yes", "yes");
INSERT INTO `wp_options` VALUES("484", "wppa_list_photos_by", "0", "yes");
INSERT INTO `wp_options` VALUES("485", "wppa_list_photos_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("486", "wppa_thumbtype", "default", "yes");
INSERT INTO `wp_options` VALUES("487", "wppa_thumbphoto_left", "no", "yes");
INSERT INTO `wp_options` VALUES("488", "wppa_valign", "center", "yes");
INSERT INTO `wp_options` VALUES("489", "wppa_use_thumb_opacity", "yes", "yes");
INSERT INTO `wp_options` VALUES("490", "wppa_thumb_opacity", "85", "yes");
INSERT INTO `wp_options` VALUES("491", "wppa_use_thumb_popup", "yes", "yes");
INSERT INTO `wp_options` VALUES("492", "wppa_list_albums_by", "0", "yes");
INSERT INTO `wp_options` VALUES("493", "wppa_list_albums_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("494", "wppa_coverphoto_pos", "right", "yes");
INSERT INTO `wp_options` VALUES("495", "wppa_use_cover_opacity", "yes", "yes");
INSERT INTO `wp_options` VALUES("496", "wppa_cover_opacity", "85", "yes");
INSERT INTO `wp_options` VALUES("497", "wppa_rating_login", "yes", "yes");
INSERT INTO `wp_options` VALUES("498", "wppa_rating_change", "yes", "yes");
INSERT INTO `wp_options` VALUES("499", "wppa_rating_multi", "no", "yes");
INSERT INTO `wp_options` VALUES("500", "wppa_rating_use_ajax", "no", "yes");
INSERT INTO `wp_options` VALUES("501", "wppa_next_on_callback", "no", "yes");
INSERT INTO `wp_options` VALUES("502", "wppa_star_opacity", "20", "yes");
INSERT INTO `wp_options` VALUES("503", "wppa_comment_login", "no", "yes");
INSERT INTO `wp_options` VALUES("504", "wppa_comments_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("505", "wppa_comment_moderation", "logout", "yes");
INSERT INTO `wp_options` VALUES("506", "wppa_comment_email_required", "yes", "yes");
INSERT INTO `wp_options` VALUES("507", "wppa_ovl_opacity", "80", "yes");
INSERT INTO `wp_options` VALUES("508", "wppa_ovl_onclick", "none", "yes");
INSERT INTO `wp_options` VALUES("509", "wppa_ovl_anim", "300", "yes");
INSERT INTO `wp_options` VALUES("510", "wppa_fontfamily_title", "", "yes");
INSERT INTO `wp_options` VALUES("511", "wppa_fontsize_title", "", "yes");
INSERT INTO `wp_options` VALUES("512", "wppa_fontcolor_title", "", "yes");
INSERT INTO `wp_options` VALUES("513", "wppa_fontweight_title", "bold", "yes");
INSERT INTO `wp_options` VALUES("514", "wppa_fontfamily_fulldesc", "", "yes");
INSERT INTO `wp_options` VALUES("515", "wppa_fontsize_fulldesc", "", "yes");
INSERT INTO `wp_options` VALUES("516", "wppa_fontcolor_fulldesc", "", "yes");
INSERT INTO `wp_options` VALUES("517", "wppa_fontweight_fulldesc", "normal", "yes");
INSERT INTO `wp_options` VALUES("518", "wppa_fontfamily_fulltitle", "", "yes");
INSERT INTO `wp_options` VALUES("519", "wppa_fontsize_fulltitle", "", "yes");
INSERT INTO `wp_options` VALUES("520", "wppa_fontcolor_fulltitle", "", "yes");
INSERT INTO `wp_options` VALUES("521", "wppa_fontweight_fulltitle", "normal", "yes");
INSERT INTO `wp_options` VALUES("522", "wppa_fontfamily_nav", "", "yes");
INSERT INTO `wp_options` VALUES("523", "wppa_fontsize_nav", "", "yes");
INSERT INTO `wp_options` VALUES("524", "wppa_fontcolor_nav", "", "yes");
INSERT INTO `wp_options` VALUES("525", "wppa_fontweight_nav", "normal", "yes");
INSERT INTO `wp_options` VALUES("526", "wppa_fontfamily_thumb", "", "yes");
INSERT INTO `wp_options` VALUES("527", "wppa_fontsize_thumb", "", "yes");
INSERT INTO `wp_options` VALUES("528", "wppa_fontcolor_thumb", "", "yes");
INSERT INTO `wp_options` VALUES("529", "wppa_fontweight_thumb", "normal", "yes");
INSERT INTO `wp_options` VALUES("530", "wppa_fontfamily_box", "", "yes");
INSERT INTO `wp_options` VALUES("531", "wppa_fontsize_box", "", "yes");
INSERT INTO `wp_options` VALUES("532", "wppa_fontcolor_box", "", "yes");
INSERT INTO `wp_options` VALUES("533", "wppa_fontweight_box", "normal", "yes");
INSERT INTO `wp_options` VALUES("534", "wppa_fontfamily_numbar", "", "yes");
INSERT INTO `wp_options` VALUES("535", "wppa_fontsize_numbar", "", "yes");
INSERT INTO `wp_options` VALUES("536", "wppa_fontcolor_numbar", "#777777", "yes");
INSERT INTO `wp_options` VALUES("537", "wppa_fontweight_numbar", "normal", "yes");
INSERT INTO `wp_options` VALUES("538", "wppa_fontfamily_numbar_active", "", "yes");
INSERT INTO `wp_options` VALUES("539", "wppa_fontsize_numbar_active", "", "yes");
INSERT INTO `wp_options` VALUES("540", "wppa_fontcolor_numbar_active", "#777777", "yes");
INSERT INTO `wp_options` VALUES("541", "wppa_fontweight_numbar_active", "bold", "yes");
INSERT INTO `wp_options` VALUES("542", "wppa_sphoto_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("543", "wppa_sphoto_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("544", "wppa_sphoto_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("545", "wppa_sphoto_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("546", "wppa_mphoto_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("547", "wppa_mphoto_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("548", "wppa_mphoto_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("549", "wppa_mphoto_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("550", "wppa_thumb_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("551", "wppa_thumb_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("552", "wppa_thumb_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("553", "wppa_thumb_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("554", "wppa_topten_widget_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("555", "wppa_topten_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("556", "wppa_topten_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("557", "wppa_topten_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("558", "wppa_slideonly_widget_linktype", "widget", "yes");
INSERT INTO `wp_options` VALUES("559", "wppa_slideonly_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("560", "wppa_sswidget_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("561", "wppa_sswidget_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("562", "wppa_widget_linktype", "album", "yes");
INSERT INTO `wp_options` VALUES("563", "wppa_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("564", "wppa_potd_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("565", "wppa_potdwidget_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("566", "wppa_coverimg_linktype", "same", "yes");
INSERT INTO `wp_options` VALUES("567", "wppa_coverimg_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("568", "wppa_coverimg_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("569", "wppa_coverimg_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("570", "wppa_comment_widget_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("571", "wppa_comment_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("572", "wppa_comment_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("573", "wppa_comment_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("574", "wppa_slideshow_linktype", "none", "yes");
INSERT INTO `wp_options` VALUES("575", "wppa_slideshow_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("576", "wppa_slideshow_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("577", "wppa_thumbnail_widget_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("578", "wppa_thumbnail_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("579", "wppa_thumbnail_widget_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("580", "wppa_thumbnail_widget_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("581", "wppa_film_linktype", "slideshow", "yes");
INSERT INTO `wp_options` VALUES("582", "wppa_lasten_widget_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("583", "wppa_lasten_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("584", "wppa_lasten_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("585", "wppa_lasten_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("586", "wppa_user_upload_login", "yes", "yes");
INSERT INTO `wp_options` VALUES("587", "wppa_owner_only", "no", "yes");
INSERT INTO `wp_options` VALUES("588", "wppa_user_upload_on", "no", "yes");
INSERT INTO `wp_options` VALUES("589", "wppa_upload_moderate", "no", "yes");
INSERT INTO `wp_options` VALUES("590", "wppa_comment_captcha", "no", "yes");
INSERT INTO `wp_options` VALUES("591", "wppa_spam_maxage", "none", "yes");
INSERT INTO `wp_options` VALUES("592", "wppa_setup", "", "yes");
INSERT INTO `wp_options` VALUES("593", "wppa_backup", "", "yes");
INSERT INTO `wp_options` VALUES("594", "wppa_load_skin", "", "yes");
INSERT INTO `wp_options` VALUES("248", "akismet_available_servers", "a:4:{s:12:\"66.135.58.62\";b:1;s:12:\"66.135.58.61\";b:1;s:12:\"72.233.69.88\";b:1;s:12:\"72.233.69.89\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("249", "akismet_connectivity_time", "1344961067", "yes");
INSERT INTO `wp_options` VALUES("250", "wordpress_api_key", "3d1ec4e4094a", "yes");
INSERT INTO `wp_options` VALUES("251", "akismet_discard_month", "true", "yes");
INSERT INTO `wp_options` VALUES("252", "akismet_show_user_comments_approved", "true", "yes");
INSERT INTO `wp_options` VALUES("255", "travel_general", "a:16:{s:13:\"header_height\";s:2:\"90\";s:12:\"display_logo\";b:0;s:4:\"logo\";s:0:\"\";s:17:\"display_site_desc\";s:4:\"true\";s:11:\"logo_bottom\";s:2:\"20\";s:13:\"top_area_type\";s:4:\"html\";s:13:\"top_area_html\";s:0:\"\";s:15:\"enable_nav_menu\";b:0;s:14:\"excluded_pages\";a:0:{}s:14:\"custom_favicon\";s:0:\"\";s:9:\"introduce\";s:4:\"true\";s:18:\"disable_breadcrumb\";s:4:\"true\";s:9:\"analytics\";s:0:\"\";s:11:\"enable_gmap\";b:0;s:12:\"gmap_api_key\";s:0:\"\";s:10:\"custom_css\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("647", "wppa_wp_wppa_albums_lastkey", "2", "no");
INSERT INTO `wp_options` VALUES("648", "wppa_last_album_used-globalthrillz", "1", "yes");
INSERT INTO `wp_options` VALUES("649", "wppa_wp_wppa_photos_lastkey", "6", "no");
INSERT INTO `wp_options` VALUES("6901", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6902", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 01:07:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=4.0-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2014/04/smith/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:411:\"Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23279:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n<embed src=\"//v0.wordpress.com/player.swf?v=1.03\" type=\"application/x-shockwave-flash\" width=\"640\" height=\"360\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\" flashvars=\"guid=sAiXhCfV&amp;isDynamicSeeking=true\" title=\"\"></embed>\n<h2 class=\"about-headline-callout\" style=\"text-align: center\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"//wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"//wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"//wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<h2 style=\"text-align: center\">Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"//wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2 style=\"text-align: center\">Do more with audio and video</h2>\n\n<a href=\'http://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\'>Ain\'t Misbehavin\'</a>\n<a href=\'http://wordpress.org/news/files/2014/04/DavenportBlues.mp3\'>Davenport Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\'>Buddy Bolden\'s Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\'>Squaty Roo</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\'>Dixie Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/WolverineBlues.mp3\'>Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2 style=\"text-align: center\">Live widget and header previews</h2>\n<div style=\"width: 692px; max-width: 100%;\" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-3154-1\" width=\"692\" height=\"448\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//wordpress.org/news/files/2014/04/widgets.mp4?_=1\" /><a href=\"//wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></video></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2 style=\"text-align: center\">Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"//wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2 style=\"text-align: center\">The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"http://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"http://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"http://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"http://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"http://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/cmmarslender\">Chris Marslender</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"http://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"http://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"http://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"http://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"http://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"http://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"http://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"http://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"http://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"http://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"http://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"http://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"http://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"http://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"http://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"http://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"http://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lkwdwrd\">lkwdwrd</a>, <a href=\"http://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"http://profiles.wordpress.org/ldebrouwer\">Luc De Brouwer</a>, <a href=\"http://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"http://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"http://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"http://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"http://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/oso96_2000\">oso96_2000</a>, <a href=\"http://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"http://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"http://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"http://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"http://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"http://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/richard2222\">richard2222</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"http://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"http://profiles.wordpress.org/ruudjoyo\">ruud@joyo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"http://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"http://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"http://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"http://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"http://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"http://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"http://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/toru\">Toru</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"http://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"http://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"http://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"http://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"http://make.wordpress.org/\">Make WordPress</a> and our <a href=\"http://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2014/04/smith/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.9 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 09:47:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3151\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:356:\"The second release candidate for WordPress 3.9 is now available for testing. If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the first release candidate, and those changes are all helpfully summarized in our weekly post on the development blog. Probably the biggest fixes are to live [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2328:\"<p>The second release candidate for WordPress 3.9 is now available for testing.</p>\n<p>If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the <a title=\"WordPress 3.9 Release Candidate\" href=\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">first release candidate</a>, and those changes are all helpfully summarized <a href=\"http://make.wordpress.org/core/?p=10237\">in our weekly post</a> on the development blog. Probably the biggest fixes are to live widget previews and the new theme browser, along with some extra TinyMCE compatibility and some RTL fixes.</p>\n<p><strong>Plugin authors:</strong> Could you test your plugins against 3.9, and if they&#8217;re compatible, make sure they are marked as tested up to 3.9? It only takes a few minutes and this really helps make launch easier. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"http://make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example: <a href=\"http://make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5</a>, <a href=\"http://make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">symlinks</a>, <a href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL</a>, <a href=\"http://make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload</a>.)</p>\n<p>To test WordPress 3.9 RC2, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-RC2.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the nearly complete About screen in your dashboard (<strong><img src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a title=\"WordPress 3.9 Beta 1\" href=\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><em>This is for testing,</em><br />\n<em>so not recommended for<br />\nproduction sites—yet.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.3 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 19:29:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3145\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"WordPress 3.8.3 is now available to fix a small but unfortunate bug in the WordPress 3.8.2 security release. The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2339:\"<p>WordPress 3.8.3 is now available to fix a small but unfortunate bug in the <a title=\"WordPress 3.8.2 Security Release\" href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">WordPress 3.8.2 security release</a>.</p>\n<p>The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using this tool, <em>any</em> loss of content is unacceptable to us.</p>\n<p>We recognize how much trust you place in us to safeguard your content, and we take this responsibility very seriously. We&#8217;re sorry we let you down.</p>\n<p>We&#8217;ve all lost words we&#8217;ve written before, like an email thanks to a cat on the keyboard or a term paper to a blue screen of death. Over the last few WordPress releases, we&#8217;ve made a number of improvements to features like autosaves and revisions. With revisions, an old edit can always be restored. We&#8217;re trying our hardest to save your content somewhere even if your power goes out or your browser crashes. We even monitor your internet connection and prevent you from hitting that &#8220;Publish&#8221; button at the exact moment the coffee shop Wi-Fi has a hiccup.</p>\n<p>It&#8217;s <em>possible</em> that the quick draft you lost last week is still in the database, and just hidden from view. As an added complication, these &#8220;discarded drafts&#8221; normally get deleted after seven days, and it&#8217;s already been six days since the release. If we were able to rescue your draft, you&#8217;ll see it on the &#8220;All Posts&#8221; screen after you update to 3.8.3. (We&#8217;ll also be pushing 3.8.3 out as a background update, so you may just see a draft appear.)</p>\n<p>So, if you tried to jot down a quick idea last week, I hope WordPress has recovered it for you. Maybe it&#8217;ll turn into that novella.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.3</a> or click &#8220;Update Now&#8221; on Dashboard → Updates.</p>\n<p><em>This affected version 3.7.2 as well, so we&#8217;re pushing a 3.7.3 to these installs, but we&#8217;d encourage you to update to the latest and greatest.</em></p>\n<hr />\n<p><em>Now for some good news:<br />\nWordPress 3.9 is near.<br />\nExpect it this week</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.9 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 21:05:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3129\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"As teased earlier, the first release candidate for WordPress 3.9 is now available for testing! We hope to ship WordPress 3.9 next week, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.) To test WordPress 3.9 [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3022:\"<p><a href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">As teased earlier</a>, the first release candidate for WordPress 3.9 is now available for testing!</p>\n<p>We hope to ship WordPress 3.9 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>To test WordPress 3.9 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the work-in-progress About screen in your dashboard (<strong><img src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and check out <a title=\"WordPress 3.9 Beta 1\" href=\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>If you&#8217;re a plugin author</strong>, there are two important changes in particular to be aware of:</p>\n<ul>\n<li>TinyMCE received a major update, to version 4.0. Any editor plugins written for TinyMCE 3.x might require some updates. (If things broke, we&#8217;d like to hear about them so we can make adjustments.) For more, see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">migration guide</a> and <a href=\"http://www.tinymce.com/wiki.php/api4:index\">API documentation</a>, and the notes on the <a href=\"http://make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\">core development blog</a>.</li>\n<li>WordPress 3.9 now uses the MySQLi Improved extension for sites running PHP 5.5. Any plugins that made direct calls to <code>mysql_*</code> functions will experience some problems on these sites. For more information, see the notes on the <a href=\"http://make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">core development blog</a>.</li>\n</ul>\n<p>Be sure to follow along the core development blog, where we will be continuing to post <a href=\"http://make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example, read <a href=\"http://make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\">this</a> if you are using Masonry in your theme.) And please, please update your plugin&#8217;s <em>Tested up to</em> version in the readme to 3.9 before April 16.</p>\n<p><em>Release candidate<br />\nThis haiku&#8217;s the easy one<br />\n3.9 is near</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 3.8.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 19:04:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3124\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:355:\"WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately. This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by Jon Cave of the WordPress [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2272:\"<p>WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by <a href=\"http://joncave.co.uk/\">Jon Cave</a> of the WordPress security team.</p>\n<p>It also contains a fix to prevent a user with the Contributor role from improperly publishing posts. Reported by <a href=\"http://edik.ch/\">edik</a>.</p>\n<p>This release also fixes nine bugs and contains three other security hardening changes:</p>\n<ul>\n<li>Pass along additional information when processing pingbacks to help hosts identify potentially abusive requests.</li>\n<li>Fix a low-impact SQL injection by trusted users. Reported by <a href=\"http://www.dxw.com/\">Tom Adams</a> of dxw.</li>\n<li>Prevent possible cross-domain scripting through Plupload, the third-party library WordPress uses for uploading files. Reported by <a href=\"http://szgru.website.pl/\">Szymon Gruszecki</a>.</li>\n</ul>\n<p>We appreciated <a href=\"http://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these security issues directly to our security team. For more information on all of the changes, see the <a href=\"http://codex.wordpress.org/Version_3.8.2\">release notes</a> or consult <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=28057&amp;stop_rev=27024\">the list of changes</a>.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.2</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Sites that support automatic background updates will be updated to WordPress 3.8.2 within 12 hours. If you are still on WordPress 3.7.1, you will be updated to 3.7.2, which contains the same security fixes as 3.8.2. We don&#8217;t support older versions, so please update to 3.8.2 for the latest and greatest.</p>\n<p>Already testing WordPress 3.9? The first release candidate is <a href=\"https://wordpress.org/wordpress-3.9-RC1.zip\">now available</a> (zip) and it contains these security fixes. Look for a full announcement later today; we expect to release 3.9 next week.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 29 Mar 2014 13:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3106\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"The third (and maybe last) beta of WordPress 3.9 is now available for download. Beta 3 includes more than 200 changes, including: New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out. UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2668:\"<p>The third (and maybe last) beta of WordPress 3.9 is now available for download.</p>\n<p>Beta 3 includes more than 200 <a href=\"https://core.trac.wordpress.org/log?rev=27850&amp;stop_rev=27639&amp;limit=300\">changes</a>, including:</p>\n<ul>\n<li>New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out.</li>\n<li>UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought back some of the advanced display settings for images.</li>\n<li>If you want to test out audio and video playlists, the links will appear in the media manager once you&#8217;ve uploaded an audio or video file.</li>\n<li>For theme developers, we&#8217;ve added HTML5 caption support (<a class=\"reopened ticket\" title=\"task (blessed): HTML5 captions (reopened)\" href=\"https://core.trac.wordpress.org/ticket/26642\">#26642</a>) to match the new gallery support (<a class=\"closed ticket\" title=\"enhancement: HTML5 Galleries (closed: fixed)\" href=\"https://core.trac.wordpress.org/ticket/26697\">#26697</a>).</li>\n<li>The formatting function that turns straight quotes into smart quotes (among other things) underwent some changes to drastically speed it up, so let us know if you see anything weird.</li>\n</ul>\n<p><strong>We need your help</strong>. We&#8217;re still aiming for an April release, which means the next week will be critical for identifying and squashing bugs. If you&#8217;re just joining us, please see <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a> for what to look out for.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums, where friendly moderators are standing by. <b>Plugin developers</b><strong>,</strong> if you haven&#8217;t tested WordPress 3.9 yet, now is the time — and be sure to update the &#8220;tested up to&#8221; version for your plugins so they&#8217;re listed as compatible with 3.9.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta3.zip\">download the beta here</a> (zip).</p>\n<p><em>WordPress 3.9<br />\nLet&#8217;s make the date official<br />\nIt&#8217;s April 16</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Mar 2014 05:01:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3101\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:309:\"WordPress 3.9 Beta 2 is now available for testing! We&#8217;ve made more than a hundred changes since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to the Beta 1 announcement post. Some of the changes in [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1901:\"<p>WordPress 3.9 Beta 2 is now available for testing!</p>\n<p>We&#8217;ve made more than a hundred <a href=\"https://core.trac.wordpress.org/log?rev=27639&amp;stop_rev=27500&amp;limit=200\">changes</a> since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a>. Some of the changes in Beta 2 include:</p>\n<ul>\n<li>Rendering of embedded audio and video players directly in the visual editor.</li>\n<li>Visual and functional improvements to the editor, the media manager, and theme installer.</li>\n<li>Various bug fixes to TinyMCE, the software behind the visual editor.</li>\n<li>Lots of fixes to widget management in the theme customizer.</li>\n</ul>\n<p>As always,<strong> if you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta2.zip\">download the beta here</a> (zip).</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Mar 2014 13:42:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3083\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"I&#8217;m excited to announce that the first beta of WordPress 3.9 is now available for testing. WordPress 3.9 is due out next month &#8212; but in order to hit that goal, we need your help testing all of the goodies we&#8217;ve added: We updated TinyMCE, the software powering the visual editor, to the latest version. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6065:\"<p>I&#8217;m excited to announce that the <strong>first beta of WordPress 3.9</strong> is now available for testing.</p>\n<p>WordPress 3.9 is due out next month &#8212; but in order to hit that goal, <strong>we need your help</strong> testing all of the goodies we&#8217;ve added:</p>\n<ul>\n<li>We updated TinyMCE, the software powering the visual editor, to the latest version. Be on the lookout for cleaner markup. Also try the new paste handling &#8212; if you paste in a block of text from Microsoft Word, for example, it will no longer come out terrible. (The &#8220;Paste from Word&#8221; button you probably never noticed has been removed.) It&#8217;s possible some plugins that added stuff to the visual editor (like a new toolbar button) no longer work, so we&#8217;d like to hear about them (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>). (And be sure to <a href=\"http://wordpress.org/support/\">open a support thread</a> for the plugin author.)</li>\n<li>We&#8217;ve added <strong>widget management to live previews</strong> (the customizer). Please test editing, adding, and rearranging widgets! (<a href=\"https://core.trac.wordpress.org/ticket/27112\">#27112</a>) We&#8217;ve also added the ability to upload, crop, and manage header images, without needing to leave the preview. (<a href=\"https://core.trac.wordpress.org/ticket/21785\">#21785</a>)</li>\n<li>We brought 3.8&#8242;s beautiful new theme browsing experience to the <strong>theme installer</strong>. Check it out! (<a title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/27055\">#27055</a>)</li>\n<li><strong>Galleries</strong> now receive a live preview in the editor. Upload some photos and insert a gallery to see this in action. (<a href=\"https://core.trac.wordpress.org/ticket/26959\">#26959</a>)</li>\n<li>You can now <strong>drag-and-drop</strong> images directly onto the editor to upload them. It can be a bit finicky, so try it and help us work out the kinks. (<a href=\"https://core.trac.wordpress.org/ticket/19845\">#19845</a>)</li>\n<li>Some things got improved around <strong>editing images</strong>. It&#8217;s a lot easier to make changes to an image after you insert it into a post (<a class=\"closed\" title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/24409\">#24409</a>) and you no longer get kicked to a new window when you need to crop or rotate an image (<a href=\"https://core.trac.wordpress.org/ticket/21811\">#21811</a>).</li>\n<li>New <strong>audio/video playlists</strong>. Upload a few audio or video files to test these. (<a href=\"https://core.trac.wordpress.org/ticket/26631\">#26631</a>)</li>\n</ul>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We&#8217;d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta1.zip\">download the beta here</a> (zip).</p>\n<hr />\n<p><strong>DEVELOPERS!</strong> Hello! There&#8217;s lots for you, too.</p>\n<p><strong>Please test your plugins and themes!</strong> There&#8217;s a lot of great stuff under the hood in 3.9 and we hope to blog a bit about them in the coming days. If you haven&#8217;t been reading the awesome <a href=\"http://make.wordpress.org/core/tag/week-in-core/\">weekly summaries</a> on the <a href=\"http://make.wordpress.org/core/\">main core development blog</a>, that&#8217;s a great place to start. (You should definitely follow that blog.) For now, here are some things to watch out for when testing:</p>\n<ul>\n<li>The <strong>load process in multisite</strong> got rewritten. If you notice any issues with your network, see <a href=\"https://core.trac.wordpress.org/ticket/27003\">#27003</a>.</li>\n<li>We now use the <strong>MySQL Improved (mysqli) database extension</strong> if you&#8217;re running a recent version of PHP (<a href=\"https://core.trac.wordpress.org/ticket/21663\">#21663</a>). Please test your plugins and see that everything works well, and please make sure you&#8217;re not calling <code>mysql_*</code> functions directly.</li>\n<li><strong>Autosave</strong> was refactored, so if you see any issues related to autosaving, heartbeat, etc., let us know (<a href=\"https://core.trac.wordpress.org/ticket/25272\">#25272</a>).</li>\n<li>Library updates, in particular Backbone 1.1 and Underscore 1.6 (<a href=\"https://core.trac.wordpress.org/ticket/26799\">#26799</a>). Also Masonry 3 (<a href=\"https://core.trac.wordpress.org/ticket/25351\">#25351</a>), PHPMailer (<a href=\"https://core.trac.wordpress.org/ticket/25560\">#25560</a>), Plupload (<a href=\"https://core.trac.wordpress.org/ticket/25663\">#25663</a>), and TinyMCE (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>).</li>\n<li>TinyMCE 4.0 is a <em>major</em> update. Please see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">upgrade guide</a> and our <a href=\"https://core.trac.wordpress.org/ticket/24067\">implementation ticket</a> for more. If you have any questions or problems, please <a href=\"http://wordpress.org/support/forum/alphabeta\">open a thread in the support forums</a>.</li>\n</ul>\n<p>Happy testing!</p>\n<p><em><em>Lots of improvements<br />\nLittle things go a long way</em><br />\nPlease test beta one<br />\n</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:37:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3063\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"After six weeks and more than 9.3 million downloads of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3809:\"<p>After six weeks and more than <a href=\"http://wordpress.org/download/counter/\">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href=\"http://codex.wordpress.org/Embeds\">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.8.1\">list of tickets</a> and <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=27018&amp;stop_rev=26862\">the changelog</a>. There&#8217;s also a <a href=\"http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/\">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"#\">José Pino</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://wordpress.org/news/2013/12/parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/parker/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2765\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:354:\"Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:19098:\"<p>Version 3.8 of WordPress, named “Parker” in honor of <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>, bebop innovator, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id=\"v-6wORgoGb-1\" class=\"video-player\"><embed id=\"v-6wORgoGb-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=6wORgoGb&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<h2 class=\"aligncenter\">Introducing a modern new design</h2>\n<p><img class=\"wp-image-2951 aligncenter\" alt=\"overview\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193\" data-recalc-dims=\"1\" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class=\"aligncenter  wp-image-2856\" style=\"margin-left: 0;margin-right: 0\" alt=\"about-modern-wordpress\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151\" data-recalc-dims=\"1\" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class=\"aligncenter\">WordPress on every device</h2>\n<p><img class=\"alignright  wp-image-2984\" alt=\"responsive\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255\" data-recalc-dims=\"1\" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class=\"aligncenter\">Admin color schemes to match your personality</h2>\n<p><img class=\"aligncenter  wp-image-2954\" alt=\"colors\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339\" data-recalc-dims=\"1\" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class=\"aligncenter\">Refined theme management</h2>\n<p><img class=\"alignright  wp-image-2967\" alt=\"themes\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344\" data-recalc-dims=\"1\" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class=\"aligncenter\">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class=\"aligncenter size-large wp-image-2789\" alt=\"The new Twenty Fourteen theme displayed on a laptop. tablet and phone\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275\" data-recalc-dims=\"1\" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title=\"Make WordPress Core\" href=\"http://make.wordpress.org/core/\" target=\"_blank\">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/admiralthrawn\">admiralthrawn</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aralbald\">Andrey Kabakchiev</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/apeatling\">Andy Peatling</a>, <a href=\"http://profiles.wordpress.org/ankitgadertcampcom\">Ankit Gade</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/fliespl\">Arkadiusz Rzadkowolski</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy Schneider</a>, <a href=\"http://profiles.wordpress.org/binarymoon\">binarymoon</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/calin\">Calin Don</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/chrisbliss18\">Chris Jean</a>, <a href=\"http://profiles.wordpress.org/iblamefish\">Clinton Montague</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/dbernar1\">Dan Bernardic</a>, <a href=\"http://profiles.wordpress.org/danieldudzic\">Daniel Dudzic</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/datafeedrcom\">datafeedr</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">Dave Martin</a>, <a href=\"http://profiles.wordpress.org/drw158\">Dave Whitley</a>, <a href=\"http://profiles.wordpress.org/designsimply\">designsimply</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/dziudek\">dziudek</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gnarf37\">gnarf37</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/isaackeyet\">Isaac Keyet</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"http://profiles.wordpress.org/janhenckens\">janhenckens</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"http://profiles.wordpress.org/jeffr0\">Jeff Chandler</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jeherve\">Jeremy Herve</a>, <a href=\"http://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jhned\">jhned</a>, <a href=\"http://profiles.wordpress.org/jim912\">jim912</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K. Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"http://profiles.wordpress.org/littlethingsstudio\">Kate Whitley</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/koki4a\">Konstantin Dankov</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lite3\">lite3</a>, <a href=\"http://profiles.wordpress.org/lucp\">Luc Princen</a>, <a href=\"http://profiles.wordpress.org/latz\">Lutz Schroer</a>, <a href=\"http://profiles.wordpress.org/mako09\">Mako</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/megane9988\">megane9988</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/micahwave\">micahwave</a>, <a href=\"http://profiles.wordpress.org/cainm\">Michael Cain</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">Michael Erlewine</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/chellycat\">Michelle Langston</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mt8biz\">moto hachi</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/neil_pie\">Neil Pie</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/ninio\">ninio</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"http://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/senlin\">Piet</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/bamadesigner\">Rachel Carden</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/radices\">Radices</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/defries\">Remkus de Vries</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/wet\">Robert Wetzlmayr, PHP-Programmierer</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood</a>, <a href=\"http://profiles.wordpress.org/sanchothefat\">sanchothefat</a>, <a href=\"http://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"http://profiles.wordpress.org/scottbasgaard\">Scott Basgaard</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirbrillig\">sirbrillig</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">tellyworth</a>, <a href=\"http://profiles.wordpress.org/thomasguillot\">Thomas Guillot</a>, <a href=\"http://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"http://profiles.wordpress.org/tillkruess\">Till Krüss</a>, <a href=\"http://profiles.wordpress.org/tlamedia\">TLA Media</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomdxw\">tomdxw</a>, <a href=\"http://profiles.wordpress.org/tommcfarlin\">tommcfarlin</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/trishasalas\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/mbmufffin\">Tyler Smith</a>, <a href=\"http://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/l10n\">Vladimir</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yonasy\">yonasy</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, and <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>. Also thanks to <a href=\"http://benmorrison.org/\">Ben Morrison</a> and <a href=\"http://christineswebb.com/\">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wordpress.org/news/2013/12/parker/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 28 Apr 2014 23:58:07 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 17 Apr 2014 01:07:32 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20131030160355\";}", "no");
INSERT INTO `wp_options` VALUES("6920", "_site_transient_timeout_browser_cdd9bb9381c4c4ef67c3954a553de46b", "1399336592", "yes");
INSERT INTO `wp_options` VALUES("6921", "_site_transient_browser_cdd9bb9381c4c4ef67c3954a553de46b", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"34.0.1847.131\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("1088", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("147", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("151", "_transient_random_seed", "b6d8e2681c51db75948349b356653cee", "yes");
INSERT INTO `wp_options` VALUES("260", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("4223", "wppa_cached_options_admin", "a:476:{s:13:\"wppa_revision\";s:4:\"5114\";s:12:\"wppa_prevrev\";s:4:\"4906\";s:13:\"wppa_colwidth\";s:3:\"640\";s:21:\"wppa_resize_on_upload\";s:2:\"no\";s:14:\"wppa_resize_to\";s:1:\"0\";s:15:\"wppa_min_thumbs\";s:1:\"1\";s:11:\"wppa_bwidth\";s:1:\"1\";s:12:\"wppa_bradius\";s:1:\"6\";s:16:\"wppa_box_spacing\";s:1:\"8\";s:13:\"wppa_fullsize\";s:3:\"640\";s:14:\"wppa_maxheight\";s:3:\"480\";s:12:\"wppa_enlarge\";s:2:\"no\";s:27:\"wppa_fullimage_border_width\";s:0:\"\";s:15:\"wppa_numbar_max\";s:2:\"10\";s:15:\"wppa_share_size\";s:2:\"32\";s:18:\"wppa_mini_treshold\";s:3:\"300\";s:23:\"wppa_slideshow_pagesize\";s:1:\"0\";s:14:\"wppa_thumbsize\";s:3:\"100\";s:18:\"wppa_thumbsize_alt\";s:3:\"130\";s:17:\"wppa_thumb_aspect\";s:8:\"0:0:none\";s:13:\"wppa_tf_width\";s:3:\"100\";s:17:\"wppa_tf_width_alt\";s:3:\"130\";s:14:\"wppa_tf_height\";s:3:\"130\";s:18:\"wppa_tf_height_alt\";s:3:\"180\";s:14:\"wppa_tn_margin\";s:1:\"4\";s:15:\"wppa_thumb_auto\";s:3:\"yes\";s:20:\"wppa_thumb_page_size\";s:1:\"0\";s:14:\"wppa_popupsize\";s:3:\"150\";s:22:\"wppa_use_thumbs_if_fit\";s:3:\"yes\";s:20:\"wppa_max_cover_width\";s:4:\"1024\";s:22:\"wppa_text_frame_height\";s:2:\"54\";s:14:\"wppa_smallsize\";s:3:\"150\";s:20:\"wppa_smallsize_multi\";s:3:\"100\";s:24:\"wppa_coversize_is_height\";s:2:\"no\";s:20:\"wppa_album_page_size\";s:1:\"0\";s:15:\"wppa_rating_max\";s:1:\"5\";s:16:\"wppa_rating_prec\";s:1:\"2\";s:18:\"wppa_gravatar_size\";s:2:\"40\";s:15:\"wppa_ratspacing\";s:2:\"30\";s:17:\"wppa_topten_count\";s:2:\"10\";s:16:\"wppa_topten_size\";s:2:\"86\";s:17:\"wppa_comten_count\";s:2:\"10\";s:16:\"wppa_comten_size\";s:2:\"86\";s:17:\"wppa_featen_count\";s:2:\"10\";s:16:\"wppa_featen_size\";s:2:\"86\";s:27:\"wppa_thumbnail_widget_count\";s:2:\"10\";s:26:\"wppa_thumbnail_widget_size\";s:2:\"86\";s:17:\"wppa_lasten_count\";s:2:\"10\";s:16:\"wppa_lasten_size\";s:2:\"86\";s:23:\"wppa_album_widget_count\";s:2:\"10\";s:22:\"wppa_album_widget_size\";s:2:\"86\";s:18:\"wppa_related_count\";s:2:\"10\";s:18:\"wppa_ovl_txt_lines\";s:4:\"auto\";s:14:\"wppa_magnifier\";s:19:\"magnifier-small.png\";s:21:\"wppa_show_bread_posts\";s:3:\"yes\";s:21:\"wppa_show_bread_pages\";s:3:\"yes\";s:17:\"wppa_bc_on_search\";s:3:\"yes\";s:17:\"wppa_bc_on_topten\";s:3:\"yes\";s:17:\"wppa_bc_on_lasten\";s:3:\"yes\";s:17:\"wppa_bc_on_comten\";s:3:\"yes\";s:17:\"wppa_bc_on_featen\";s:3:\"yes\";s:14:\"wppa_bc_on_tag\";s:3:\"yes\";s:18:\"wppa_bc_on_related\";s:3:\"yes\";s:14:\"wppa_show_home\";s:3:\"yes\";s:14:\"wppa_show_page\";s:3:\"yes\";s:17:\"wppa_bc_separator\";s:5:\"raquo\";s:11:\"wppa_bc_txt\";s:80:\"&lt;span style=&quot;color:red; font_size:24px;&quot;&gt;&amp;bull;&lt;/span&gt;\";s:11:\"wppa_bc_url\";s:95:\"http://israelvasquez.com/traveltheworld/wp-content/plugins/wp-photo-album-plus/images/arrow.gif\";s:17:\"wppa_pagelink_pos\";s:6:\"bottom\";s:23:\"wppa_bc_slide_thumblink\";s:2:\"no\";s:30:\"wppa_show_startstop_navigation\";s:3:\"yes\";s:27:\"wppa_show_browse_navigation\";s:3:\"yes\";s:14:\"wppa_filmstrip\";s:3:\"yes\";s:19:\"wppa_film_show_glue\";s:3:\"yes\";s:19:\"wppa_show_full_name\";s:3:\"yes\";s:20:\"wppa_show_full_owner\";s:2:\"no\";s:19:\"wppa_show_full_desc\";s:3:\"yes\";s:20:\"wppa_hide_when_empty\";s:2:\"no\";s:14:\"wppa_rating_on\";s:3:\"yes\";s:23:\"wppa_dislike_mail_every\";s:1:\"5\";s:24:\"wppa_dislike_set_pending\";s:1:\"0\";s:19:\"wppa_dislike_delete\";s:1:\"0\";s:23:\"wppa_dislike_show_count\";s:3:\"yes\";s:24:\"wppa_rating_display_type\";s:7:\"graphic\";s:20:\"wppa_show_avg_rating\";s:3:\"yes\";s:18:\"wppa_show_comments\";s:3:\"yes\";s:21:\"wppa_comment_gravatar\";s:4:\"none\";s:25:\"wppa_comment_gravatar_url\";s:7:\"http://\";s:13:\"wppa_show_bbb\";s:2:\"no\";s:14:\"wppa_custom_on\";s:2:\"no\";s:19:\"wppa_custom_content\";s:95:\"<div style=\"color:red; font-size:24px; font-weight:bold; text-align:center;\">Hello world!</div>\";s:25:\"wppa_show_slideshownumbar\";s:2:\"no\";s:14:\"wppa_show_iptc\";s:2:\"no\";s:19:\"wppa_show_iptc_open\";s:2:\"no\";s:14:\"wppa_show_exif\";s:2:\"no\";s:19:\"wppa_show_exif_open\";s:2:\"no\";s:17:\"wppa_copyright_on\";s:3:\"yes\";s:21:\"wppa_copyright_notice\";s:76:\"<span style=\"color:red\" >Warning: Do not upload copyrighted material!</span>\";s:13:\"wppa_share_on\";s:2:\"no\";s:20:\"wppa_share_on_widget\";s:2:\"no\";s:13:\"wppa_share_qr\";s:3:\"yes\";s:19:\"wppa_share_facebook\";s:3:\"yes\";s:18:\"wppa_share_twitter\";s:3:\"yes\";s:16:\"wppa_share_hyves\";s:3:\"yes\";s:17:\"wppa_share_google\";s:3:\"yes\";s:20:\"wppa_share_pinterest\";s:3:\"yes\";s:19:\"wppa_share_linkedin\";s:3:\"yes\";s:22:\"wppa_facebook_comments\";s:3:\"yes\";s:18:\"wppa_facebook_like\";s:3:\"yes\";s:22:\"wppa_facebook_admin_id\";s:0:\"\";s:20:\"wppa_facebook_app_id\";s:0:\"\";s:23:\"wppa_share_single_image\";s:2:\"no\";s:20:\"wppa_thumb_text_name\";s:3:\"yes\";s:21:\"wppa_thumb_text_owner\";s:2:\"no\";s:20:\"wppa_thumb_text_desc\";s:3:\"yes\";s:22:\"wppa_thumb_text_rating\";s:3:\"yes\";s:20:\"wppa_popup_text_name\";s:3:\"yes\";s:20:\"wppa_popup_text_desc\";s:3:\"yes\";s:26:\"wppa_popup_text_desc_strip\";s:2:\"no\";s:22:\"wppa_popup_text_rating\";s:3:\"yes\";s:25:\"wppa_popup_text_ncomments\";s:3:\"yes\";s:22:\"wppa_show_rating_count\";s:2:\"no\";s:25:\"wppa_thumb_text_viewcount\";s:2:\"no\";s:25:\"wppa_albdesc_on_thumbarea\";s:4:\"none\";s:20:\"wppa_show_cover_text\";s:3:\"yes\";s:21:\"wppa_enable_slideshow\";s:3:\"yes\";s:29:\"wppa_show_slideshowbrowselink\";s:3:\"yes\";s:18:\"wppa_show_viewlink\";s:3:\"yes\";s:19:\"wppa_show_treecount\";s:2:\"no\";s:22:\"wppa_skip_empty_albums\";s:3:\"yes\";s:20:\"wppa_show_bbb_widget\";s:2:\"no\";s:27:\"wppa_show_albwidget_tooltip\";s:3:\"yes\";s:18:\"wppa_ovl_close_txt\";s:5:\"CLOSE\";s:14:\"wppa_ovl_theme\";s:5:\"black\";s:19:\"wppa_ovl_slide_name\";s:2:\"no\";s:19:\"wppa_ovl_slide_desc\";s:3:\"yes\";s:19:\"wppa_ovl_thumb_name\";s:3:\"yes\";s:19:\"wppa_ovl_thumb_desc\";s:2:\"no\";s:18:\"wppa_ovl_potd_name\";s:3:\"yes\";s:18:\"wppa_ovl_potd_desc\";s:2:\"no\";s:20:\"wppa_ovl_sphoto_name\";s:3:\"yes\";s:20:\"wppa_ovl_sphoto_desc\";s:2:\"no\";s:20:\"wppa_ovl_mphoto_name\";s:3:\"yes\";s:20:\"wppa_ovl_mphoto_desc\";s:2:\"no\";s:17:\"wppa_ovl_alw_name\";s:3:\"yes\";s:17:\"wppa_ovl_alw_desc\";s:2:\"no\";s:19:\"wppa_ovl_cover_name\";s:3:\"yes\";s:19:\"wppa_ovl_cover_desc\";s:2:\"no\";s:16:\"wppa_show_zoomin\";s:3:\"yes\";s:21:\"wppa_ovl_show_counter\";s:3:\"yes\";s:17:\"wppa_bgcolor_even\";s:7:\"#eeeeee\";s:16:\"wppa_bcolor_even\";s:7:\"#cccccc\";s:16:\"wppa_bgcolor_alt\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_alt\";s:7:\"#bbbbbb\";s:16:\"wppa_bgcolor_nav\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_nav\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_namedesc\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_namedesc\";s:7:\"#bbbbbb\";s:16:\"wppa_bgcolor_com\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_com\";s:7:\"#bbbbbb\";s:16:\"wppa_bgcolor_img\";s:7:\"#eeeeee\";s:15:\"wppa_bcolor_img\";s:0:\"\";s:20:\"wppa_bgcolor_fullimg\";s:7:\"#cccccc\";s:19:\"wppa_bcolor_fullimg\";s:7:\"#777777\";s:16:\"wppa_bgcolor_cus\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_cus\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_numbar\";s:7:\"#cccccc\";s:18:\"wppa_bcolor_numbar\";s:7:\"#cccccc\";s:26:\"wppa_bgcolor_numbar_active\";s:7:\"#333333\";s:25:\"wppa_bcolor_numbar_active\";s:7:\"#333333\";s:17:\"wppa_bgcolor_iptc\";s:7:\"#dddddd\";s:16:\"wppa_bcolor_iptc\";s:7:\"#bbbbbb\";s:17:\"wppa_bgcolor_exif\";s:7:\"#dddddd\";s:16:\"wppa_bcolor_exif\";s:7:\"#bbbbbb\";s:18:\"wppa_bgcolor_share\";s:7:\"#dddddd\";s:17:\"wppa_bcolor_share\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_upload\";s:7:\"#dddddd\";s:18:\"wppa_bcolor_upload\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_multitag\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_multitag\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_tagcloud\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_tagcloud\";s:7:\"#bbbbbb\";s:15:\"wppa_allow_ajax\";s:2:\"no\";s:28:\"wppa_use_photo_names_in_urls\";s:2:\"no\";s:21:\"wppa_use_pretty_links\";s:2:\"no\";s:23:\"wppa_update_addressline\";s:3:\"yes\";s:28:\"wppa_render_shortcode_always\";s:2:\"no\";s:15:\"wppa_fullvalign\";s:3:\"fit\";s:15:\"wppa_fullhalign\";s:6:\"center\";s:16:\"wppa_start_slide\";s:3:\"run\";s:20:\"wppa_start_slideonly\";s:3:\"yes\";s:19:\"wppa_animation_type\";s:8:\"fadeover\";s:22:\"wppa_slideshow_timeout\";s:4:\"2500\";s:20:\"wppa_animation_speed\";s:3:\"800\";s:16:\"wppa_slide_pause\";s:2:\"no\";s:15:\"wppa_slide_wrap\";s:3:\"yes\";s:19:\"wppa_fulldesc_align\";s:6:\"center\";s:14:\"wppa_clean_pbr\";s:3:\"yes\";s:25:\"wppa_run_wppautop_on_desc\";s:2:\"no\";s:23:\"wppa_auto_open_comments\";s:3:\"yes\";s:20:\"wppa_film_hover_goto\";s:2:\"no\";s:16:\"wppa_slide_swipe\";s:3:\"yes\";s:19:\"wppa_list_photos_by\";s:1:\"0\";s:21:\"wppa_list_photos_desc\";s:2:\"no\";s:14:\"wppa_thumbtype\";s:7:\"default\";s:20:\"wppa_thumbphoto_left\";s:2:\"no\";s:11:\"wppa_valign\";s:6:\"center\";s:22:\"wppa_use_thumb_opacity\";s:3:\"yes\";s:18:\"wppa_thumb_opacity\";s:2:\"85\";s:20:\"wppa_use_thumb_popup\";s:3:\"yes\";s:19:\"wppa_list_albums_by\";s:1:\"0\";s:21:\"wppa_list_albums_desc\";s:2:\"no\";s:19:\"wppa_coverphoto_pos\";s:5:\"right\";s:22:\"wppa_use_cover_opacity\";s:3:\"yes\";s:18:\"wppa_cover_opacity\";s:2:\"85\";s:15:\"wppa_cover_type\";s:7:\"default\";s:18:\"wppa_imgfact_count\";s:2:\"10\";s:17:\"wppa_rating_login\";s:3:\"yes\";s:18:\"wppa_rating_change\";s:3:\"yes\";s:17:\"wppa_rating_multi\";s:2:\"no\";s:18:\"wppa_dislike_value\";s:2:\"-5\";s:21:\"wppa_next_on_callback\";s:2:\"no\";s:17:\"wppa_star_opacity\";s:2:\"20\";s:21:\"wppa_vote_button_text\";s:12:\"Vote for me!\";s:22:\"wppa_voted_button_text\";s:12:\"Voted for me\";s:15:\"wppa_vote_thumb\";s:2:\"no\";s:18:\"wppa_comment_login\";s:2:\"no\";s:18:\"wppa_comments_desc\";s:2:\"no\";s:23:\"wppa_comment_moderation\";s:6:\"logout\";s:27:\"wppa_comment_email_required\";s:3:\"yes\";s:19:\"wppa_comment_notify\";s:4:\"none\";s:25:\"wppa_comment_notify_added\";s:3:\"yes\";s:16:\"wppa_ovl_opacity\";s:2:\"80\";s:16:\"wppa_ovl_onclick\";s:4:\"none\";s:13:\"wppa_ovl_anim\";s:3:\"300\";s:22:\"wppa_ovl_chrome_at_top\";s:3:\"yes\";s:21:\"wppa_fontfamily_title\";s:0:\"\";s:19:\"wppa_fontsize_title\";s:0:\"\";s:20:\"wppa_fontcolor_title\";s:0:\"\";s:21:\"wppa_fontweight_title\";s:4:\"bold\";s:24:\"wppa_fontfamily_fulldesc\";s:0:\"\";s:22:\"wppa_fontsize_fulldesc\";s:0:\"\";s:23:\"wppa_fontcolor_fulldesc\";s:0:\"\";s:24:\"wppa_fontweight_fulldesc\";s:6:\"normal\";s:25:\"wppa_fontfamily_fulltitle\";s:0:\"\";s:23:\"wppa_fontsize_fulltitle\";s:0:\"\";s:24:\"wppa_fontcolor_fulltitle\";s:0:\"\";s:25:\"wppa_fontweight_fulltitle\";s:6:\"normal\";s:19:\"wppa_fontfamily_nav\";s:0:\"\";s:17:\"wppa_fontsize_nav\";s:0:\"\";s:18:\"wppa_fontcolor_nav\";s:0:\"\";s:19:\"wppa_fontweight_nav\";s:6:\"normal\";s:21:\"wppa_fontfamily_thumb\";s:0:\"\";s:19:\"wppa_fontsize_thumb\";s:0:\"\";s:20:\"wppa_fontcolor_thumb\";s:0:\"\";s:21:\"wppa_fontweight_thumb\";s:6:\"normal\";s:19:\"wppa_fontfamily_box\";s:0:\"\";s:17:\"wppa_fontsize_box\";s:0:\"\";s:18:\"wppa_fontcolor_box\";s:0:\"\";s:19:\"wppa_fontweight_box\";s:6:\"normal\";s:22:\"wppa_fontfamily_numbar\";s:0:\"\";s:20:\"wppa_fontsize_numbar\";s:0:\"\";s:21:\"wppa_fontcolor_numbar\";s:7:\"#777777\";s:22:\"wppa_fontweight_numbar\";s:6:\"normal\";s:29:\"wppa_fontfamily_numbar_active\";s:0:\"\";s:27:\"wppa_fontsize_numbar_active\";s:0:\"\";s:28:\"wppa_fontcolor_numbar_active\";s:7:\"#777777\";s:29:\"wppa_fontweight_numbar_active\";s:4:\"bold\";s:24:\"wppa_fontfamily_lightbox\";s:0:\"\";s:22:\"wppa_fontsize_lightbox\";s:2:\"10\";s:23:\"wppa_fontcolor_lightbox\";s:0:\"\";s:24:\"wppa_fontweight_lightbox\";s:4:\"bold\";s:26:\"wppa_fontsize_widget_thumb\";s:1:\"9\";s:20:\"wppa_sphoto_linktype\";s:5:\"photo\";s:20:\"wppa_sphoto_linkpage\";s:1:\"0\";s:17:\"wppa_sphoto_blank\";s:2:\"no\";s:20:\"wppa_sphoto_overrule\";s:2:\"no\";s:20:\"wppa_mphoto_linktype\";s:5:\"photo\";s:20:\"wppa_mphoto_linkpage\";s:1:\"0\";s:17:\"wppa_mphoto_blank\";s:2:\"no\";s:20:\"wppa_mphoto_overrule\";s:2:\"no\";s:19:\"wppa_thumb_linktype\";s:5:\"photo\";s:19:\"wppa_thumb_linkpage\";s:1:\"0\";s:16:\"wppa_thumb_blank\";s:2:\"no\";s:19:\"wppa_thumb_overrule\";s:2:\"no\";s:27:\"wppa_topten_widget_linktype\";s:5:\"photo\";s:27:\"wppa_topten_widget_linkpage\";s:1:\"0\";s:17:\"wppa_topten_blank\";s:2:\"no\";s:20:\"wppa_topten_overrule\";s:2:\"no\";s:27:\"wppa_featen_widget_linktype\";s:5:\"photo\";s:27:\"wppa_featen_widget_linkpage\";s:1:\"0\";s:17:\"wppa_featen_blank\";s:2:\"no\";s:20:\"wppa_featen_overrule\";s:2:\"no\";s:30:\"wppa_slideonly_widget_linktype\";s:6:\"widget\";s:30:\"wppa_slideonly_widget_linkpage\";s:1:\"0\";s:19:\"wppa_sswidget_blank\";s:2:\"no\";s:22:\"wppa_sswidget_overrule\";s:2:\"no\";s:20:\"wppa_widget_linktype\";s:5:\"album\";s:20:\"wppa_widget_linkpage\";s:1:\"0\";s:15:\"wppa_potd_blank\";s:2:\"no\";s:24:\"wppa_potdwidget_overrule\";s:2:\"no\";s:22:\"wppa_coverimg_linktype\";s:4:\"same\";s:22:\"wppa_coverimg_linkpage\";s:1:\"0\";s:19:\"wppa_coverimg_blank\";s:2:\"no\";s:22:\"wppa_coverimg_overrule\";s:2:\"no\";s:28:\"wppa_comment_widget_linktype\";s:5:\"photo\";s:28:\"wppa_comment_widget_linkpage\";s:1:\"0\";s:18:\"wppa_comment_blank\";s:2:\"no\";s:21:\"wppa_comment_overrule\";s:2:\"no\";s:23:\"wppa_slideshow_linktype\";s:4:\"none\";s:23:\"wppa_slideshow_linkpage\";s:1:\"0\";s:20:\"wppa_slideshow_blank\";s:2:\"no\";s:23:\"wppa_slideshow_overrule\";s:2:\"no\";s:30:\"wppa_thumbnail_widget_linktype\";s:5:\"photo\";s:30:\"wppa_thumbnail_widget_linkpage\";s:1:\"0\";s:30:\"wppa_thumbnail_widget_overrule\";s:2:\"no\";s:27:\"wppa_thumbnail_widget_blank\";s:2:\"no\";s:18:\"wppa_film_linktype\";s:9:\"slideshow\";s:27:\"wppa_lasten_widget_linktype\";s:5:\"photo\";s:27:\"wppa_lasten_widget_linkpage\";s:1:\"0\";s:17:\"wppa_lasten_blank\";s:2:\"no\";s:20:\"wppa_lasten_overrule\";s:2:\"no\";s:20:\"wppa_art_monkey_link\";s:4:\"none\";s:26:\"wppa_art_monkey_popup_link\";s:4:\"file\";s:25:\"wppa_artmonkey_use_source\";s:2:\"no\";s:26:\"wppa_album_widget_linktype\";s:7:\"content\";s:26:\"wppa_album_widget_linkpage\";s:1:\"0\";s:23:\"wppa_album_widget_blank\";s:2:\"no\";s:22:\"wppa_tagcloud_linktype\";s:5:\"album\";s:22:\"wppa_tagcloud_linkpage\";s:1:\"0\";s:19:\"wppa_tagcloud_blank\";s:2:\"no\";s:22:\"wppa_multitag_linktype\";s:5:\"album\";s:22:\"wppa_multitag_linkpage\";s:1:\"0\";s:19:\"wppa_multitag_blank\";s:2:\"no\";s:24:\"wppa_super_view_linkpage\";s:1:\"0\";s:22:\"wppa_user_upload_login\";s:3:\"yes\";s:15:\"wppa_owner_only\";s:2:\"no\";s:19:\"wppa_user_upload_on\";s:2:\"no\";s:20:\"wppa_upload_moderate\";s:2:\"no\";s:16:\"wppa_upload_edit\";s:2:\"no\";s:18:\"wppa_upload_notify\";s:2:\"no\";s:26:\"wppa_upload_backend_notify\";s:2:\"no\";s:20:\"wppa_upload_one_only\";s:2:\"no\";s:22:\"wppa_memcheck_frontend\";s:3:\"yes\";s:19:\"wppa_memcheck_admin\";s:3:\"yes\";s:20:\"wppa_comment_captcha\";s:2:\"no\";s:16:\"wppa_spam_maxage\";s:4:\"none\";s:30:\"wppa_editor_upload_limit_count\";s:1:\"0\";s:29:\"wppa_editor_upload_limit_time\";s:1:\"0\";s:30:\"wppa_author_upload_limit_count\";s:1:\"0\";s:29:\"wppa_author_upload_limit_time\";s:1:\"0\";s:35:\"wppa_contributor_upload_limit_count\";s:1:\"0\";s:34:\"wppa_contributor_upload_limit_time\";s:1:\"0\";s:34:\"wppa_subscriber_upload_limit_count\";s:1:\"0\";s:33:\"wppa_subscriber_upload_limit_time\";s:1:\"0\";s:33:\"wppa_loggedout_upload_limit_count\";s:1:\"0\";s:32:\"wppa_loggedout_upload_limit_time\";s:1:\"0\";s:10:\"wppa_setup\";s:0:\"\";s:11:\"wppa_backup\";s:0:\"\";s:14:\"wppa_load_skin\";s:0:\"\";s:13:\"wppa_skinfile\";s:7:\"default\";s:10:\"wppa_regen\";s:0:\"\";s:11:\"wppa_rerate\";s:0:\"\";s:12:\"wppa_cleanup\";s:0:\"\";s:10:\"wppa_recup\";s:0:\"\";s:16:\"wppa_file_system\";s:4:\"flat\";s:17:\"wppa_rating_clear\";s:2:\"no\";s:15:\"wppa_iptc_clear\";s:0:\"\";s:15:\"wppa_exif_clear\";s:0:\"\";s:28:\"wppa_apply_new_photodesc_all\";s:0:\"\";s:17:\"wppa_remake_index\";s:0:\"\";s:17:\"wppa_extend_index\";s:0:\"\";s:15:\"wppa_list_index\";s:0:\"\";s:16:\"wppa_append_text\";s:0:\"\";s:24:\"wppa_append_to_photodesc\";s:0:\"\";s:16:\"wppa_remove_text\";s:0:\"\";s:26:\"wppa_remove_from_photodesc\";s:0:\"\";s:24:\"wppa_remove_empty_albums\";s:0:\"\";s:18:\"wppa_check_balance\";s:2:\"no\";s:16:\"wppa_arrow_color\";s:5:\"black\";s:20:\"wppa_search_linkpage\";s:1:\"0\";s:13:\"wppa_excl_sep\";s:2:\"no\";s:16:\"wppa_search_tags\";s:2:\"no\";s:16:\"wppa_photos_only\";s:2:\"no\";s:19:\"wppa_indexed_search\";s:2:\"no\";s:22:\"wppa_max_search_photos\";s:3:\"250\";s:22:\"wppa_max_search_albums\";s:2:\"25\";s:17:\"wppa_tags_or_only\";s:2:\"no\";s:15:\"wppa_wild_front\";s:2:\"no\";s:26:\"wppa_add_shortcode_to_post\";s:2:\"no\";s:21:\"wppa_shortcode_to_add\";s:48:\"[wppa type=\"album\" album=\"#related,desc\"][/wppa]\";s:14:\"wppa_meta_page\";s:3:\"yes\";s:13:\"wppa_meta_all\";s:3:\"yes\";s:22:\"wppa_cp_points_comment\";s:1:\"0\";s:21:\"wppa_cp_points_rating\";s:1:\"0\";s:21:\"wppa_cp_points_upload\";s:1:\"0\";s:14:\"wppa_use_scabn\";s:2:\"no\";s:18:\"wppa_gpx_shortcode\";s:88:\"[map style=\"width: auto; height:300px; margin:0; \" marker=\"yes\" lat=\"w#lat\" lon=\"w#lon\"]\";s:18:\"wppa_use_wp_editor\";s:2:\"no\";s:16:\"wppa_hier_albsel\";s:2:\"no\";s:17:\"wppa_hier_pagesel\";s:2:\"no\";s:13:\"wppa_alt_type\";s:8:\"fullname\";s:25:\"wppa_photo_admin_pagesize\";s:2:\"20\";s:27:\"wppa_comment_admin_pagesize\";s:2:\"10\";s:17:\"wppa_jpeg_quality\";s:2:\"95\";s:13:\"wppa_geo_edit\";s:2:\"no\";s:18:\"wppa_auto_continue\";s:3:\"yes\";s:23:\"wppa_max_execution_time\";s:2:\"60\";s:23:\"wppa_adminbarmenu_admin\";s:3:\"yes\";s:26:\"wppa_adminbarmenu_frontend\";s:3:\"yes\";s:19:\"wppa_feed_use_thumb\";s:2:\"no\";s:15:\"wppa_og_tags_on\";s:3:\"yes\";s:9:\"wppa_html\";s:2:\"no\";s:16:\"wppa_allow_debug\";s:2:\"no\";s:16:\"wppa_slide_order\";s:22:\"0,1,2,3,4,5,6,7,8,9,10\";s:22:\"wppa_slide_order_split\";s:25:\"0,1,2,3,4,5,6,7,8,9,10,11\";s:18:\"wppa_swap_namedesc\";s:2:\"no\";s:19:\"wppa_split_namedesc\";s:2:\"no\";s:22:\"wppa_max_album_newtime\";s:1:\"0\";s:22:\"wppa_max_photo_newtime\";s:1:\"0\";s:18:\"wppa_lightbox_name\";s:4:\"wppa\";s:20:\"wppa_filter_priority\";s:4:\"1001\";s:24:\"wppa_apply_newphoto_desc\";s:2:\"no\";s:29:\"wppa_apply_newphoto_desc_user\";s:2:\"no\";s:25:\"wppa_newphoto_description\";s:1334:\"\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'block\'); jQuery(\'.wppa-more\').css(\'display\', \'none\'); wppaOvlResize();\">\r\n<div class=\"wppa-more\">\r\nCamera info\r\n</div>\r\n</a>\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'none\'); jQuery(\'.wppa-more\').css(\'display\', \'block\'); wppaOvlResize();\">\r\n<div class=\"wppa-dtl\" style=\"display:none;\" >\r\nHide Camera info\r\n</div>\r\n</a>\r\n<div class=\"wppa-dtl\" style=\"display:none;\">\r\n<br />\r\n<style>\r\n.wppa-label { padding: 0 3px !important; border: none !important; }\r\n.wppa-value { padding: 0 3px 0 12px !important; border:none !important; }\r\n</style>\r\n<table style=\"margin:0; border:none;\" >\r\n<tr><td class=\"wppa-label\" >Date Time</td><td class=\"wppa-value\" >E#0132</td></tr>\r\n<tr><td class=\"wppa-label\" >Camera</td><td class=\"wppa-value\" >E#0110</td></tr>\r\n<tr><td class=\"wppa-label\" >Focal length</td><td class=\"wppa-value\" >E#920A</td></tr>\r\n<tr><td class=\"wppa-label\" >F-Stop</td><td class=\"wppa-value\" >E#829D</td></tr>\r\n<tr><td class=\"wppa-label\" >ISO Speed Rating</td><td class=\"wppa-value\" >E#8827</td></tr>\r\n<tr><td class=\"wppa-label\" >Exposure program</td><td class=\"wppa-value\" >E#8822</td></tr>\r\n<tr><td class=\"wppa-label\" >Metering mode</td><td class=\"wppa-value\" >E#9207</td></tr>\r\n<tr><td class=\"wppa-label\" >Flash</td><td class=\"wppa-value\" >E#9209</td></tr>\r\n</table>\r\n</div>\";s:23:\"wppa_upload_limit_count\";s:1:\"0\";s:22:\"wppa_upload_limit_time\";s:1:\"0\";s:20:\"wppa_show_album_full\";s:3:\"yes\";s:19:\"wppa_grant_an_album\";s:2:\"no\";s:15:\"wppa_grant_name\";s:7:\"display\";s:17:\"wppa_grant_parent\";s:1:\"0\";s:15:\"wppa_max_albums\";s:1:\"0\";s:22:\"wppa_alt_is_restricted\";s:2:\"no\";s:23:\"wppa_link_is_restricted\";s:2:\"no\";s:28:\"wppa_covertype_is_restricted\";s:2:\"no\";s:19:\"wppa_strip_file_ext\";s:2:\"no\";s:19:\"wppa_copy_timestamp\";s:2:\"no\";s:17:\"wppa_watermark_on\";s:2:\"no\";s:19:\"wppa_watermark_user\";s:2:\"no\";s:19:\"wppa_watermark_file\";s:12:\"specimen.png\";s:18:\"wppa_watermark_pos\";s:6:\"cencen\";s:21:\"wppa_watermark_upload\";s:0:\"\";s:22:\"wppa_watermark_opacity\";s:2:\"20\";s:29:\"wppa_allow_foreign_shortcodes\";s:2:\"no\";s:36:\"wppa_allow_foreign_shortcodes_thumbs\";s:2:\"no\";s:16:\"wppa_widgettitle\";s:16:\"Photo of the day\";s:19:\"wppa_widget_linkurl\";s:25:\"Type your custom url here\";s:21:\"wppa_widget_linktitle\";s:19:\"Type the title here\";s:20:\"wppa_widget_subtitle\";s:4:\"none\";s:17:\"wppa_widget_album\";s:1:\"0\";s:17:\"wppa_widget_photo\";s:0:\"\";s:15:\"wppa_potd_align\";s:6:\"center\";s:18:\"wppa_widget_method\";s:1:\"1\";s:18:\"wppa_widget_period\";s:3:\"168\";s:17:\"wppa_widget_width\";s:3:\"200\";s:22:\"wppa_toptenwidgettitle\";s:14:\"Top Ten Photos\";s:25:\"wppa_thumbnailwidgettitle\";s:16:\"Thumbnail Photos\";s:22:\"wppa_searchwidgettitle\";s:13:\"Search photos\";s:18:\"wppa_comadmin_show\";s:3:\"all\";s:19:\"wppa_comadmin_order\";s:9:\"timestamp\";s:12:\"wppa_qr_size\";s:3:\"200\";s:13:\"wppa_qr_color\";s:7:\"#000000\";s:15:\"wppa_qr_bgcolor\";s:7:\"#FFFFFF\";s:22:\"wppa_keep_source_admin\";s:2:\"no\";s:25:\"wppa_keep_source_frontend\";s:2:\"no\";s:15:\"wppa_source_dir\";s:70:\"/home/israel/public_html/traveltheworld/wp-content/uploads/wppa-source\";s:14:\"wppa_keep_sync\";s:3:\"yes\";s:15:\"wppa_remake_add\";s:3:\"yes\";s:14:\"wppa_save_iptc\";s:3:\"yes\";s:14:\"wppa_save_exif\";s:3:\"yes\";s:24:\"wppa_exif_max_array_size\";s:2:\"10\";s:25:\"wppa_chgsrc_is_restricted\";s:2:\"no\";s:18:\"wppa_newpag_create\";s:2:\"no\";s:19:\"wppa_newpag_content\";s:57:\"[wppa type=\"cover\" album=\"w#album\" align=\"center\"][/wppa]\";s:16:\"wppa_newpag_type\";s:4:\"page\";s:18:\"wppa_newpag_status\";s:7:\"publish\";}", "yes");
INSERT INTO `wp_options` VALUES("157", "theme_mods_twentyeleven", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1344539545;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("158", "current_theme", "Twenty Eleven", "yes");
INSERT INTO `wp_options` VALUES("159", "theme_mods_TheTravelTheme", "a:3:{i:0;b:0;s:16:\"background_color\";s:6:\"ffe4e2\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1398731899;s:4:\"data\";a:12:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:4:{i:0;s:8:\"search-2\";i:1;s:10:\"nav_menu-2\";i:2;s:6:\"text-2\";i:3;s:8:\"social-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}s:9:\"sidebar-8\";a:0:{}s:9:\"sidebar-9\";a:0:{}s:10:\"sidebar-10\";a:0:{}s:10:\"sidebar-11\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("160", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("163", "widget_nav_menu", "a:2:{i:2;a:2:{s:5:\"title\";s:9:\"Countries\";s:8:\"nav_menu\";i:85;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("167", "pixopoint-menu", "a:53:{s:5:\"2_css\";s:0:\"\";s:3:\"css\";s:2407:\"#suckerfishnav {\r\n    background:#9C1F1B url(\"../multi-level-navigation-plugin/images/suckerfish_red.png\") repeat-x;\r\n    font-size:14px;\r\n    font-family:verdana,sans-serif;\r\n    font-weight:solid;\r\n    width:100%;\r\n    }\r\n#suckerfishnav, #suckerfishnav ul {\r\n    float:left;\r\n    list-style:none;\r\n    line-height:40px;\r\n    padding:0;\r\n    border:1px solid #aaa;\r\n    margin:0;\r\n    width:100%;\r\n    }\r\n#suckerfishnav a {\r\n    display:block;\r\n    color:#dddddd;\r\n    text-decoration:none;\r\n    padding:0px 10px;\r\n    }\r\n#suckerfishnav li {\r\n    float:left;\r\n    padding:0;\r\n    }\r\n#suckerfishnav ul {\r\n    position:absolute;\r\n    left:-999em;\r\n    height:auto;\r\n    width:101px;\r\n    font-weight:normal;\r\n    margin:0;\r\n    line-height:1;\r\n    border:0;\r\n    border-top:1px solid #666666;\r\n    z-index:1;\r\n    }\r\n#suckerfishnav li li {\r\n\r\n    width:99px;\r\n    border-bottom:1px solid #666666;\r\n    border-left:1px solid #666666;\r\n    border-right:1px solid #666666;\r\n    font-family:verdana,sans-serif;\r\n    /* my additons */\r\n    margin-left:0px;\r\n\r\n    }\r\n#suckerfishnav li li a {\r\n\r\n    padding:4px 10px;\r\n    width:80px;\r\n    font-size:12px;\r\n    color:#dddddd;\r\n    }\r\n#suckerfishnav li ul ul {\r\n    margin:-21px 0 0 100px;\r\n   \r\n    }\r\n#suckerfishnav li li:hover {\r\n    background:#9C1F1B; \r\n\r\n\r\n    }\r\n#suckerfishnav li ul li:hover a, #suckerfishnav li ul li li:hover a, #suckerfishnav li ul li li li:hover a, #suckerfishnav li ul li li li:hover a {\r\n    color:#dddddd;\r\n\r\n    }\r\n#suckerfishnav li:hover a, #suckerfishnav li.sfhover a {\r\n    color:#dddddd;\r\n\r\n    }\r\n#suckerfishnav li:hover li a, #suckerfishnav li li:hover li a, #suckerfishnav li li li:hover li a, #suckerfishnav li li li li:hover li a {\r\n    color:#dddddd;\r\n\r\n    }\r\n#suckerfishnav li:hover ul ul, #suckerfishnav li:hover ul ul ul, #suckerfishnav li:hover ul ul ul ul, #suckerfishnav li.sfhover ul ul, #suckerfishnav li.sfhover ul ul ul, #suckerfishnav li.sfhover ul ul ul ul {\r\n    /*left:-999em;*/\r\nleft:10px;\r\n\r\n    }\r\n#suckerfishnav li:hover ul, #suckerfishnav li li:hover ul, #suckerfishnav li li li:hover ul, #suckerfishnav li li li li:hover ul, #suckerfishnav li.sfhover ul, #suckerfishnav li li.sfhover ul, #suckerfishnav li li li.sfhover ul, #suckerfishnav li li li li.sfhover ul {\r\n\r\n    left:auto;\r\n    background:#444444;\r\n    }\r\n#suckerfishnav li:hover, #suckerfishnav li.sfhover {\r\n    background:#DA0909;\r\n\r\n    }\";s:15:\"superfish_speed\";s:6:\"normal\";s:9:\"menuitem1\";s:4:\"Home\";s:9:\"menuitem2\";s:5:\"Pages\";s:9:\"menuitem3\";s:28:\"Categories (single dropdown)\";s:9:\"menuitem4\";s:4:\"None\";s:9:\"menuitem5\";s:4:\"None\";s:9:\"menuitem6\";s:4:\"None\";s:9:\"menuitem7\";s:4:\"None\";s:9:\"menuitem8\";s:4:\"None\";s:9:\"menuitem9\";s:4:\"None\";s:10:\"menuitem10\";s:4:\"None\";s:9:\"hometitle\";s:4:\"Home\";s:10:\"pagestitle\";s:5:\"Pages\";s:15:\"categoriestitle\";s:9:\"Countries\";s:13:\"archivestitle\";s:8:\"Archives\";s:13:\"blogrolltitle\";s:5:\"Links\";s:19:\"recentcommentstitle\";s:15:\"Recent Comments\";s:16:\"recentpoststitle\";s:12:\"Recent Posts\";s:8:\"keyboard\";s:0:\"\";s:10:\"disablecss\";s:0:\"\";s:9:\"inlinecss\";s:0:\"\";s:21:\"superfish_sensitivity\";s:4:\"high\";s:11:\"2_menuitem1\";s:4:\"Home\";s:11:\"2_menuitem2\";s:5:\"Pages\";s:11:\"2_menuitem3\";s:28:\"Categories (single dropdown)\";s:11:\"2_menuitem4\";s:4:\"None\";s:11:\"2_menuitem5\";s:4:\"None\";s:11:\"2_menuitem6\";s:4:\"None\";s:11:\"2_menuitem7\";s:4:\"None\";s:11:\"2_menuitem8\";s:4:\"None\";s:11:\"2_menuitem9\";s:4:\"None\";s:12:\"2_menuitem10\";s:4:\"None\";s:13:\"categoryorder\";s:14:\"Ascending Name\";s:13:\"categorycount\";s:0:\"\";s:9:\"titletags\";s:0:\"\";s:5:\"delay\";s:1:\"0\";s:10:\"displaycss\";s:6:\"Normal\";s:19:\"includeexcludepages\";s:7:\"include\";s:12:\"excludepages\";s:0:\"\";s:24:\"includeexcludecategories\";s:7:\"include\";s:17:\"excludecategories\";s:0:\"\";s:9:\"superfish\";i:0;s:14:\"superfish_time\";i:0;s:17:\"superfish_timeout\";i:0;s:24:\"superfish_delaymouseover\";i:100;s:17:\"recentpostsnumber\";i:10;s:20:\"recentcommentsnumber\";i:10;s:10:\"custommenu\";s:0:\"\";s:11:\"custommenu2\";s:0:\"\";s:11:\"custommenu3\";s:0:\"\";s:11:\"custommenu4\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("358", "wppa_revision", "5114", "yes");
INSERT INTO `wp_options` VALUES("359", "wppa_spam_auto_delcount", "0", "yes");
INSERT INTO `wp_options` VALUES("181", "travel_color", "a:46:{s:9:\"header_bg\";s:7:\"#fefefe\";s:15:\"feature_area_bg\";s:7:\"#fefefe\";s:10:\"feature_bg\";s:7:\"#7f7f7f\";s:18:\"feature_bg_Opacity\";s:3:\"0.8\";s:7:\"page_bg\";s:8:\"##fefefe\";s:9:\"footer_bg\";s:7:\"#000000\";s:13:\"sub_footer_bg\";s:0:\"\";s:9:\"site_name\";s:7:\"#444444\";s:16:\"site_description\";s:7:\"#444444\";s:8:\"menu_top\";s:7:\"#000000\";s:16:\"menu_top_current\";s:7:\"#000000\";s:15:\"menu_top_active\";s:7:\"#000000\";s:8:\"menu_sub\";s:7:\"#000000\";s:15:\"menu_sub_active\";s:7:\"#000000\";s:19:\"menu_sub_background\";s:7:\"#f5f5f5\";s:25:\"menu_sub_hover_background\";s:7:\"#dddddd\";s:16:\"feature_box_text\";s:7:\"#ffffff\";s:20:\"feature_box_category\";s:7:\"#ffffff\";s:27:\"feature_box_category_active\";s:7:\"#ffffff\";s:14:\"feature_header\";s:7:\"#ffffff\";s:17:\"feature_introduce\";s:7:\"#ffffff\";s:4:\"page\";s:7:\"#333333\";s:11:\"page_header\";s:7:\"#333333\";s:7:\"page_h1\";s:0:\"\";s:7:\"page_h2\";s:0:\"\";s:7:\"page_h3\";s:0:\"\";s:7:\"page_h4\";s:0:\"\";s:7:\"page_h5\";s:0:\"\";s:7:\"page_h6\";s:0:\"\";s:9:\"page_link\";s:7:\"#666666\";s:16:\"page_link_active\";s:7:\"#333333\";s:19:\"portfolio_header_bg\";s:7:\"#eeeeee\";s:21:\"portfolio_header_text\";s:7:\"#666666\";s:12:\"sidebar_link\";s:7:\"#666666\";s:19:\"sidebar_link_active\";s:7:\"#333333\";s:11:\"breadcrumbs\";s:7:\"#999999\";s:16:\"breadcrumbs_link\";s:7:\"#999999\";s:18:\"breadcrumbs_active\";s:7:\"#999999\";s:12:\"divider_line\";s:7:\"#eeeeee\";s:11:\"footer_text\";s:7:\"#ffffff\";s:12:\"footer_title\";s:7:\"#ffffff\";s:11:\"footer_link\";s:7:\"#ffffff\";s:18:\"footer_link_active\";s:7:\"#ffffff\";s:9:\"copyright\";s:7:\"#ffffff\";s:11:\"footer_menu\";s:7:\"#ffffff\";s:18:\"footer_menu_active\";s:7:\"#ffffff\";}", "yes");
INSERT INTO `wp_options` VALUES("766", "wppa_prevrev", "4906", "yes");
INSERT INTO `wp_options` VALUES("767", "wppa_ratspacing", "30", "yes");
INSERT INTO `wp_options` VALUES("768", "wppa_magnifier", "magnifier-small.png", "yes");
INSERT INTO `wp_options` VALUES("769", "wppa_use_wp_editor", "no", "yes");
INSERT INTO `wp_options` VALUES("898", "akismet_spam_count", "469", "yes");
INSERT INTO `wp_options` VALUES("1135", "wppa_ovl_mphoto_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("6332", "wppa_i_responsive", "", "yes");
INSERT INTO `wp_options` VALUES("6297", "_transient_feed_df272f46eda81b57710ed75dad73a85b", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:4:\"\n  \n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:33:\"\n    \n    \n    \n    \n    \n    \n  \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:3:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"link:http://israelvasquez.com/traveltheworld/ - Google Blog Search\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://www.google.com/search?ie=utf-8&q=link:http://israelvasquez.com/traveltheworld/&tbm=blg&tbs=sbd:1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"Your search - <b>link:http://israelvasquez.com/traveltheworld/</b> - did not match any documents.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://a9.com/-/spec/opensearch/1.1/\";a:3:{s:12:\"totalResults\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:10:\"startIndex\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:12:\"itemsPerPage\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:12:\"content-type\";s:28:\"text/xml; charset=ISO-8859-1\";s:4:\"date\";s:29:\"Wed, 23 Apr 2014 16:23:53 GMT\";s:7:\"expires\";s:2:\"-1\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:10:\"set-cookie\";a:2:{i:0;s:143:\"PREF=ID=9256f1fa6baf6bf1:FF=0:TM=1398270233:LM=1398270233:S=z4XEhDtwG581KvEV; expires=Fri, 22-Apr-2016 16:23:53 GMT; path=/; domain=.google.com\";i:1;s:212:\"NID=67=jUX3Lu4zk5dCCFjrGiGPHKA1OhBpMxQyyKfRSw89QAOJeP90dkQxyElyCXUGNmRrY-itgte1KhNEJ8CFkGcj-Ary7536G6H5olUpvRAVHayonLYzHuI5omuFVolWG3-K; expires=Thu, 23-Oct-2014 16:23:53 GMT; path=/; domain=.google.com; HttpOnly\";}s:3:\"p3p\";s:122:\"CP=\"This is not a P3P policy! See http://www.google.com/support/accounts/bin/answer.py?hl=en&answer=151657 for more info.\"\";s:6:\"server\";s:3:\"gws\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:18:\"alternate-protocol\";s:7:\"80:quic\";}s:5:\"build\";s:14:\"20131030160355\";}", "no");
INSERT INTO `wp_options` VALUES("1131", "wppa_hide_when_empty", "no", "yes");
INSERT INTO `wp_options` VALUES("1132", "wppa_ovl_sphoto_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("1133", "wppa_ovl_sphoto_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("1134", "wppa_ovl_mphoto_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("6333", "wppa_i_downsize", "", "yes");
INSERT INTO `wp_options` VALUES("6334", "wppa_i_userupload", "", "yes");
INSERT INTO `wp_options` VALUES("6335", "wppa_i_rating", "", "yes");
INSERT INTO `wp_options` VALUES("6336", "wppa_i_comment", "", "yes");
INSERT INTO `wp_options` VALUES("6337", "wppa_i_share", "", "yes");
INSERT INTO `wp_options` VALUES("6338", "wppa_i_iptc", "", "yes");
INSERT INTO `wp_options` VALUES("6339", "wppa_i_exif", "", "yes");
INSERT INTO `wp_options` VALUES("6340", "wppa_i_gpx", "", "yes");
INSERT INTO `wp_options` VALUES("6341", "wppa_i_fotomoto", "", "yes");
INSERT INTO `wp_options` VALUES("6342", "wppa_i_done", "", "yes");
INSERT INTO `wp_options` VALUES("6343", "wppa_pagelinks_max", "7", "yes");
INSERT INTO `wp_options` VALUES("6344", "wppa_show_ubb", "no", "yes");
INSERT INTO `wp_options` VALUES("6345", "wppa_share_hide_when_running", "no", "yes");
INSERT INTO `wp_options` VALUES("6346", "wppa_share_on_thumbs", "no", "yes");
INSERT INTO `wp_options` VALUES("6347", "wppa_share_on_lightbox", "no", "yes");
INSERT INTO `wp_options` VALUES("6348", "wppa_share_on_mphoto", "no", "yes");
INSERT INTO `wp_options` VALUES("6349", "wppa_load_facebook_sdk", "yes", "yes");
INSERT INTO `wp_options` VALUES("6350", "wppa_albname_on_thumbarea", "none", "yes");
INSERT INTO `wp_options` VALUES("6351", "wppa_show_ubb_widget", "no", "yes");
INSERT INTO `wp_options` VALUES("6352", "wppa_bgcolor_thumbnail", "#000000", "yes");
INSERT INTO `wp_options` VALUES("6353", "wppa_bgcolor_superview", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("6354", "wppa_bcolor_superview", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("6355", "wppa_bgcolor_search", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("6356", "wppa_bcolor_search", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("6357", "wppa_bgcolor_bestof", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("6358", "wppa_bcolor_bestof", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("6359", "wppa_ajax_non_admin", "no", "yes");
INSERT INTO `wp_options` VALUES("6360", "wppa_track_viewcounts", "yes", "yes");
INSERT INTO `wp_options` VALUES("6361", "wppa_auto_page", "no", "yes");
INSERT INTO `wp_options` VALUES("6362", "wppa_auto_page_type", "photo", "yes");
INSERT INTO `wp_options` VALUES("6363", "wppa_auto_page_links", "bottom", "yes");
INSERT INTO `wp_options` VALUES("6364", "wppa_defer_javascript", "no", "yes");
INSERT INTO `wp_options` VALUES("6365", "wppa_inline_css", "yes", "yes");
INSERT INTO `wp_options` VALUES("6366", "wppa_custom_style", "", "yes");
INSERT INTO `wp_options` VALUES("6367", "wppa_run_wpautop_on_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("6368", "wppa_align_thumbtext", "no", "yes");
INSERT INTO `wp_options` VALUES("6369", "wppa_medal_bronze_when", "5", "yes");
INSERT INTO `wp_options` VALUES("6370", "wppa_medal_silver_when", "10", "yes");
INSERT INTO `wp_options` VALUES("6371", "wppa_medal_gold_when", "15", "yes");
INSERT INTO `wp_options` VALUES("6372", "wppa_medal_color", "2", "yes");
INSERT INTO `wp_options` VALUES("6373", "wppa_medal_position", "botright", "yes");
INSERT INTO `wp_options` VALUES("6374", "wppa_comten_alt_display", "no", "yes");
INSERT INTO `wp_options` VALUES("6375", "wppa_comten_alt_thumbsize", "75", "yes");
INSERT INTO `wp_options` VALUES("6376", "wppa_comment_smiley_picker", "no", "yes");
INSERT INTO `wp_options` VALUES("6377", "wppa_ovl_slide", "5000", "yes");
INSERT INTO `wp_options` VALUES("6378", "wppa_lightbox_global", "no", "yes");
INSERT INTO `wp_options` VALUES("6379", "wppa_lightbox_global_set", "no", "yes");
INSERT INTO `wp_options` VALUES("6380", "wppa_art_monkey_display", "button", "yes");
INSERT INTO `wp_options` VALUES("6381", "wppa_upldr_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("6382", "wppa_bestof_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("6383", "wppa_album_navigator_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("6384", "wppa_user_create_on", "no", "yes");
INSERT INTO `wp_options` VALUES("6385", "wppa_user_create_login", "yes", "yes");
INSERT INTO `wp_options` VALUES("6386", "wppa_upload_fronend_maxsize", "0", "yes");
INSERT INTO `wp_options` VALUES("6387", "wppa_void_dups", "no", "yes");
INSERT INTO `wp_options` VALUES("6388", "wppa_regen_thumbs", "", "yes");
INSERT INTO `wp_options` VALUES("6389", "wppa_regen_thumbs_skip_one", "", "yes");
INSERT INTO `wp_options` VALUES("6390", "wppa_blacklist_user", "", "yes");
INSERT INTO `wp_options` VALUES("6391", "wppa_un_blacklist_user", "", "yes");
INSERT INTO `wp_options` VALUES("6392", "wppa_remake", "", "yes");
INSERT INTO `wp_options` VALUES("6393", "wppa_remake_skip_one", "", "yes");
INSERT INTO `wp_options` VALUES("6394", "wppa_errorlog_purge", "", "yes");
INSERT INTO `wp_options` VALUES("6395", "wppa_viewcount_clear", "no", "yes");
INSERT INTO `wp_options` VALUES("6396", "wppa_list_index_display_start", "", "yes");
INSERT INTO `wp_options` VALUES("6397", "wppa_watermark_all", "", "yes");
INSERT INTO `wp_options` VALUES("6398", "wppa_shortcode_priority", "11", "yes");
INSERT INTO `wp_options` VALUES("6399", "wppa_default_parent", "0", "yes");
INSERT INTO `wp_options` VALUES("6400", "wppa_porder_restricted", "no", "yes");
INSERT INTO `wp_options` VALUES("6401", "wppa_newphoto_name_method", "filename", "yes");
INSERT INTO `wp_options` VALUES("6402", "wppa_search_cats", "no", "yes");
INSERT INTO `wp_options` VALUES("6403", "wppa_search_comments", "no", "yes");
INSERT INTO `wp_options` VALUES("6404", "wppa_search_display_type", "content", "yes");
INSERT INTO `wp_options` VALUES("6405", "wppa_textual_watermark_type", "tvstyle", "yes");
INSERT INTO `wp_options` VALUES("6406", "wppa_textual_watermark_text", "Copyright (c) 2014 w#site \n w#filename (w#owner)", "yes");
INSERT INTO `wp_options` VALUES("6407", "wppa_textual_watermark_font", "system", "yes");
INSERT INTO `wp_options` VALUES("6408", "wppa_textual_watermark_size", "10", "yes");
INSERT INTO `wp_options` VALUES("6409", "wppa_watermark_opacity_text", "80", "yes");
INSERT INTO `wp_options` VALUES("6410", "wppa_gpx_implementation", "none", "yes");
INSERT INTO `wp_options` VALUES("6411", "wppa_map_height", "300", "yes");
INSERT INTO `wp_options` VALUES("6412", "wppa_map_apikey", "", "yes");
INSERT INTO `wp_options` VALUES("6413", "wppa_fotomoto_on", "no", "yes");
INSERT INTO `wp_options` VALUES("6414", "wppa_fotomoto_fontsize", "", "yes");
INSERT INTO `wp_options` VALUES("6415", "wppa_fotomoto_hide_when_running", "no", "yes");
INSERT INTO `wp_options` VALUES("6416", "wppa_fotomoto_min_width", "400", "yes");
INSERT INTO `wp_options` VALUES("6417", "wppa_cdn_service", "", "yes");
INSERT INTO `wp_options` VALUES("6418", "wppa_cdn_cloud_name", "", "yes");
INSERT INTO `wp_options` VALUES("6419", "wppa_cdn_api_key", "", "yes");
INSERT INTO `wp_options` VALUES("6420", "wppa_cdn_api_secret", "", "yes");
INSERT INTO `wp_options` VALUES("6421", "wppa_cdn_service_update", "no", "yes");
INSERT INTO `wp_options` VALUES("6422", "wppa_delete_all_from_cloudinary", "", "yes");
INSERT INTO `wp_options` VALUES("6423", "wppa_wp_wppa_session_lastkey", "382", "no");
INSERT INTO `wp_options` VALUES("6882", "_site_transient_update_plugins", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1398729510;s:7:\"checked\";a:6:{s:19:\"akismet/akismet.php\";s:5:\"2.5.9\";s:45:\"bulletproof-security/bulletproof-security.php\";s:5:\".49.5\";s:25:\"duplicator/duplicator.php\";s:5:\"0.5.2\";s:39:\"multi-level-navigation-plugin/index.php\";s:5:\"2.3.6\";s:41:\"wordpress-importer/wordpress-importer.php\";s:5:\"0.6.1\";s:28:\"wp-photo-album-plus/wppa.php\";s:5:\"5.3.4\";}s:8:\"response\";a:3:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:2:\"15\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"3.0.0\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.3.0.0.zip\";}s:45:\"bulletproof-security/bulletproof-security.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:5:\"14569\";s:4:\"slug\";s:20:\"bulletproof-security\";s:6:\"plugin\";s:45:\"bulletproof-security/bulletproof-security.php\";s:11:\"new_version\";s:5:\".50.1\";s:14:\"upgrade_notice\";s:300:\"Security Logging major changes/improvements to logging template files/code &amp; start of Phase 1 Security Log Solution Targeting: \nThe Security Logging code has been significantly improved in BPS .50.1. Logging is more streamlined, performance optimized &amp; faster than in previous BPS versions, e\";s:3:\"url\";s:51:\"https://wordpress.org/plugins/bulletproof-security/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/bulletproof-security.0.50.1.zip\";}s:28:\"wp-photo-album-plus/wppa.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"12749\";s:4:\"slug\";s:19:\"wp-photo-album-plus\";s:6:\"plugin\";s:28:\"wp-photo-album-plus/wppa.php\";s:11:\"new_version\";s:5:\"5.3.5\";s:3:\"url\";s:50:\"https://wordpress.org/plugins/wp-photo-album-plus/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/wp-photo-album-plus.zip\";}}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("1136", "wppa_ovl_show_counter", "yes", "yes");
INSERT INTO `wp_options` VALUES("1137", "wppa_show_zoomin", "yes", "yes");
INSERT INTO `wp_options` VALUES("1138", "wppa_run_wppautop_on_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("1139", "wppa_comment_notify", "none", "yes");
INSERT INTO `wp_options` VALUES("1140", "wppa_fontfamily_lightbox", "", "yes");
INSERT INTO `wp_options` VALUES("1141", "wppa_fontsize_lightbox", "10", "yes");
INSERT INTO `wp_options` VALUES("1142", "wppa_fontcolor_lightbox", "", "yes");
INSERT INTO `wp_options` VALUES("1143", "wppa_fontweight_lightbox", "bold", "yes");
INSERT INTO `wp_options` VALUES("1144", "wppa_art_monkey_link", "none", "yes");
INSERT INTO `wp_options` VALUES("1145", "wppa_art_monkey_popup_link", "file", "yes");
INSERT INTO `wp_options` VALUES("1146", "wppa_memcheck_frontend", "yes", "yes");
INSERT INTO `wp_options` VALUES("1147", "wppa_memcheck_admin", "yes", "yes");
INSERT INTO `wp_options` VALUES("1148", "wppa_slide_order_split", "0,1,2,3,4,5,6,7,8,9,10,11", "yes");
INSERT INTO `wp_options` VALUES("1149", "wppa_split_namedesc", "no", "yes");
INSERT INTO `wp_options` VALUES("1914", "wppa_bgcolor_share", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("6903", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6904", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1398729485", "no");
INSERT INTO `wp_options` VALUES("1915", "wppa_bcolor_share", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("1916", "wppa_comten_count", "10", "yes");
INSERT INTO `wp_options` VALUES("1919", "wppa_mini_treshold", "300", "yes");
INSERT INTO `wp_options` VALUES("1920", "wppa_thumbsize_alt", "130", "yes");
INSERT INTO `wp_options` VALUES("1921", "wppa_tf_width_alt", "130", "yes");
INSERT INTO `wp_options` VALUES("1922", "wppa_tf_height_alt", "180", "yes");
INSERT INTO `wp_options` VALUES("1923", "wppa_coversize_is_height", "no", "yes");
INSERT INTO `wp_options` VALUES("1924", "wppa_album_widget_count", "10", "yes");
INSERT INTO `wp_options` VALUES("1925", "wppa_album_widget_size", "86", "yes");
INSERT INTO `wp_options` VALUES("1926", "wppa_bc_on_comten", "yes", "yes");
INSERT INTO `wp_options` VALUES("1927", "wppa_bc_on_tag", "yes", "yes");
INSERT INTO `wp_options` VALUES("1928", "wppa_show_page", "yes", "yes");
INSERT INTO `wp_options` VALUES("1929", "wppa_dislike_mail_every", "5", "yes");
INSERT INTO `wp_options` VALUES("1930", "wppa_share_on", "no", "yes");
INSERT INTO `wp_options` VALUES("1931", "wppa_share_on_widget", "no", "yes");
INSERT INTO `wp_options` VALUES("1932", "wppa_share_qr", "yes", "yes");
INSERT INTO `wp_options` VALUES("1933", "wppa_share_facebook", "yes", "yes");
INSERT INTO `wp_options` VALUES("1934", "wppa_share_twitter", "yes", "yes");
INSERT INTO `wp_options` VALUES("1935", "wppa_share_hyves", "yes", "yes");
INSERT INTO `wp_options` VALUES("1936", "wppa_share_google", "yes", "yes");
INSERT INTO `wp_options` VALUES("1937", "wppa_share_pinterest", "yes", "yes");
INSERT INTO `wp_options` VALUES("1938", "wppa_share_single_image", "no", "yes");
INSERT INTO `wp_options` VALUES("1939", "wppa_popup_text_ncomments", "yes", "yes");
INSERT INTO `wp_options` VALUES("1940", "wppa_albdesc_on_thumbarea", "none", "yes");
INSERT INTO `wp_options` VALUES("1941", "wppa_ovl_alw_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("1942", "wppa_ovl_alw_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("1943", "wppa_ovl_cover_name", "yes", "yes");
INSERT INTO `wp_options` VALUES("1944", "wppa_ovl_cover_desc", "no", "yes");
INSERT INTO `wp_options` VALUES("1945", "wppa_use_pretty_links", "no", "yes");
INSERT INTO `wp_options` VALUES("1946", "wppa_auto_open_comments", "yes", "yes");
INSERT INTO `wp_options` VALUES("1947", "wppa_film_hover_goto", "no", "yes");
INSERT INTO `wp_options` VALUES("1948", "wppa_comment_notify_added", "yes", "yes");
INSERT INTO `wp_options` VALUES("1949", "wppa_album_widget_linktype", "content", "yes");
INSERT INTO `wp_options` VALUES("1950", "wppa_album_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("1951", "wppa_album_widget_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("1952", "wppa_tagcloud_linktype", "album", "yes");
INSERT INTO `wp_options` VALUES("1953", "wppa_tagcloud_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("1954", "wppa_tagcloud_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("1955", "wppa_multitag_linktype", "album", "yes");
INSERT INTO `wp_options` VALUES("1956", "wppa_multitag_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("1957", "wppa_multitag_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("1958", "wppa_upload_notify", "no", "yes");
INSERT INTO `wp_options` VALUES("1959", "wppa_hier_albsel", "no", "yes");
INSERT INTO `wp_options` VALUES("1960", "wppa_grant_an_album", "no", "yes");
INSERT INTO `wp_options` VALUES("1961", "wppa_grant_parent", "0", "yes");
INSERT INTO `wp_options` VALUES("1962", "wppa_cp_points_upload", "0", "yes");
INSERT INTO `wp_options` VALUES("1963", "wppa_qr_size", "200", "yes");
INSERT INTO `wp_options` VALUES("1964", "wppa_qr_color", "#000000", "yes");
INSERT INTO `wp_options` VALUES("1965", "wppa_qr_bgcolor", "#FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("4103", "wppa_show_bread_pages", "yes", "yes");
INSERT INTO `wp_options` VALUES("4106", "wppa_smallsize_multi", "100", "yes");
INSERT INTO `wp_options` VALUES("4107", "wppa_featen_count", "10", "yes");
INSERT INTO `wp_options` VALUES("4108", "wppa_featen_size", "86", "yes");
INSERT INTO `wp_options` VALUES("4109", "wppa_related_count", "10", "yes");
INSERT INTO `wp_options` VALUES("4110", "wppa_bc_on_featen", "yes", "yes");
INSERT INTO `wp_options` VALUES("4111", "wppa_bc_on_related", "yes", "yes");
INSERT INTO `wp_options` VALUES("4112", "wppa_bc_slide_thumblink", "no", "yes");
INSERT INTO `wp_options` VALUES("4113", "wppa_show_full_owner", "no", "yes");
INSERT INTO `wp_options` VALUES("4114", "wppa_dislike_set_pending", "0", "yes");
INSERT INTO `wp_options` VALUES("4115", "wppa_dislike_delete", "0", "yes");
INSERT INTO `wp_options` VALUES("4116", "wppa_dislike_show_count", "yes", "yes");
INSERT INTO `wp_options` VALUES("4117", "wppa_show_iptc_open", "no", "yes");
INSERT INTO `wp_options` VALUES("4118", "wppa_show_exif_open", "no", "yes");
INSERT INTO `wp_options` VALUES("4119", "wppa_share_linkedin", "yes", "yes");
INSERT INTO `wp_options` VALUES("4120", "wppa_facebook_comments", "yes", "yes");
INSERT INTO `wp_options` VALUES("4121", "wppa_facebook_like", "yes", "yes");
INSERT INTO `wp_options` VALUES("4122", "wppa_facebook_admin_id", "", "yes");
INSERT INTO `wp_options` VALUES("4123", "wppa_facebook_app_id", "", "yes");
INSERT INTO `wp_options` VALUES("4124", "wppa_thumb_text_owner", "no", "yes");
INSERT INTO `wp_options` VALUES("4125", "wppa_thumb_text_viewcount", "no", "yes");
INSERT INTO `wp_options` VALUES("4126", "wppa_show_treecount", "no", "yes");
INSERT INTO `wp_options` VALUES("4127", "wppa_skip_empty_albums", "yes", "yes");
INSERT INTO `wp_options` VALUES("4128", "wppa_show_albwidget_tooltip", "yes", "yes");
INSERT INTO `wp_options` VALUES("4129", "wppa_bgcolor_upload", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("4130", "wppa_bcolor_upload", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("4131", "wppa_bgcolor_multitag", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("4132", "wppa_bcolor_multitag", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("4133", "wppa_bgcolor_tagcloud", "#dddddd", "yes");
INSERT INTO `wp_options` VALUES("4134", "wppa_bcolor_tagcloud", "#bbbbbb", "yes");
INSERT INTO `wp_options` VALUES("4135", "wppa_update_addressline", "yes", "yes");
INSERT INTO `wp_options` VALUES("4136", "wppa_render_shortcode_always", "no", "yes");
INSERT INTO `wp_options` VALUES("4137", "wppa_slide_swipe", "yes", "yes");
INSERT INTO `wp_options` VALUES("4138", "wppa_cover_type", "default", "yes");
INSERT INTO `wp_options` VALUES("4139", "wppa_imgfact_count", "10", "yes");
INSERT INTO `wp_options` VALUES("4140", "wppa_dislike_value", "-5", "yes");
INSERT INTO `wp_options` VALUES("4141", "wppa_vote_button_text", "Vote for me!", "yes");
INSERT INTO `wp_options` VALUES("4142", "wppa_voted_button_text", "Voted for me", "yes");
INSERT INTO `wp_options` VALUES("4143", "wppa_vote_thumb", "no", "yes");
INSERT INTO `wp_options` VALUES("4144", "wppa_ovl_chrome_at_top", "yes", "yes");
INSERT INTO `wp_options` VALUES("4145", "wppa_fontsize_widget_thumb", "9", "yes");
INSERT INTO `wp_options` VALUES("4146", "wppa_featen_widget_linktype", "photo", "yes");
INSERT INTO `wp_options` VALUES("4147", "wppa_featen_widget_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("4148", "wppa_featen_blank", "no", "yes");
INSERT INTO `wp_options` VALUES("4149", "wppa_featen_overrule", "no", "yes");
INSERT INTO `wp_options` VALUES("4150", "wppa_slideshow_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("4151", "wppa_artmonkey_use_source", "no", "yes");
INSERT INTO `wp_options` VALUES("4152", "wppa_super_view_linkpage", "0", "yes");
INSERT INTO `wp_options` VALUES("4153", "wppa_upload_edit", "no", "yes");
INSERT INTO `wp_options` VALUES("4154", "wppa_upload_backend_notify", "no", "yes");
INSERT INTO `wp_options` VALUES("4155", "wppa_upload_one_only", "no", "yes");
INSERT INTO `wp_options` VALUES("4156", "wppa_editor_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("4157", "wppa_editor_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("4158", "wppa_author_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("4159", "wppa_author_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("4160", "wppa_contributor_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("4161", "wppa_contributor_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("4162", "wppa_subscriber_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("4163", "wppa_subscriber_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("4164", "wppa_loggedout_upload_limit_count", "0", "yes");
INSERT INTO `wp_options` VALUES("4165", "wppa_loggedout_upload_limit_time", "0", "yes");
INSERT INTO `wp_options` VALUES("4166", "wppa_file_system", "flat", "yes");
INSERT INTO `wp_options` VALUES("4167", "wppa_apply_new_photodesc_all", "", "yes");
INSERT INTO `wp_options` VALUES("4168", "wppa_remake_index", "", "yes");
INSERT INTO `wp_options` VALUES("4169", "wppa_extend_index", "", "yes");
INSERT INTO `wp_options` VALUES("4170", "wppa_list_index", "", "yes");
INSERT INTO `wp_options` VALUES("4171", "wppa_append_text", "", "yes");
INSERT INTO `wp_options` VALUES("4172", "wppa_append_to_photodesc", "", "yes");
INSERT INTO `wp_options` VALUES("4173", "wppa_remove_text", "", "yes");
INSERT INTO `wp_options` VALUES("4174", "wppa_remove_from_photodesc", "", "yes");
INSERT INTO `wp_options` VALUES("4175", "wppa_remove_empty_albums", "", "yes");
INSERT INTO `wp_options` VALUES("4176", "wppa_allow_foreign_shortcodes_thumbs", "no", "yes");
INSERT INTO `wp_options` VALUES("4177", "wppa_hier_pagesel", "no", "yes");
INSERT INTO `wp_options` VALUES("4178", "wppa_alt_type", "fullname", "yes");
INSERT INTO `wp_options` VALUES("4179", "wppa_photo_admin_pagesize", "20", "yes");
INSERT INTO `wp_options` VALUES("4180", "wppa_comment_admin_pagesize", "10", "yes");
INSERT INTO `wp_options` VALUES("4181", "wppa_jpeg_quality", "95", "yes");
INSERT INTO `wp_options` VALUES("4182", "wppa_geo_edit", "no", "yes");
INSERT INTO `wp_options` VALUES("4183", "wppa_auto_continue", "yes", "yes");
INSERT INTO `wp_options` VALUES("4184", "wppa_max_execution_time", "60", "yes");
INSERT INTO `wp_options` VALUES("4185", "wppa_adminbarmenu_admin", "yes", "yes");
INSERT INTO `wp_options` VALUES("4186", "wppa_adminbarmenu_frontend", "yes", "yes");
INSERT INTO `wp_options` VALUES("4187", "wppa_feed_use_thumb", "no", "yes");
INSERT INTO `wp_options` VALUES("4188", "wppa_og_tags_on", "yes", "yes");
INSERT INTO `wp_options` VALUES("4189", "wppa_add_shortcode_to_post", "no", "yes");
INSERT INTO `wp_options` VALUES("4190", "wppa_shortcode_to_add", "[wppa type=\"album\" album=\"#related,desc\"][/wppa]", "yes");
INSERT INTO `wp_options` VALUES("4191", "wppa_show_album_full", "yes", "yes");
INSERT INTO `wp_options` VALUES("4192", "wppa_grant_name", "display", "yes");
INSERT INTO `wp_options` VALUES("4193", "wppa_max_albums", "0", "yes");
INSERT INTO `wp_options` VALUES("4194", "wppa_alt_is_restricted", "no", "yes");
INSERT INTO `wp_options` VALUES("4195", "wppa_link_is_restricted", "no", "yes");
INSERT INTO `wp_options` VALUES("4196", "wppa_covertype_is_restricted", "no", "yes");
INSERT INTO `wp_options` VALUES("4197", "wppa_strip_file_ext", "no", "yes");
INSERT INTO `wp_options` VALUES("4198", "wppa_copy_timestamp", "no", "yes");
INSERT INTO `wp_options` VALUES("4199", "wppa_search_tags", "no", "yes");
INSERT INTO `wp_options` VALUES("4200", "wppa_indexed_search", "no", "yes");
INSERT INTO `wp_options` VALUES("4201", "wppa_max_search_photos", "250", "yes");
INSERT INTO `wp_options` VALUES("4202", "wppa_max_search_albums", "25", "yes");
INSERT INTO `wp_options` VALUES("4203", "wppa_tags_or_only", "no", "yes");
INSERT INTO `wp_options` VALUES("4204", "wppa_wild_front", "no", "yes");
INSERT INTO `wp_options` VALUES("4205", "wppa_use_scabn", "no", "yes");
INSERT INTO `wp_options` VALUES("4206", "wppa_gpx_shortcode", "[map style=\"width: auto; height:300px; margin:0; \" marker=\"yes\" lat=\"w#lat\" lon=\"w#lon\"]", "yes");
INSERT INTO `wp_options` VALUES("4207", "wppa_keep_source_admin", "no", "yes");
INSERT INTO `wp_options` VALUES("4208", "wppa_keep_source_frontend", "no", "yes");
INSERT INTO `wp_options` VALUES("4209", "wppa_source_dir", "/home/israel/public_html/traveltheworld/wp-content/uploads/wppa-source", "yes");
INSERT INTO `wp_options` VALUES("4210", "wppa_keep_sync", "yes", "yes");
INSERT INTO `wp_options` VALUES("4211", "wppa_remake_add", "yes", "yes");
INSERT INTO `wp_options` VALUES("4212", "wppa_save_iptc", "yes", "yes");
INSERT INTO `wp_options` VALUES("4213", "wppa_save_exif", "yes", "yes");
INSERT INTO `wp_options` VALUES("4214", "wppa_exif_max_array_size", "10", "yes");
INSERT INTO `wp_options` VALUES("4215", "wppa_chgsrc_is_restricted", "no", "yes");
INSERT INTO `wp_options` VALUES("4216", "wppa_newpag_create", "no", "yes");
INSERT INTO `wp_options` VALUES("4217", "wppa_newpag_content", "[wppa type=\"cover\" album=\"w#album\" align=\"center\"][/wppa]", "yes");
INSERT INTO `wp_options` VALUES("4218", "wppa_newpag_type", "page", "yes");
INSERT INTO `wp_options` VALUES("4219", "wppa_newpag_status", "publish", "yes");
INSERT INTO `wp_options` VALUES("4102", "wppa_show_bread_posts", "yes", "yes");
INSERT INTO `wp_options` VALUES("6300", "_transient_timeout_dash_20494a3d90a6669585674ed0eb8dcd8f", "1398313431", "no");
INSERT INTO `wp_options` VALUES("6301", "_transient_dash_20494a3d90a6669585674ed0eb8dcd8f", "<p>This dashboard widget queries <a href=\"http://blogsearch.google.com/\">Google Blog Search</a> so that when another blog links to your site it will show up here. It has found no incoming links&hellip; yet. It&#8217;s okay &#8212; there is no rush.</p>\n", "no");
INSERT INTO `wp_options` VALUES("4237", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1398729488;s:7:\"checked\";a:6:{s:14:\"TheTravelTheme\";s:3:\"1.3\";s:12:\"twentyeleven\";s:3:\"1.7\";s:14:\"twentyfourteen\";s:3:\"1.0\";s:9:\"twentyten\";s:3:\"1.6\";s:14:\"twentythirteen\";s:3:\"1.1\";s:12:\"twentytwelve\";s:3:\"1.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("4239", "wppa_taglist", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("6330", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-3.9.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-3.9.zip\";s:10:\"no_content\";b:0;s:11:\"new_bundled\";b:0;s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"3.9\";s:7:\"version\";s:3:\"3.9\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1398729488;s:15:\"version_checked\";s:3:\"3.9\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("6117", "auto_core_update_notified", "a:4:{s:4:\"type\";s:6:\"manual\";s:5:\"email\";s:23:\"admin@israelvasquez.com\";s:7:\"version\";s:5:\"3.8.2\";s:9:\"timestamp\";i:1397546235;}", "yes");
INSERT INTO `wp_options` VALUES("6765", "wppa_counts", "a:2:{i:1;a:3:{i:3;s:1:\"0\";i:4;s:1:\"6\";i:5;s:1:\"0\";}i:2;a:3:{i:3;s:1:\"0\";i:4;s:1:\"0\";i:5;s:1:\"0\";}}", "yes");
INSERT INTO `wp_options` VALUES("6766", "wppa_counts_tree", "a:2:{i:1;a:2:{i:0;s:1:\"0\";i:1;s:1:\"6\";}i:2;a:2:{i:0;s:1:\"0\";i:1;s:1:\"0\";}}", "yes");
INSERT INTO `wp_options` VALUES("6898", "_site_transient_timeout_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "1399334281", "yes");
INSERT INTO `wp_options` VALUES("6899", "_site_transient_browser_6d44eab61dcf5b1f0e6fa8f6595ee1bc", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";N;s:7:\"version\";N;s:10:\"update_url\";s:0:\"\";s:7:\"img_src\";s:0:\"\";s:11:\"img_src_ssl\";s:0:\"\";s:15:\"current_version\";s:0:\"\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("6298", "_transient_timeout_feed_mod_df272f46eda81b57710ed75dad73a85b", "1398313431", "no");
INSERT INTO `wp_options` VALUES("6299", "_transient_feed_mod_df272f46eda81b57710ed75dad73a85b", "1398270231", "no");
INSERT INTO `wp_options` VALUES("6911", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6909", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6910", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Apr 2014 23:44:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"The easiest, most effective way to secure WordPress in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WP-Optimize\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/plugins/wp-optimize/#post-8691\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 21 Jan 2009 04:28:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8691@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Simple but effective plugin allows you to extensively clean up your WordPress database and optimize it without doing manual queries.\nThis simple but e\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"ruhanirabin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"MailPoet Newsletters\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wysija-newsletters/#post-32629\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Dec 2011 17:09:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"32629@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"Send newsletters, post notifications or autoresponders from WordPress easily, and beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"MailPoet Staff\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5468@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"Create a slick mobile WordPress website with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2082@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 9 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"25254@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Fully customise WordPress edit screens with powerful fields. Boasting a professional interface and a powerful API, it’s a must have for any web deve\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 28 Apr 2014 23:58:08 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Tue, 29 Apr 2014 00:19:18 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Mon, 28 Apr 2014 23:44:18 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20131030160355\";}", "no");
INSERT INTO `wp_options` VALUES("6318", "_transient_timeout_feed_77fa140e07ce53fe8c87136636f83d72", "1398313434", "no");
INSERT INTO `wp_options` VALUES("6319", "_transient_feed_77fa140e07ce53fe8c87136636f83d72", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Apr 2014 16:06:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Hide Admin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/plugins/hide-admin/#post-66364\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Apr 2014 15:13:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66364@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"This plugin is used to hide specific users list.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"aitcreation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Complex TV Embed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/complex-tv-embed/#post-66314\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 21:21:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66314@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"Creates a Shortcode to Embed Videos from Complex TV Publisher Hub.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"complex_ntrsctn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Headstore Call Button Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/plugins/headstore-call-button/#post-65960\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 07 Apr 2014 10:30:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"65960@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"Adds a Headstore Call Button to the Widget Panel.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"mrvv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Twitter Peep\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/twitter-peep/#post-66422\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Apr 2014 12:47:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66422@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"Twitter Peep is a wordpress widget used to display feeds in a nice and elegant way.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"abhisheksaha11\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Users Ultra\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/users-ultra/#post-66320\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 00:13:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66320@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"Users Ultra is the ideal tool for creating advanced user communities in few minutes.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"UsersUltra\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Google Maps Master\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/google-maps-master/#post-66311\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 18:05:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66311@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"Google Maps Master is the professional wordpress plugin to display locations with Google Maps V3.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"TechGasp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"WangGuard Registration Notice Add-on\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/plugins/wangguard-registration-notice-add-on/#post-66507\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 20 Apr 2014 09:36:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66507@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"WangGuard Registration Notice Add-on is an Add-on for WangGuard plugin. You can add a Notice in the registration page.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"José Conti\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WangGuard Limited Registration Domain Add-On\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.org/plugins/wangguard-limited-registration-domain-add-on/#post-66505\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 20 Apr 2014 09:32:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66505@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"WangGuard Limited Registration Domain Add-On is an Add-on for WangGuard plugin. You can allow or disallow a list of domains.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"José Conti\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WangGuard Blacklisted Words Add-On\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/plugins/wangguard-blacklisted-words-add-on/#post-66506\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 20 Apr 2014 09:34:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66506@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WangGuard Blacklisted Words is an Add-on for WangGuard plugin. You can blacklist words.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"José Conti\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Y2K Bug Simulator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/y2k-bug-simulator/#post-66533\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 01:42:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66533@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"The Y2K Bug Simulator adds filters to most core WordPress functions that report back a date, rendering 19xx in place of 20xx.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"James Luberda\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Bugherd Dashboard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/bugherd-dashboard/#post-63777\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 09 Feb 2014 02:11:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"63777@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"The Bugherd Dashboard provides a client facing interface within WordPress to track the progress of the bugs that have been submitted.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"drrobotnik\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"WP Responsive Jquery Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/plugins/wp-responsive-jquery-slider/#post-66467\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 15:59:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66467@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"An easy way to add WP Responsive Jquery Slider in your pages and post with shortcode[post_slider].\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Team Vivacity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"WP Twitter Autopost\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/wp-twitter-autopost/#post-66550\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Apr 2014 22:59:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66550@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Provides ability to autopost a Twitter update as the post gets created/edited on your Wordpress blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Team Vivacity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Drag an Drop Front-End Design Builder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.org/plugins/drag-and-drop-front-end-design-builder/#post-66480\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 22:44:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66480@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:230:\"Design Builder that allow live edition in the front end through the Limitless drag and drop system (<a href=\"http://themeforest.net/item/limitless-multipurpose\" rel=\"nofollow\">http://themeforest.net/item/limitless-multipurpose</a>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"diegpl\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Modal Links\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/modal-links/#post-66474\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 19 Apr 2014 19:08:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"66474@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"This plugin opens a post/page in modal window using the post/page id in shortcode.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"grglaz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 23 Apr 2014 16:23:55 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Wed, 23 Apr 2014 16:41:35 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Wed, 23 Apr 2014 16:06:35 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20131030160355\";}", "no");
INSERT INTO `wp_options` VALUES("6320", "_transient_timeout_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1398313434", "no");
INSERT INTO `wp_options` VALUES("6321", "_transient_feed_mod_77fa140e07ce53fe8c87136636f83d72", "1398270234", "no");
INSERT INTO `wp_options` VALUES("6913", "_transient_timeout_plugin_slugs", "1398818843", "no");
INSERT INTO `wp_options` VALUES("6914", "_transient_plugin_slugs", "a:6:{i:0;s:19:\"akismet/akismet.php\";i:1;s:45:\"bulletproof-security/bulletproof-security.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:39:\"multi-level-navigation-plugin/index.php\";i:4;s:41:\"wordpress-importer/wordpress-importer.php\";i:5;s:28:\"wp-photo-album-plus/wppa.php\";}", "no");
INSERT INTO `wp_options` VALUES("6324", "_transient_timeout_dash_de3249c4736ad3bd2cd29147c4a0d43e", "1398313434", "no");
INSERT INTO `wp_options` VALUES("6325", "_transient_dash_de3249c4736ad3bd2cd29147c4a0d43e", "<h4>Most Popular</h4>\n<h5><a href=\'http://wordpress.org/plugins/jetpack/\'>Jetpack by WordPress.com</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=jetpack&amp;_wpnonce=965eca4e89&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Jetpack by WordPress.com\'>Install</a>)</span>\n<p>Supercharge your WordPress site with powerful features previously only available to WordPress.com users.</p>\n<h4>Newest Plugins</h4>\n<h5><a href=\'http://wordpress.org/plugins/wp-twitter-autopost/\'>WP Twitter Autopost</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=wp-twitter-autopost&amp;_wpnonce=96930b586f&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'WP Twitter Autopost\'>Install</a>)</span>\n<p>Provides ability to autopost a Twitter update as the post gets created/edited on your Wordpress blog.</p>\n", "no");
INSERT INTO `wp_options` VALUES("6331", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("6434", "wppa_ini_js_version_en", "355", "yes");
INSERT INTO `wp_options` VALUES("6927", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1398743152", "yes");
INSERT INTO `wp_options` VALUES("6928", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"3898\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2456\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2344\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"1930\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"1856\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1583\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1329\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1325\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1310\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1260\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1225\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1121\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1000\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:3:\"982\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:3:\"974\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:3:\"950\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:3:\"844\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:3:\"821\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:3:\"780\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"722\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"686\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"681\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"678\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"623\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"615\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"595\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"572\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"570\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"541\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"539\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"530\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"522\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"506\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"505\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"471\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"458\";}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";s:3:\"453\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"452\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"436\";}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";s:3:\"432\";}}", "yes");
INSERT INTO `wp_options` VALUES("6929", "duplicator_settings", "a:8:{s:7:\"version\";s:5:\"0.5.2\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:17:\"package_zip_flush\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("6930", "duplicator_version_plugin", "0.5.2", "yes");
INSERT INTO `wp_options` VALUES("6932", "duplicator_package_active", "s:1314:\"O:11:\"DUP_Package\":15:{s:2:\"ID\";N;s:4:\"Name\";s:23:\"20140429_traveltheworld\";s:4:\"Hash\";N;s:8:\"NameHash\";N;s:7:\"Version\";s:5:\"0.5.2\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:56:\"/home/israel/public_html/traveltheworld/wp-snapshots/tmp\";s:8:\"StoreURL\";s:53:\"http://israelvasquez.com/traveltheworld/wp-snapshots/\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":15:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:39:\"/home/israel/public_html/traveltheworld\";s:8:\"DirCount\";i:0;s:9:\"FileCount\";i:0;s:9:\"LinkCount\";i:0;s:4:\"Size\";i:0;s:11:\"BigFileList\";a:0:{}s:15:\"InvalidFileList\";a:0:{}s:10:\"\0*\0Package\";r:1;s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}\";", "yes");
INSERT INTO `wp_options` VALUES("6907", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1398772685", "no");
INSERT INTO `wp_options` VALUES("6908", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1398729485", "no");
INSERT INTO `wp_options` VALUES("6912", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1398729485", "no");
INSERT INTO `wp_options` VALUES("6915", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1398772686", "no");
INSERT INTO `wp_options` VALUES("6916", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2014/04/smith/\'>WordPress 3.9 “Smith”</a> <span class=\"rss-date\">April 16, 2014</span><div class=\"rssSummary\">Version 3.9 of WordPress, named “Smith” in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you’ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wptavern.com/how-to-change-buddypress-profile-field-visibility-settings?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=how-to-change-buddypress-profile-field-visibility-settings\' title=\'Profile field visibility settings were added to BuddyPress in version 1.6 in order to address a popular request for profile privacy. The settings had remained the same up until the recent 2.0 release. Field visibility settings were previously tacked onto each field in the profile editing screens. BuddyPress project lead John James Jacoby proposed that the pl\'>WPTavern: How to Change BuddyPress Profile Field Visibility Settings</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/genesis-skeleton-for-wordpress-rapidly-create-develop-and-deploy-across-multiple-environments?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=genesis-skeleton-for-wordpress-rapidly-create-develop-and-deploy-across-multiple-environments\' title=\'Last week we featured a collection of Vagrant resources for WordPress development. Eric Clemmons, one of our readers, commented to let us know about Genesis Skeleton for WordPress, an awesome project that uses Vagrant for creating, developing and deploying WordPress across multiple environments. When Clemmons created Genesis, he wasn’t aware of how easily th\'>WPTavern: Genesis Skeleton for WordPress: Rapidly Create, Develop, and Deploy Across Multiple Environments</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/wpweekly-episode-147-interview-with-japh-thompson?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=wpweekly-episode-147-interview-with-japh-thompson\' title=\'In this episode of WordPress Weekly, I sat down with Japh Thompson to discuss his experience working at Envato for the past four years. Thompson worked in support before becoming the WordPress Evangelist for ThemeForest. In the interview, we learned what it was like to be a liaison between a huge theme marketplace and the WordPress Community. We learned how\'>WPTavern: WPWeekly Episode 147 – Interview With Japh Thompson</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'http://wordpress.org/plugins/jetpack/\' class=\'dashboard-news-plugin-link\'>Jetpack by WordPress.com</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=jetpack&amp;_wpnonce=f8025c66c6&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Jetpack by WordPress.com\'>Install</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("6926", "wppa_cached_options", "a:564:{s:13:\"wppa_revision\";s:4:\"5114\";s:12:\"wppa_prevrev\";s:4:\"4906\";s:17:\"wppa_i_responsive\";s:0:\"\";s:15:\"wppa_i_downsize\";s:0:\"\";s:17:\"wppa_i_userupload\";s:0:\"\";s:13:\"wppa_i_rating\";s:0:\"\";s:14:\"wppa_i_comment\";s:0:\"\";s:12:\"wppa_i_share\";s:0:\"\";s:11:\"wppa_i_iptc\";s:0:\"\";s:11:\"wppa_i_exif\";s:0:\"\";s:10:\"wppa_i_gpx\";s:0:\"\";s:15:\"wppa_i_fotomoto\";s:0:\"\";s:11:\"wppa_i_done\";s:0:\"\";s:13:\"wppa_colwidth\";s:3:\"640\";s:21:\"wppa_resize_on_upload\";s:2:\"no\";s:14:\"wppa_resize_to\";s:1:\"0\";s:15:\"wppa_min_thumbs\";s:1:\"1\";s:11:\"wppa_bwidth\";s:1:\"1\";s:12:\"wppa_bradius\";s:1:\"6\";s:16:\"wppa_box_spacing\";s:1:\"8\";s:18:\"wppa_pagelinks_max\";s:1:\"7\";s:13:\"wppa_fullsize\";s:3:\"640\";s:14:\"wppa_maxheight\";s:3:\"480\";s:12:\"wppa_enlarge\";s:2:\"no\";s:27:\"wppa_fullimage_border_width\";s:0:\"\";s:15:\"wppa_numbar_max\";s:2:\"10\";s:15:\"wppa_share_size\";s:2:\"32\";s:18:\"wppa_mini_treshold\";s:3:\"300\";s:23:\"wppa_slideshow_pagesize\";s:1:\"0\";s:14:\"wppa_thumbsize\";s:3:\"100\";s:18:\"wppa_thumbsize_alt\";s:3:\"130\";s:17:\"wppa_thumb_aspect\";s:8:\"0:0:none\";s:13:\"wppa_tf_width\";s:3:\"100\";s:17:\"wppa_tf_width_alt\";s:3:\"130\";s:14:\"wppa_tf_height\";s:3:\"130\";s:18:\"wppa_tf_height_alt\";s:3:\"180\";s:14:\"wppa_tn_margin\";s:1:\"4\";s:15:\"wppa_thumb_auto\";s:3:\"yes\";s:20:\"wppa_thumb_page_size\";s:1:\"0\";s:14:\"wppa_popupsize\";s:3:\"150\";s:22:\"wppa_use_thumbs_if_fit\";s:3:\"yes\";s:20:\"wppa_max_cover_width\";s:4:\"1024\";s:22:\"wppa_text_frame_height\";s:2:\"54\";s:14:\"wppa_smallsize\";s:3:\"150\";s:20:\"wppa_smallsize_multi\";s:3:\"100\";s:24:\"wppa_coversize_is_height\";s:2:\"no\";s:20:\"wppa_album_page_size\";s:1:\"0\";s:15:\"wppa_rating_max\";s:1:\"5\";s:16:\"wppa_rating_prec\";s:1:\"2\";s:18:\"wppa_gravatar_size\";s:2:\"40\";s:15:\"wppa_ratspacing\";s:2:\"30\";s:17:\"wppa_topten_count\";s:2:\"10\";s:16:\"wppa_topten_size\";s:2:\"86\";s:17:\"wppa_comten_count\";s:2:\"10\";s:16:\"wppa_comten_size\";s:2:\"86\";s:17:\"wppa_featen_count\";s:2:\"10\";s:16:\"wppa_featen_size\";s:2:\"86\";s:27:\"wppa_thumbnail_widget_count\";s:2:\"10\";s:26:\"wppa_thumbnail_widget_size\";s:2:\"86\";s:17:\"wppa_lasten_count\";s:2:\"10\";s:16:\"wppa_lasten_size\";s:2:\"86\";s:23:\"wppa_album_widget_count\";s:2:\"10\";s:22:\"wppa_album_widget_size\";s:2:\"86\";s:18:\"wppa_related_count\";s:2:\"10\";s:18:\"wppa_ovl_txt_lines\";s:4:\"auto\";s:14:\"wppa_magnifier\";s:19:\"magnifier-small.png\";s:21:\"wppa_show_bread_posts\";s:3:\"yes\";s:21:\"wppa_show_bread_pages\";s:3:\"yes\";s:17:\"wppa_bc_on_search\";s:3:\"yes\";s:17:\"wppa_bc_on_topten\";s:3:\"yes\";s:17:\"wppa_bc_on_lasten\";s:3:\"yes\";s:17:\"wppa_bc_on_comten\";s:3:\"yes\";s:17:\"wppa_bc_on_featen\";s:3:\"yes\";s:14:\"wppa_bc_on_tag\";s:3:\"yes\";s:18:\"wppa_bc_on_related\";s:3:\"yes\";s:14:\"wppa_show_home\";s:3:\"yes\";s:14:\"wppa_show_page\";s:3:\"yes\";s:17:\"wppa_bc_separator\";s:5:\"raquo\";s:11:\"wppa_bc_txt\";s:80:\"&lt;span style=&quot;color:red; font_size:24px;&quot;&gt;&amp;bull;&lt;/span&gt;\";s:11:\"wppa_bc_url\";s:95:\"http://israelvasquez.com/traveltheworld/wp-content/plugins/wp-photo-album-plus/images/arrow.gif\";s:17:\"wppa_pagelink_pos\";s:6:\"bottom\";s:23:\"wppa_bc_slide_thumblink\";s:2:\"no\";s:30:\"wppa_show_startstop_navigation\";s:3:\"yes\";s:27:\"wppa_show_browse_navigation\";s:3:\"yes\";s:14:\"wppa_filmstrip\";s:3:\"yes\";s:19:\"wppa_film_show_glue\";s:3:\"yes\";s:19:\"wppa_show_full_name\";s:3:\"yes\";s:20:\"wppa_show_full_owner\";s:2:\"no\";s:19:\"wppa_show_full_desc\";s:3:\"yes\";s:20:\"wppa_hide_when_empty\";s:2:\"no\";s:14:\"wppa_rating_on\";s:3:\"yes\";s:23:\"wppa_dislike_mail_every\";s:1:\"5\";s:24:\"wppa_dislike_set_pending\";s:1:\"0\";s:19:\"wppa_dislike_delete\";s:1:\"0\";s:23:\"wppa_dislike_show_count\";s:3:\"yes\";s:24:\"wppa_rating_display_type\";s:7:\"graphic\";s:20:\"wppa_show_avg_rating\";s:3:\"yes\";s:18:\"wppa_show_comments\";s:3:\"yes\";s:21:\"wppa_comment_gravatar\";s:4:\"none\";s:25:\"wppa_comment_gravatar_url\";s:7:\"http://\";s:13:\"wppa_show_bbb\";s:2:\"no\";s:13:\"wppa_show_ubb\";s:2:\"no\";s:14:\"wppa_custom_on\";s:2:\"no\";s:19:\"wppa_custom_content\";s:95:\"<div style=\"color:red; font-size:24px; font-weight:bold; text-align:center;\">Hello world!</div>\";s:25:\"wppa_show_slideshownumbar\";s:2:\"no\";s:14:\"wppa_show_iptc\";s:2:\"no\";s:19:\"wppa_show_iptc_open\";s:2:\"no\";s:14:\"wppa_show_exif\";s:2:\"no\";s:19:\"wppa_show_exif_open\";s:2:\"no\";s:17:\"wppa_copyright_on\";s:3:\"yes\";s:21:\"wppa_copyright_notice\";s:76:\"<span style=\"color:red\" >Warning: Do not upload copyrighted material!</span>\";s:13:\"wppa_share_on\";s:2:\"no\";s:28:\"wppa_share_hide_when_running\";s:2:\"no\";s:20:\"wppa_share_on_widget\";s:2:\"no\";s:20:\"wppa_share_on_thumbs\";s:2:\"no\";s:22:\"wppa_share_on_lightbox\";s:2:\"no\";s:20:\"wppa_share_on_mphoto\";s:2:\"no\";s:13:\"wppa_share_qr\";s:3:\"yes\";s:19:\"wppa_share_facebook\";s:3:\"yes\";s:18:\"wppa_share_twitter\";s:3:\"yes\";s:16:\"wppa_share_hyves\";s:3:\"yes\";s:17:\"wppa_share_google\";s:3:\"yes\";s:20:\"wppa_share_pinterest\";s:3:\"yes\";s:19:\"wppa_share_linkedin\";s:3:\"yes\";s:22:\"wppa_facebook_comments\";s:3:\"yes\";s:18:\"wppa_facebook_like\";s:3:\"yes\";s:22:\"wppa_facebook_admin_id\";s:0:\"\";s:20:\"wppa_facebook_app_id\";s:0:\"\";s:22:\"wppa_load_facebook_sdk\";s:3:\"yes\";s:23:\"wppa_share_single_image\";s:2:\"no\";s:20:\"wppa_thumb_text_name\";s:3:\"yes\";s:21:\"wppa_thumb_text_owner\";s:2:\"no\";s:20:\"wppa_thumb_text_desc\";s:3:\"yes\";s:22:\"wppa_thumb_text_rating\";s:3:\"yes\";s:25:\"wppa_thumb_text_viewcount\";s:2:\"no\";s:20:\"wppa_popup_text_name\";s:3:\"yes\";s:20:\"wppa_popup_text_desc\";s:3:\"yes\";s:26:\"wppa_popup_text_desc_strip\";s:2:\"no\";s:22:\"wppa_popup_text_rating\";s:3:\"yes\";s:25:\"wppa_popup_text_ncomments\";s:3:\"yes\";s:22:\"wppa_show_rating_count\";s:2:\"no\";s:25:\"wppa_albdesc_on_thumbarea\";s:4:\"none\";s:25:\"wppa_albname_on_thumbarea\";s:4:\"none\";s:20:\"wppa_show_cover_text\";s:3:\"yes\";s:21:\"wppa_enable_slideshow\";s:3:\"yes\";s:29:\"wppa_show_slideshowbrowselink\";s:3:\"yes\";s:18:\"wppa_show_viewlink\";s:3:\"yes\";s:19:\"wppa_show_treecount\";s:2:\"no\";s:22:\"wppa_skip_empty_albums\";s:3:\"yes\";s:20:\"wppa_show_bbb_widget\";s:2:\"no\";s:20:\"wppa_show_ubb_widget\";s:2:\"no\";s:27:\"wppa_show_albwidget_tooltip\";s:3:\"yes\";s:18:\"wppa_ovl_close_txt\";s:5:\"CLOSE\";s:14:\"wppa_ovl_theme\";s:5:\"black\";s:19:\"wppa_ovl_slide_name\";s:2:\"no\";s:19:\"wppa_ovl_slide_desc\";s:3:\"yes\";s:19:\"wppa_ovl_thumb_name\";s:3:\"yes\";s:19:\"wppa_ovl_thumb_desc\";s:2:\"no\";s:18:\"wppa_ovl_potd_name\";s:3:\"yes\";s:18:\"wppa_ovl_potd_desc\";s:2:\"no\";s:20:\"wppa_ovl_sphoto_name\";s:3:\"yes\";s:20:\"wppa_ovl_sphoto_desc\";s:2:\"no\";s:20:\"wppa_ovl_mphoto_name\";s:3:\"yes\";s:20:\"wppa_ovl_mphoto_desc\";s:2:\"no\";s:17:\"wppa_ovl_alw_name\";s:3:\"yes\";s:17:\"wppa_ovl_alw_desc\";s:2:\"no\";s:19:\"wppa_ovl_cover_name\";s:3:\"yes\";s:19:\"wppa_ovl_cover_desc\";s:2:\"no\";s:21:\"wppa_ovl_show_counter\";s:3:\"yes\";s:16:\"wppa_show_zoomin\";s:3:\"yes\";s:17:\"wppa_bgcolor_even\";s:7:\"#eeeeee\";s:16:\"wppa_bcolor_even\";s:7:\"#cccccc\";s:16:\"wppa_bgcolor_alt\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_alt\";s:7:\"#bbbbbb\";s:22:\"wppa_bgcolor_thumbnail\";s:7:\"#000000\";s:16:\"wppa_bgcolor_nav\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_nav\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_namedesc\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_namedesc\";s:7:\"#bbbbbb\";s:16:\"wppa_bgcolor_com\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_com\";s:7:\"#bbbbbb\";s:16:\"wppa_bgcolor_img\";s:7:\"#eeeeee\";s:15:\"wppa_bcolor_img\";s:0:\"\";s:20:\"wppa_bgcolor_fullimg\";s:7:\"#cccccc\";s:19:\"wppa_bcolor_fullimg\";s:7:\"#777777\";s:16:\"wppa_bgcolor_cus\";s:7:\"#dddddd\";s:15:\"wppa_bcolor_cus\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_numbar\";s:7:\"#cccccc\";s:18:\"wppa_bcolor_numbar\";s:7:\"#cccccc\";s:26:\"wppa_bgcolor_numbar_active\";s:7:\"#333333\";s:25:\"wppa_bcolor_numbar_active\";s:7:\"#333333\";s:17:\"wppa_bgcolor_iptc\";s:7:\"#dddddd\";s:16:\"wppa_bcolor_iptc\";s:7:\"#bbbbbb\";s:17:\"wppa_bgcolor_exif\";s:7:\"#dddddd\";s:16:\"wppa_bcolor_exif\";s:7:\"#bbbbbb\";s:18:\"wppa_bgcolor_share\";s:7:\"#dddddd\";s:17:\"wppa_bcolor_share\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_upload\";s:7:\"#dddddd\";s:18:\"wppa_bcolor_upload\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_multitag\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_multitag\";s:7:\"#bbbbbb\";s:21:\"wppa_bgcolor_tagcloud\";s:7:\"#dddddd\";s:20:\"wppa_bcolor_tagcloud\";s:7:\"#bbbbbb\";s:22:\"wppa_bgcolor_superview\";s:7:\"#dddddd\";s:21:\"wppa_bcolor_superview\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_search\";s:7:\"#dddddd\";s:18:\"wppa_bcolor_search\";s:7:\"#bbbbbb\";s:19:\"wppa_bgcolor_bestof\";s:7:\"#dddddd\";s:18:\"wppa_bcolor_bestof\";s:7:\"#bbbbbb\";s:15:\"wppa_allow_ajax\";s:2:\"no\";s:19:\"wppa_ajax_non_admin\";s:2:\"no\";s:28:\"wppa_use_photo_names_in_urls\";s:2:\"no\";s:21:\"wppa_use_pretty_links\";s:2:\"no\";s:23:\"wppa_update_addressline\";s:3:\"yes\";s:28:\"wppa_render_shortcode_always\";s:2:\"no\";s:21:\"wppa_track_viewcounts\";s:3:\"yes\";s:14:\"wppa_auto_page\";s:2:\"no\";s:19:\"wppa_auto_page_type\";s:5:\"photo\";s:20:\"wppa_auto_page_links\";s:6:\"bottom\";s:21:\"wppa_defer_javascript\";s:2:\"no\";s:15:\"wppa_inline_css\";s:3:\"yes\";s:17:\"wppa_custom_style\";s:0:\"\";s:15:\"wppa_fullvalign\";s:3:\"fit\";s:15:\"wppa_fullhalign\";s:6:\"center\";s:16:\"wppa_start_slide\";s:3:\"run\";s:20:\"wppa_start_slideonly\";s:3:\"yes\";s:19:\"wppa_animation_type\";s:8:\"fadeover\";s:22:\"wppa_slideshow_timeout\";s:4:\"2500\";s:20:\"wppa_animation_speed\";s:3:\"800\";s:16:\"wppa_slide_pause\";s:2:\"no\";s:15:\"wppa_slide_wrap\";s:3:\"yes\";s:19:\"wppa_fulldesc_align\";s:6:\"center\";s:14:\"wppa_clean_pbr\";s:3:\"yes\";s:24:\"wppa_run_wpautop_on_desc\";s:2:\"no\";s:23:\"wppa_auto_open_comments\";s:3:\"yes\";s:20:\"wppa_film_hover_goto\";s:2:\"no\";s:16:\"wppa_slide_swipe\";s:3:\"yes\";s:19:\"wppa_list_photos_by\";s:1:\"0\";s:21:\"wppa_list_photos_desc\";s:2:\"no\";s:14:\"wppa_thumbtype\";s:7:\"default\";s:20:\"wppa_thumbphoto_left\";s:2:\"no\";s:11:\"wppa_valign\";s:6:\"center\";s:22:\"wppa_use_thumb_opacity\";s:3:\"yes\";s:18:\"wppa_thumb_opacity\";s:2:\"85\";s:20:\"wppa_use_thumb_popup\";s:3:\"yes\";s:20:\"wppa_align_thumbtext\";s:2:\"no\";s:19:\"wppa_list_albums_by\";s:1:\"0\";s:21:\"wppa_list_albums_desc\";s:2:\"no\";s:19:\"wppa_coverphoto_pos\";s:5:\"right\";s:22:\"wppa_use_cover_opacity\";s:3:\"yes\";s:18:\"wppa_cover_opacity\";s:2:\"85\";s:15:\"wppa_cover_type\";s:7:\"default\";s:18:\"wppa_imgfact_count\";s:2:\"10\";s:17:\"wppa_rating_login\";s:3:\"yes\";s:18:\"wppa_rating_change\";s:3:\"yes\";s:17:\"wppa_rating_multi\";s:2:\"no\";s:18:\"wppa_dislike_value\";s:2:\"-5\";s:21:\"wppa_next_on_callback\";s:2:\"no\";s:17:\"wppa_star_opacity\";s:2:\"20\";s:21:\"wppa_vote_button_text\";s:12:\"Vote for me!\";s:22:\"wppa_voted_button_text\";s:12:\"Voted for me\";s:15:\"wppa_vote_thumb\";s:2:\"no\";s:22:\"wppa_medal_bronze_when\";s:1:\"5\";s:22:\"wppa_medal_silver_when\";s:2:\"10\";s:20:\"wppa_medal_gold_when\";s:2:\"15\";s:16:\"wppa_medal_color\";s:1:\"2\";s:19:\"wppa_medal_position\";s:8:\"botright\";s:18:\"wppa_comment_login\";s:2:\"no\";s:18:\"wppa_comments_desc\";s:2:\"no\";s:23:\"wppa_comment_moderation\";s:6:\"logout\";s:27:\"wppa_comment_email_required\";s:3:\"yes\";s:19:\"wppa_comment_notify\";s:4:\"none\";s:25:\"wppa_comment_notify_added\";s:3:\"yes\";s:23:\"wppa_comten_alt_display\";s:2:\"no\";s:25:\"wppa_comten_alt_thumbsize\";s:2:\"75\";s:26:\"wppa_comment_smiley_picker\";s:2:\"no\";s:16:\"wppa_ovl_opacity\";s:2:\"80\";s:16:\"wppa_ovl_onclick\";s:4:\"none\";s:13:\"wppa_ovl_anim\";s:3:\"300\";s:14:\"wppa_ovl_slide\";s:4:\"5000\";s:22:\"wppa_ovl_chrome_at_top\";s:3:\"yes\";s:20:\"wppa_lightbox_global\";s:2:\"no\";s:24:\"wppa_lightbox_global_set\";s:2:\"no\";s:21:\"wppa_fontfamily_title\";s:0:\"\";s:19:\"wppa_fontsize_title\";s:0:\"\";s:20:\"wppa_fontcolor_title\";s:0:\"\";s:21:\"wppa_fontweight_title\";s:4:\"bold\";s:24:\"wppa_fontfamily_fulldesc\";s:0:\"\";s:22:\"wppa_fontsize_fulldesc\";s:0:\"\";s:23:\"wppa_fontcolor_fulldesc\";s:0:\"\";s:24:\"wppa_fontweight_fulldesc\";s:6:\"normal\";s:25:\"wppa_fontfamily_fulltitle\";s:0:\"\";s:23:\"wppa_fontsize_fulltitle\";s:0:\"\";s:24:\"wppa_fontcolor_fulltitle\";s:0:\"\";s:25:\"wppa_fontweight_fulltitle\";s:6:\"normal\";s:19:\"wppa_fontfamily_nav\";s:0:\"\";s:17:\"wppa_fontsize_nav\";s:0:\"\";s:18:\"wppa_fontcolor_nav\";s:0:\"\";s:19:\"wppa_fontweight_nav\";s:6:\"normal\";s:21:\"wppa_fontfamily_thumb\";s:0:\"\";s:19:\"wppa_fontsize_thumb\";s:0:\"\";s:20:\"wppa_fontcolor_thumb\";s:0:\"\";s:21:\"wppa_fontweight_thumb\";s:6:\"normal\";s:19:\"wppa_fontfamily_box\";s:0:\"\";s:17:\"wppa_fontsize_box\";s:0:\"\";s:18:\"wppa_fontcolor_box\";s:0:\"\";s:19:\"wppa_fontweight_box\";s:6:\"normal\";s:22:\"wppa_fontfamily_numbar\";s:0:\"\";s:20:\"wppa_fontsize_numbar\";s:0:\"\";s:21:\"wppa_fontcolor_numbar\";s:7:\"#777777\";s:22:\"wppa_fontweight_numbar\";s:6:\"normal\";s:29:\"wppa_fontfamily_numbar_active\";s:0:\"\";s:27:\"wppa_fontsize_numbar_active\";s:0:\"\";s:28:\"wppa_fontcolor_numbar_active\";s:7:\"#777777\";s:29:\"wppa_fontweight_numbar_active\";s:4:\"bold\";s:24:\"wppa_fontfamily_lightbox\";s:0:\"\";s:22:\"wppa_fontsize_lightbox\";s:2:\"10\";s:23:\"wppa_fontcolor_lightbox\";s:0:\"\";s:24:\"wppa_fontweight_lightbox\";s:4:\"bold\";s:26:\"wppa_fontsize_widget_thumb\";s:1:\"9\";s:20:\"wppa_sphoto_linktype\";s:5:\"photo\";s:20:\"wppa_sphoto_linkpage\";s:1:\"0\";s:17:\"wppa_sphoto_blank\";s:2:\"no\";s:20:\"wppa_sphoto_overrule\";s:2:\"no\";s:20:\"wppa_mphoto_linktype\";s:5:\"photo\";s:20:\"wppa_mphoto_linkpage\";s:1:\"0\";s:17:\"wppa_mphoto_blank\";s:2:\"no\";s:20:\"wppa_mphoto_overrule\";s:2:\"no\";s:19:\"wppa_thumb_linktype\";s:5:\"photo\";s:19:\"wppa_thumb_linkpage\";s:1:\"0\";s:16:\"wppa_thumb_blank\";s:2:\"no\";s:19:\"wppa_thumb_overrule\";s:2:\"no\";s:27:\"wppa_topten_widget_linktype\";s:5:\"photo\";s:27:\"wppa_topten_widget_linkpage\";s:1:\"0\";s:17:\"wppa_topten_blank\";s:2:\"no\";s:20:\"wppa_topten_overrule\";s:2:\"no\";s:27:\"wppa_featen_widget_linktype\";s:5:\"photo\";s:27:\"wppa_featen_widget_linkpage\";s:1:\"0\";s:17:\"wppa_featen_blank\";s:2:\"no\";s:20:\"wppa_featen_overrule\";s:2:\"no\";s:30:\"wppa_slideonly_widget_linktype\";s:6:\"widget\";s:30:\"wppa_slideonly_widget_linkpage\";s:1:\"0\";s:19:\"wppa_sswidget_blank\";s:2:\"no\";s:22:\"wppa_sswidget_overrule\";s:2:\"no\";s:20:\"wppa_widget_linktype\";s:5:\"album\";s:20:\"wppa_widget_linkpage\";s:1:\"0\";s:15:\"wppa_potd_blank\";s:2:\"no\";s:24:\"wppa_potdwidget_overrule\";s:2:\"no\";s:22:\"wppa_coverimg_linktype\";s:4:\"same\";s:22:\"wppa_coverimg_linkpage\";s:1:\"0\";s:19:\"wppa_coverimg_blank\";s:2:\"no\";s:22:\"wppa_coverimg_overrule\";s:2:\"no\";s:28:\"wppa_comment_widget_linktype\";s:5:\"photo\";s:28:\"wppa_comment_widget_linkpage\";s:1:\"0\";s:18:\"wppa_comment_blank\";s:2:\"no\";s:21:\"wppa_comment_overrule\";s:2:\"no\";s:23:\"wppa_slideshow_linktype\";s:4:\"none\";s:23:\"wppa_slideshow_linkpage\";s:1:\"0\";s:20:\"wppa_slideshow_blank\";s:2:\"no\";s:23:\"wppa_slideshow_overrule\";s:2:\"no\";s:30:\"wppa_thumbnail_widget_linktype\";s:5:\"photo\";s:30:\"wppa_thumbnail_widget_linkpage\";s:1:\"0\";s:30:\"wppa_thumbnail_widget_overrule\";s:2:\"no\";s:27:\"wppa_thumbnail_widget_blank\";s:2:\"no\";s:18:\"wppa_film_linktype\";s:9:\"slideshow\";s:27:\"wppa_lasten_widget_linktype\";s:5:\"photo\";s:27:\"wppa_lasten_widget_linkpage\";s:1:\"0\";s:17:\"wppa_lasten_blank\";s:2:\"no\";s:20:\"wppa_lasten_overrule\";s:2:\"no\";s:20:\"wppa_art_monkey_link\";s:4:\"none\";s:26:\"wppa_art_monkey_popup_link\";s:4:\"file\";s:25:\"wppa_artmonkey_use_source\";s:2:\"no\";s:23:\"wppa_art_monkey_display\";s:6:\"button\";s:26:\"wppa_album_widget_linktype\";s:7:\"content\";s:26:\"wppa_album_widget_linkpage\";s:1:\"0\";s:23:\"wppa_album_widget_blank\";s:2:\"no\";s:22:\"wppa_tagcloud_linktype\";s:5:\"album\";s:22:\"wppa_tagcloud_linkpage\";s:1:\"0\";s:19:\"wppa_tagcloud_blank\";s:2:\"no\";s:22:\"wppa_multitag_linktype\";s:5:\"album\";s:22:\"wppa_multitag_linkpage\";s:1:\"0\";s:19:\"wppa_multitag_blank\";s:2:\"no\";s:24:\"wppa_super_view_linkpage\";s:1:\"0\";s:26:\"wppa_upldr_widget_linkpage\";s:1:\"0\";s:27:\"wppa_bestof_widget_linkpage\";s:1:\"0\";s:36:\"wppa_album_navigator_widget_linkpage\";s:1:\"0\";s:22:\"wppa_user_upload_login\";s:3:\"yes\";s:15:\"wppa_owner_only\";s:2:\"no\";s:19:\"wppa_user_upload_on\";s:2:\"no\";s:20:\"wppa_upload_moderate\";s:2:\"no\";s:16:\"wppa_upload_edit\";s:2:\"no\";s:18:\"wppa_upload_notify\";s:2:\"no\";s:26:\"wppa_upload_backend_notify\";s:2:\"no\";s:20:\"wppa_upload_one_only\";s:2:\"no\";s:22:\"wppa_memcheck_frontend\";s:3:\"yes\";s:19:\"wppa_memcheck_admin\";s:3:\"yes\";s:20:\"wppa_comment_captcha\";s:2:\"no\";s:16:\"wppa_spam_maxage\";s:4:\"none\";s:19:\"wppa_user_create_on\";s:2:\"no\";s:22:\"wppa_user_create_login\";s:3:\"yes\";s:27:\"wppa_upload_fronend_maxsize\";s:1:\"0\";s:14:\"wppa_void_dups\";s:2:\"no\";s:30:\"wppa_editor_upload_limit_count\";s:1:\"0\";s:29:\"wppa_editor_upload_limit_time\";s:1:\"0\";s:30:\"wppa_author_upload_limit_count\";s:1:\"0\";s:29:\"wppa_author_upload_limit_time\";s:1:\"0\";s:35:\"wppa_contributor_upload_limit_count\";s:1:\"0\";s:34:\"wppa_contributor_upload_limit_time\";s:1:\"0\";s:34:\"wppa_subscriber_upload_limit_count\";s:1:\"0\";s:33:\"wppa_subscriber_upload_limit_time\";s:1:\"0\";s:33:\"wppa_loggedout_upload_limit_count\";s:1:\"0\";s:32:\"wppa_loggedout_upload_limit_time\";s:1:\"0\";s:10:\"wppa_setup\";s:0:\"\";s:11:\"wppa_backup\";s:0:\"\";s:14:\"wppa_load_skin\";s:0:\"\";s:13:\"wppa_skinfile\";s:7:\"default\";s:17:\"wppa_regen_thumbs\";s:0:\"\";s:26:\"wppa_regen_thumbs_skip_one\";s:0:\"\";s:11:\"wppa_rerate\";s:0:\"\";s:12:\"wppa_cleanup\";s:0:\"\";s:10:\"wppa_recup\";s:0:\"\";s:16:\"wppa_file_system\";s:4:\"flat\";s:19:\"wppa_blacklist_user\";s:0:\"\";s:22:\"wppa_un_blacklist_user\";s:0:\"\";s:11:\"wppa_remake\";s:0:\"\";s:20:\"wppa_remake_skip_one\";s:0:\"\";s:19:\"wppa_errorlog_purge\";s:0:\"\";s:17:\"wppa_rating_clear\";s:2:\"no\";s:20:\"wppa_viewcount_clear\";s:2:\"no\";s:15:\"wppa_iptc_clear\";s:0:\"\";s:15:\"wppa_exif_clear\";s:0:\"\";s:28:\"wppa_apply_new_photodesc_all\";s:0:\"\";s:17:\"wppa_remake_index\";s:0:\"\";s:17:\"wppa_extend_index\";s:0:\"\";s:15:\"wppa_list_index\";s:0:\"\";s:29:\"wppa_list_index_display_start\";s:0:\"\";s:16:\"wppa_append_text\";s:0:\"\";s:24:\"wppa_append_to_photodesc\";s:0:\"\";s:16:\"wppa_remove_text\";s:0:\"\";s:26:\"wppa_remove_from_photodesc\";s:0:\"\";s:24:\"wppa_remove_empty_albums\";s:0:\"\";s:18:\"wppa_watermark_all\";s:0:\"\";s:9:\"wppa_html\";s:2:\"no\";s:18:\"wppa_check_balance\";s:2:\"no\";s:16:\"wppa_allow_debug\";s:2:\"no\";s:20:\"wppa_filter_priority\";s:4:\"1001\";s:23:\"wppa_shortcode_priority\";s:2:\"11\";s:18:\"wppa_lightbox_name\";s:4:\"wppa\";s:29:\"wppa_allow_foreign_shortcodes\";s:2:\"no\";s:36:\"wppa_allow_foreign_shortcodes_thumbs\";s:2:\"no\";s:16:\"wppa_arrow_color\";s:5:\"black\";s:14:\"wppa_meta_page\";s:3:\"yes\";s:13:\"wppa_meta_all\";s:3:\"yes\";s:18:\"wppa_use_wp_editor\";s:2:\"no\";s:16:\"wppa_hier_albsel\";s:2:\"no\";s:17:\"wppa_hier_pagesel\";s:2:\"no\";s:13:\"wppa_alt_type\";s:8:\"fullname\";s:25:\"wppa_photo_admin_pagesize\";s:2:\"20\";s:27:\"wppa_comment_admin_pagesize\";s:2:\"10\";s:17:\"wppa_jpeg_quality\";s:2:\"95\";s:13:\"wppa_geo_edit\";s:2:\"no\";s:18:\"wppa_auto_continue\";s:3:\"yes\";s:23:\"wppa_max_execution_time\";s:2:\"60\";s:23:\"wppa_adminbarmenu_admin\";s:3:\"yes\";s:26:\"wppa_adminbarmenu_frontend\";s:3:\"yes\";s:19:\"wppa_feed_use_thumb\";s:2:\"no\";s:15:\"wppa_og_tags_on\";s:3:\"yes\";s:26:\"wppa_add_shortcode_to_post\";s:2:\"no\";s:21:\"wppa_shortcode_to_add\";s:48:\"[wppa type=\"album\" album=\"#related,desc\"][/wppa]\";s:22:\"wppa_max_album_newtime\";s:1:\"0\";s:22:\"wppa_max_photo_newtime\";s:1:\"0\";s:24:\"wppa_apply_newphoto_desc\";s:2:\"no\";s:29:\"wppa_apply_newphoto_desc_user\";s:2:\"no\";s:25:\"wppa_newphoto_description\";s:1334:\"\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'block\'); jQuery(\'.wppa-more\').css(\'display\', \'none\'); wppaOvlResize();\">\r\n<div class=\"wppa-more\">\r\nCamera info\r\n</div>\r\n</a>\r\n<a onClick=\"jQuery(\'.wppa-dtl\').css(\'display\', \'none\'); jQuery(\'.wppa-more\').css(\'display\', \'block\'); wppaOvlResize();\">\r\n<div class=\"wppa-dtl\" style=\"display:none;\" >\r\nHide Camera info\r\n</div>\r\n</a>\r\n<div class=\"wppa-dtl\" style=\"display:none;\">\r\n<br />\r\n<style>\r\n.wppa-label { padding: 0 3px !important; border: none !important; }\r\n.wppa-value { padding: 0 3px 0 12px !important; border:none !important; }\r\n</style>\r\n<table style=\"margin:0; border:none;\" >\r\n<tr><td class=\"wppa-label\" >Date Time</td><td class=\"wppa-value\" >E#0132</td></tr>\r\n<tr><td class=\"wppa-label\" >Camera</td><td class=\"wppa-value\" >E#0110</td></tr>\r\n<tr><td class=\"wppa-label\" >Focal length</td><td class=\"wppa-value\" >E#920A</td></tr>\r\n<tr><td class=\"wppa-label\" >F-Stop</td><td class=\"wppa-value\" >E#829D</td></tr>\r\n<tr><td class=\"wppa-label\" >ISO Speed Rating</td><td class=\"wppa-value\" >E#8827</td></tr>\r\n<tr><td class=\"wppa-label\" >Exposure program</td><td class=\"wppa-value\" >E#8822</td></tr>\r\n<tr><td class=\"wppa-label\" >Metering mode</td><td class=\"wppa-value\" >E#9207</td></tr>\r\n<tr><td class=\"wppa-label\" >Flash</td><td class=\"wppa-value\" >E#9209</td></tr>\r\n</table>\r\n</div>\";s:23:\"wppa_upload_limit_count\";s:1:\"0\";s:22:\"wppa_upload_limit_time\";s:1:\"0\";s:20:\"wppa_show_album_full\";s:3:\"yes\";s:19:\"wppa_grant_an_album\";s:2:\"no\";s:15:\"wppa_grant_name\";s:7:\"display\";s:17:\"wppa_grant_parent\";s:1:\"0\";s:19:\"wppa_default_parent\";s:1:\"0\";s:15:\"wppa_max_albums\";s:1:\"0\";s:22:\"wppa_alt_is_restricted\";s:2:\"no\";s:23:\"wppa_link_is_restricted\";s:2:\"no\";s:28:\"wppa_covertype_is_restricted\";s:2:\"no\";s:22:\"wppa_porder_restricted\";s:2:\"no\";s:25:\"wppa_newphoto_name_method\";s:8:\"filename\";s:19:\"wppa_copy_timestamp\";s:2:\"no\";s:20:\"wppa_search_linkpage\";s:1:\"0\";s:13:\"wppa_excl_sep\";s:2:\"no\";s:16:\"wppa_search_tags\";s:2:\"no\";s:16:\"wppa_search_cats\";s:2:\"no\";s:20:\"wppa_search_comments\";s:2:\"no\";s:16:\"wppa_photos_only\";s:2:\"no\";s:19:\"wppa_indexed_search\";s:2:\"no\";s:22:\"wppa_max_search_photos\";s:3:\"250\";s:22:\"wppa_max_search_albums\";s:2:\"25\";s:17:\"wppa_tags_or_only\";s:2:\"no\";s:15:\"wppa_wild_front\";s:2:\"no\";s:24:\"wppa_search_display_type\";s:7:\"content\";s:17:\"wppa_watermark_on\";s:2:\"no\";s:19:\"wppa_watermark_user\";s:2:\"no\";s:19:\"wppa_watermark_file\";s:12:\"specimen.png\";s:18:\"wppa_watermark_pos\";s:6:\"cencen\";s:27:\"wppa_textual_watermark_type\";s:7:\"tvstyle\";s:27:\"wppa_textual_watermark_text\";s:48:\"Copyright (c) 2014 w#site \n w#filename (w#owner)\";s:27:\"wppa_textual_watermark_font\";s:6:\"system\";s:27:\"wppa_textual_watermark_size\";s:2:\"10\";s:21:\"wppa_watermark_upload\";s:0:\"\";s:22:\"wppa_watermark_opacity\";s:2:\"20\";s:27:\"wppa_watermark_opacity_text\";s:2:\"80\";s:16:\"wppa_slide_order\";s:22:\"0,1,2,3,4,5,6,7,8,9,10\";s:22:\"wppa_slide_order_split\";s:25:\"0,1,2,3,4,5,6,7,8,9,10,11\";s:18:\"wppa_swap_namedesc\";s:2:\"no\";s:19:\"wppa_split_namedesc\";s:2:\"no\";s:22:\"wppa_cp_points_comment\";s:1:\"0\";s:21:\"wppa_cp_points_rating\";s:1:\"0\";s:21:\"wppa_cp_points_upload\";s:1:\"0\";s:14:\"wppa_use_scabn\";s:2:\"no\";s:23:\"wppa_gpx_implementation\";s:4:\"none\";s:15:\"wppa_map_height\";s:3:\"300\";s:15:\"wppa_map_apikey\";s:0:\"\";s:18:\"wppa_gpx_shortcode\";s:88:\"[map style=\"width: auto; height:300px; margin:0; \" marker=\"yes\" lat=\"w#lat\" lon=\"w#lon\"]\";s:16:\"wppa_fotomoto_on\";s:2:\"no\";s:22:\"wppa_fotomoto_fontsize\";s:0:\"\";s:31:\"wppa_fotomoto_hide_when_running\";s:2:\"no\";s:23:\"wppa_fotomoto_min_width\";s:3:\"400\";s:16:\"wppa_widgettitle\";s:16:\"Photo of the day\";s:19:\"wppa_widget_linkurl\";s:25:\"Type your custom url here\";s:21:\"wppa_widget_linktitle\";s:19:\"Type the title here\";s:20:\"wppa_widget_subtitle\";s:4:\"none\";s:17:\"wppa_widget_album\";s:1:\"0\";s:17:\"wppa_widget_photo\";s:0:\"\";s:15:\"wppa_potd_align\";s:6:\"center\";s:18:\"wppa_widget_method\";s:1:\"1\";s:18:\"wppa_widget_period\";s:3:\"168\";s:17:\"wppa_widget_width\";s:3:\"200\";s:22:\"wppa_toptenwidgettitle\";s:14:\"Top Ten Photos\";s:25:\"wppa_thumbnailwidgettitle\";s:16:\"Thumbnail Photos\";s:22:\"wppa_searchwidgettitle\";s:13:\"Search photos\";s:18:\"wppa_comadmin_show\";s:3:\"all\";s:19:\"wppa_comadmin_order\";s:9:\"timestamp\";s:12:\"wppa_qr_size\";s:3:\"200\";s:13:\"wppa_qr_color\";s:7:\"#000000\";s:15:\"wppa_qr_bgcolor\";s:7:\"#FFFFFF\";s:22:\"wppa_keep_source_admin\";s:2:\"no\";s:25:\"wppa_keep_source_frontend\";s:2:\"no\";s:15:\"wppa_source_dir\";s:70:\"/home/israel/public_html/traveltheworld/wp-content/uploads/wppa-source\";s:14:\"wppa_keep_sync\";s:3:\"yes\";s:15:\"wppa_remake_add\";s:3:\"yes\";s:14:\"wppa_save_iptc\";s:3:\"yes\";s:14:\"wppa_save_exif\";s:3:\"yes\";s:24:\"wppa_exif_max_array_size\";s:2:\"10\";s:25:\"wppa_chgsrc_is_restricted\";s:2:\"no\";s:18:\"wppa_newpag_create\";s:2:\"no\";s:19:\"wppa_newpag_content\";s:57:\"[wppa type=\"cover\" album=\"w#album\" align=\"center\"][/wppa]\";s:16:\"wppa_newpag_type\";s:4:\"page\";s:18:\"wppa_newpag_status\";s:7:\"publish\";s:16:\"wppa_cdn_service\";s:0:\"\";s:19:\"wppa_cdn_cloud_name\";s:0:\"\";s:16:\"wppa_cdn_api_key\";s:0:\"\";s:19:\"wppa_cdn_api_secret\";s:0:\"\";s:23:\"wppa_cdn_service_update\";s:2:\"no\";s:31:\"wppa_delete_all_from_cloudinary\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("6925", "_transient_is_multi_author", "0", "yes");
INSERT INTO `wp_options` VALUES("6931", "duplicator_ui_view_state", "a:1:{s:14:\"dup-wpnotice01\";b:1;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("337", "147", "_edit_lock", "1366215801:1");
INSERT INTO `wp_postmeta` VALUES("329", "292", "_edit_lock", "1359044865:1");
INSERT INTO `wp_postmeta` VALUES("332", "294", "_edit_lock", "1359044814:1");
INSERT INTO `wp_postmeta` VALUES("4", "36", "_wp_attached_file", "2011/04/IMG_1629.jpg");
INSERT INTO `wp_postmeta` VALUES("5", "36", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"525\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_1629.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1629-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1629-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1629-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1629-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1629-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("6", "37", "_wp_attached_file", "2011/04/IMG_1622.jpg");
INSERT INTO `wp_postmeta` VALUES("7", "37", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"525\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_1622.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1622-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1622-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1622-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1622-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1622-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("8", "38", "_wp_attached_file", "2011/04/IMG_1617.jpg");
INSERT INTO `wp_postmeta` VALUES("9", "38", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"525\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_1617.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1617-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1617-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1617-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1617-700x288.jpg\";s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1617-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("10", "51", "_wp_attached_file", "2011/03/IMG_15981.jpg");
INSERT INTO `wp_postmeta` VALUES("11", "51", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"750\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:21:\"2011/03/IMG_15981.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_15981-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:21:\"IMG_15981-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:22:\"IMG_15981-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:22:\"IMG_15981-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:21:\"IMG_15981-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("12", "54", "_wp_attached_file", "2011/03/IMG_1611.jpg");
INSERT INTO `wp_postmeta` VALUES("13", "54", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"750\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/03/IMG_1611.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1611-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1611-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_1611-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_1611-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1611-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("14", "60", "_wp_attached_file", "2011/04/IMG_1659.jpg");
INSERT INTO `wp_postmeta` VALUES("15", "60", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"750\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_1659.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1659-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1659-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_1659-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_1659-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1659-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"9\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1302158193\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.9\";s:3:\"iso\";s:3:\"160\";s:13:\"shutter_speed\";s:6:\"0.0008\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("16", "69", "_wp_attached_file", "2011/04/IMG_1787.jpg");
INSERT INTO `wp_postmeta` VALUES("17", "69", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1333\";s:14:\"hwstring_small\";s:22:\"height=\'96\' width=\'72\'\";s:4:\"file\";s:20:\"2011/04/IMG_1787.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1787-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1787-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}s:5:\"large\";a:3:{s:4:\"file\";s:21:\"IMG_1787-768x1024.jpg\";s:5:\"width\";s:3:\"768\";s:6:\"height\";s:4:\"1024\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_1787-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_1787-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1787-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("18", "69", "_wp_attachment_backup_sizes", "a:2:{s:9:\"full-orig\";a:3:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:4:\"1333\";s:4:\"file\";s:12:\"IMG_1787.jpg\";}s:18:\"full-1302915440315\";a:3:{s:5:\"width\";s:3:\"562\";s:6:\"height\";s:3:\"750\";s:4:\"file\";s:27:\"IMG_1787-e1302915431226.jpg\";}}");
INSERT INTO `wp_postmeta` VALUES("19", "76", "_wp_attached_file", "2011/04/IMG_1872.jpg");
INSERT INTO `wp_postmeta` VALUES("20", "76", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"768\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_1872.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1872-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1872-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_1872-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_1872-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_1872-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.2\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1302764242\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.9\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:5:\"0.001\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("21", "84", "_wp_attached_file", "2011/04/IMG_2052.jpg");
INSERT INTO `wp_postmeta` VALUES("22", "84", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"434\";s:14:\"hwstring_small\";s:23:\"height=\'55\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_2052.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_2052-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_2052-300x130.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"130\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_2052-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_2052-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_2052-500x217.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"217\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:2:\"10\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1303010708\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:5:\"7.173\";s:3:\"iso\";s:3:\"160\";s:13:\"shutter_speed\";s:7:\"0.00125\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("23", "88", "_wp_attached_file", "2011/04/216050_10150232508100797_520940796_8974582_7434625_n.jpg");
INSERT INTO `wp_postmeta` VALUES("24", "88", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"437\";s:6:\"height\";s:3:\"466\";s:14:\"hwstring_small\";s:22:\"height=\'96\' width=\'90\'\";s:4:\"file\";s:64:\"2011/04/216050_10150232508100797_520940796_8974582_7434625_n.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:64:\"216050_10150232508100797_520940796_8974582_7434625_n-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:64:\"216050_10150232508100797_520940796_8974582_7434625_n-281x300.jpg\";s:5:\"width\";s:3:\"281\";s:6:\"height\";s:3:\"300\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:64:\"216050_10150232508100797_520940796_8974582_7434625_n-437x288.jpg\";s:5:\"width\";s:3:\"437\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:64:\"216050_10150232508100797_520940796_8974582_7434625_n-437x288.jpg\";s:5:\"width\";s:3:\"437\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:64:\"216050_10150232508100797_520940796_8974582_7434625_n-281x300.jpg\";s:5:\"width\";s:3:\"281\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("25", "88", "_wp_attachment_temp_parent", "-98765");
INSERT INTO `wp_postmeta` VALUES("26", "93", "_wp_attached_file", "2011/04/IMG_2108.jpg");
INSERT INTO `wp_postmeta` VALUES("27", "93", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"618\";s:14:\"hwstring_small\";s:23:\"height=\'79\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_2108.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_2108-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_2108-300x185.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"185\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_2108-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_2108-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_2108-485x300.jpg\";s:5:\"width\";s:3:\"485\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"4.5\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1303374895\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:6:\"10.551\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("28", "99", "_wp_attached_file", "2011/04/IMG_2235.jpg");
INSERT INTO `wp_postmeta` VALUES("29", "99", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"549\";s:14:\"hwstring_small\";s:23:\"height=\'70\' width=\'128\'\";s:4:\"file\";s:20:\"2011/04/IMG_2235.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_2235-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_2235-300x164.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"164\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_2235-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_2235-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_2235-500x274.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"274\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.2\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1303554237\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.9\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:8:\"0.003125\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("30", "102", "_wp_attached_file", "2011/05/IMG_2262.jpg");
INSERT INTO `wp_postmeta` VALUES("31", "102", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"484\";s:14:\"hwstring_small\";s:23:\"height=\'61\' width=\'128\'\";s:4:\"file\";s:20:\"2011/05/IMG_2262.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_2262-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_2262-300x145.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"145\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"IMG_2262-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"IMG_2262-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"IMG_2262-500x242.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"242\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.2\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1303558223\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.9\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:6:\"0.0025\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("32", "112", "_wp_attached_file", "2011/05/DSC00077.jpg");
INSERT INTO `wp_postmeta` VALUES("33", "112", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"541\";s:14:\"hwstring_small\";s:23:\"height=\'69\' width=\'128\'\";s:4:\"file\";s:20:\"2011/05/DSC00077.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00077-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00077-300x162.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"162\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00077-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00077-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00077-500x270.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"270\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"4\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1304689463\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:5:\"11.75\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:5:\"0.002\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("34", "127", "_wp_attached_file", "2011/05/DSC00200.jpg");
INSERT INTO `wp_postmeta` VALUES("35", "127", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"540\";s:14:\"hwstring_small\";s:23:\"height=\'69\' width=\'128\'\";s:4:\"file\";s:20:\"2011/05/DSC00200.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00200-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00200-300x162.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"162\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00200-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00200-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00200-500x270.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"270\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305047799\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:8:\"0.003125\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("36", "134", "_wp_attached_file", "2011/05/DSC00364.jpg");
INSERT INTO `wp_postmeta` VALUES("37", "134", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"457\";s:14:\"hwstring_small\";s:23:\"height=\'58\' width=\'128\'\";s:4:\"file\";s:20:\"2011/05/DSC00364.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00364-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00364-300x137.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"137\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00364-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00364-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00364-500x228.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"228\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:2:\"10\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305553660\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"7.4\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("38", "137", "_wp_attached_file", "2011/05/DSC00327.jpg");
INSERT INTO `wp_postmeta` VALUES("39", "137", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"564\";s:14:\"hwstring_small\";s:23:\"height=\'72\' width=\'128\'\";s:4:\"file\";s:20:\"2011/05/DSC00327.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00327-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00327-300x169.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"169\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00327-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00327-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00327-500x282.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"282\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305475431\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:15:\"0.0769230769231\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("40", "140", "_wp_attached_file", "2011/06/DSC00622.jpg");
INSERT INTO `wp_postmeta` VALUES("41", "140", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"623\";s:14:\"hwstring_small\";s:23:\"height=\'79\' width=\'128\'\";s:4:\"file\";s:20:\"2011/06/DSC00622.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00622-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00622-300x186.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"186\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00622-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00622-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00622-481x300.jpg\";s:5:\"width\";s:3:\"481\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1306407909\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:5:\"0.002\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("42", "143", "_wp_attached_file", "2011/06/DSC00497.jpg");
INSERT INTO `wp_postmeta` VALUES("43", "143", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"220\";s:14:\"hwstring_small\";s:23:\"height=\'28\' width=\'128\'\";s:4:\"file\";s:20:\"2011/06/DSC00497.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00497-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:19:\"DSC00497-300x66.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:2:\"66\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00497-500x110.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"110\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305814980\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("44", "147", "_wp_attached_file", "2011/06/DSC004971.jpg");
INSERT INTO `wp_postmeta` VALUES("45", "147", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"4090\";s:6:\"height\";s:4:\"1080\";s:14:\"hwstring_small\";s:23:\"height=\'33\' width=\'128\'\";s:4:\"file\";s:21:\"2011/06/DSC004971.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC004971-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC004971-300x79.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:2:\"79\";}s:5:\"large\";a:3:{s:4:\"file\";s:22:\"DSC004971-1024x270.jpg\";s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"270\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:22:\"DSC004971-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:22:\"DSC004971-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:21:\"DSC004971-500x132.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"132\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305814980\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("46", "153", "_wp_attached_file", "2011/06/DSC00246.jpg");
INSERT INTO `wp_postmeta` VALUES("47", "153", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"446\";s:6:\"height\";s:3:\"285\";s:14:\"hwstring_small\";s:23:\"height=\'81\' width=\'128\'\";s:4:\"file\";s:20:\"2011/06/DSC00246.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00246-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00246-300x191.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"191\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1305121627\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:15:\"0.0333333333333\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("48", "160", "_wp_attached_file", "2011/06/IMG_1652.jpg");
INSERT INTO `wp_postmeta` VALUES("49", "160", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"448\";s:6:\"height\";s:3:\"254\";s:14:\"hwstring_small\";s:23:\"height=\'72\' width=\'128\'\";s:4:\"file\";s:20:\"2011/06/IMG_1652.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"IMG_1652-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"IMG_1652-300x170.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"170\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.2\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:24:\"Canon PowerShot SD780 IS\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1301968994\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.9\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:4:\"0.05\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("50", "161", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("51", "161", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("52", "161", "_menu_item_object_id", "8");
INSERT INTO `wp_postmeta` VALUES("53", "161", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("54", "161", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("55", "161", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("56", "161", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("57", "161", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("58", "162", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("59", "162", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("60", "162", "_menu_item_object_id", "12");
INSERT INTO `wp_postmeta` VALUES("61", "162", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("62", "162", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("63", "162", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("64", "162", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("65", "162", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("66", "163", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("67", "163", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("68", "163", "_menu_item_object_id", "6");
INSERT INTO `wp_postmeta` VALUES("69", "163", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("70", "163", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("71", "163", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("72", "163", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("73", "163", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("74", "198", "_wp_attached_file", "2011/06/DSC00741.jpg");
INSERT INTO `wp_postmeta` VALUES("75", "198", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"750\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'128\'\";s:4:\"file\";s:20:\"2011/06/DSC00741.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00741-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00741-300x225.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"225\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00741-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00741-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00741-400x300.jpg\";s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1307015197\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:5:\"0.002\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("76", "205", "_wp_attached_file", "2011/07/DSC00988.jpg");
INSERT INTO `wp_postmeta` VALUES("77", "205", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1024\";s:6:\"height\";s:3:\"540\";s:14:\"hwstring_small\";s:23:\"height=\'67\' width=\'128\'\";s:4:\"file\";s:20:\"2011/07/DSC00988.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00988-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00988-300x158.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"158\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00988-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00988-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00988-500x263.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"263\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1309882723\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("78", "214", "_wp_attached_file", "2011/07/DSC01095.jpg");
INSERT INTO `wp_postmeta` VALUES("79", "214", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"604\";s:14:\"hwstring_small\";s:23:\"height=\'77\' width=\'128\'\";s:4:\"file\";s:20:\"2011/07/DSC01095.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01095-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC01095-300x181.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"181\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC01095-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC01095-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01095-496x300.jpg\";s:5:\"width\";s:3:\"496\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1310313461\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"400\";s:13:\"shutter_speed\";s:15:\"0.0333333333333\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("80", "221", "_wp_attached_file", "2011/08/DSC01245.jpg");
INSERT INTO `wp_postmeta` VALUES("81", "221", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"252\";s:14:\"hwstring_small\";s:23:\"height=\'32\' width=\'128\'\";s:4:\"file\";s:20:\"2011/08/DSC01245.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01245-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:19:\"DSC01245-300x75.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:2:\"75\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01245-500x126.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"126\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1311155473\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:7:\"0.00125\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("82", "229", "_wp_attached_file", "2011/09/DSC01545.jpg");
INSERT INTO `wp_postmeta` VALUES("83", "229", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"275\";s:14:\"hwstring_small\";s:23:\"height=\'35\' width=\'128\'\";s:4:\"file\";s:20:\"2011/09/DSC01545.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01545-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:19:\"DSC01545-300x82.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:2:\"82\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01545-500x137.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"137\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1311968176\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:5:\"0.008\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("84", "232", "_wp_attached_file", "2011/09/20110914-162249.jpg");
INSERT INTO `wp_postmeta` VALUES("85", "232", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"640\";s:14:\"hwstring_small\";s:22:\"height=\'96\' width=\'72\'\";s:4:\"file\";s:27:\"2011/09/20110914-162249.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:27:\"20110914-162249-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:27:\"20110914-162249-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:27:\"20110914-162249-480x288.jpg\";s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:27:\"20110914-162249-480x288.jpg\";s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:27:\"20110914-162249-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1315931539\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"3.85\";s:3:\"iso\";s:2:\"64\";s:13:\"shutter_speed\";s:17:\"0.000877963125549\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("86", "233", "_wp_attached_file", "2011/09/20110914-1622491.jpg");
INSERT INTO `wp_postmeta` VALUES("87", "233", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"640\";s:14:\"hwstring_small\";s:22:\"height=\'96\' width=\'72\'\";s:4:\"file\";s:28:\"2011/09/20110914-1622491.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:28:\"20110914-1622491-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:28:\"20110914-1622491-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:28:\"20110914-1622491-480x288.jpg\";s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:28:\"20110914-1622491-480x288.jpg\";s:5:\"width\";s:3:\"480\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:28:\"20110914-1622491-225x300.jpg\";s:5:\"width\";s:3:\"225\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1315931539\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"3.85\";s:3:\"iso\";s:2:\"64\";s:13:\"shutter_speed\";s:17:\"0.000877963125549\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("88", "238", "_wp_attached_file", "2011/10/DSC01644.jpg");
INSERT INTO `wp_postmeta` VALUES("89", "238", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"502\";s:14:\"hwstring_small\";s:23:\"height=\'64\' width=\'128\'\";s:4:\"file\";s:20:\"2011/10/DSC01644.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01644-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC01644-300x150.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"150\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC01644-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC01644-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01644-500x251.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"251\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1312320771\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:8:\"0.003125\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("90", "242", "_wp_attached_file", "2011/10/DSC01589.jpg");
INSERT INTO `wp_postmeta` VALUES("91", "242", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"545\";s:14:\"hwstring_small\";s:23:\"height=\'69\' width=\'128\'\";s:4:\"file\";s:20:\"2011/10/DSC01589.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01589-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC01589-300x163.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"163\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC01589-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC01589-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01589-500x272.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"272\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1312045768\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("92", "243", "_wp_attached_file", "2011/10/DSC015891.jpg");
INSERT INTO `wp_postmeta` VALUES("93", "243", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"545\";s:14:\"hwstring_small\";s:23:\"height=\'69\' width=\'128\'\";s:4:\"file\";s:21:\"2011/10/DSC015891.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC015891-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:21:\"DSC015891-300x163.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"163\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:22:\"DSC015891-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:22:\"DSC015891-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:21:\"DSC015891-500x272.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"272\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"2.6\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"DSC-W570\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1312045768\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"4.5\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("94", "244", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("95", "244", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("96", "244", "_menu_item_object_id", "4");
INSERT INTO `wp_postmeta` VALUES("97", "244", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("98", "244", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("99", "244", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("100", "244", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("101", "244", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("102", "262", "_wp_attached_file", "2011/10/DSC00367.jpg");
INSERT INTO `wp_postmeta` VALUES("103", "262", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"995\";s:6:\"height\";s:3:\"677\";s:14:\"hwstring_small\";s:23:\"height=\'87\' width=\'128\'\";s:4:\"file\";s:20:\"2011/10/DSC00367.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00367-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00367-300x204.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"204\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00367-995x288.jpg\";s:5:\"width\";s:3:\"995\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:20:\"DSC00367-995x288.jpg\";s:5:\"width\";s:3:\"995\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00367-440x300.jpg\";s:5:\"width\";s:3:\"440\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"9\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"DSC-H70\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1316688143\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"6.06\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:4:\"0.01\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("104", "269", "_wp_attached_file", "2011/10/DSC00979.jpg");
INSERT INTO `wp_postmeta` VALUES("105", "269", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"264\";s:14:\"hwstring_small\";s:23:\"height=\'33\' width=\'128\'\";s:4:\"file\";s:20:\"2011/10/DSC00979.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00979-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:19:\"DSC00979-300x79.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:2:\"79\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00979-500x132.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"132\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.5\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"DSC-H70\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1317834014\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"4.25\";s:3:\"iso\";s:4:\"1600\";s:13:\"shutter_speed\";s:15:\"0.0333333333333\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("106", "271", "_wp_attached_file", "2011/10/DSC00987.jpg");
INSERT INTO `wp_postmeta` VALUES("107", "271", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"636\";s:14:\"hwstring_small\";s:23:\"height=\'81\' width=\'128\'\";s:4:\"file\";s:20:\"2011/10/DSC00987.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC00987-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC00987-300x190.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"190\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC00987-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC00987-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC00987-471x300.jpg\";s:5:\"width\";s:3:\"471\";s:6:\"height\";s:3:\"300\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.5\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"DSC-H70\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1317834308\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"4.25\";s:3:\"iso\";s:3:\"800\";s:13:\"shutter_speed\";s:15:\"0.0769230769231\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("108", "294", "_wp_attached_file", "2011/11/DSC01174.jpg");
INSERT INTO `wp_postmeta` VALUES("109", "294", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"547\";s:14:\"hwstring_small\";s:23:\"height=\'70\' width=\'128\'\";s:4:\"file\";s:20:\"2011/11/DSC01174.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:20:\"DSC01174-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:20:\"DSC01174-300x164.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"164\";}s:14:\"post-thumbnail\";a:3:{s:4:\"file\";s:21:\"DSC01174-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"large-feature\";a:3:{s:4:\"file\";s:21:\"DSC01174-1000x288.jpg\";s:5:\"width\";s:4:\"1000\";s:6:\"height\";s:3:\"288\";}s:13:\"small-feature\";a:3:{s:4:\"file\";s:20:\"DSC01174-500x273.jpg\";s:5:\"width\";s:3:\"500\";s:6:\"height\";s:3:\"273\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:3:\"3.5\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:7:\"DSC-H70\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1318051325\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"4.25\";s:3:\"iso\";s:2:\"80\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("110", "295", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("111", "295", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("112", "295", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("113", "295", "_featured_box", "false");
INSERT INTO `wp_postmeta` VALUES("114", "295", "_thumbnail_id", "51");
INSERT INTO `wp_postmeta` VALUES("115", "295", "_wp_old_slug", "hello-world");
INSERT INTO `wp_postmeta` VALUES("116", "296", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("117", "296", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("118", "296", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("119", "296", "_introduce_text_type", "default");
INSERT INTO `wp_postmeta` VALUES("120", "296", "_disable_breadcrumb", "-1");
INSERT INTO `wp_postmeta` VALUES("121", "297", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("122", "297", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("123", "297", "_introduce_text_type", "default");
INSERT INTO `wp_postmeta` VALUES("124", "297", "_disable_breadcrumb", "-1");
INSERT INTO `wp_postmeta` VALUES("125", "297", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("126", "28", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("127", "28", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("128", "28", "_introduce_text_type", "default");
INSERT INTO `wp_postmeta` VALUES("129", "28", "_disable_breadcrumb", "-1");
INSERT INTO `wp_postmeta` VALUES("130", "28", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("131", "32", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("132", "32", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("133", "32", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("134", "32", "_featured_box", "false");
INSERT INTO `wp_postmeta` VALUES("135", "32", "_thumbnail_id", "54");
INSERT INTO `wp_postmeta` VALUES("136", "59", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("137", "59", "_thumbnail_id", "60");
INSERT INTO `wp_postmeta` VALUES("138", "59", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("139", "59", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("140", "59", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("141", "68", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("142", "68", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("143", "68", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("144", "68", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("145", "68", "_thumbnail_id", "69");
INSERT INTO `wp_postmeta` VALUES("146", "75", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("147", "75", "_thumbnail_id", "76");
INSERT INTO `wp_postmeta` VALUES("148", "75", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("149", "75", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("150", "75", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("151", "83", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("152", "83", "_thumbnail_id", "84");
INSERT INTO `wp_postmeta` VALUES("153", "83", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("154", "83", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("155", "83", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("156", "92", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("157", "92", "_thumbnail_id", "93");
INSERT INTO `wp_postmeta` VALUES("158", "92", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("159", "92", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("160", "92", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("161", "98", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("162", "98", "_thumbnail_id", "99");
INSERT INTO `wp_postmeta` VALUES("163", "98", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("164", "98", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("165", "98", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("166", "101", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("167", "101", "_thumbnail_id", "102");
INSERT INTO `wp_postmeta` VALUES("168", "101", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("169", "101", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("170", "101", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("171", "111", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("172", "111", "_thumbnail_id", "112");
INSERT INTO `wp_postmeta` VALUES("173", "111", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("174", "111", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("175", "111", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("176", "117", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("177", "117", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("178", "117", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("179", "117", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("180", "126", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("181", "126", "_thumbnail_id", "127");
INSERT INTO `wp_postmeta` VALUES("182", "126", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("183", "126", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("184", "126", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("185", "149", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("186", "149", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("187", "149", "_introduce_text_type", "default");
INSERT INTO `wp_postmeta` VALUES("188", "149", "_disable_breadcrumb", "-1");
INSERT INTO `wp_postmeta` VALUES("189", "149", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("190", "159", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("191", "159", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("192", "159", "_introduce_text_type", "default");
INSERT INTO `wp_postmeta` VALUES("193", "159", "_disable_breadcrumb", "-1");
INSERT INTO `wp_postmeta` VALUES("194", "159", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("195", "298", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("196", "298", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("197", "298", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("198", "298", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("199", "298", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("200", "298", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("201", "298", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("202", "298", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("203", "299", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("204", "299", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("205", "299", "_menu_item_object_id", "9");
INSERT INTO `wp_postmeta` VALUES("206", "299", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("207", "299", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("208", "299", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("209", "299", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("210", "299", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("307", "297", "_edit_lock", "1345749405:1");
INSERT INTO `wp_postmeta` VALUES("306", "296", "_edit_lock", "1345733139:1");
INSERT INTO `wp_postmeta` VALUES("213", "133", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("214", "133", "_thumbnail_id", "134");
INSERT INTO `wp_postmeta` VALUES("215", "133", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("216", "133", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("217", "133", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("218", "136", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("219", "136", "_thumbnail_id", "137");
INSERT INTO `wp_postmeta` VALUES("220", "136", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("221", "136", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("222", "136", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("223", "139", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("224", "139", "_thumbnail_id", "140");
INSERT INTO `wp_postmeta` VALUES("225", "139", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("226", "139", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("227", "139", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("228", "142", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("229", "142", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("230", "142", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("231", "142", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("232", "142", "_thumbnail_id", "147");
INSERT INTO `wp_postmeta` VALUES("233", "189", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("234", "189", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("235", "189", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("236", "189", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("237", "194", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("238", "194", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("239", "194", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("240", "194", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("241", "194", "_thumbnail_id", "198");
INSERT INTO `wp_postmeta` VALUES("242", "202", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("243", "202", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("244", "202", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("245", "202", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("246", "202", "_thumbnail_id", "205");
INSERT INTO `wp_postmeta` VALUES("247", "208", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("248", "208", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("249", "208", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("250", "208", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("251", "218", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("252", "218", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("253", "218", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("254", "218", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("255", "218", "_thumbnail_id", "221");
INSERT INTO `wp_postmeta` VALUES("256", "226", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("257", "226", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("258", "226", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("259", "226", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("260", "226", "_thumbnail_id", "229");
INSERT INTO `wp_postmeta` VALUES("261", "237", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("262", "237", "_thumbnail_id", "238");
INSERT INTO `wp_postmeta` VALUES("263", "237", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("264", "237", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("265", "237", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("266", "241", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("267", "241", "_thumbnail_id", "243");
INSERT INTO `wp_postmeta` VALUES("268", "241", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("269", "241", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("270", "241", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("271", "248", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("272", "248", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("273", "248", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("274", "248", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("275", "257", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("276", "257", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("277", "257", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("278", "257", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("279", "257", "_thumbnail_id", "262");
INSERT INTO `wp_postmeta` VALUES("280", "265", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("281", "265", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("282", "265", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("283", "265", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("284", "265", "_thumbnail_id", "271");
INSERT INTO `wp_postmeta` VALUES("285", "292", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("286", "292", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("287", "292", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("288", "292", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("289", "292", "_thumbnail_id", "294");
INSERT INTO `wp_postmeta` VALUES("290", "324", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("291", "324", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("292", "324", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("293", "324", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("294", "302", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("295", "302", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("296", "302", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("297", "302", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("340", "345", "_edit_lock", "1383162085:1");
INSERT INTO `wp_postmeta` VALUES("341", "345", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("305", "257", "_edit_lock", "1344566615:1");
INSERT INTO `wp_postmeta` VALUES("308", "28", "_edit_lock", "1346296898:1");
INSERT INTO `wp_postmeta` VALUES("309", "338", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("310", "338", "_edit_lock", "1383161715:1");
INSERT INTO `wp_postmeta` VALUES("318", "345", "_wp_attached_file", "2012/09/indicatorsRaglan.jpg");
INSERT INTO `wp_postmeta` VALUES("319", "345", "_wp_attachment_metadata", "a:6:{s:5:\"width\";s:3:\"989\";s:6:\"height\";s:3:\"397\";s:14:\"hwstring_small\";s:23:\"height=\'51\' width=\'128\'\";s:4:\"file\";s:28:\"2012/09/indicatorsRaglan.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:28:\"indicatorsRaglan-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}s:6:\"medium\";a:3:{s:4:\"file\";s:28:\"indicatorsRaglan-300x120.jpg\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"120\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("314", "338", "textfalse", "");
INSERT INTO `wp_postmeta` VALUES("315", "338", "_layout", "default");
INSERT INTO `wp_postmeta` VALUES("316", "338", "_featured_box", "default");
INSERT INTO `wp_postmeta` VALUES("317", "126", "_edit_lock", "1347170726:1");
INSERT INTO `wp_postmeta` VALUES("349", "233", "_edit_lock", "1383162067:1");
INSERT INTO `wp_postmeta` VALUES("346", "338", "_thumbnail_id", "345");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("354", "1", "2012-09-09 06:25:19", "2012-09-09 06:25:19", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had a big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:25:19", "2012-09-09 06:25:19", "", "338", "http://israelvasquez.com/traveltheworld/?p=354", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("331", "1", "2011-04-01 19:13:46", "2011-04-01 19:13:46", "My name is Israel Vasquez. Ive been traveling for a while now but only on 2 week vacations here and there, mainly surf trips. I\'ve pretty much lived in Miami all my life since I was 5. So what now? I simplified my life about three years ago and started saving and planning for this trip. It\'s been a dream of mine to travel the world. So I quit my 9-5 cubicle life and decided to begin this journey with nothing to hold me back. I went against what society here in the States told me never to do, break free. So here\'s my story, my journey, my blogs, and some photos. I will be sharing information that will be beneficial for other travelers and friends. As I always say to my friends, Pura Vida!", "About ", "", "inherit", "open", "open", "", "297-revision", "", "", "2011-04-01 19:13:46", "2011-04-01 19:13:46", "", "297", "http://israelvasquez.com/traveltheworld/?p=331", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2011-04-01 21:53:20", "2011-04-01 21:53:20", "", "IMG_1629", "", "inherit", "open", "open", "", "img_1629", "", "", "2011-04-01 21:53:20", "2011-04-01 21:53:20", "", "32", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1629.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2011-04-01 21:53:28", "2011-04-01 21:53:28", "", "IMG_1622", "", "inherit", "open", "open", "", "img_1622", "", "", "2011-04-01 21:53:28", "2011-04-01 21:53:28", "", "32", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1622.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2011-04-01 21:53:35", "2011-04-01 21:53:35", "", "IMG_1617", "", "inherit", "open", "open", "", "img_1617", "", "", "2011-04-01 21:53:35", "2011-04-01 21:53:35", "", "32", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1617.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2011-04-02 15:34:24", "2011-04-02 15:34:24", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_15981.jpg", "IMG_1598", "City of Miami", "inherit", "open", "open", "", "img_1598-2", "", "", "2011-04-02 15:34:24", "2011-04-02 15:34:24", "", "295", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_15981.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2011-04-02 15:45:38", "2011-04-02 15:45:38", "", "IMG_1611", "", "inherit", "open", "open", "", "img_1611-3", "", "", "2011-04-02 15:45:38", "2011-04-02 15:45:38", "", "32", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2011-04-08 02:05:47", "2011-04-08 02:05:47", "", "IMG_1659", "Newport Beach Lookout Point - California", "inherit", "open", "open", "", "img_1659", "", "", "2011-04-08 02:05:47", "2011-04-08 02:05:47", "", "59", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1659.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2011-04-12 20:53:46", "2011-04-12 20:53:46", "", "IMG_1787", "", "inherit", "open", "open", "", "img_1787", "", "", "2011-04-12 20:53:46", "2011-04-12 20:53:46", "", "68", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1787.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2011-04-16 01:07:58", "2011-04-16 01:07:58", "", "Cloudbreak @ Fiji", "Cloudbreak ", "inherit", "open", "open", "", "img_1872", "", "", "2011-04-16 01:07:58", "2011-04-16 01:07:58", "", "75", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1872.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2011-04-20 05:39:15", "2011-04-20 05:39:15", "", "Fiji from the airport", "Fiji from the airport", "inherit", "open", "open", "", "img_2052", "", "", "2011-04-20 05:39:15", "2011-04-20 05:39:15", "", "83", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2052.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2011-04-20 07:04:04", "2011-04-20 07:04:04", "", "216050_10150232508100797_520940796_8974582_7434625_n", "", "inherit", "open", "open", "", "216050_10150232508100797_520940796_8974582_7434625_n", "", "", "2011-04-20 07:04:04", "2011-04-20 07:04:04", "", "0", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/216050_10150232508100797_520940796_8974582_7434625_n.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("93", "1", "2011-04-26 09:07:04", "2011-04-26 09:07:04", "", "New Zealand country side", "", "inherit", "open", "open", "", "img_2108", "", "", "2011-04-26 09:07:04", "2011-04-26 09:07:04", "", "92", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2108.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("99", "1", "2011-04-29 00:09:03", "2011-04-29 00:09:03", "", "Cape Reinga", "", "inherit", "open", "open", "", "img_2235", "", "", "2011-04-29 00:09:03", "2011-04-29 00:09:03", "", "98", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2235.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2011-05-01 09:40:24", "2011-05-01 09:40:24", "", "90 mile beach", "", "inherit", "open", "open", "", "img_2262", "", "", "2011-05-01 09:40:24", "2011-05-01 09:40:24", "", "101", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/IMG_2262.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("112", "1", "2011-05-09 10:49:31", "2011-05-09 10:49:31", "", "piha, new zealand", "", "inherit", "open", "open", "", "dsc00077", "", "", "2011-05-09 10:49:31", "2011-05-09 10:49:31", "", "111", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00077.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("127", "1", "2011-05-12 09:27:47", "2011-05-12 09:27:47", "", "Raglan", "", "inherit", "open", "open", "", "dsc00200", "", "", "2011-05-12 09:27:47", "2011-05-12 09:27:47", "", "126", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00200.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("134", "1", "2011-05-18 05:01:16", "2011-05-18 05:01:16", "", "Marlborough wineries", "", "inherit", "open", "open", "", "dsc00364", "", "", "2011-05-18 05:01:16", "2011-05-18 05:01:16", "", "133", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00364.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("137", "1", "2011-05-30 10:53:44", "2011-05-30 10:53:44", "", "World\'s largest colossal squid", "", "inherit", "open", "open", "", "dsc00327", "", "", "2011-05-30 10:53:44", "2011-05-30 10:53:44", "", "136", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00327.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2011-06-03 00:49:33", "2011-06-03 00:49:33", "", "Fox glacier hike", "", "inherit", "open", "open", "", "dsc00622", "", "", "2011-06-03 00:49:33", "2011-06-03 00:49:33", "", "139", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00622.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2011-06-07 00:14:09", "2011-06-07 00:14:09", "", "Mt. Cook/Aoraki", "", "inherit", "open", "open", "", "dsc00497", "", "", "2011-06-07 00:14:09", "2011-06-07 00:14:09", "", "142", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00497.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2011-06-07 00:20:03", "2011-06-07 00:20:03", "", "DSC00497", "", "inherit", "open", "open", "", "dsc00497-2", "", "", "2011-06-07 00:20:03", "2011-06-07 00:20:03", "", "142", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC004971.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("153", "1", "2011-06-11 22:47:24", "2011-06-11 22:47:24", "", "Maps", "", "inherit", "open", "open", "", "dsc00246", "", "", "2011-06-11 22:47:24", "2011-06-11 22:47:24", "", "149", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00246.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2011-06-11 22:53:22", "2011-06-11 22:53:22", "", "Packing", "", "inherit", "open", "open", "", "img_1652", "", "", "2011-06-11 22:53:22", "2011-06-11 22:53:22", "", "159", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/IMG_1652.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("161", "1", "2012-08-09 19:10:25", "2012-08-09 19:10:25", " ", "", "", "publish", "open", "open", "", "161", "", "", "2012-08-09 19:10:25", "2012-08-09 19:10:25", "", "0", "http://israelvasquez.com/traveltheworld/?p=161", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("162", "1", "2012-08-09 19:10:25", "2012-08-09 19:10:25", " ", "", "", "publish", "open", "open", "", "162", "", "", "2012-08-09 19:10:25", "2012-08-09 19:10:25", "", "0", "http://israelvasquez.com/traveltheworld/?p=162", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("163", "1", "2012-08-09 19:10:25", "2012-08-09 19:10:25", " ", "", "", "publish", "open", "open", "", "163", "", "", "2012-08-09 19:10:25", "2012-08-09 19:10:25", "", "0", "http://israelvasquez.com/traveltheworld/?p=163", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("198", "1", "2011-06-23 01:51:39", "2011-06-23 01:51:39", "", "Mud pool at Craters or the Moon - Taupo, New Zealand", "", "inherit", "open", "open", "", "dsc00741", "", "", "2011-06-23 01:51:39", "2011-06-23 01:51:39", "", "194", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00741.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("205", "1", "2011-07-18 05:12:13", "2011-07-18 05:12:13", "", "Sydney Opera House", "", "inherit", "open", "open", "", "dsc00988", "", "", "2011-07-18 05:12:13", "2011-07-18 05:12:13", "", "202", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC00988.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2011-07-30 11:26:41", "2011-07-30 11:26:41", "", "Nimbin", "", "inherit", "open", "open", "", "dsc01095", "", "", "2011-07-30 11:26:41", "2011-07-30 11:26:41", "", "208", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC01095.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("221", "1", "2011-08-19 12:18:56", "2011-08-19 12:18:56", "", "Whitehaven Beach", "", "inherit", "open", "open", "", "dsc01245", "", "", "2011-08-19 12:18:56", "2011-08-19 12:18:56", "", "218", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/08/DSC01245.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("229", "1", "2011-09-14 09:44:48", "2011-09-14 09:44:48", "", "Rice fields in Indo", "", "inherit", "open", "open", "", "dsc01545", "", "", "2011-09-14 09:44:48", "2011-09-14 09:44:48", "", "226", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/09/DSC01545.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("232", "1", "2011-09-14 15:22:23", "2011-09-14 15:22:23", "", "20110914-162249.jpg", "", "inherit", "open", "open", "", "20110914-162249-jpg", "", "", "2011-09-14 15:22:23", "2011-09-14 15:22:23", "", "0", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/09/20110914-162249.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("233", "1", "2011-09-14 15:22:25", "2011-09-14 15:22:25", "", "20110914-162249.jpg", "", "inherit", "open", "open", "", "20110914-162249-jpg-2", "", "", "2011-09-14 15:22:25", "2011-09-14 15:22:25", "", "0", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/09/20110914-1622491.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("238", "1", "2011-10-16 13:38:25", "2011-10-16 13:38:25", "", "Gili Trawangan", "", "inherit", "open", "open", "", "dsc01644", "", "", "2011-10-16 13:38:25", "2011-10-16 13:38:25", "", "237", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01644.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("242", "1", "2011-10-18 14:42:38", "2011-10-18 14:42:38", "", "Ubud Monkey Forest", "", "inherit", "open", "open", "", "dsc01589", "", "", "2011-10-18 14:42:38", "2011-10-18 14:42:38", "", "241", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01589.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("243", "1", "2011-10-18 14:43:48", "2011-10-18 14:43:48", "", "DSC01589", "", "inherit", "open", "open", "", "dsc01589-2", "", "", "2011-10-18 14:43:48", "2011-10-18 14:43:48", "", "241", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC015891.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("244", "1", "2012-08-09 19:10:31", "2012-08-09 19:10:31", " ", "", "", "publish", "open", "open", "", "244", "", "", "2012-08-09 19:10:31", "2012-08-09 19:10:31", "", "0", "http://israelvasquez.com/traveltheworld/?p=244", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("262", "1", "2011-10-21 20:35:24", "2011-10-21 20:35:24", "", "Blyde river canyon", "", "inherit", "open", "open", "", "dsc00367", "", "", "2011-10-21 20:35:24", "2011-10-21 20:35:24", "", "257", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00367.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("269", "1", "2011-10-23 11:44:09", "2011-10-23 11:44:09", "", "Sheikh Zayed Grand Mosque", "", "inherit", "open", "open", "", "dsc00979", "", "", "2011-10-23 11:44:09", "2011-10-23 11:44:09", "", "265", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00979.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("271", "1", "2011-10-23 12:26:45", "2011-10-23 12:26:45", "", "Sheik Zayed Grand Mosque", "", "inherit", "open", "open", "", "dsc00987", "", "", "2011-10-23 12:26:45", "2011-10-23 12:26:45", "", "265", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00987.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("294", "1", "2011-11-02 19:18:10", "2011-11-02 19:18:10", "", "Mt. Sinai", "", "inherit", "open", "open", "", "dsc01174", "", "", "2011-11-02 19:18:10", "2011-11-02 19:18:10", "", "292", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("295", "1", "2011-03-25 11:44:03", "2011-03-25 11:44:03", "[caption id=\"attachment_51\" align=\"alignleft\" width=\"150\" caption=\"City of Miami\"]<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_15981.jpg\"><img class=\"size-thumbnail wp-image-51 \" title=\"IMG_1598\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_15981-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>[/caption]\n\nThe people I worked with were awesome. After working there 3 years they had a farewell lunch for me as well as a cake party in the conference room. I had a wonderful 3 years there and a great experience, both professional and personal.", "My farewell lunch at work.", "", "publish", "open", "open", "", "city-of-miami", "", "", "2011-03-25 11:44:03", "2011-03-25 11:44:03", "", "0", "http://israelvasquez.com/travel/?p=1", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("296", "1", "2011-03-25 11:44:03", "2011-03-25 18:44:03", "<tt>%%wppa%%</tt>", "Gallery", "", "publish", "open", "open", "", "sample-page-2", "", "", "2012-08-23 14:47:24", "2012-08-23 14:47:24", "", "0", "http://israelvasquez.com/travel/?page_id=2", "4", "page", "", "0");
INSERT INTO `wp_posts` VALUES("297", "1", "2011-04-01 19:13:46", "2011-04-01 19:13:46", "My name is Israel Vasquez. Ive been traveling for a while now but only on 2 week vacations here and there, mainly surf trips. I\'ve pretty much lived in Miami all my life since I was 5. So what now? I simplified my life about three years ago and started saving and planning for this trip. It\'s been a dream of mine to travel the world. So here\'s my story, my journey, my blogs, and some photos. I will be sharing information that will be beneficial for other travelers and friends. As I always say to my friends, Pura Vida!", "About ", "", "publish", "open", "open", "", "about", "", "", "2012-08-23 19:18:28", "2012-08-23 19:18:28", "", "0", "http://israelvasquez.com/travel/?page_id=4", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("332", "1", "2011-04-01 21:24:02", "2011-04-01 21:24:02", "", "Blog", "", "inherit", "open", "open", "", "28-revision", "", "", "2011-04-01 21:24:02", "2011-04-01 21:24:02", "", "28", "http://israelvasquez.com/traveltheworld/?p=332", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2011-04-01 21:24:02", "2011-04-01 21:24:02", "[blog count=\"7\" cat=\"3,4,87,5,6,7,88,8,9,86,11,12,89\" width=\"630\"]", "Blog", "", "publish", "open", "open", "", "blog", "", "", "2012-08-30 03:23:26", "2012-08-30 03:23:26", "", "0", "http://israelvasquez.com/travel/?page_id=28", "1", "page", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2011-03-01 15:00:11", "2011-03-01 15:00:11", "[caption id=\"attachment_34\" align=\"alignleft\" width=\"150\" caption=\"Sony Ericsson Open\"]<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg\"><img class=\"size-thumbnail wp-image-34\" title=\"IMG_1611\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>[/caption]\n\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg\"></a><a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1617.jpg\">\n</a>Some good friends invited me to the Sony Ericsson Open.This is one week before I leave on my journey. I have never been to a tennis match but I appreciate it. I\'ve gotten into before but never dedicated enough time to it. I know it requires a lot of stamina and quick sprints which is a great exercise. To see a few of the greatest players on the planet play before my eyes was a great privilege. I was able to see Sharapova beat Petkovic. I think I fell in love with Sharapova. We were also able to see Federer beat Simon, Simon quit after the first set because of a stiff neck. That sucked! Whatever at least we saw them play a little.\n\n&nbsp;\n\n[image icon=\"zoom\" link=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1629.jpg\"]http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1629.jpg[/image]\n\n[image icon=\"zoom\" link=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1622.jpg\"]http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1622.jpg[/image]\n\n[image icon=\"zoom\" link=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1617.jpg\"]http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1617.jpg[/image]\n\n[image icon=\"zoom\" link=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg\"]http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/03/IMG_1611.jpg[/image]\n\n&nbsp;\n\n&nbsp;", "Sony Ericsson Open", "", "publish", "open", "open", "", "sony-ericsson-open", "", "", "2011-03-01 15:00:11", "2011-03-01 15:00:11", "", "0", "http://israelvasquez.com/travel/?p=32", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("59", "1", "2011-04-08 02:09:02", "2011-04-08 02:09:02", "[caption id=\"attachment_60\" align=\"alignleft\" width=\"150\" caption=\"Newport Beach Lookout Point - California\"]<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1659.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1659-150x150.jpg\" alt=\"\" title=\"IMG_1659\" width=\"150\" height=\"150\" class=\"size-thumbnail wp-image-60\" /></a>[/caption]Just got here a few hours and we are getting ready to go have some sushi. So far, I\'m completely in love with this place. Growing up in Miami, I\'m not use to seeing so many cliffs and hills by the ocean and all I can say is WOW!", "My first day in California", "", "publish", "open", "open", "", "my-first-day-in-california", "", "", "2011-04-08 02:09:02", "2011-04-08 02:09:02", "", "0", "http://israelvasquez.com/travel/?p=59", "0", "post", "", "14");
INSERT INTO `wp_posts` VALUES("68", "1", "2011-04-12 21:01:40", "2011-04-12 21:01:40", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1787.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1787-150x150.jpg\" alt=\"\" title=\"IMG_1787\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-69\" /></a>Sometimes you think its not safe. Sometimes you think its not smart. Sometimes you have to leap before you know. My first stop California has been amazing. San Diego is  like living on the beach in the 90\'s Dr.Dre style. Not to mention Dana Point, a beautiful town in Southern California on the Pacific Coast Highway or as they say the PCH or 101. I\'ll post pics up soon but I got fly to the airport to catch my flight to Fiji. ", "A single step..", "", "publish", "open", "open", "", "a-single-step", "", "", "2011-04-12 21:01:40", "2011-04-12 21:01:40", "", "0", "http://israelvasquez.com/travel/?p=68", "0", "post", "", "7");
INSERT INTO `wp_posts` VALUES("75", "1", "2011-04-16 01:09:46", "2011-04-16 01:09:46", "[caption id=\"attachment_76\" align=\"alignleft\" width=\"150\" caption=\"Cloudbreak \"]<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1872.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_1872-150x150.jpg\" alt=\"\" title=\"Cloudbreak @ Fiji\" width=\"150\" height=\"150\" class=\"size-thumbnail wp-image-76\" /></a>[/caption]When I first arrived in Nadi, Fiji I had no idea what to expect and to be honest I was a little lost specially since I got here at 5am. I refused to take a taxi only because it was $50 to go where I wanted to go as oppose to a $2.50 bus ride with the locals which made the experience a whole lot richer. So I arrived in this village called Momi about a 1 hour ride from the airport. I booked my stay here only because it was facing a famous surf break CloudBreak by Tavarua, which by the way I surfed! What a heavy wave! Not to mention the razor sharp coral reef only a few feet below. The water is so clear you could see everything 20ft deep clearly. It\'s so beautiful. This entire island is beautiful and rich in nature which is something I have always appreciated. ", "Bula! From Fiji!", "", "publish", "open", "open", "", "bula-from-fiji", "", "", "2011-04-16 01:09:46", "2011-04-16 01:09:46", "", "0", "http://israelvasquez.com/travel/?p=75", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("83", "1", "2011-04-20 05:42:11", "2011-04-20 05:42:11", "[caption id=\"attachment_84\" align=\"alignleft\" width=\"150\" caption=\"Fiji from the airport\"]<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2052.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2052-150x150.jpg\" alt=\"\" title=\"Fiji from the airport\" width=\"150\" height=\"150\" class=\"size-thumbnail wp-image-84\" /></a>[/caption]What an amazing place. The people, their land, their culture. A humbling experience I must say. From playing volleyball and becoming good friends with the locals to drinking Kava with them after being invited to their homes, it was more than just a vacation. A spiritual experience made it an even better one attending the Fijian Memorial of Jesus Christ. The locals here in general are spiritual with most of them being Christians. As kids, they are taught their families, friends, spirituality, and showing their love to others is most important. It\'s a country where you feel it as soon as you step off the plane. I will definitely miss this place but it is time to move on. I definitely want to come back. As the locals say, Moce!(Bye).", "Vinaka. Moce. Thank you and goodbye Fiji.", "", "publish", "open", "open", "", "vinaka-moce-thank-you-and-goodbye-fiji", "", "", "2011-04-20 05:42:11", "2011-04-20 05:42:11", "", "0", "http://israelvasquez.com/travel/?p=83", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("92", "1", "2011-04-26 09:10:45", "2011-04-26 09:10:45", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2108.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2108-150x150.jpg\" alt=\"\" title=\"New Zealand country side\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-93\" /></a>Well I arrived here and its pretty cool, as in the weather. It doesn\'t get too cold where I stay around in Auckland but if I go down south it might be snowing in a few weeks. Life is definitely a lot slower here which is awesome. Learning to drive on the left lane and on the right hand drivers seat was pretty confusing at first but I managed to pick it up pretty quick. It was a little harder for me because the car I\'m driving is manual so focusing on that and not turning into the opposite lane made it a little harder. What got me a few times was the turning signal being on the right side of the steering wheel instead of the left. New Zealand is truly a beautiful place and everything is so close to the main city from beaches to ranges to volcanoes. One thing is for sure, I have never seen so many sheep in my life. ", "Kiwi land!", "", "publish", "open", "open", "", "kiwi-land", "", "", "2011-04-26 09:10:45", "2011-04-26 09:10:45", "", "0", "http://israelvasquez.com/travel/?p=92", "0", "post", "", "4");
INSERT INTO `wp_posts` VALUES("98", "1", "2011-04-29 00:09:53", "2011-04-29 00:09:53", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2235.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/04/IMG_2235-150x150.jpg\" alt=\"\" title=\"Cape Reinga\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-99\" /></a>Cape Reinga, located at the northern end of the North Island of New Zealand. The name of the cape comes from the M?ori word \'Reinga\', meaning the \'Underworld\'. Cape Reinga is generally considered the separation marker between the Tasman Sea to the west and the Pacific Ocean to the east. From the lighthouse it is possible to watch the tidal race, as the two seas clash to create unsettled waters just off the coast. It\'s April here and the climate is cool and windy. A beautiful peaceful place to come and visit. Very scenic with sand dunes a bit south and a 90 mile beach which you can drive on. ", "Cape Reinga", "", "publish", "open", "open", "", "cape-reinga", "", "", "2011-04-29 00:09:53", "2011-04-29 00:09:53", "", "0", "http://israelvasquez.com/travel/?p=98", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("101", "1", "2011-05-01 09:43:14", "2011-05-01 09:43:14", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/IMG_2262.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/IMG_2262-150x150.jpg\" alt=\"\" title=\"90 mile beach\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-102\" /></a>Ninety Mile Beach is a beach located on the western coast of the far north of the North Island of New Zealand. The beach, and specifically its northern dunes, is a famous tourist destination. The dunes, looking very much like a desert landscape, was pretty unexpected. We went body boarding down them and it was a blast and saw a few funny wipe outs.", "90 Mile Beach Sand dunes body boarding", "", "publish", "open", "open", "", "90-mile-beach-sand-dunes-body-boarding", "", "", "2011-05-01 09:43:14", "2011-05-01 09:43:14", "", "0", "http://israelvasquez.com/travel/?p=101", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("111", "1", "2011-05-09 10:50:51", "2011-05-09 10:50:51", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00077.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00077-150x150.jpg\" alt=\"\" title=\"piha, new zealand\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-112\" /></a>When your traveling alone for a while and haven\'t seen close friends or family in a while, you could have your down days every once in a while. There is also days where you say to yourself: \"I wish I could have my family/friends here to see this too.\" But its these \"up\" moments that make you want to keep going and see more. The key is to stay busy. I went to Piha on a pretty lonely day and boy did it blow me away. I went to Piha from Auckland, New Zealand and its about a 45 minute drive west of Auckland. I totally recommend it and would say its worth the drive. Well Piha was one of the spots where you look out and think to yourself: \"Wow, I cant believe I\'m here.\"  I know I haven\'t seen much of New Zealand yet but I\'ve read and seen pictures of nothing but amazing landscapes and scenery. I\'m super excited to go explore more. As I make my way down around the north Island and the South Island, I will be posting more must see spots in New Zealand.  ", "And the journey continues..Piha, New Zealand", "", "publish", "open", "open", "", "an-the-journey-continues-piha-new-zealand", "", "", "2011-05-09 10:50:51", "2011-05-09 10:50:51", "", "0", "http://israelvasquez.com/travel/?p=111", "0", "post", "", "20");
INSERT INTO `wp_posts` VALUES("117", "1", "2011-05-11 08:30:08", "2011-05-11 08:30:08", "Great article for people who want to start traveling. I found some of these things useful to know. Very good tips. Even if you know this, a good reminder is always needed. <a href=\"http://tiny.cc/ykn25\" target=\"_blank\">Click here to read the article. </a>", "80 things we wish we knew before we started traveling", "", "publish", "open", "open", "", "80-things-we-wish-we-knew-before-we-started-traveling", "", "", "2011-05-11 08:30:08", "2011-05-11 08:30:08", "", "0", "http://israelvasquez.com/travel/?p=117", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("126", "1", "2011-05-12 09:42:26", "2011-05-12 09:42:26", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00200.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00200-150x150.jpg\" alt=\"\" title=\"Raglan\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-127\" /></a>Raglan is a small quiet little surfer town on the west coast of New Zealand. It was definitely the type of place where I would want to stay for a few weeks. I stayed in this surf camp lodge located on a mountain by the ocean, in the middle of a jungle and a view of the glow worms that New Zealand is known for. The surf is pretty good here but if it\'s ever flat you can drive 35 min further south to where it\'s always about 2-3ft if flat in Raglan. I also recommend you see the Bridal Veil Falls. It\'s not too far from there and totally worth the 10 minute hike with different levels of views. Raglan made me feel so relaxed. When your seeing these things and traveling through such a beautiful country, life feels surreal. ", "The road to Raglan, a surfer town.", "", "publish", "open", "open", "", "the-road-to-raglan-a-surfer-town", "", "", "2011-05-12 09:42:26", "2011-05-12 09:42:26", "", "0", "http://israelvasquez.com/travel/?p=126", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("149", "1", "2011-06-11 23:03:10", "2011-06-11 23:03:10", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00246.jpg\"><img class=\"alignright size-full wp-image-153\" title=\"Maps\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00246.jpg\" alt=\"\" width=\"446\" height=\"285\" /></a>I did quite a lot of research before leaving on my trip. The internet is best for this. You can find many websites with valuable information but it’s all so spread out. This page is a good mix of important tips I found very useful and hopefully you will too. Below is a list with tips and important things you should read before taking the plunge.\n\n<strong>Safety</strong>\n<ul> 	<li>Make several copies of your passport and keep them in different places in case of anything.</li>\n</ul>\n<ul>	<li> Get a credit card with travel points and put everything on there. It’s safer too. If you get robbed, the credit company will take care of any charges you didn’t make.</li>\n</ul>\n<ul> 	<li>Make sure never to have a lot of money available at an ATM account just in case anyone decides to point a gun at you in a third world country and tell you to withdraw all your money. DO NOT make your saving account available from your ATM card. Just transfer money over once a month in case you need cash.</li>\n</ul>\n<ul> 	<li>Pick pocketing is popular in Europe. Be careful, be street smart and do not have important things like your wallet and passport in your pockets and in easily accessible places like in a zipped up pocket on your backpack.</li></ul>\n<strong>Backing up\n</strong>\n<ul> Adrive.com gives you 50 free GB of space and it’s secure. Good for backing up your pictures and files. Dropbox.com is also pretty good but only gives 2GB free but paying for backing up service is worth it because if they steal your laptop you will lose all you files.</ul>\n<strong>Visa\'s</strong>\n<ul> When you are budgeting for your trip, take into consideration the money you will spend on visa\'s to enter different countries. A good website to see whether you need a visa is http://www.visahq.com. You can save money by going to government websites and buying it directly from them. For example, I only payed 20 dollars for my Australian visa at http://www.eta.immi.gov.au/ as oppose to the $65 Visahq wanted to charge me. They charge you almost $50 for a service fee that you can do on your own in 1 minute.</ul>\n<strong>Flight\'s</strong>\n<ul>\nWell, so how do you afford a trip around the world? Easy. Do your research and be smart. One company that really gave me a good deal for my world airline ticket is <a href=\" http://www.airtreks.com/redirect/?DIR=inbound&AFFID=ISRAELVASQUEZ&DST=Referr al&GOTOPAGE=http://www.airtreks.com\">Airtreks </a>. With other companies you are limited to the airlines you can fly on and they are mainly based on miles. </ul>\n\n", "Travel Tips", "", "publish", "open", "open", "", "travel-tips", "", "", "2011-06-11 23:03:10", "2011-06-11 23:03:10", "", "0", "http://israelvasquez.com/travel/?page_id=149", "2", "page", "", "0");
INSERT INTO `wp_posts` VALUES("159", "1", "2011-06-11 23:02:24", "2011-06-11 23:02:24", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/IMG_1652.jpg\"><img class=\"alignright size-full wp-image-160\" title=\"Packing\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/IMG_1652.jpg\" alt=\"\" width=\"448\" height=\"254\" /></a>On my year long trip I decided to buy a 90L backpack but some would say that’s too much. Because I needed to take some business clothes for seminars and meetings I had to pack a little more than your average traveler. Take into account that I also needed to pack a wetsuit for surfing.\n\nI took a day bag as well which I carry in the front for my laptop and some books. You don’t really need a laptop now in days specially in the continent of Australia and Europe. There are plenty of cheap internet café’s for you to back up your pictures online. See the Tips page for more information on that.  A laptop is just another item you have to worry about and if you get robbed you will lose all your files. Below is a list of things that I brought on my year long trip so you have a better idea of what to pack for an extended trip.  The best way to pack your clothes is to roll it up. I will link you to a instructional video that I found helpful when I was packing. If you have any questions at all feel free to email me or post a comment and I’ll be more than happy to answer them.\n\n<strong>A few packing tips</strong>\n<ul>\n	<li>Roll up everything. The clothes don’t wrinkle as much and it saves a lot of space. There are many good instructional videos out there. Here is an example YouTube video if you need help. <a href=\"http://www.youtube.com/watch?v=u9g4CTnjHiQ\" TARGET=\"_blank\">How to Fold Shirts & Pants : Rolling Shirts </a></li>\n</ul>\n\n\n<ul>\n	<li>Taking your SLR camera might not be the best choice unless photography is your life. I decided to take a small point and shoot that I can fit in my pocket.  It saves space and when you go out at night its easier and safer to carry. They sell really good point and shoot cameras now in days that take great quality pictures.</li>\n</ul>\n\n\n<ul>	<li>\nMake sure that you pack everything in sections and you know where everything is. Looking for an item you need is a mission when you don’t know where it is and it is not easily accessible.</li>\n</ul>\n<ul>\n	<li>Choosing a bag took me a long time and a lot of research. I knew I was going to be living out of this bag for a year so I had to choose wisely. Durability and comfort were most important but I was not looking to spend too much either. I decided to buy a High Sierra Long Trail 90 Frame Pack which has a top cover and a front cover which you can easily unzip and get things from the bottom. So far I have no complains. </li>\n</ul>\n\n", "Packing Tips", "", "publish", "open", "open", "", "packing-tips", "", "", "2011-06-11 23:02:24", "2011-06-11 23:02:24", "", "0", "http://israelvasquez.com/travel/?page_id=159", "3", "page", "", "0");
INSERT INTO `wp_posts` VALUES("298", "1", "2012-08-09 19:10:34", "2012-08-09 19:10:34", " ", "", "", "publish", "open", "open", "", "298", "", "", "2012-08-09 19:10:34", "2012-08-09 19:10:34", "", "0", "http://israelvasquez.com/traveltheworld/?p=298", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("299", "1", "2012-08-09 19:10:34", "2012-08-09 19:10:34", " ", "", "", "publish", "open", "open", "", "299", "", "", "2012-08-09 19:10:34", "2012-08-09 19:10:34", "", "0", "http://israelvasquez.com/traveltheworld/?p=299", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("330", "1", "2011-03-25 11:44:03", "2011-03-25 18:44:03", "", "Gallery", "", "inherit", "open", "open", "", "296-revision", "", "", "2011-03-25 11:44:03", "2011-03-25 18:44:03", "", "296", "http://israelvasquez.com/traveltheworld/?p=330", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("133", "1", "2011-05-18 05:03:50", "2011-05-18 05:03:50", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00364.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00364-150x150.jpg\" alt=\"\" title=\"Marlborough wineries\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-134\" /></a>Marlborough is one of the regions in New Zealand. It is mainly known for all of its wineries and vineyards. It is located on the northeast part of New Zealand. Blenheim is its main city and dozens of wine companies have their vineyards here. The fertile soil and temperate weather makes it the center of New Zealand\'s wine industry. Sauvignon Blanc is mainly produced here followed by Pinot Noir and Chardonnay. I definitely recommend stopping by here and doing a few wine tasting tours. ", "Marlborough Region in the South Island of N.Z", "", "publish", "open", "open", "", "marlborough-region-in-the-south-island-of-n-z", "", "", "2011-05-18 05:03:50", "2011-05-18 05:03:50", "", "0", "http://israelvasquez.com/travel/?p=133", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("136", "1", "2011-05-30 10:55:23", "2011-05-30 10:55:23", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00327.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/05/DSC00327-150x150.jpg\" alt=\"\" title=\"World&#039;s largest colossal squid\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-137\" /></a>I wasn\'t sure what to expect of Wellington after seeing so many small cities on the way down from Auckland. It was quite the surprise, it\'s architecture in the city center or downtown area left me pretty amazed, definitely a place to see on foot. Wellington is well known for its arts, culture, and fine dining. Walking through the downtown area you definitely notice that. They have a street called Cuba St. and it\'s based on the Cuban culture having a whole lot of Cuban cafe\'s around. I lived in Miami for a long time and it was pretty shocking for me to see Cuba St. I thought Miami was the only place with Cuban culture other than Cuba.  Wellington is also known for its huge and attractive Te Papa Museum which currently holds the worlds largest Colossal Squid. Definitely a museum you don\'t want to miss. Also known as Wellywood, Wellington has a huge film industry with big name studios there and director of Lord of the Rings living there as well.", "Wellington, New Zealand", "", "publish", "open", "open", "", "wellington-new-zealand", "", "", "2011-05-30 10:55:23", "2011-05-30 10:55:23", "", "0", "http://israelvasquez.com/travel/?p=136", "0", "post", "", "3");
INSERT INTO `wp_posts` VALUES("139", "1", "2011-06-03 00:50:26", "2011-06-03 00:50:26", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00622.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00622-150x150.jpg\" alt=\"\" title=\"Fox glacier hike\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-140\" /></a>Located in the western side of the South island of New Zealand sits Fox Glacier. A 30 minute drive up the coast leads you to Franz Josef Glacier. Fox Glacier is the bigger one so that\'s how I made the decision on which one to hike. I choose to do the full day hike only because everyone told me that the half day hike is pretty but you don\'t see as much. I was excited to see it all. I\'ve never even seen a glacier and for me to be able to hike through one would be a dream come true. It is important to go with a guided group and follow directions on not to go pass the barriers to take pictures, many tourist have died. The ice is as hard as solid rock and it is very slippery. The full day hike tour provided all the gear we need like boots with proper clamps, jackets, weather proof pants etc. I give this tour two thumbs up. Recommended! ", "Fox Glacier", "", "publish", "open", "open", "", "fox-glacier", "", "", "2011-06-03 00:50:26", "2011-06-03 00:50:26", "", "0", "http://israelvasquez.com/travel/?p=139", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2011-06-07 00:21:12", "2011-06-07 00:21:12", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC004971.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC004971-150x150.jpg\" alt=\"\" title=\"DSC00497\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-147\" /></a>Mt. Cook, the highest mountain in New Zealand. It reaches a height of 3,754 metres (12,316 ft). It is located in the south island of New Zealand and it is part of the Southern Alps. The view is beautiful and stunning, it reminds us humans of how small we really are. The town itself is really small so there is not much to do there but to go see the enormous mountain. There are 10 short or day walks around the Mount Cook Village and into the main valleys. The most popular are to Kea Point and the Hooker Valley. I wasn\'t able to do them but I hear they are nice walks. ", "Mt. Cook, the highest mountain in New Zealand", "", "publish", "open", "open", "", "mt-cook-the-highest-mountain-in-new-zealand", "", "", "2011-06-07 00:21:12", "2011-06-07 00:21:12", "", "0", "http://israelvasquez.com/travel/?p=142", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("189", "1", "2011-06-17 00:41:14", "2011-06-17 00:41:14", "I\'m planning my trip to Australia and I leave in three weeks. I\'m super excited. I plan on doing most of the east coast from Sydney to Cairns. Surfing places like Byron Bay, Manly beach, and Surfer\'s Paradise in the Gold Coast has always been a dream. Diving the great barrier reef is definitely on my bucket list of things to do before I die. Ever asked yourself when is the best time to visit Australia? Well that depends but any time of year has its beauty. Check out the article. <a href=\"http://matadornetwork.com/trips/whats-the-best-time-to-visit-australia/\">What’s the best time to visit Australia?</a>", "What’s the best time to visit Australia?", "", "publish", "open", "open", "", "whats-the-best-time-to-visit-australia", "", "", "2011-06-17 00:41:14", "2011-06-17 00:41:14", "", "0", "http://israelvasquez.com/travel/?p=189", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("194", "1", "2011-06-23 01:53:47", "2011-06-23 01:53:47", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00741.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/06/DSC00741-150x150.jpg\" alt=\"\" title=\"Mud pool at Craters or the Moon - Taupo, New Zealand\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-198\" /></a>Have you ever seen yourself walking through a cratered valley with clouds of steam surrounding you? With steam clouds coming out of mud pools? Well, if you haven\'t, come to Taupo New Zealand. The entrance to the park is pretty cheap at $6. There is a sulfur like smell as you walk through this geothermal active field. It is a natural phenomena. When the Wairakei Geothermal Power Station was built, approximately 2000 meters north of the field, it utilized underground thermal energy to become more active and because of that it is now full of high pressure sulfurous steam. There is wooden boardwalks for you to walk safely through the park and enjoy it without worrying about any type of danger. For more pictures, see the Gallery page on this website. ", "Craters of the Moon - Taupo, New Zealand", "", "publish", "open", "open", "", "craters-of-the-moon-taupo-new-zealand", "", "", "2011-06-23 01:53:47", "2011-06-23 01:53:47", "", "0", "http://israelvasquez.com/travel/?p=194", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("202", "1", "2011-07-18 05:14:41", "2011-07-18 05:14:41", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC00988.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC00988-150x150.jpg\" alt=\"\" title=\"Sydney Opera House\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-205\" /></a>Being the largest and most populated city in Australia, Sydney reminded me of a mixture between New York and London. It attracts many artist and musicians to perform and support street performing arts. It is a city full of energy and nightlife as well. From it\'s zoo to its fish market to its aquarium and a 20 minute drive to Bondi Beach, Sydney is spectacular. Not to mention the Opera house, where every traveler dreams of taking a picture. It is a city well balanced with outdoor and indoor activities as well. ", "I feel of Sydney, Australia. ", "", "publish", "open", "open", "", "i-feel-of-sydney-australia", "", "", "2011-07-18 05:14:41", "2011-07-18 05:14:41", "", "0", "http://israelvasquez.com/travel/?p=202", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("208", "1", "2011-07-30 11:38:46", "2011-07-30 11:38:46", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC01095.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/07/DSC01095-150x150.jpg\" alt=\"\" title=\"Nimbin\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-214\" /></a>Nimbin, known as the drug capital of Australia or a social experiment this place is just what you the locals tell you it is. You can catch a \"magic bus\" tour to the city from Byron Bay for just about $35 which also passes by some really nice waterfalls which you can bathe in the summer and some local craft markets for shopping. As soon as you get there the locals will offer you \"cookies\" which you can take at your own discretion. Cannabis is also sold in the streets as well as other drugs but it is still considered illegal even though it is just looked over by the local authorities. The whole town is pretty much composed of stores which sell and promote their counterculture things like Bob Marley and Rasta clothing as well as bongs, pipes, lighters etc.. Its as like you took a little Amsterdam and dropped it in on the east coast of Australia. The Nimbin Museum is also popular and has a lot of the town\'s history. ", "Nimbin - A counterculture accepted by Australia", "", "publish", "open", "open", "", "nimbin-a-counterculture-accepted-by-australia", "", "", "2011-07-30 11:38:46", "2011-07-30 11:38:46", "", "0", "http://israelvasquez.com/travel/?p=208", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2011-08-19 12:21:26", "2011-08-19 12:21:26", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/08/DSC01245.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/08/DSC01245-150x150.jpg\" alt=\"\" title=\"Whitehaven Beach\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-221\" /></a>Surrounded by the Great Barrier Reef, the Whitsunday Islands are nothing but just beautiful. I did a 3 day sailing trip around the islands. The tour passed by Whitehaven Beach on the second day. It was one of the most impressice views I have yet to see. More beautiful than a postcard you would find at a tour company\'s desk, Whitehaven beach has 7km of crystal clear aqua waters surrounded by silica sand known to rejuvenate skin. Only accessible by boat this beach is truly worth the sailing trip. All of the sailing trip companies depart from Airlie Beach, Australia. On our sailing trip we were lucky enough to see several humpback whales and dolphins. We had a really great crew and staff. It definitely was 3 days I will never forget waking up to watch the sunrise and having dinner watching the sunset. ", "Sailing the Whitsundays Islands", "", "publish", "open", "open", "", "sailing-the-whitsundays-islands", "", "", "2011-08-19 12:21:26", "2011-08-19 12:21:26", "", "0", "http://israelvasquez.com/travel/?p=218", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("226", "1", "2011-09-14 09:45:37", "2011-09-14 09:45:37", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/09/DSC01545.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/09/DSC01545-150x150.jpg\" alt=\"\" title=\"Rice fields in Indo\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-229\" /></a>There are many places on this earth that can be called magical but there are not many places that the people of the land make it magical. Welcome to Indonesia. I\'m in Asia! As I first arrived I was mixed with excitement but at the same time awareness. Why? I\'ve heard a few crazy stories. But crazy is what makes this place a magical place, that and of course little islands in the middle of no where completely surround by the sound of crashing waves on colorful reef or beautiful rice fields under a sunny but rainy day. From it\'s food to its religious based decorations up and down the street this place has many surprises to offer. Must enter with an open mind if not prepare for culture shock if its your first time in Asia. Surfing, diving, fishing, hiking, trekking, motorbike riding, elephant riding are just some of the things you can do here. Enjoy it and breathe it in, because breath is life. ", "A new inspiration, a different world.....or continent. ", "", "publish", "open", "open", "", "a-new-inspiration-a-different-world-or-continent", "", "", "2011-09-14 09:45:37", "2011-09-14 09:45:37", "", "0", "http://israelvasquez.com/travel/?p=226", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("237", "1", "2011-10-16 13:39:25", "2011-10-16 13:39:25", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01644.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01644-150x150.jpg\" alt=\"\" title=\"Gili Trawangan\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-238\" /></a>Gili Trawangan, a little island off the coast of Lombok. Lombok is in Indonesia, east of Bali. Known for its beautiful white sand beaches and parties, its a backpackers heaven. Cheap prices, great drinks, and even nice resorts a long the beach for those in a little honeymoon escape. Getting to the island on a little wooden boat from Lombok was quite the experience with the waves a few meters high and the boat feeling like it was about to flip. May I say a divers paradise as well. With great reef dives there are many companies that offer great diving packages for everyone from beginners to experience level divers. A place I wouldn\'t only post about but also recommend. ", "Gili Trawangan", "", "publish", "open", "open", "", "gili-trawangan", "", "", "2011-10-16 13:39:25", "2011-10-16 13:39:25", "", "0", "http://israelvasquez.com/travel/?p=237", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("241", "1", "2011-10-18 14:44:26", "2011-10-18 14:44:26", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01589.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC01589-150x150.jpg\" alt=\"\" title=\"Ubud Monkey Forest\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-242\" /></a>Ever been to a monkey forest where you have to watch your belongings because they might get stolen..from monkeys? Yes, these little sneaky animals have one interest and only one interest in mind, that you have a banana in your pocket or purse. They will grab your purse or bag and run with it up a tree. With over a few hundred monkeys running around and even jumping on you, it makes it a interesting place to visit. You can buy banana\'s in the entrance to feed them but don\'t let them see you have some because they will tell all their friends and follow you around the entire time. There is also a nice Hindu temple to visit while you are there. Be prepared to wear a Sarong if you want to enter out of respect.", "Ubud Monkey Forest in Bali, Indonesia", "", "publish", "open", "open", "", "ubud-monkey-forest-in-bali-indonesia", "", "", "2011-10-18 14:44:26", "2011-10-18 14:44:26", "", "0", "http://israelvasquez.com/travel/?p=241", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("248", "1", "2011-10-21 15:55:46", "2011-10-21 15:55:46", "Is it possible? Is this really true? I\'m asking myself the same questions. But of course, you have to be rich to do it, or get into a huge debt how American\'s like to do it. Only kidding. So when you put science and money together, you get a group of people to build a feather lite air craft that takes you into outer space past our atmosphere and a spaceport in New Mexico. Interesting? Check out their site. <a href=\"http://www.virgingalactic.com/\" title=\"Click here to see more\" target=\"_blank\">http://www.virgingalactic.com/</a><br>\n<iframe width=\"560\" height=\"315\" src=\"http://www.youtube.com/embed/Er9-sTDhJ58\" frameborder=\"0\" allowfullscreen></iframe>", "Now you can fly to outerspace for $200,000. Who\'s going first?", "", "publish", "open", "open", "", "now-you-can-fly-to-outerspace-for-200000-whos-going-first", "", "", "2011-10-21 15:55:46", "2011-10-21 15:55:46", "", "0", "http://israelvasquez.com/travel/?p=248", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("257", "1", "2011-10-21 20:39:05", "2011-10-21 20:39:05", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00367.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00367-150x150.jpg\" alt=\"\" title=\"Blyde river canyon\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-262\" /></a>On our way back from our Kruger Park Safari we passed by this beautiful canyon. I wasn\'t even informed of this stop but it was definitely the icing on the cake. The third largest in the world and a wonder of South Africa it is a view that will just drop your jaw for a few minutes. You stare in surprise that something so amazing exist and that you are there to look at it. It\'s a view you will likely never forget. At about 800 meters the canyons rise from Blyde River and never mind the signs, it\'s always important to get a better view and think about the important things in life... this beautiful planet we live on. ", "The three sisters at Blyde River Canyon", "", "publish", "open", "open", "", "the-three-sisters-at-blyde-river-canyon", "", "", "2011-10-21 20:39:05", "2011-10-21 20:39:05", "", "0", "http://israelvasquez.com/travel/?p=257", "0", "post", "", "2");
INSERT INTO `wp_posts` VALUES("265", "1", "2011-10-23 12:14:39", "2011-10-23 12:14:39", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00987.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/10/DSC00987-150x150.jpg\" alt=\"\" title=\"Sheik Zayed Grand Mosque\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-271\" /></a>To immerse yourself in another culture is to put all your stereotypes away and learn with an open mind other people\'s views and beliefs. A highly visited destination, Abu Dhabi has the one of the world\'s largest mosque, named Sheikh Zayed Grand Mosque, which is now not only a place of worship for the Islam religion but a big tourist attraction given the beauty of the place. So much thought and money was put into this mosque it even holds the worlds largest chandelier under its main dome in the main prayer hall. Take a free tour of the place scheduled daily and learn all about how it was built and how its used. When I was in the courtyard and the call to prayer came on the loud speakers, the earth stood still for me as I looked all around me in admiration of their dedication they put into it, a very special moment that made me realize I was totally on the other side of the world. With Dubai two hours away by car and so many attractions to see in this city do not forget to visit Ferrari World and get on the world\'s fastest roller coaster.", "Sheikh Zayed Grand Mosque - Abu Dhabi", "", "publish", "open", "open", "", "sheikh-zayed-grand-mosque-abu-dhabi", "", "", "2011-10-23 12:14:39", "2011-10-23 12:14:39", "", "0", "http://israelvasquez.com/travel/?p=265", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("292", "1", "2011-11-02 19:20:57", "2011-11-02 19:20:57", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174.jpg\"><img class=\"alignleft size-thumbnail wp-image-294\" title=\"Mt. Sinai\" alt=\"\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174-150x150.jpg\" width=\"150\" height=\"150\" /></a>This is definitely not a place to party or a place to come and do business. Instead, it is place where many come for spiritual reasons. Mt. Sinai, the mountains Moses once climbed to receive the ten commandments from God as written in the Bible. We were in Dahab diving the Red Sea all day, which by the way is amazing, and at night we caught a bus at around 10pm to take us to Sinai. From there we took a 4 hour bus ride before we arrived at Sinai. It was around 2 in the morning and all the stars were out, when I say they were out, I mean you could see every star in the universe! Natures light lit up our path to the top as we trekked and climbed for hours as camels walked right by us. It was an incredible feeling to be there. It was not an easy trek at all but it sure as hell was worth it. When we finally got to the point to see the sun come up with the clouds below us, my eyes could not blink as I stared at natures beauty. The mountains, the sky, the sun and the effort that was made to see it all before our eyes was nothing below amazing. The trek down was tougher than we thought as our knees trembled from all the grinding we put into them but at the end of the trip all we could say was \"that was about the most amazing thing I have ever seen\".", "Mt. Sinai, an incredible experience relived.", "", "publish", "open", "open", "", "mt-sinai-an-incredible-experience-relived", "", "", "2013-01-24 16:27:43", "2013-01-24 16:27:43", "", "0", "http://israelvasquez.com/travel/?p=292", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("324", "1", "2011-11-05 12:29:09", "2011-11-05 12:29:09", "\"So why do we do it? Why do thousands of people year after year travel on their own – whether it be a weekend or a gap year – when it can seem so daunting? Why do we not go with friends or tour groups but instead brave it all alone?\n\nQuite simply, because it’s a complete rush. The feeling you get when you realize you just navigated your way through a foreign metropolis or survived a hellish train journey makes you feel invincible. And it’s also completely addictive, for as soon as you feel content in one place you often move swiftly onto the next, yanking yourself from the comfort zone that you’ve just managed to build around yourself to do it all over again.\" <a href=\"http://www.womanseeksworld.com/why-you-shouldnt-be-scared-of-solo-travel/\" title=\"READ MORE\">READ MORE</a> ", "Scared of solo travel? This is a must read.", "", "publish", "open", "open", "", "scared-of-solo-travel-this-is-a-must-read", "", "", "2011-11-05 12:29:09", "2011-11-05 12:29:09", "", "0", "http://israelvasquez.com/travel/?p=298", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("302", "1", "2011-11-06 11:00:13", "2011-11-06 11:00:13", "Well here is a lesson, the skies do not belong to us. This is the first time anything like this has ever been caught on video. Not only it is a crazy video, but the experienced Russian paraglider in the video is also pretty humorous. I have always dreamed of going to the Himalayas and I will one day, but it would be a total rush to experience something like this. Only the video can describe such the rush. Check it out! <a href=\'http://www.youtube.com/watch?v=xRzhloqMUFs\' >Vulture Vs Paraglider - Click here</a>\n\n<iframe width=\"560\" height=\"315\" src=\"http://www.youtube.com/embed/xRzhloqMUFs\" frameborder=\"0\" allowfullscreen></iframe>", "First person video of paraglider taken down by vulture in Himalayas", "", "publish", "open", "open", "", "first-person-video-of-paraglider-taken-down-by-vulture-in-himalayas", "", "", "2011-11-06 11:00:13", "2011-11-06 11:00:13", "", "0", "http://israelvasquez.com/travel/?p=302", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("355", "1", "2011-11-02 19:20:57", "2011-11-02 19:20:57", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174.jpg\"><img src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174-150x150.jpg\" alt=\"\" title=\"Mt. Sinai\" width=\"150\" height=\"150\" class=\"alignleft size-thumbnail wp-image-294\" /></a>This is definitely not a place to party or a place to come and do business. Instead, it is place where many come for spiritual reasons. Mt. Sinai, the mountains Moses once climbed to receive the ten commandments from God as written in the Bible. We were in Dahab diving the Red Sea all day, which by the way is amazing, and at night we caught a bus at around 10pm to take us to Sinai. From there we took a 4 hour bus ride before we arrived at Sinai. It was around 2 in the morning and all the stars were out, when I say they were out, I mean you could see every star in the universe! Natures light lit up our path to the top as we trekked and climbed for hours as camels walked right by us. It was an incredible feeling to be there. It was not an easy trek at all but it sure as hell was worth it. When we finally got to the point to see the sun come up with the clouds below us, my eyes could not blink as I stared at natures beauty. The mountains, the sky, the sun and the effort that was made to see it all before our eyes was nothing below amazing. The trek down was tougher than we thought as our knees trembled from all the grinding we put into them but at the end of the trip all we could say was \"that was about the most amazing thing I have ever seen\".\n", "Mt. Sinai, an incredible experience relived.", "", "inherit", "open", "open", "", "292-revision", "", "", "2011-11-02 19:20:57", "2011-11-02 19:20:57", "", "292", "http://israelvasquez.com/traveltheworld/?p=355", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("333", "1", "2012-08-30 02:56:06", "2012-08-30 02:56:06", "", "Blog", "", "inherit", "open", "open", "", "28-revision-2", "", "", "2012-08-30 02:56:06", "2012-08-30 02:56:06", "", "28", "http://israelvasquez.com/traveltheworld/?p=333", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("334", "1", "2012-08-30 03:20:06", "2012-08-30 03:20:06", "[blog count=\"3\" cat=\"3,4,87,5,6,7,88,8,9,86,11,12,89\" width=\"630\"]", "Blog", "", "inherit", "open", "open", "", "28-revision-3", "", "", "2012-08-30 03:20:06", "2012-08-30 03:20:06", "", "28", "http://israelvasquez.com/traveltheworld/?p=334", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("335", "1", "2012-08-30 03:20:45", "2012-08-30 03:20:45", "[blog count=\"3\" cat=\"3,4,87,5,6,7,88,8,9,86,11,12,89\" width=\"630\"]", "Blog", "", "inherit", "open", "open", "", "28-revision-4", "", "", "2012-08-30 03:20:45", "2012-08-30 03:20:45", "", "28", "http://israelvasquez.com/traveltheworld/?p=335", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("336", "1", "2012-08-30 03:22:47", "2012-08-30 03:22:47", "[blog count=\"3\" cat=\"3,4,87,5,6,7,88,8,9,86,11,12,89\" width=\"630\"]", "Blog", "", "inherit", "open", "open", "", "28-revision-5", "", "", "2012-08-30 03:22:47", "2012-08-30 03:22:47", "", "28", "http://israelvasquez.com/traveltheworld/?p=336", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("338", "1", "2012-09-09 06:11:26", "2012-09-09 06:11:26", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" alt=\"\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had a big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "publish", "open", "open", "", "raglan-indicators-surf-break", "", "", "2013-10-30 19:35:13", "2013-10-30 19:35:13", "", "0", "http://israelvasquez.com/traveltheworld/?p=338", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("345", "1", "2012-09-09 06:22:05", "2012-09-09 06:22:05", "", "indicatorsRaglan", "", "inherit", "open", "open", "", "indicatorsraglan", "", "", "2012-09-09 06:22:05", "2012-09-09 06:22:05", "", "338", "http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("340", "1", "2012-09-09 06:05:33", "2012-09-09 06:05:33", "A point break called Indicators did it for me. It\'s the break in the picture. <a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>", "Raglan - a whole new surf experience", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:05:33", "2012-09-09 06:05:33", "", "338", "http://israelvasquez.com/traveltheworld/?p=340", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("341", "1", "2012-09-09 06:11:28", "2012-09-09 06:11:28", "Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has irie feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long surf se<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:11:28", "2012-09-09 06:11:28", "", "338", "http://israelvasquez.com/traveltheworld/?p=341", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("344", "1", "2012-09-09 06:20:26", "2012-09-09 06:20:26", "<img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" />\r\n\r\nRaglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was\r\n\r\nhere in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:20:26", "2012-09-09 06:20:26", "", "338", "http://israelvasquez.com/traveltheworld/?p=344", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("342", "1", "2012-09-09 06:19:09", "2012-09-09 06:19:09", "Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels. <a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:19:09", "2012-09-09 06:19:09", "", "338", "http://israelvasquez.com/traveltheworld/?p=342", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("343", "1", "2012-09-09 06:19:42", "2012-09-09 06:19:42", "Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels. <a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:19:42", "2012-09-09 06:19:42", "", "338", "http://israelvasquez.com/traveltheworld/?p=343", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("346", "1", "2012-09-09 06:20:31", "2012-09-09 06:20:31", "<p><img class=\"alignleft size-thumbnail wp-image-339\" title=\"Raglan - Indicators\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></p>\r\n<p>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was</p>\r\n<p>here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.</p>\r\n", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:20:31", "2012-09-09 06:20:31", "", "338", "http://israelvasquez.com/traveltheworld/?p=346", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("347", "1", "2012-09-09 06:23:18", "2012-09-09 06:23:18", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was\r\n\r\nhere in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:23:18", "2012-09-09 06:23:18", "", "338", "http://israelvasquez.com/traveltheworld/?p=347", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("348", "1", "2012-09-09 06:23:36", "2012-09-09 06:23:36", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was\r\n\r\nhere in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:23:36", "2012-09-09 06:23:36", "", "338", "http://israelvasquez.com/traveltheworld/?p=348", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("349", "1", "2012-09-09 06:23:39", "2012-09-09 06:23:39", "<p>&nbsp;</p>\r\n<p><a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was</p>\r\n<p>here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.</p>\r\n", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:23:39", "2012-09-09 06:23:39", "", "338", "http://israelvasquez.com/traveltheworld/?p=349", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("350", "1", "2012-09-09 06:24:01", "2012-09-09 06:24:01", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was\r\n\r\nhere in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-autosave-v1", "", "", "2012-09-09 06:24:01", "2012-09-09 06:24:01", "", "338", "http://israelvasquez.com/traveltheworld/?p=350", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("351", "1", "2012-09-09 06:23:56", "2012-09-09 06:23:56", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" alt=\"\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had an big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was\r\n\r\nhere in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2012-09-09 06:23:56", "2012-09-09 06:23:56", "", "338", "http://israelvasquez.com/traveltheworld/?p=351", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("356", "1", "2013-01-24 16:24:48", "2013-01-24 16:24:48", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174.jpg\"><img class=\"alignleft size-thumbnail wp-image-294\" title=\"Mt. Sinai\" alt=\"\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174-150x150.jpg\" width=\"150\" height=\"150\" /></a>This is definitely not a place to party or a place to come and do business. Instead, it is place where many come for spiritual reasons. Mt. Sinai, the mountains Moses once climbed to receive the ten commandments from God as written in the Bible. We were in Dahab diving the Red Sea all day, which by the way is amazing, and at night we caught a bus at around 10pm to take us to Sinai. From there we took a 4 hour bus ride before we arrived at Sinai. It was around 2 in the morning and all the stars were out, when I say they were out, I mean you could see every star in the universe! Natures light lit up our path to the top as we trekked and climbed for hours as camels walked right by us. It was an incredible feeling to be there. It was not an easy trek at all but it sure as hell was worth it. When we finally got to the point to see the sun come up with the clouds below us, my eyes could not blink as I stared at natures beauty. The mountains, the sky, the sun and the effort that was made to see it all before our eyes was nothing below amazing. The trek down was tougher than we thought as our knees trembled from all the grinding we put into them but at the end of the trip all we could say was \"that was about the most amazing thing I have ever seen\".", "Mt. Sinai, an incredible experience relived.", "", "inherit", "open", "open", "", "292-revision-2", "", "", "2013-01-24 16:24:48", "2013-01-24 16:24:48", "", "292", "http://israelvasquez.com/traveltheworld/?p=356", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("357", "1", "2013-01-24 16:27:31", "2013-01-24 16:27:31", "<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174.jpg\"><img class=\"alignleft size-thumbnail wp-image-294\" title=\"Mt. Sinai\" alt=\"\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2011/11/DSC01174-150x150.jpg\" width=\"150\" height=\"150\" /></a>This is definitely not a place to party or a place to come and do business. Instead, it is place where many come for spiritual reasons. Mt. Sinai, the mountains Moses once climbed to receive the ten commandments from God as written in the Bible. We were in Dahab diving the Red Sea all day, which by the way is amazing, and at night we caught a bus at around 10pm to take us to Sinai. From there we took a 4 hour bus ride before we arrived at Sinai. It was around 2 in the morning and all the stars were out, when I say they were out, I mean you could see every star in the universe! Natures light lit up our path to the top as we trekked and climbed for hours as camels walked right by us. It was an incredible feeling to be there. It was not an easy trek at all but it sure as hell was worth it. When we finally got to the point to see the sun come up with the clouds below us, my eyes could not blink as I stared at natures beauty. The mountains, the sky, the sun and the effort that was made to see it all before our eyes was nothing below amazing. The trek down was tougher than we thought as our knees trembled from all the grinding we put into them but at the end of the trip all we could say was \"that was about the most amazing thing I have ever seen\".", "Mt. Sinai, an incredible experience relived.", "", "inherit", "open", "open", "", "292-revision-3", "", "", "2013-01-24 16:27:31", "2013-01-24 16:27:31", "", "292", "http://israelvasquez.com/traveltheworld/?p=357", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("360", "1", "2013-01-24 16:24:34", "2013-01-24 16:24:34", "&nbsp;\r\n\r\n<a href=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan.jpg\"><img class=\"alignleft size-thumbnail wp-image-345\" title=\"indicatorsRaglan\" alt=\"\" src=\"http://israelvasquez.com/traveltheworld/wp-content/uploads/2012/09/indicatorsRaglan-150x150.jpg\" width=\"150\" height=\"150\" /></a>Raglan really converted me into a whole other surfer. I must say it had a big impact on me. I stayed on this lodge close to a break called Indicators. It\'s really down the mountain from where I stayed, a nice lodge called Karioi Lodge. It\'s really inexpensive compared to most places and it has an cozy feeling to it. I was here in the winter and it was just the perfect cozy place you want to stay after a long day of surfing. This break called Indicators is a long left about 600 meters which feels like an endless wave if caught from the peak. On a big day it can link up with a wave from another break called Whale Bay. It is a long-walled, fast wave with occasional barrels.", "Raglan - Indicators surf break", "", "inherit", "open", "open", "", "338-revision-v1", "", "", "2013-01-24 16:24:34", "2013-01-24 16:24:34", "", "338", "http://israelvasquez.com/traveltheworld/?p=360", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("361", "1", "2014-04-23 16:23:45", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2014-04-23 16:23:45", "0000-00-00 00:00:00", "", "0", "http://israelvasquez.com/traveltheworld/?p=361", "0", "post", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("2", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("3", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("4", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("5", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("6", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("7", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("161", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("162", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("163", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("244", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("111", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("295", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("59", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "68", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "69", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "72", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "82", "0");
INSERT INTO `wp_term_relationships` VALUES("75", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "41", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "68", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "69", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "72", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "82", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "60", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "77", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("98", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("98", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("98", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("101", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("101", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("101", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("101", "58", "0");
INSERT INTO `wp_term_relationships` VALUES("101", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("111", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("111", "51", "0");
INSERT INTO `wp_term_relationships` VALUES("111", "52", "0");
INSERT INTO `wp_term_relationships` VALUES("111", "53", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "40", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "78", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "85", "0");
INSERT INTO `wp_term_relationships` VALUES("117", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "47", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "55", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "56", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "57", "0");
INSERT INTO `wp_term_relationships` VALUES("298", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("299", "86", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "55", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "39", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "48", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "49", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "54", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "59", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("136", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("139", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("142", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("189", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("189", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("189", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("189", "70", "0");
INSERT INTO `wp_term_relationships` VALUES("189", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "28", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "32", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "33", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "71", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "75", "0");
INSERT INTO `wp_term_relationships` VALUES("194", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("202", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("208", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("218", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("226", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("237", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "43", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "80", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "81", "0");
INSERT INTO `wp_term_relationships` VALUES("241", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("248", "65", "0");
INSERT INTO `wp_term_relationships` VALUES("248", "66", "0");
INSERT INTO `wp_term_relationships` VALUES("248", "83", "0");
INSERT INTO `wp_term_relationships` VALUES("248", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "64", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "74", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "76", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("265", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("265", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("265", "61", "0");
INSERT INTO `wp_term_relationships` VALUES("265", "62", "0");
INSERT INTO `wp_term_relationships` VALUES("265", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "30", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "42", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "44", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "45", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "67", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "73", "0");
INSERT INTO `wp_term_relationships` VALUES("292", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("324", "63", "0");
INSERT INTO `wp_term_relationships` VALUES("324", "79", "0");
INSERT INTO `wp_term_relationships` VALUES("324", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("302", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("302", "50", "0");
INSERT INTO `wp_term_relationships` VALUES("302", "84", "0");
INSERT INTO `wp_term_relationships` VALUES("302", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "91", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "46", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "92", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "93", "0");
INSERT INTO `wp_term_relationships` VALUES("338", "94", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "link_category", "", "0", "7");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "category", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "category", "", "0", "11");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "category", "Inspiring and helpful articles about traveling. ", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("14", "14", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("15", "15", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("16", "4", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("17", "16", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("18", "17", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("19", "18", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("20", "19", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("21", "20", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("22", "21", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("23", "22", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("24", "23", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("25", "24", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("26", "25", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("27", "26", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("28", "27", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("29", "28", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("30", "29", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("31", "30", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("32", "31", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("33", "32", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("34", "33", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("35", "34", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("36", "35", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("37", "36", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("38", "37", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("39", "38", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("40", "39", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("41", "40", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("42", "41", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("43", "42", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("44", "43", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("45", "44", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("46", "45", "post_tag", "", "0", "7");
INSERT INTO `wp_term_taxonomy` VALUES("47", "46", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("48", "47", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("49", "48", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("50", "49", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("51", "50", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("52", "51", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("53", "52", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("54", "53", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("55", "54", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("56", "55", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("57", "56", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("58", "57", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("59", "58", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("60", "59", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("61", "60", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("62", "61", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("63", "62", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("64", "63", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("65", "64", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("66", "65", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("67", "66", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("68", "67", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("69", "68", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("70", "69", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("71", "70", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("72", "71", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("73", "72", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("74", "73", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("75", "74", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("76", "75", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("77", "76", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("78", "77", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("79", "78", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("80", "79", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("81", "80", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("82", "81", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("83", "82", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("84", "83", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("85", "84", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("86", "85", "nav_menu", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("87", "86", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("88", "87", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("89", "88", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("90", "89", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("91", "90", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("92", "91", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("93", "92", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("94", "93", "post_tag", "", "0", "1");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `wp_terms` VALUES("2", "Blogroll", "blogroll", "0");
INSERT INTO `wp_terms` VALUES("3", "Abu Dhabi", "abu-dhabi", "0");
INSERT INTO `wp_terms` VALUES("4", "Australia", "australia", "0");
INSERT INTO `wp_terms` VALUES("5", "Egypt", "egypt", "0");
INSERT INTO `wp_terms` VALUES("6", "Fiji", "fiji", "0");
INSERT INTO `wp_terms` VALUES("7", "Indonesia", "indonesia", "0");
INSERT INTO `wp_terms` VALUES("8", "New Zealand", "new-zealand", "0");
INSERT INTO `wp_terms` VALUES("9", "South Africa", "south-africa", "0");
INSERT INTO `wp_terms` VALUES("10", "Travel articles", "articleslinks", "0");
INSERT INTO `wp_terms` VALUES("11", "United Kingdom", "united-kingdom", "0");
INSERT INTO `wp_terms` VALUES("12", "USA", "usa", "0");
INSERT INTO `wp_terms` VALUES("13", "80 things we wish", "80-things-we-wish", "0");
INSERT INTO `wp_terms` VALUES("14", "90 mile beach", "90-mile-beach", "0");
INSERT INTO `wp_terms` VALUES("15", "abu dahbi mosque", "abu-dahbi-mosque", "0");
INSERT INTO `wp_terms` VALUES("16", "bali monkey", "bali-monkey", "0");
INSERT INTO `wp_terms` VALUES("17", "before we started traveling", "before-we-started-traveling", "0");
INSERT INTO `wp_terms` VALUES("18", "best time to visit australia", "best-time-to-visit-australia", "0");
INSERT INTO `wp_terms` VALUES("19", "blenheim", "blenheim", "0");
INSERT INTO `wp_terms` VALUES("20", "Blyde irver canyon", "blyde-irver-canyon", "0");
INSERT INTO `wp_terms` VALUES("21", "body boarding sand dunes", "body-boarding-sand-dunes", "0");
INSERT INTO `wp_terms` VALUES("22", "cairns", "cairns", "0");
INSERT INTO `wp_terms` VALUES("23", "canyon", "canyon", "0");
INSERT INTO `wp_terms` VALUES("24", "Cape reinga", "cape-reinga", "0");
INSERT INTO `wp_terms` VALUES("25", "Chardonnay", "chardonnay", "0");
INSERT INTO `wp_terms` VALUES("26", "cloudbreak", "cloudbreak", "0");
INSERT INTO `wp_terms` VALUES("27", "craters of the moon", "craters-of-the-moon", "0");
INSERT INTO `wp_terms` VALUES("28", "dahab", "dahab", "0");
INSERT INTO `wp_terms` VALUES("29", "egypt", "egypt-2", "0");
INSERT INTO `wp_terms` VALUES("30", "fiji", "fiji-2", "0");
INSERT INTO `wp_terms` VALUES("31", "geothermal", "geothermal", "0");
INSERT INTO `wp_terms` VALUES("32", "geothermal walks", "geothermal-walks", "0");
INSERT INTO `wp_terms` VALUES("33", "grand mosque", "grand-mosque", "0");
INSERT INTO `wp_terms` VALUES("34", "himalayas paraglider", "himalayas-paraglider", "0");
INSERT INTO `wp_terms` VALUES("35", "indonesia monkey", "indonesia-monkey", "0");
INSERT INTO `wp_terms` VALUES("36", "israel vasquez", "israel-vasquez", "0");
INSERT INTO `wp_terms` VALUES("37", "kiwi", "kiwi", "0");
INSERT INTO `wp_terms` VALUES("38", "marlborough", "marlborough", "0");
INSERT INTO `wp_terms` VALUES("39", "matador network", "matador-network", "0");
INSERT INTO `wp_terms` VALUES("40", "moce", "moce", "0");
INSERT INTO `wp_terms` VALUES("41", "moises", "moises", "0");
INSERT INTO `wp_terms` VALUES("42", "monkey forest", "monkey-forest", "0");
INSERT INTO `wp_terms` VALUES("43", "mt. sinai", "mt-sinai", "0");
INSERT INTO `wp_terms` VALUES("44", "mt. sinai trek", "mt-sinai-trek", "0");
INSERT INTO `wp_terms` VALUES("45", "new zealand", "new-zealand-2", "0");
INSERT INTO `wp_terms` VALUES("46", "new zealand surf", "new-zealand-surf", "0");
INSERT INTO `wp_terms` VALUES("47", "new zealand vineyards", "new-zealand-vineyards", "0");
INSERT INTO `wp_terms` VALUES("48", "new zealand wineries", "new-zealand-wineries", "0");
INSERT INTO `wp_terms` VALUES("49", "paraglider vs vulture", "paraglider-vs-vulture", "0");
INSERT INTO `wp_terms` VALUES("50", "piha", "piha", "0");
INSERT INTO `wp_terms` VALUES("51", "piha new zealand", "piha-new-zealand", "0");
INSERT INTO `wp_terms` VALUES("52", "piha surf", "piha-surf", "0");
INSERT INTO `wp_terms` VALUES("53", "Pinot Noir", "pinot-noir", "0");
INSERT INTO `wp_terms` VALUES("54", "raglan", "raglan", "0");
INSERT INTO `wp_terms` VALUES("55", "raglan hostels", "raglan-hostels", "0");
INSERT INTO `wp_terms` VALUES("56", "raglan surf", "raglan-surf", "0");
INSERT INTO `wp_terms` VALUES("57", "sand dunes", "sand-dunes", "0");
INSERT INTO `wp_terms` VALUES("58", "Sauvignon Blanc", "sauvignon-blanc", "0");
INSERT INTO `wp_terms` VALUES("59", "sheep", "sheep", "0");
INSERT INTO `wp_terms` VALUES("60", "sheikh zayed", "sheikh-zayed", "0");
INSERT INTO `wp_terms` VALUES("61", "Sheikh Zayed Grand Mosque", "sheikh-zayed-grand-mosque", "0");
INSERT INTO `wp_terms` VALUES("62", "solo travel. traveling alone", "solo-travel-traveling-alone", "0");
INSERT INTO `wp_terms` VALUES("63", "south africa canyons", "south-africa-canyons", "0");
INSERT INTO `wp_terms` VALUES("64", "space flight", "space-flight", "0");
INSERT INTO `wp_terms` VALUES("65", "space travel", "space-travel", "0");
INSERT INTO `wp_terms` VALUES("66", "sunrise", "sunrise", "0");
INSERT INTO `wp_terms` VALUES("67", "surf", "surf", "0");
INSERT INTO `wp_terms` VALUES("68", "surfing fiji", "surfing-fiji", "0");
INSERT INTO `wp_terms` VALUES("69", "sydney", "sydney", "0");
INSERT INTO `wp_terms` VALUES("70", "taupo", "taupo", "0");
INSERT INTO `wp_terms` VALUES("71", "tavarua", "tavarua", "0");
INSERT INTO `wp_terms` VALUES("72", "ten commandments", "ten-commandments", "0");
INSERT INTO `wp_terms` VALUES("73", "the three sisters", "the-three-sisters", "0");
INSERT INTO `wp_terms` VALUES("74", "thermal energy", "thermal-energy", "0");
INSERT INTO `wp_terms` VALUES("75", "three sisters", "three-sisters", "0");
INSERT INTO `wp_terms` VALUES("76", "travel", "travel", "0");
INSERT INTO `wp_terms` VALUES("77", "travel tips", "travel-tips", "0");
INSERT INTO `wp_terms` VALUES("78", "traveling the world", "traveling-the-world", "0");
INSERT INTO `wp_terms` VALUES("79", "ubud", "ubud", "0");
INSERT INTO `wp_terms` VALUES("80", "Ubud Monkey forest", "ubud-monkey-forest", "0");
INSERT INTO `wp_terms` VALUES("81", "vinaka", "vinaka", "0");
INSERT INTO `wp_terms` VALUES("82", "virgin galactic", "virgin-galactic", "0");
INSERT INTO `wp_terms` VALUES("83", "vulture collision with paraglider", "vulture-collision-with-paraglider", "0");
INSERT INTO `wp_terms` VALUES("84", "world trip", "world-trip", "0");
INSERT INTO `wp_terms` VALUES("85", "Countries", "countries", "0");
INSERT INTO `wp_terms` VALUES("86", "Thailand", "thailand", "0");
INSERT INTO `wp_terms` VALUES("87", "Cambodia", "cambodia", "0");
INSERT INTO `wp_terms` VALUES("88", "Laos", "laos", "0");
INSERT INTO `wp_terms` VALUES("89", "Vietnam", "vietnam", "0");
INSERT INTO `wp_terms` VALUES("90", "indicators", "indicators", "0");
INSERT INTO `wp_terms` VALUES("91", "surfing", "surfing", "0");
INSERT INTO `wp_terms` VALUES("92", "karioi lodge", "karioi-lodge", "0");
INSERT INTO `wp_terms` VALUES("93", "surfer", "surfer", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "globalthrillz");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";s:1:\"1\";}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp330_toolbar,wp330_media_uploader,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "361");
INSERT INTO `wp_usermeta` VALUES("15", "1", "nav_menu_recently_edited", "85");
INSERT INTO `wp_usermeta` VALUES("16", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "metaboxhidden_nav-menus", "a:4:{i:0;s:8:\"add-post\";i:1;s:13:\"add-portfolio\";i:2;s:12:\"add-post_tag\";i:3;s:22:\"add-portfolio_category\";}");
INSERT INTO `wp_usermeta` VALUES("18", "1", "wp_user-settings", "imgsize=thumbnail&align=left&libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("19", "1", "wp_user-settings-time", "1359044847");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "globalthrillz", "$P$BCgJVpBYI4ClhfjiwsfhQGdlPaZUmk1", "globalthrillz", "admin@israelvasquez.com", "", "2012-08-09 19:06:49", "", "0", "globalthrillz");

/* INSERT TABLE DATA: wp_wppa_albums */
INSERT INTO `wp_wppa_albums` VALUES("1", "New Zealand", "", "0", "0", "0", "0", "content", "0", "globalthrillz", "1345733265", "0/0", "", "", "", "", "23", "");
INSERT INTO `wp_wppa_albums` VALUES("2", "Fiji", "", "0", "0", "0", "0", "content", "0", "globalthrillz", "1345733314", "0/0", "", "", "", "", "0", "");

/* INSERT TABLE DATA: wp_wppa_photos */
INSERT INTO `wp_wppa_photos` VALUES("1", "1", "jpg", "DSC00383.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "5", "0", "");
INSERT INTO `wp_wppa_photos` VALUES("2", "1", "jpg", "DSC00384.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "2", "0", "");
INSERT INTO `wp_wppa_photos` VALUES("3", "1", "jpg", "DSC00417.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "4", "0", "");
INSERT INTO `wp_wppa_photos` VALUES("4", "1", "jpg", "DSC00466.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "3", "0", "");
INSERT INTO `wp_wppa_photos` VALUES("5", "1", "jpg", "DSC00469.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "3", "0", "");
INSERT INTO `wp_wppa_photos` VALUES("6", "1", "jpg", "DSC00506.jpg", "", "0", "0", "", "", "_self", "globalthrillz", "1345733827", "publish", "0", "", "", "", "", "", "3", "0", "");

/* INSERT TABLE DATA: wp_wppa_session */
INSERT INTO `wp_wppa_session` VALUES("1", "00d9ebe5d268ced61e54c2c6417144d2", "1398270457", "globalthrillz", "98.211.209.175", "expired", "b:0;", "58");
INSERT INTO `wp_wppa_session` VALUES("2", "042114596f067407dd69e7e40ca3d92c", "1398271441", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("3", "6ca74e18314d652ec0a77e3e371a42f5", "1398272209", "67.227.167.177", "67.227.167.177", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("4", "25165cbd1c950e43afad871b83237853", "1398274888", "166.78.183.13", "166.78.183.13", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("5", "07fcb8c691d0a080d771a9b291ded7d3", "1398276244", "78.137.164.50", "78.137.164.50", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("6", "003a9b69e1fe719cfe950809698630fc", "1398278697", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("7", "bab1766db9d7512dbf0fb0918ec490dd", "1398278717", "83.96.132.85", "83.96.132.85", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("8", "f48c496fcaa000075a9406428aa7c0d8", "1398279087", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("9", "36221c5c658019a024618d088e73ca83", "1398279146", "67.205.2.246", "67.205.2.246", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("10", "756d97b14166776a3da1e5d50233264b", "1398279699", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("11", "f7bcb82429cc4f96aecde0ce83b8b7bf", "1398280464", "194.150.113.89", "194.150.113.89", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("12", "042114596f067407dd69e7e40ca3d92c", "1398280466", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("13", "edf78e43a0c9e056d35e75ab93fa1274", "1398281663", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("14", "8e3ac7b77829510b9e59f3ad72375308", "1398282194", "176.123.9.11", "176.123.9.11", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("15", "fe3dfe36768c29774509bf620620ce61", "1398283051", "173.83.251.38", "173.83.251.38", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("16", "c4a7f939f557d52cfbaf50cf049f89a0", "1398283579", "220.181.108.149", "220.181.108.149", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("17", "c046c9718263b6244ae7df2e5c015e5a", "1398285439", "220.181.108.157", "220.181.108.157", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("18", "733f3e92132a955428fb3c83a881b1d6", "1398285792", "75.119.222.161", "75.119.222.161", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("19", "f5a801c9cca62916080150d571484b8a", "1398292143", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("20", "f48c496fcaa000075a9406428aa7c0d8", "1398292892", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("21", "fc9ed38329f98260f4b91d59357a49a8", "1398292932", "188.121.62.249", "188.121.62.249", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("22", "db4fa916135130765b8e0f51b5112763", "1398293620", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("23", "3a637a241445dc5755a4a59f18b971c8", "1398293753", "187.1.140.35", "187.1.140.35", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("24", "5eae3bcc491798d77f8b66464d432fb8", "1398294073", "220.181.108.163", "220.181.108.163", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("25", "c77f885e95f24b2ef0e5176f48e112f5", "1398295082", "94.73.151.180", "94.73.151.180", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("26", "003a9b69e1fe719cfe950809698630fc", "1398296185", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("27", "6eabf55bb3599e26a3adaa20ab5c3987", "1398298802", "83.166.232.56", "83.166.232.56", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("28", "872fd806254ace21ca8a9f101d7f5d7e", "1398299107", "69.73.150.22", "69.73.150.22", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("29", "f174de98b9f665069f8f10597c4f6222", "1398300301", "91.185.208.27", "91.185.208.27", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("30", "b65e6bc954ed600304d54d3095099048", "1398301479", "188.65.115.24", "188.65.115.24", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("31", "ea1f181777487dcfcb703274bbb2445f", "1398302674", "97.79.238.112", "97.79.238.112", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("32", "e17c00a0f2105fd199098d108b88f742", "1398302716", "220.181.108.181", "220.181.108.181", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("33", "3646ba34e21f6daad8f6605f5931e377", "1398305176", "108.168.250.16", "108.168.250.16", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("34", "5bbdcff927c4cd60b2c7a0e70a2d385a", "1398305193", "70.32.105.98", "70.32.105.98", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("35", "b1984d8e7249925a8b7aad02320aeb17", "1398307660", "188.121.41.32", "188.121.41.32", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("36", "c8ef2aace323173003d416faa793e8d1", "1398307832", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("37", "edf78e43a0c9e056d35e75ab93fa1274", "1398307865", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("38", "2ade2c5b260c1efb5180755c53599026", "1398309038", "94.73.151.230", "94.73.151.230", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("39", "c279418411e66519ff639af04a6bd0c8", "1398309122", "190.107.177.102", "190.107.177.102", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("40", "409df147fbcada489e77cbc83eb558d6", "1398311354", "220.181.108.176", "220.181.108.176", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("41", "5bbdcff927c4cd60b2c7a0e70a2d385a", "1398311406", "70.32.105.98", "70.32.105.98", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("42", "054f1e9b55aefc5ddff0fc00a83083b7", "1398311436", "88.214.230.71", "88.214.230.71", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("43", "4eda01f785145adb19eb91e1d99c233b", "1398312632", "217.12.199.138", "217.12.199.138", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("44", "74b1291d09981e1f966334884763581b", "1398315082", "82.98.161.2", "82.98.161.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("45", "7eb5b707317f732d0ab87be29f8bc9df", "1398315083", "180.76.6.136", "180.76.6.136", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("46", "d2166f3bdb3d874cf03540cd4452bb8a", "1398315084", "180.76.5.175", "180.76.5.175", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("47", "c3469957922ea80f5e65759dc7995cd4", "1398315126", "176.123.6.32", "176.123.6.32", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("48", "ed2023852b2b7ff41a0e7f530f87756c", "1398315630", "208.115.111.68", "208.115.111.68", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("49", "f0a37db57204af7cb9a54bfb6f6b6001", "1398316449", "182.160.158.142", "182.160.158.142", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("50", "23a31ccaf14a80ffe14f3d90d05cccff", "1398317611", "94.75.225.12", "94.75.225.12", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("51", "2f532f579b716f8acb85cd6d92404ffa", "1398318511", "210.210.178.20", "210.210.178.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("52", "2339970a40fcb7033817feebc30a3fac", "1398318767", "192.254.250.160", "192.254.250.160", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("53", "b1057a69da6151f7029bd97861107e1d", "1398321231", "50.63.196.78", "50.63.196.78", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("54", "524de8a3a7c7f4b4fd6206bec16c126a", "1398322394", "69.163.240.132", "69.163.240.132", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("55", "42f396cfcbb012dd8260003f0d0d9395", "1398322422", "94.76.207.55", "94.76.207.55", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("56", "3985b5edf099351ee2470508b344127a", "1398323629", "209.236.72.10", "209.236.72.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("57", "042114596f067407dd69e7e40ca3d92c", "1398323630", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("58", "756d97b14166776a3da1e5d50233264b", "1398323706", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("59", "9ae07cc8faeaa7fb1ecd0013146ffcdb", "1398324791", "89.145.66.180", "89.145.66.180", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("60", "f48c496fcaa000075a9406428aa7c0d8", "1398324870", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("61", "f8a7bbd79b2795e6e0117d0c10849053", "1398326541", "5.135.165.206", "5.135.165.206", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("62", "3c8e63bbbb27df78efdab40188362516", "1398327150", "162.253.145.149", "162.253.145.149", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("63", "0dbe3b37d4905490276f1ef852affeb3", "1398327348", "202.153.186.118", "202.153.186.118", "expired", "b:0;", "3");
INSERT INTO `wp_wppa_session` VALUES("64", "91e40deb33f007fbb52863f73fe94043", "1398327493", "65.55.24.233", "65.55.24.233", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("65", "dc9c3b19b72a6590ada36190d471c034", "1398329486", "209.190.27.4", "209.190.27.4", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("66", "d18751f7d36b9114ed403f4916073b90", "1398330747", "93.89.225.214", "93.89.225.214", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("67", "ed2023852b2b7ff41a0e7f530f87756c", "1398330775", "208.115.111.68", "208.115.111.68", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("68", "3983140bf5a5cba5999840fdf47d7316", "1398331338", "176.123.1.20", "176.123.1.20", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("69", "325adc8b7a1f9522948a8d9c52978c04", "1398332044", "184.173.118.226", "184.173.118.226", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("70", "003a9b69e1fe719cfe950809698630fc", "1398332253", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("71", "91e40deb33f007fbb52863f73fe94043", "1398332696", "65.55.24.233", "65.55.24.233", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("72", "524de8a3a7c7f4b4fd6206bec16c126a", "1398333162", "69.163.240.132", "69.163.240.132", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("73", "9201ae568424dc6f641075b3716c0eb4", "1398334292", "50.87.144.171", "50.87.144.171", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("74", "f94e02a73a785629444d75fc848310e0", "1398337914", "64.90.42.58", "64.90.42.58", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("75", "042114596f067407dd69e7e40ca3d92c", "1398337915", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("76", "1e3908492dea7db7d0023fdd24710af9", "1398339132", "74.63.215.162", "74.63.215.162", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("77", "f48c496fcaa000075a9406428aa7c0d8", "1398339383", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("78", "f5a801c9cca62916080150d571484b8a", "1398339625", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("79", "4876df3f926cf48df954672c26936262", "1398340336", "195.26.58.58", "195.26.58.58", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("80", "5bbdcff927c4cd60b2c7a0e70a2d385a", "1398340476", "70.32.105.98", "70.32.105.98", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("81", "39723c7492555ace550f9bf5986357bd", "1398341668", "180.76.5.151", "180.76.5.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("82", "eff9a89772306769ff08678f2f0a52df", "1398341673", "180.76.5.67", "180.76.5.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("83", "38485e00191e00a8aba04afc437e4c1b", "1398341739", "94.73.151.40", "94.73.151.40", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("84", "db4fa916135130765b8e0f51b5112763", "1398342453", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("85", "cbf0255b1c4ace0a82d056c12b51542c", "1398342739", "31.3.233.120", "31.3.233.120", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("86", "444bca351693adcac718dd1efcfabc12", "1398344488", "36.250.177.42", "36.250.177.42", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("87", "52d673ea1ccdcdc0653168401da3d2b8", "1398345235", "213.171.218.175", "213.171.218.175", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("88", "3feb035f6679a720a13c746175fddb65", "1398346302", "62.212.130.150", "62.212.130.150", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("89", "0437221eb2b3a9bf8312d7bcb1c65b18", "1398346850", "64.246.165.200", "64.246.165.200", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("90", "9825996927205a7387b927e920b6e1e3", "1398346850", "64.246.165.200", "64.246.165.200", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("91", "be0bc2453497ea11ece6e6bf5b9e353a", "1398346851", "64.246.165.200", "64.246.165.200", "expired", "N;", "1");
INSERT INTO `wp_wppa_session` VALUES("92", "617bf81ece1cfa7fc875aed9ed2aee63", "1398346966", "64.202.161.44", "64.202.161.44", "expired", "b:0;", "3");
INSERT INTO `wp_wppa_session` VALUES("93", "0a22499d5ddaff042c6725d727f1ee99", "1398346966", "64.202.161.41", "64.202.161.41", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("94", "c1f7f424c267269a0a11976131745663", "1398346969", "64.202.161.41", "64.202.161.41", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("95", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398347470", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("96", "bb5c0b67c8ad475101920f7bc1883c6c", "1398348238", "180.76.5.23", "180.76.5.23", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("97", "9c9034412a704bb572c1ec4437892f10", "1398348254", "180.76.5.146", "180.76.5.146", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("98", "693afbd8c448b620f7151b577de93600", "1398348833", "78.111.80.234", "78.111.80.234", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("99", "c64238baa3345c968c6521980b5d2602", "1398351115", "61.135.190.221", "61.135.190.221", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("100", "8df06749ca088f58ab13b4f885c3f644", "1398351209", "74.220.219.132", "74.220.219.132", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("101", "d9b26b14b1fd256f07b113899609cb6b", "1398351627", "180.76.6.36", "180.76.6.36", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("102", "b59a9336fbc69189bf9a271967f94493", "1398352440", "50.23.65.198", "50.23.65.198", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("103", "32c31f75d59d28f91ce028807cc46c90", "1398355948", "222.165.255.253", "222.165.255.253", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("104", "ee613206c5974a7f2a6ea7e69ae15168", "1398356177", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("105", "ef695e067779ce1059ecd07b3c45d6f1", "1398357760", "66.249.79.165", "66.249.79.165", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("106", "7e4f34528506861b3b9a420694277e05", "1398359592", "157.56.93.186", "157.56.93.186", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("107", "042114596f067407dd69e7e40ca3d92c", "1398359593", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("108", "db4fa916135130765b8e0f51b5112763", "1398359975", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("109", "c6762f375eaa5f3364540b12071e09a5", "1398363387", "157.55.32.209", "157.55.32.209", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("110", "aff82a31e886576a64a3b000699fd3b4", "1398364529", "173.192.34.95", "173.192.34.95", "expired", "b:0;", "18");
INSERT INTO `wp_wppa_session` VALUES("111", "cf81ea00129ca58a16a5dd4bbfe3b1d2", "1398365747", "180.76.6.141", "180.76.6.141", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("112", "8a377adb88b63ffc106ad08325bc28f6", "1398365748", "180.76.5.153", "180.76.5.153", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("113", "982b35e2a6971a412afb061d9f2494af", "1398366719", "123.125.71.90", "123.125.71.90", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("114", "042114596f067407dd69e7e40ca3d92c", "1398366720", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("115", "8e3ac7b77829510b9e59f3ad72375308", "1398367511", "176.123.9.11", "176.123.9.11", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("116", "67b016914f85082878aba4f6c31487e4", "1398370813", "185.10.104.195", "185.10.104.195", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("117", "90f28e18830ca22ea16533af4c3ea6b0", "1398370814", "185.10.104.194", "185.10.104.194", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("118", "db4fa916135130765b8e0f51b5112763", "1398371948", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("119", "74ed2b73c0b5e1f8d829683773f2971a", "1398371963", "198.74.231.31", "198.74.231.31", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("120", "f48c496fcaa000075a9406428aa7c0d8", "1398372095", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("121", "d3fb67d652718c0710b230bcad66df30", "1398372393", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("122", "3b19bc272e80dc197d903e70b1cc64a2", "1398373826", "100.43.83.150", "100.43.83.150", "expired", "b:0;", "3");
INSERT INTO `wp_wppa_session` VALUES("123", "f5a801c9cca62916080150d571484b8a", "1398374395", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("124", "514728497b1d3bc0780d594e25a8e13d", "1398375356", "220.181.108.109", "220.181.108.109", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("125", "4c4f48e3e8adf196818a33d004bb4c88", "1398376364", "180.76.6.54", "180.76.6.54", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("126", "917df78ac54f58cd096a2851d2029656", "1398376365", "180.76.6.233", "180.76.6.233", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("127", "0d8ab708b841b8a1cc096062cc33c97f", "1398378089", "180.76.5.171", "180.76.5.171", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("128", "0c482bae5b6d0cb6343d76d8a3b897b1", "1398380873", "220.181.125.198", "220.181.125.198", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("129", "3983140bf5a5cba5999840fdf47d7316", "1398381543", "176.123.1.20", "176.123.1.20", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("130", "73d40c2c3409df48496cb5e72c622657", "1398383998", "220.181.108.119", "220.181.108.119", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("131", "7ef782f208090cad41ed5855d04f6e7d", "1398385346", "180.210.228.83", "180.210.228.83", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("132", "4b23225bad4284d9bfe191679dd59550", "1398388723", "37.59.29.48", "37.59.29.48", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("133", "272a76df988875900158153607baef7c", "1398388762", "203.195.184.151", "203.195.184.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("134", "2f532f579b716f8acb85cd6d92404ffa", "1398389057", "210.210.178.20", "210.210.178.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("135", "e1b5822747f1dd229903fe241a569702", "1398390115", "217.69.133.252", "217.69.133.252", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("136", "edf78e43a0c9e056d35e75ab93fa1274", "1398391594", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("137", "48e08ad55f5c032ae27beab6c140b9a7", "1398392639", "123.125.71.109", "123.125.71.109", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("138", "8e95e135f9e1ad600b3a2da127a136d7", "1398392750", "202.46.48.69", "202.46.48.69", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("139", "efe175ebef21e37fdf67693be35cf7a4", "1398392751", "202.46.62.134", "202.46.62.134", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("140", "9ce374dc27b89a4ed94190074deb094f", "1398395984", "176.123.31.26", "176.123.31.26", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("141", "7d13fb56564038e3718a526d20a96ced", "1398398666", "180.76.5.154", "180.76.5.154", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("142", "06bdc410026edccb6d4c97603c5e19c3", "1398398668", "180.76.6.134", "180.76.6.134", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("143", "81bd4b2d87130c7496cd22352e21f48f", "1398401288", "123.125.71.100", "123.125.71.100", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("144", "756d97b14166776a3da1e5d50233264b", "1398403162", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("145", "edf78e43a0c9e056d35e75ab93fa1274", "1398404631", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("146", "d3fb67d652718c0710b230bcad66df30", "1398404974", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("147", "2b17c9d7615198ebc2b30ba9f3317fda", "1398405018", "60.12.119.200", "60.12.119.200", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("148", "0f9252a7fe565247594253d1c67395fb", "1398407778", "64.202.240.136", "64.202.240.136", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("149", "7c1860fafd31db459f8da97ffb8851d2", "1398409916", "220.181.108.185", "220.181.108.185", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("150", "042114596f067407dd69e7e40ca3d92c", "1398409917", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("151", "c3469957922ea80f5e65759dc7995cd4", "1398410188", "176.123.6.32", "176.123.6.32", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("152", "b26888ee271c5c7b79e1be54d949192c", "1398414814", "217.69.133.253", "217.69.133.253", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("153", "c8ef2aace323173003d416faa793e8d1", "1398416969", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("154", "20ee71c9d083192344b393811cf7ff04", "1398417557", "157.55.35.100", "157.55.35.100", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("155", "5c95af26958ff2ff7281ea6b6a84c83e", "1398418840", "180.76.6.28", "180.76.6.28", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("156", "3e7fd2082064d79ad097f1a756c0f68b", "1398418841", "180.76.5.148", "180.76.5.148", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("157", "287cd240d82515b3fe07f18262be9606", "1398420064", "157.55.34.26", "157.55.34.26", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("158", "27400d031d40a818cfd0146080342d7d", "1398420171", "157.55.35.117", "157.55.35.117", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("159", "003a9b69e1fe719cfe950809698630fc", "1398420553", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("160", "d3fb67d652718c0710b230bcad66df30", "1398421223", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("161", "db4fa916135130765b8e0f51b5112763", "1398421375", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("162", "756d97b14166776a3da1e5d50233264b", "1398421376", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("163", "5feee8d3b9c14251df5a1e1ce9372293", "1398423692", "199.30.25.192", "199.30.25.192", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("164", "042114596f067407dd69e7e40ca3d92c", "1398423693", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("165", "c8ef2aace323173003d416faa793e8d1", "1398424518", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("166", "b96e600af6befebf14bb315ce6a0b74d", "1398424558", "83.166.232.19", "83.166.232.19", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("167", "a626832d171834fbd880200cfb7970c2", "1398424649", "123.125.71.75", "123.125.71.75", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("168", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398425504", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("169", "c85851543461d1ea1b204b315989518a", "1398433081", "66.249.79.133", "66.249.79.133", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("170", "edf78e43a0c9e056d35e75ab93fa1274", "1398436911", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("171", "5b676550cca473e1e2d948e4fc83c0f1", "1398437164", "217.69.133.250", "217.69.133.250", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("172", "88e5ea60a7410e1fce688af4f30515bc", "1398437167", "217.69.133.251", "217.69.133.251", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("173", "c8ef2aace323173003d416faa793e8d1", "1398437183", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("174", "95b9e454097ffb0215ce07eb7ff4a8d5", "1398437663", "61.135.190.101", "61.135.190.101", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("175", "eba4f0631103af9ed9205018f492d82d", "1398437669", "61.135.190.224", "61.135.190.224", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("176", "287cd240d82515b3fe07f18262be9606", "1398438677", "157.55.34.26", "157.55.34.26", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("177", "fd39b461645d229d10309fec50ec4131", "1398438933", "180.76.5.166", "180.76.5.166", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("178", "5bbe7b37cec33ae28cfbf5c81501dc70", "1398438934", "180.76.6.40", "180.76.6.40", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("179", "6eabf55bb3599e26a3adaa20ab5c3987", "1398440835", "83.166.232.56", "83.166.232.56", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("180", "c8ef2aace323173003d416faa793e8d1", "1398441312", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("181", "2f532f579b716f8acb85cd6d92404ffa", "1398444596", "210.210.178.20", "210.210.178.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("182", "042114596f067407dd69e7e40ca3d92c", "1398444597", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("183", "6f75adea74078a24e56fa440c24c9fd7", "1398445016", "175.42.93.93", "175.42.93.93", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("184", "f5a801c9cca62916080150d571484b8a", "1398452903", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("185", "042114596f067407dd69e7e40ca3d92c", "1398452904", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("186", "29b614f67eb5c191bdd836fadc77ea3a", "1398453497", "66.249.79.133", "66.249.79.133", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("187", "c8ef2aace323173003d416faa793e8d1", "1398453788", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("188", "f48c496fcaa000075a9406428aa7c0d8", "1398453789", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("189", "e1b5822747f1dd229903fe241a569702", "1398453928", "217.69.133.252", "217.69.133.252", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("190", "4ca778358a9e7108ec2bc5249e66203c", "1398457642", "176.123.12.8", "176.123.12.8", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("191", "8942b69f39ea2908cff9920990a8ddea", "1398458392", "66.249.79.165", "66.249.79.165", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("192", "f5a801c9cca62916080150d571484b8a", "1398458574", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("193", "ee613206c5974a7f2a6ea7e69ae15168", "1398458699", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("194", "88e5ea60a7410e1fce688af4f30515bc", "1398464894", "217.69.133.251", "217.69.133.251", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("195", "8c5b0a57cf997fc73a9c4f6131488a65", "1398468441", "65.55.52.88", "65.55.52.88", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("196", "01e933aedd4a2b112f335cb8889ab126", "1398469497", "180.76.6.144", "180.76.6.144", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("197", "23e6d0ceccb08a0232bec0322d348515", "1398469498", "180.76.6.51", "180.76.6.51", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("198", "003a9b69e1fe719cfe950809698630fc", "1398469575", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("199", "edf78e43a0c9e056d35e75ab93fa1274", "1398470239", "69.64.65.10", "69.64.65.10", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("200", "5b676550cca473e1e2d948e4fc83c0f1", "1398470634", "217.69.133.250", "217.69.133.250", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("201", "272a76df988875900158153607baef7c", "1398472963", "203.195.184.151", "203.195.184.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("202", "2f532f579b716f8acb85cd6d92404ffa", "1398474654", "210.210.178.20", "210.210.178.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("203", "ef695e067779ce1059ecd07b3c45d6f1", "1398476078", "66.249.79.165", "66.249.79.165", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("204", "7e3514dcc869209189bef8c45952dd0c", "1398478260", "202.46.62.84", "202.46.62.84", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("205", "822f333fcc67bb82cfd4a805996bc8fd", "1398478261", "202.46.56.174", "202.46.56.174", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("206", "6c2fce2e73a1520df03346b65256a9ab", "1398479058", "157.55.35.88", "157.55.35.88", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("207", "756d97b14166776a3da1e5d50233264b", "1398486064", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("208", "003a9b69e1fe719cfe950809698630fc", "1398486214", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("209", "f5a801c9cca62916080150d571484b8a", "1398487647", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("210", "cb4f54e94d9b51469a4f6d46870f8192", "1398489657", "123.125.71.32", "123.125.71.32", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("211", "d464f2b8df5d8cf8dcbe38438d6493f6", "1398490096", "180.76.5.17", "180.76.5.17", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("212", "9866b095967e46cee21ca9869e4a7dd5", "1398492466", "198.27.114.15", "198.27.114.15", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("213", "02865bd6b07260febbdef2b518f1bfd3", "1398492478", "107.158.228.53", "107.158.228.53", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("214", "02790df5dea7adcd8921d5714db30ff2", "1398496720", "180.76.5.77", "180.76.5.77", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("215", "042114596f067407dd69e7e40ca3d92c", "1398496721", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("216", "865afb05ae920ee4c5ff73d1749ee7c8", "1398496724", "180.76.6.140", "180.76.6.140", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("217", "cf3b3c1eec6b68fada8b60fb26d1a161", "1398497916", "157.55.35.84", "157.55.35.84", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("218", "4b23225bad4284d9bfe191679dd59550", "1398500247", "37.59.29.48", "37.59.29.48", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("219", "b5d23854ae813793d8b45e225ca00bc7", "1398502343", "65.55.52.113", "65.55.52.113", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("220", "0f9252a7fe565247594253d1c67395fb", "1398503991", "64.202.240.136", "64.202.240.136", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("221", "f5a801c9cca62916080150d571484b8a", "1398504048", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("222", "1e38447822e296969a6fe6be80154b30", "1398505444", "176.123.2.7", "176.123.2.7", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("223", "8debef1a3e04b6a62d47d74d41399bd4", "1398505593", "180.76.5.173", "180.76.5.173", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("224", "047e4a0d842673e9c038e91f7fb0ae5f", "1398505594", "180.76.5.63", "180.76.5.63", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("225", "aa89cc72ef084bb26d3f8210a8b40588", "1398506979", "123.125.71.18", "123.125.71.18", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("226", "c144803e783e4e35d729a8ea53678249", "1398506980", "123.125.71.33", "123.125.71.33", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("227", "2b17c9d7615198ebc2b30ba9f3317fda", "1398507556", "60.12.119.200", "60.12.119.200", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("228", "28e9134259845a3a7bdc88eb81764a87", "1398509530", "217.69.133.249", "217.69.133.249", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("229", "042114596f067407dd69e7e40ca3d92c", "1398509531", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("230", "c8ef2aace323173003d416faa793e8d1", "1398513857", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("231", "9212bb359efd4e762c92e620d0fbae10", "1398517386", "176.123.0.49", "176.123.0.49", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("232", "b08cb3357dc52d8c5ee31b6af8ad8fc5", "1398520656", "188.143.232.31", "188.143.232.31", "expired", "b:0;", "11");
INSERT INTO `wp_wppa_session` VALUES("233", "253a7e3d3e1f550d74d2bd98cd8313b0", "1398520866", "180.76.5.69", "180.76.5.69", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("234", "7d13fb56564038e3718a526d20a96ced", "1398520868", "180.76.5.154", "180.76.5.154", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("235", "8e3b9d7d369e328f20659536f3ea464b", "1398520925", "217.69.133.191", "217.69.133.191", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("236", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398521388", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("237", "2b17c9d7615198ebc2b30ba9f3317fda", "1398521420", "60.12.119.200", "60.12.119.200", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("238", "f5a801c9cca62916080150d571484b8a", "1398523498", "142.4.208.97", "142.4.208.97", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("239", "c64238baa3345c968c6521980b5d2602", "1398523855", "61.135.190.221", "61.135.190.221", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("240", "c83bf138af482cf707e20f72d4cb3b09", "1398523857", "61.135.190.104", "61.135.190.104", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("241", "756d97b14166776a3da1e5d50233264b", "1398528344", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("242", "28e9134259845a3a7bdc88eb81764a87", "1398532093", "217.69.133.249", "217.69.133.249", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("243", "042114596f067407dd69e7e40ca3d92c", "1398532094", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("244", "4355513abd656550737aaa3ce3cf6584", "1398535900", "199.30.20.15", "199.30.20.15", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("245", "6c2e271fccd59e945e5c975bc4f61299", "1398536211", "83.166.233.14", "83.166.233.14", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("246", "0c482bae5b6d0cb6343d76d8a3b897b1", "1398536567", "220.181.125.198", "220.181.125.198", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("247", "e1b5822747f1dd229903fe241a569702", "1398537492", "217.69.133.252", "217.69.133.252", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("248", "c8ef2aace323173003d416faa793e8d1", "1398539782", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("249", "042114596f067407dd69e7e40ca3d92c", "1398539783", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("250", "e6d9b33de6f91a4dcdc9bfecff62fd54", "1398540226", "54.83.103.110", "54.83.103.110", "expired", "b:0;", "3");
INSERT INTO `wp_wppa_session` VALUES("251", "4f2fe7e974be7a762a2120a3fd5ad28e", "1398540238", "54.83.103.110", "54.83.103.110", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("252", "4b23225bad4284d9bfe191679dd59550", "1398540311", "37.59.29.48", "37.59.29.48", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("253", "db4fa916135130765b8e0f51b5112763", "1398541518", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("254", "756d97b14166776a3da1e5d50233264b", "1398543154", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("255", "003a9b69e1fe719cfe950809698630fc", "1398543751", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("256", "88e5ea60a7410e1fce688af4f30515bc", "1398547791", "217.69.133.251", "217.69.133.251", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("257", "8e3b9d7d369e328f20659536f3ea464b", "1398547796", "217.69.133.191", "217.69.133.191", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("258", "0c92a763221053a1cbfabcdd6d898a69", "1398548467", "157.55.33.26", "157.55.33.26", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("259", "28e9134259845a3a7bdc88eb81764a87", "1398554259", "217.69.133.249", "217.69.133.249", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("260", "c8ef2aace323173003d416faa793e8d1", "1398557393", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("261", "ee613206c5974a7f2a6ea7e69ae15168", "1398557915", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("262", "db4fa916135130765b8e0f51b5112763", "1398558147", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("263", "003a9b69e1fe719cfe950809698630fc", "1398559271", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("264", "68ac98177399dd4eb591d82f1fd9cef7", "1398560806", "175.42.93.93", "175.42.93.93", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("265", "c066a909a0816d605b8d9ff299eb5618", "1398563482", "180.76.6.147", "180.76.6.147", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("266", "00aba8557a3d0ac27ecb98f7664e12b2", "1398563485", "180.76.6.130", "180.76.6.130", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("267", "8e64de6c768a5a3b8bb4940e73026bcd", "1398564473", "180.76.6.148", "180.76.6.148", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("268", "983fb3c6c2ba75724d8e67671e214bac", "1398564480", "180.76.6.44", "180.76.6.44", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("269", "6c2fce2e73a1520df03346b65256a9ab", "1398566725", "157.55.35.88", "157.55.35.88", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("270", "3ba1dc0e032bd5f2806e362e0f809975", "1398567122", "131.253.24.6", "131.253.24.6", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("271", "02a82df6361e8c3c59defebb7fd29701", "1398567137", "199.30.20.1", "199.30.20.1", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("272", "95b9e454097ffb0215ce07eb7ff4a8d5", "1398570081", "61.135.190.101", "61.135.190.101", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("273", "eba4f0631103af9ed9205018f492d82d", "1398570086", "61.135.190.224", "61.135.190.224", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("274", "9ef46942fed355c9a0ea5023c1950eef", "1398574454", "106.187.47.170", "106.187.47.170", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("275", "272a76df988875900158153607baef7c", "1398575870", "203.195.184.151", "203.195.184.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("276", "5b676550cca473e1e2d948e4fc83c0f1", "1398576787", "217.69.133.250", "217.69.133.250", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("277", "f48c496fcaa000075a9406428aa7c0d8", "1398579945", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("278", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398583298", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("279", "042114596f067407dd69e7e40ca3d92c", "1398583300", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("280", "f48c496fcaa000075a9406428aa7c0d8", "1398587594", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("281", "756d97b14166776a3da1e5d50233264b", "1398592536", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("282", "03793f65cd67b0695219b5c6a3bc79f3", "1398595156", "91.121.170.197", "91.121.170.197", "expired", "b:0;", "11");
INSERT INTO `wp_wppa_session` VALUES("283", "042114596f067407dd69e7e40ca3d92c", "1398595157", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("284", "c85851543461d1ea1b204b315989518a", "1398595584", "66.249.79.133", "66.249.79.133", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("285", "c8ef2aace323173003d416faa793e8d1", "1398595967", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("286", "db4fa916135130765b8e0f51b5112763", "1398598794", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("287", "72f1bb42b4acfa2a49111f57d1d2dc4d", "1398602002", "180.76.5.172", "180.76.5.172", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("288", "3feb035f6679a720a13c746175fddb65", "1398602363", "62.212.130.150", "62.212.130.150", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("289", "9e6df72e53d75a11bb9e3ab3975f80ec", "1398602435", "176.123.9.12", "176.123.9.12", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("290", "4355513abd656550737aaa3ce3cf6584", "1398606325", "199.30.20.15", "199.30.20.15", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("291", "d3fb67d652718c0710b230bcad66df30", "1398611603", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("292", "f48c496fcaa000075a9406428aa7c0d8", "1398614915", "87.255.57.169", "87.255.57.169", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("293", "8be81fc3f79234df14d986bc96c43575", "1398615234", "180.76.6.47", "180.76.6.47", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("294", "9c9034412a704bb572c1ec4437892f10", "1398615235", "180.76.5.146", "180.76.5.146", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("295", "6672b30e16845e3a72deb197c226835c", "1398615500", "220.181.51.76", "220.181.51.76", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("296", "83ed9f48d2976e23fa68c60301271988", "1398615500", "220.181.51.82", "220.181.51.82", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("297", "1ca464d2226007a426ba5532a6ee972b", "1398615501", "220.181.51.75", "220.181.51.75", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("298", "c659630320039abeacc8a71277e2f077", "1398615502", "220.181.51.81", "220.181.51.81", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("299", "272a76df988875900158153607baef7c", "1398616871", "203.195.184.151", "203.195.184.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("300", "8e70147049556a035ca55ac5e08f259e", "1398616947", "157.55.32.55", "157.55.32.55", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("301", "ee613206c5974a7f2a6ea7e69ae15168", "1398617205", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("302", "042114596f067407dd69e7e40ca3d92c", "1398617206", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("303", "09c1afb3b13c2ad4f82451f8114eccdb", "1398620593", "188.143.232.111", "188.143.232.111", "expired", "b:0;", "11");
INSERT INTO `wp_wppa_session` VALUES("304", "8f2a93a9f1ad5d5f42b107cb82129577", "1398622087", "180.76.5.95", "180.76.5.95", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("305", "2f187e60021a5e5e51283d12e4f47a7b", "1398622088", "180.76.5.145", "180.76.5.145", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("306", "68ac98177399dd4eb591d82f1fd9cef7", "1398622521", "175.42.93.93", "175.42.93.93", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("307", "01779bfab4536f24c869e630c7f9bba5", "1398625536", "180.76.5.25", "180.76.5.25", "expired", "a:2:{s:7:\"rootbox\";s:1:\"0\";s:16:\"use_searchstring\";s:0:\"\";}", "1");
INSERT INTO `wp_wppa_session` VALUES("308", "db45d2dc2305bd56b19ba04ed3c785c1", "1398628418", "180.76.6.29", "180.76.6.29", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("309", "042114596f067407dd69e7e40ca3d92c", "1398628419", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("310", "451332a09964fdfddbc89fa2fdda687b", "1398628421", "180.76.6.139", "180.76.6.139", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("311", "4b23225bad4284d9bfe191679dd59550", "1398628648", "37.59.29.48", "37.59.29.48", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("312", "910c44b93ae31772f401bc8dd763eaa8", "1398632224", "42.62.24.250", "42.62.24.250", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("313", "b4599cd02690ed6bcf1ab2c866424da0", "1398634157", "46.102.232.243", "46.102.232.243", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("314", "cdf44132094c749ff5a19ad424b26f81", "1398635237", "107.170.53.48", "107.170.53.48", "expired", "a:4:{s:7:\"rootbox\";s:1:\"0\";s:16:\"use_searchstring\";s:0:\"\";s:11:\"search_root\";s:1:\"1\";s:5:\"album\";a:1:{i:1;b:1;}}", "166");
INSERT INTO `wp_wppa_session` VALUES("315", "cd0a603e71e3a2130bc16a83a7419892", "1398636175", "123.125.71.23", "123.125.71.23", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("316", "3208ab633a182cef8deefd4f7382b686", "1398638017", "66.249.79.197", "66.249.79.197", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("317", "c46d150fb3821533af1059db1a44c988", "1398642231", "176.123.0.50", "176.123.0.50", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("318", "d3fb67d652718c0710b230bcad66df30", "1398645104", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("319", "9ef46942fed355c9a0ea5023c1950eef", "1398645690", "106.187.47.170", "106.187.47.170", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("320", "3790648f10a2fe040da72f55c3e6c8f5", "1398648596", "180.76.6.230", "180.76.6.230", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("321", "d3fb67d652718c0710b230bcad66df30", "1398649283", "64.31.25.60", "64.31.25.60", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("322", "86c85b2dcb613cde44abc5b11ba0a623", "1398649538", "180.76.6.137", "180.76.6.137", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("323", "35f8f4221bf23215f969852c81f59852", "1398649540", "180.76.6.21", "180.76.6.21", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("324", "003a9b69e1fe719cfe950809698630fc", "1398650727", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("325", "58bc813d81c64f76eb34a6742958bb0c", "1398653582", "157.55.33.41", "157.55.33.41", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("326", "fc9ed38329f98260f4b91d59357a49a8", "1398654827", "188.121.62.249", "188.121.62.249", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("327", "003a9b69e1fe719cfe950809698630fc", "1398659632", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("328", "931c0424586564baeeb3a46426e5a709", "1398660772", "88.214.193.25", "88.214.193.25", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("329", "49163f80cd239d58600b61cb9360aedf", "1398660773", "157.55.32.109", "157.55.32.109", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("330", "95f4204511ad7bfdf81605139814c3e3", "1398661184", "176.123.12.9", "176.123.12.9", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("331", "ee613206c5974a7f2a6ea7e69ae15168", "1398667325", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("332", "b4599cd02690ed6bcf1ab2c866424da0", "1398668854", "46.102.232.243", "46.102.232.243", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("333", "756d97b14166776a3da1e5d50233264b", "1398673266", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("334", "042114596f067407dd69e7e40ca3d92c", "1398673267", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("335", "58bc813d81c64f76eb34a6742958bb0c", "1398678853", "157.55.33.41", "157.55.33.41", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("336", "c8ef2aace323173003d416faa793e8d1", "1398681143", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("337", "042114596f067407dd69e7e40ca3d92c", "1398681143", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("338", "20d9192d9c67ad13d21d05a868435203", "1398681651", "83.166.232.20", "83.166.232.20", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("339", "265184eb7f8365f97728b85474008dab", "1398682908", "208.115.113.84", "208.115.113.84", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("340", "3b19bc272e80dc197d903e70b1cc64a2", "1398683560", "100.43.83.150", "100.43.83.150", "expired", "b:0;", "3");
INSERT INTO `wp_wppa_session` VALUES("341", "2f532f579b716f8acb85cd6d92404ffa", "1398685043", "210.210.178.20", "210.210.178.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("342", "272a76df988875900158153607baef7c", "1398686845", "203.195.184.151", "203.195.184.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("343", "3feb035f6679a720a13c746175fddb65", "1398688100", "62.212.130.150", "62.212.130.150", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("344", "db4fa916135130765b8e0f51b5112763", "1398691866", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("345", "0c482bae5b6d0cb6343d76d8a3b897b1", "1398694571", "220.181.125.198", "220.181.125.198", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("346", "3c1f54201ca0795946d0116431462110", "1398695161", "180.76.5.20", "180.76.5.20", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("347", "f1544834adf91d8974f09fb2d88bdf5e", "1398695657", "83.166.233.15", "83.166.233.15", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("348", "265184eb7f8365f97728b85474008dab", "1398697771", "208.115.113.84", "208.115.113.84", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("349", "db4fa916135130765b8e0f51b5112763", "1398700192", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("350", "95f4204511ad7bfdf81605139814c3e3", "1398700245", "176.123.12.9", "176.123.12.9", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("351", "c8f6acb09ec087737c96ffcdf35815ea", "1398700909", "180.76.5.143", "180.76.5.143", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("352", "39723c7492555ace550f9bf5986357bd", "1398700910", "180.76.5.151", "180.76.5.151", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("353", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398701402", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("354", "14e42efa8f00a8c5ee962808e6d67962", "1398702977", "157.55.33.39", "157.55.33.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("355", "c8ef2aace323173003d416faa793e8d1", "1398703435", "198.50.112.114", "198.50.112.114", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("356", "042114596f067407dd69e7e40ca3d92c", "1398703438", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("357", "003a9b69e1fe719cfe950809698630fc", "1398704514", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("358", "5ebf0c69219f355bb582e7fa2f714ab2", "1398705204", "83.166.232.57", "83.166.232.57", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("359", "a2204d7ba16ed062e4f3581599cd377b", "1398707789", "189.107.254.24", "189.107.254.24", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("360", "be48a8d38c91a9a21d7197d3cc64db03", "1398709701", "176.123.31.27", "176.123.31.27", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("361", "ee613206c5974a7f2a6ea7e69ae15168", "1398711986", "89.47.253.2", "89.47.253.2", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("362", "20d9192d9c67ad13d21d05a868435203", "1398714530", "83.166.232.20", "83.166.232.20", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("363", "042114596f067407dd69e7e40ca3d92c", "1398714531", "209.200.245.229", "209.200.245.229", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("364", "6f4d8c7b84ae71e15e50fa25d6b495ec", "1398716762", "5.39.50.0", "5.39.50.0", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("365", "3945616ea3f486e62c99104e299c57d5", "1398716817", "23.81.201.86", "23.81.201.86", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("366", "3790648f10a2fe040da72f55c3e6c8f5", "1398717257", "180.76.6.230", "180.76.6.230", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("367", "a66ac593595d8ee05ff94921c88c1666", "1398717258", "180.76.6.66", "180.76.6.66", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("368", "c85851543461d1ea1b204b315989518a", "1398717385", "66.249.79.133", "66.249.79.133", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("369", "5e11d1946b6db8b2bb7c08e03b860eb1", "1398717672", "61.135.190.103", "61.135.190.103", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("370", "c64238baa3345c968c6521980b5d2602", "1398717674", "61.135.190.221", "61.135.190.221", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("371", "756d97b14166776a3da1e5d50233264b", "1398718854", "64.34.173.227", "64.34.173.227", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("372", "9e6df72e53d75a11bb9e3ab3975f80ec", "1398718906", "176.123.9.12", "176.123.9.12", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("373", "003a9b69e1fe719cfe950809698630fc", "1398720183", "5.39.106.19", "5.39.106.19", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("374", "c46d150fb3821533af1059db1a44c988", "1398723944", "176.123.0.50", "176.123.0.50", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("375", "db4fa916135130765b8e0f51b5112763", "1398724845", "222.255.29.39", "222.255.29.39", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("376", "3a7c562e879d3a858987cb1d4dbe9f6b", "1398727111", "66.249.74.67", "66.249.74.67", "expired", "b:0;", "1");
INSERT INTO `wp_wppa_session` VALUES("377", "7c55f6289527a5ca423029b94676fd7d", "1398728579", "176.123.2.8", "176.123.2.8", "expired", "b:0;", "2");
INSERT INTO `wp_wppa_session` VALUES("378", "fe1ae8519ab211429a47ed16f9c85cf4", "1398729404", "108.211.21.75", "108.211.21.75", "valid", "b:0;", "6");
INSERT INTO `wp_wppa_session` VALUES("379", "8c32c9844e056401b3708ed593ce3090", "1398729481", "globalthrillz", "108.211.21.75", "valid", "b:0;", "5");
INSERT INTO `wp_wppa_session` VALUES("380", "303c27265de3f436ea7e941ea582cc46", "1398729905", "108.211.21.75", "108.211.21.75", "valid", "b:0;", "6");
INSERT INTO `wp_wppa_session` VALUES("381", "077ec1c86a57d67b9263d1def51c0793", "1398731791", "globalthrillz", "108.211.21.75", "valid", "b:0;", "36");
INSERT INTO `wp_wppa_session` VALUES("382", "cbf0255b1c4ace0a82d056c12b51542c", "1398732047", "31.3.233.120", "31.3.233.120", "valid", "b:0;", "2");

SET FOREIGN_KEY_CHECKS = 1;